Package: GBScleanR
Type: Package
Title: Error correction tool for noisy genotyping by sequencing (GBS)
        data
Version: 2.7.2
Date: 2026-07-13
Authors@R: person("Tomoyuki", "Furuta", 
           email = "f.tomoyuki@okayama-u.ac.jp",
           role = c("aut", "cre"),
           comment = c(ORCID = "0000-0002-0869-6626"))
Description: GBScleanR is a package for quality check, filtering, and error 
   correction of genotype data derived from next generation sequcener (NGS)
   based genotyping platforms. GBScleanR takes Variant Call Format (VCF) file as
   input. The main function of this package is `estGeno()` which estimates the 
   true genotypes of samples from given read counts for genotype markers using a
   hidden Markov model with incorporating uneven observation ratio of allelic 
   reads. This implementation gives robust genotype estimation even in noisy 
   genotype data usually observed in Genotyping-By-Sequnencing (GBS) and similar
   methods, e.g. RADseq. The current implementation accepts genotype data of a 
   diploid population at any generation of multi-parental cross, e.g. biparental
   F2 from inbred parents, biparental F2 from outbred parents, and 8-way 
   recombinant inbred lines (8-way RILs) which can be refered to as MAGIC 
   population.
License: GPL-3 + file LICENSE
Encoding: UTF-8
LinkingTo: Rcpp, RcppParallel
SystemRequirements: GNU make, C++11
Depends: SeqArray
Imports: stats, utils, methods, ggplot2, tidyr, expm, Rcpp,
        RcppParallel, gdsfmt
Suggests: BiocStyle, testthat (>= 3.0.0), knitr, rmarkdown
VignetteBuilder: knitr
Roxygen: list(markdown = TRUE)
biocViews: GeneticVariability, SNP, Genetics, HiddenMarkovModel,
        Sequencing, QualityControl
BugReports: https://github.com/tomoyukif/GBScleanR/issues
URL: https://github.com/tomoyukif/GBScleanR
Config/testthat/edition: 3
Config/roxygen2/version: 8.0.0
git_url: https://git.bioconductor.org/packages/GBScleanR
git_branch: devel
git_last_commit: 09dd0ee
git_last_commit_date: 2026-07-13
Repository: Bioconductor 3.24
Date/Publication: 2026-07-26
NeedsCompilation: yes
Packaged: 2026-07-26 22:22:23 UTC; biocbuild
Author: Tomoyuki Furuta [aut, cre] (ORCID:
    <https://orcid.org/0000-0002-0869-6626>)
Maintainer: Tomoyuki Furuta <f.tomoyuki@okayama-u.ac.jp>

# GBScelaneR
![GBScleanR_icon](https://github.com/tomoyukif/GBScleanR/blob/main/inst/GSBcleanR_Icon.png?raw=true)

Error correction tool for genotype data derived from reduced representation 
sequencing(RRS).

## Introduction

`GBScleanR` is a package for quality check, filtering, and error correction of 
genotype data derived from next generation sequcener (NGS) based genotyping 
platforms. GBScleanR takes Variant Call Format (VCF) file as input. The main
function of this package is `estGeno()` which estimates the true genotypes of 
samples from given read counts for genotype markers using a hidden Markov model 
with incorporating uneven observation ratio of allele reads. This implementation
gives robust genotype estimation even in noisy genotype data usually observed in
Genotyping-By-Sequnencing (GBS) and similar methods, e.g. RADseq. 
The current implementation accepts genotype data of a 
diploid population at any generation of multi-parental cross, e.g. biparental
F2 from inbred parents, biparental F2 from outbred parents, and 8-way 
recombinant inbred lines (8-way RILs) which can be refered to as MAGIC 
population.

## Prerequisites
You may need to install the latest versions of the following packages.
```
BiocManager::install("gdsfmt")
BiocManager::install("SeqArray")
install.packages("ggplot2")
install.packages("tidyr")
install.packages("expm")
install.packages("Rcpp")
install.packages("RcppParallel")

# To create the vignette of GBScleanR
install.packages("rmarkdown")
install.packages("knitr")
BiocManager::install("BiocStyle")
```

## Installation
You can install `GBScleanR` from the Bioconductor repository with running the 
following code on an R console. Currently `GBScleanR` is listed in the 
developmental package repository of Bioconductor(https://doi.org/doi:10.18129/B9.bioc.GBScleanR). 
You need to set to use Bioc 
devel as shown below. On the other hand, `GBScleanR` on the GitHub repository
provide you the latest package with some developmental functions. If you need 
the stable release version of the package, please install the one on 
Bioconductor.

From Bioconductor:
```
if (!requireNamespace("BiocManager", quietly = TRUE))
    install.packages("BiocManager")
    
# The following initializes usage of Bioc devel
BiocManager::install(version='devel')

BiocManager::install("GBScleanR")
```

From GitHub:
```
if (!requireNamespace("devtools", quietly = TRUE))
    install.packages("devtools")
    
devtools::install_github("tomoyukif/GBScleanR", build_vignettes = TRUE)
```

For more information see vignette or run the following code on a R console.
```
browseVignettes(package = "GBScleanR")
```

## Citations
"Furuta, T., Yamamoto, T., Ashikari, M., GBScleanR: robust genotyping error 
correction using a hidden Markov model with error pattern recognition. 
Genetics 2023; doi: [10.1093/genetics/iyad055](https://doi.org/10.1093/genetics/iyad055)

#' GBScleanR: A package to conduct error correction for noisy genotyping by
#'  sequencing (reduced representation sequencing based genotyoing) data.
#'
#' GBScleanR is a package for quality check, filtering, and error correction of
#' genotype data derived from next generation sequcener (NGS) based genotyping
#' platforms. GBScleanR takes Variant Call Format (VCF) file as input. The main
#' function of this package is "clean.geno" which estimates the true genotypes
#' of samples from given read counts for genotype markers using a hidden Markov
#' model with incorporating uneven observation ratio of allelic reads. This
#' implementation gives robust genotype estimation even in noisy genotype data
#' usually observed in Genotyping-By-Sequnencing (GBS) and similar methods, e.g.
#' RADseq. GBScleanR currenly only supports genotype data of
#' biparental populations.
#'
#'
#' @docType package
#' @name GBScleanR
#' @useDynLib GBScleanR, .registration = TRUE
#' @importFrom Rcpp sourceCpp
#' @keywords internal
"_PACKAGE"

#' Draw histograms of specified statistics
#'
#' @param x A [GbsrGenotypeData] object.
#' @param stats A string to specify statistics to be drawn.
#' @param target Either or both of "marker" and "sample", e.g. `target = "marker"`
#' to draw a histogram only for SNPs.
#' @param binwidth An integer to specify bin width of the histogram.
#' This value is passed to the ggplot function.
#' @param color A named vector "Marker" and "Sample" to specify border
#' color of bins in the histograms.
#' @param fill A named vector "Marker" and "Sample" to specify fill
#' color of bins in the histograms.
#'
#' @details
#' You can draw histograms of several summary statistics of genotype counts
#' and read counts per sample and per marker. The "stats" argument can take
#' the following values:
#' \describe{
#'   \item{missing}{Proportion of missing genotype calls.}
#'   \item{het}{Proportion of heterozygote calls.}
#'   \item{raf}{Reference allele frequency.}
#'   \item{dp}{Total read counts.}
#'   \item{ad_ref}{Reference allele read counts.}
#'   \item{ad_alt}{Alternative allele read counts.}
#'   \item{rrf}{Reference allele read frequency.}
#'   \item{mean_ref}{Mean of reference allele read counts.}
#'   \item{sd_ref}{Standard deviation of reference allele read counts.}
#'   \item{median_ref}{Quantile of reference allele read counts.}
#'   \item{mean_alt}{Mean of alternative allele read counts.}
#'   \item{sd_alt}{Standard deviation of alternative allele read counts.}
#'   \item{median_alt}{Quantile of alternative allele read counts.}
#'   \item{mq}{Mapping quality.}
#'   \item{fs}{Phred-scaled p-value (strand bias)}
#'   \item{qd}{Variant Quality by Depth}
#'   \item{sor}{Symmetric Odds Ratio (strand bias)}
#'   \item{mqranksum}{Alt vs. Ref read mapping qualities}
#'   \item{readposranksum}{Alt vs. Ref read position bias}
#'   \item{baseqranksum}{Alt Vs. Ref base qualities}
#' }
#'
#' To draw histograms for "missing", "het", "raf", you need to run
#' [countGenotype()] first to obtain statistics. Similary, "dp",
#'  "ad_ref", "ad_alt", "rrf" requires values obtained via
#'  [countRead()]. "mq", "fs", "qd", "sor", "mqranksum", "readposranksum",
#' and "baseqranksum" only work with `target = "marker"`, if your data
#'  contains those values supplied via SNP calling tools like
#' [GATK](https://gatk.broadinstitute.org/hc/en-us).
#'
#' @export
#'
#' @return A ggplot object.
#'
#' @importFrom ggplot2 ggplot aes xlab ylab xlim scale_fill_manual
#' @importFrom ggplot2 scale_color_manual theme element_text rel
#'
#' @examples
#' # Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
#' gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
#' gds <- loadGDS(gds_fn)
#'
#' # Summarize genotype count information to be used in `histGBSR()`
#' gds <- countGenotype(gds)
#'
#' # Draw histograms of missing rate, heterozygosity, and reference
#' # allele frequency per SNP and per sample.
#' histGBSR(gds, stats = "missing")
#'
#' # Close the connection to the GDS file
#' closeGDS(gds)
histGBSR  <- function(x,
                      stats = c("dp", "missing", "het"),
                      target = c("marker", "sample"),
                      binwidth = NULL,
                      color = c(Marker = "darkblue", Sample = "darkblue"),
                      fill = c(Marker = "skyblue", Sample = "skyblue")) {
    stats_list <- c("dp",
                    "ad_ref",
                    "ad_alt",
                    "missing",
                    "het",
                    "raf",
                    "rrf",
                    "mean_ref",
                    "sd_ref",
                    "median_ref",
                    "mean_alt",
                    "sd_alt",
                    "median_alt",
                    "mq",
                    "fs",
                    "qd",
                    "sor",
                    "mqranksum",
                    "readposranksum",
                    "baseqranksum")

    if (missing(x)) {
        return(data.frame(
            stats = stats_list,
            description = c(
                "Total read depth",
                "Reference allele read depth",
                "Alternative allele read depth",
                "Missing rate",
                "Heterozygosity",
                "Referernce allele frequency",
                "Reference allele read frequency",
                "Mean of reference read depth",
                "SD of reference read depth",
                "Median of reference read depth",
                "Mean of alternative read depth",
                "SD of alternative read depth",
                "Median of alternative read depth",
                "Phred-scaled p-value (strand bias)",
                "Variant Quality by Depth",
                "Symmetric Odds Ratio (strand bias)",
                "Alt vs. Ref read mapping qualities",
                "Alt vs. Ref read position bias",
                "Alt Vs. Ref base qualities"
            )
        ))
    }

    stats <- match.arg(stats, stats_list)

    if (is.null(binwidth)) {
        if (stats %in% c("missing", "het", "raf", "rrf")) {
            binwidth <- 0.025
        }
    }

    df <- .df.maker(x, stats, target)
    p <- ggplot(df)
    p <- .hist.maker(p, stats, binwidth)
    p <- p + xlab(.lab.maker(stats)) +
        ylab("Count") +
        xlim(.limit.maker(stats)) +
        scale_fill_manual(values=fill, breaks=names(fill)) +
        scale_color_manual(values=color, breaks=names(color)) +
        theme(axis.title=element_text(face="bold", size=rel(1)),
              axis.text=element_text(size=rel(0.5)),
              strip.text=element_text(size=rel(0.8), face="bold"),
              legend.position="none")
    return(p)
}

#' Draw boxplots of specified statistics
#'
#' @param x A [GbsrGenotypeData] object.
#' @param stats A string to specify statistics to be drawn.
#' @param target Either or both of "marker" and "sample", e.g. `target = "marker"`
#' to draw a histogram only for SNPs.
#' @param color A named vector "Marker" and "Sample" to specify
#' border color of bins in the histograms.
#' @param fill A named vector "Marker" and "Sample" to specify
#' fill color of bins in the histograms.
#'
#' @details
#' You can draw boxplots of several summary statistics of genotype counts
#' and read counts per sample and per marker. The "stats" argument can take
#' the following values:
#'
#' \describe{
#'   \item{missing}{Proportion of missing genotype calls.}
#'   \item{het}{Proportion of heterozygote calls.}
#'   \item{raf}{Reference allele frequency.}
#'   \item{dp}{Total read counts.}
#'   \item{ad_ref}{Reference allele read counts.}
#'   \item{ad_alt}{Alternative allele read counts.}
#'   \item{rrf}{Reference allele read frequency.}
#'   \item{mean_ref}{Mean of reference allele read counts.}
#'   \item{sd_ref}{Standard deviation of reference allele read counts.}
#'   \item{median_ref}{Quantile of reference allele read counts.}
#'   \item{mean_alt}{Mean of alternative allele read counts.}
#'   \item{sd_alt}{Standard deviation of alternative allele read counts.}
#'   \item{median_alt}{Quantile of alternative allele read counts.}
#'   \item{mq}{Mapping quality.}
#'   \item{fs}{Phred-scaled p-value (strand bias)}
#'   \item{qd}{Variant Quality by Depth}
#'   \item{sor}{Symmetric Odds Ratio (strand bias)}
#'   \item{mqranksum}{Alt vs. Ref read mapping qualities}
#'   \item{readposranksum}{Alt vs. Ref read position bias}
#'   \item{baseqranksum}{Alt Vs. Ref base qualities}
#' }
#'
#' To draw boxplots for "missing", "het", "raf", you need to run
#' [countGenotype()] first to obtain statistics. Similary, "dp",
#' "ad_ref", "ad_alt", "rrf" requires values obtained via [countRead()].
#' "mq", "fs", "qd", "sor", "mqranksum", "readposranksum",
#' and "baseqranksum" only work with `target = "marker"`, if your data
#' contains those values supplied via SNP calling tools like
#' [GATK](https://gatk.broadinstitute.org/hc/en-us).
#'
#' @export
#'
#' @return A ggplot object.
#'
#' @importFrom ggplot2 ggplot aes xlab ylab xlim scale_fill_manual
#' @importFrom ggplot2 scale_color_manual theme element_text rel
#'
#' @examples
#' # Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
#' gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
#' gds <- loadGDS(gds_fn)
#'
#' # Summarize genotype count information to be used in `boxplotGBSR()`
#' gds <- countGenotype(gds)
#'
#' boxplotGBSR(gds, stats = "missing")
#'
#' # Close the connection to the GDS file
#' closeGDS(gds)
#'
boxplotGBSR <- function(x,
                        stats = "missing",
                        target = c("marker", "sample"),
                        color = c(Marker = "darkblue", Sample = "darkblue"),
                        fill = c(Marker = "skyblue", Sample = "skyblue")) {
    stats_list <- c("dp",
                    "ad_ref",
                    "ad_alt",
                    "missing",
                    "het",
                    "raf",
                    "rrf",
                    "mean_ref",
                    "sd_ref",
                    "median_ref",
                    "mean_alt",
                    "sd_alt",
                    "median_alt",
                    "mq",
                    "fs",
                    "qd",
                    "sor",
                    "mqranksum",
                    "readposranksum",
                    "baseqranksum")

    if (missing(x)) {
        return(data.frame(
            stats = stats_list,
            description = c(
                "Total read depth",
                "Reference allele read depth",
                "Alternative allele read depth",
                "Missing rate",
                "Heterozygosity",
                "Referernce allele frequency",
                "Reference allele read frequency",
                "Mean of reference read depth",
                "SD of reference read depth",
                "Median of reference read depth",
                "Mean of alternative read depth",
                "SD of alternative read depth",
                "Median of alternative read depth",
                "Phred-scaled p-value (strand bias)",
                "Variant Quality by Depth",
                "Symmetric Odds Ratio (strand bias)",
                "Alt vs. Ref read mapping qualities",
                "Alt vs. Ref read position bias",
                "Alt Vs. Ref base qualities"
            )
        ))
    }

    stats <- match.arg(stats, stats_list)

    df <- .df.maker(x, stats, target)
    p <- ggplot(df)
    p <- .boxplot.maker(p, stats)
    p <- p + ylab("") +
        xlab(.lab.maker(stats)) +
        xlim(.limit.maker(stats)) +
        scale_fill_manual(values=fill, breaks=names(fill)) +
        scale_color_manual(values=color, breaks=names(color)) +
        theme(axis.title=element_text(face="bold", size=rel(1)),
              axis.text=element_text(size=rel(0.5)),
              strip.text=element_text(size=rel(0.8), face="bold"),
              legend.position="none")
    return(p)
}


#' Draw line plots of specified statistics
#'
#' @param x A [GbsrGenotypeData] object.
#' @param stats A string to specify statistics to be drawn.
#' @param coord A vector with two integer specifying the number of rows
#' and columns to draw faceted line plots for chromosomes.
#' @param lwd A numeric value to specify the line width in plots.
#' @param binwidth An integer to specify bin width of the histogram.
#' This argument only work with `stats = "marker"` and is passed to the ggplot
#' function.
#' @param color A strings vector named "Marker", "Ref", "Het", "Alt"
#' to specify line colors. `stats = "geno` only requires "Ref", "Het" and "Alt",
#' while others uses the value named "Marker".
#'
#' @details
#' You can draw line plots of several summary statistics of genotype counts
#' and read counts per sample and per marker. The "stats" argument can take
#' the following values:
#' \describe{
#'   \item{marker}{Marker density.}
#'   \item{geno}{Proportion of missing genotype calls.}
#'   \item{missing}{Proportion of missing genotype calls.}
#'   \item{het}{Proportion of heterozygote calls.}
#'   \item{raf}{Reference allele frequency.}
#'   \item{dp}{Total read counts.}
#'   \item{ad_ref}{Reference allele read counts.}
#'   \item{ad_alt}{Alternative allele read counts.}
#'   \item{rrf}{Reference allele read frequency.}
#'   \item{mean_ref}{Mean of reference allele read counts.}
#'   \item{sd_ref}{Standard deviation of reference allele read counts.}
#'   \item{median_ref}{Quantile of reference allele read counts.}
#'   \item{mean_alt}{Mean of alternative allele read counts.}
#'   \item{sd_alt}{Standard deviation of alternative allele read counts.}
#'   \item{median_alt}{Quantile of alternative allele read counts.}
#'   \item{mq}{Mapping quality.}
#'   \item{fs}{Phred-scaled p-value (strand bias)}
#'   \item{qd}{Variant Quality by Depth}
#'   \item{sor}{Symmetric Odds Ratio (strand bias)}
#'   \item{mqranksum}{Alt vs. Ref read mapping qualities}
#'   \item{readposranksum}{Alt vs. Ref read position bias}
#'   \item{baseqranksum}{Alt Vs. Ref base qualities}
#' }
#'
#' To draw line plots for "missing", "het", "raf", you need to run
#' [countGenotype()] first to obtain statistics. Similary, "dp",
#' "ad_ref", "ad_alt", "rrf" requires values obtained via [countRead()].
#' "mq", "fs", "qd", "sor", "mqranksum", "readposranksum",
#' #' and "baseqranksum" only work with `target = "marker"`, if your data
#' contains those values supplied via SNP calling tools like
#' [GATK](https://gatk.broadinstitute.org/hc/en-us).
#'
#' @export
#' @importFrom ggplot2 ggplot aes xlab ylab labs ylim scale_x_continuous
#' @importFrom ggplot2 scale_color_manual theme element_text rel expansion
#'
#' @return A ggplot object.
#'
#' @examples
#' # Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
#' gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
#' gds <- loadGDS(gds_fn)
#'
#' # Summarize genotype count information to be used in `plotGBSR()`
#' gds <- countGenotype(gds)
#'
#' # Draw line plots of missing rate, heterozygosity, proportion of genotype
#' # calls per SNP.
#' plotGBSR(gds, stats = "missing")
#'
#' # Close the connection to the GDS file
#' closeGDS(gds)
#'
plotGBSR  <- function(x,
                      stats = c("dp", "missing", "het"),
                      coord = NULL,
                      lwd = 0.5,
                      binwidth = NULL,
                      color = c(
                          Marker = "darkblue",
                          Ref = "darkgreen",
                          Het = "magenta",
                          Alt = "blue")) {
    stats_list <- c("marker",
                    "geno",
                    "dp",
                    "ad_ref",
                    "ad_alt",
                    "missing",
                    "het",
                    "raf",
                    "rrf",
                    "mean_ref",
                    "sd_ref",
                    "median_ref",
                    "mean_alt",
                    "sd_alt",
                    "median_alt",
                    "mq",
                    "fs",
                    "qd",
                    "sor",
                    "mqranksum",
                    "readposranksum",
                    "baseqranksum"
    )
    if (missing(x)) {
        return(data.frame(
            stats = stats_list,
            description = c(
                "Marker density",
                "genotype ratio",
                "Total read depth",
                "Reference allele read depth",
                "Alternative allele read depth",
                "Missing rate",
                "Heterozygosity",
                "Referernce allele frequency",
                "Reference allele read frequency",
                "Mean of reference read depth",
                "SD of reference read depth",
                "Median of reference read depth",
                "Mean of alternative read depth",
                "SD of alternative read depth",
                "Median of alternative read depth",
                "Phred-scaled p-value (strand bias)",
                "Variant Quality by Depth",
                "Symmetric Odds Ratio (strand bias)",
                "Alt vs. Ref read mapping qualities",
                "Alt vs. Ref read position bias",
                "Alt Vs. Ref base qualities"
            )
        ))
    }
    stats <- match.arg(stats, stats_list)

    if(stats == "geno"){
        color <- color[2:4]
    }
    if(stats == "marker"){
        color <- color[1]
    }

    df <- .df.maker(x, stats, "marker", TRUE)
    p <- ggplot(df)
    p <- .plot.maker(p, stats, binwidth, lwd, coord)
    p <- p + xlab("Physical position (Mb)") +
        ylab("") +
        labs(title = .lab.maker(stats)) +
        ylim(.limit.maker(stats)) +
        scale_x_continuous(expand=expansion(0, 0.5), limits=c(0, NA)) +
        scale_color_manual(values=color, breaks=names(color)) +
        theme(
            plot.title=element_text(face="bold", size=rel(1)),
            axis.title=element_text(face="bold", size=rel(0.7)),
            axis.text=element_text(size=rel(0.5)),
            strip.text.y=element_text(size=rel(0.8), face="bold", angle=0)
        )
    if (stats != "geno") {
        p <- p + theme(legend.position="none")
    }
    return(p)
}



#' Draw a scatter plot of a pair of specified statistics
#'
#' @param x A [GbsrGenotypeData] object.
#' @param stats1 A string to specify statistics to be drawn.
#' @param stats2 A string to specify statistics to be drawn.
#' @param target Either or both of "marker" and "sample", e.g.
#' `target = "marker"` to draw a histogram only for SNPs.
#' @param size A numeric value to specify the dot size of a scatter plot.
#' @param alpha A numeric value \[0-1\] to specify the transparency of
#' dots in a scatter plot.
#' @param color A named vector "Marker" and "Sample" to specify border
#' color of bins in the histograms.
#' @param fill A named vector "Marker" and "Sample" to specify fill color
#' of bins in the histograms.`stats = "geno` only requires "Ref", "Het"
#' and "Alt", while others uses the value named "Marker".
#' @param smooth A logical value to indicate whether draw a smooth line for
#' data points. See also [ggplot2::stat_smooth()].
#'
#' @details
#' You can draw a scatter plot of per-marker and/or per-sample summary
#' statistics specified at `stats1` and `stats2`. The "stats1" and "stats2"
#' arguments can take the following values:
#' \describe{
#'   \item{missing}{Proportion of missing genotype calls.}
#'   \item{het}{Proportion of heterozygote calls.}
#'   \item{raf}{Reference allele frequency.}
#'   \item{dp}{Total read counts.}
#'   \item{ad_ref}{Reference allele read counts.}
#'   \item{ad_alt}{Alternative allele read counts.}
#'   \item{rrf}{Reference allele read frequency.}
#'   \item{mean_ref}{Mean of reference allele read counts.}
#'   \item{sd_ref}{Standard deviation of reference allele read counts.}
#'   \item{median_ref}{Quantile of reference allele read counts.}
#'   \item{mean_alt}{Mean of alternative allele read counts.}
#'   \item{sd_alt}{Standard deviation of alternative allele read counts.}
#'   \item{median_alt}{Quantile of alternative allele read counts.}
#'   \item{mq}{Mapping quality.}
#'   \item{fs}{Phred-scaled p-value (strand bias)}
#'   \item{qd}{Variant Quality by Depth}
#'   \item{sor}{Symmetric Odds Ratio (strand bias)}
#'   \item{mqranksum}{Alt vs. Ref read mapping qualities}
#'   \item{readposranksum}{Alt vs. Ref read position bias}
#'   \item{baseqranksum}{Alt Vs. Ref base qualities}
#' }
#'
#' To draw scatter plots for "missing", "het", "raf", you need to run
#' [countGenotype()] first to obtain statistics. Similary, "dp",
#' "ad_ref", "ad_alt", "rrf" requires values obtained via [countRead()].
#' "mq", "fs", "qd", "sor", "mqranksum", "readposranksum",
#' and "baseqranksum" only work with `target = "marker"`, if your data
#' contains those values supplied via SNP calling tools like
#' [GATK](https://gatk.broadinstitute.org/hc/en-us).
#'
#' @return A ggplot object.
#'
#' @export
#' @importFrom ggplot2 ggplot aes xlab ylab xlim ylim scale_fill_manual
#' @importFrom ggplot2 scale_color_manual theme stat_smooth element_text rel
#'
#' @examples
#' # Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
#' gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
#' gds <- loadGDS(gds_fn)
#'
#' # Summarize genotype count information to be used in `pairsGBSR()`
#' gds <- countGenotype(gds)
#'
#' # Draw scatter plots of missing rate vs heterozygosity.
#' pairsGBSR(gds, stats1 = "missing", stats2 = "het")
#'
#' # Close the connection to the GDS file
#' closeGDS(gds)
#'
#'
pairsGBSR  <- function(x,
                       stats1 = "dp",
                       stats2 = "missing",
                       target = "marker",
                       size = 0.5,
                       alpha = 0.8,
                       color = c(Marker = "darkblue", Sample = "darkblue"),
                       fill = c(Marker = "skyblue", Sample = "skyblue"),
                       smooth = FALSE) {
    stats_list <- c("dp",
                    "ad_ref",
                    "ad_alt",
                    "missing",
                    "het",
                    "raf",
                    "rrf",
                    "mean_ref",
                    "sd_ref",
                    "median_ref",
                    "mean_alt",
                    "sd_alt",
                    "median_alt",
                    "mq",
                    "fs",
                    "qd",
                    "sor",
                    "mqranksum",
                    "readposranksum",
                    "baseqranksum")

    if (missing(x)) {
        return(data.frame(
            stats = stats_list,
            description = c(
                "Total read depth",
                "Reference allele read depth",
                "Alternative allele read depth",
                "Missing rate",
                "Heterozygosity",
                "Referernce allele frequency",
                "Reference allele read frequency",
                "Mean of reference read depth",
                "SD of reference read depth",
                "Median of reference read depth",
                "Mean of alternative read depth",
                "SD of alternative read depth",
                "Median of alternative read depth",
                "Mapping quality",
                "Phred-scaled p-value (strand bias)",
                "Variant Quality by Depth",
                "Symmetric Odds Ratio (strand bias)",
                "Alt vs. Ref read mapping qualities",
                "Alt vs. Ref read position bias",
                "Alt Vs. Ref base qualities"
            )
        ))
    }

    stats1 <-
        match.arg(stats1, stats_list)
    stats2 <-
        match.arg(stats2, stats_list)

    df1 <- .df.maker(x, stats1, target)
    df2 <- .df.maker(x, stats2, target)
    df <-
        data.frame(val1 = df1$val,
                   val2 = df2$val,
                   target = df1$target)

    val1 <- val2 <- NULL
    p <- ggplot(df)
    p <- .pairs.maker(p, size, alpha)
    p <- p + xlab(.lab.maker(stats1)) +
        ylab(.lab.maker(stats2)) +
        xlim(.limit.maker(stats1)) +
        ylim(.limit.maker(stats2)) +
        scale_fill_manual(values=fill, breaks=names(fill)) +
        scale_color_manual(values=color, breaks=names(color)) +
        theme(
            plot.title=element_text(face="bold", size=rel(1)),
            axis.title=element_text(face="bold", size=rel(0.7)),
            axis.text=element_text(size=rel(0.5)),
            strip.text.y=element_text(size=rel(0.8), face="bold", angle=0),
            legend.position="none"
        )
    if (smooth) {
        p <- p + stat_smooth(aes(x=val1, y=val2),)
    }
    return(p)
}


# Internal function to build a data.frame passed to ggplot().
#' @importFrom tidyr pivot_longer
.df.maker <- function(x, stats, target, pos = FALSE) {
    Ref <- NULL
    Alt <- NULL
    if (stats == "geno") {
        snp <- data.frame(Ref = getCountGenoRef(x, "marker", TRUE, TRUE),
                          Het = getCountGenoHet(x, "marker", TRUE, TRUE),
                          Alt = getCountGenoAlt(x, "marker", TRUE, TRUE),
                          chr = getChromosome(x),
                          pos = getPosition(x) * 10^-6,
                          stringsAsFactors=FALSE)
        if (is.null(snp)) {
            msg <- paste0('No data for the statistic: ', stats)
            stop(msg)
        }
        snp <- pivot_longer(snp, Ref:Alt,
                            names_to="genotype", values_to="val")
        scan <- NULL

    } else if (stats == "marker") {
        snp <- data.frame(chr = getChromosome(x),
                          pos = getPosition(x) * 10^-6,
                          target = "Marker",
                          stringsAsFactors=FALSE)
        scan <- NULL

    } else {
        if ("marker" %in% target) {
            snp <- switch(
                stats,
                "dp" = getCountRead(x, "marker"),
                "missing" = getCountGenoMissing(x, "marker", TRUE, TRUE),
                "het" = getCountGenoHet(x, "marker", TRUE, TRUE),
                "raf" = getCountAlleleRef(x, "marker", TRUE, TRUE),
                "rrf" = getCountReadRef(x, "marker", TRUE, TRUE),
                "ad_ref" = getCountReadRef(x, "marker"),
                "mean_ref" = getMeanReadRef(x, "marker"),
                "sd_ref" = getSDReadRef(x, "marker"),
                "median_ref" = getMedianReadRef(x, "marker"),
                "ad_alt" = getCountReadAlt(x, "marker"),
                "mean_alt" = getMeanReadAlt(x, "marker"),
                "sd_alt" = getSDReadAlt(x, "marker"),
                "median_alt" = getMedianReadAlt(x, "marker"),
                "mq" = getInfo(x, "MQ"),
                "fs" = getInfo(x, "FS"),
                "qd" = getInfo(x, "QD"),
                "sor" = getInfo(x, "SOR"),
                "mqranksum" = getInfo(x, "MQRankSum"),
                "readposranksum" = getInfo(x, "ReadPosRankSum"),
                "baseqranksum" = getInfo(x, "BaseQRankSum")
            )
            if (is.null(snp)) {
                msg <- paste0('No SNP summary for the statistic: ', stats)
                warning(msg)
            } else {
                if (pos) {
                    snp <- data.frame(val = snp,
                                      target = "Marker",
                                      chr = getChromosome(x),
                                      pos = getPosition(x) * 10^-6,
                                      stringsAsFactors=FALSE)
                } else {
                    snp <- data.frame(val = snp, target = "Marker")
                }
            }
        } else {
            snp <- NULL
        }
        if ("sample" %in% target) {
            scan <- switch(
                stats,
                "dp" = getCountRead(x, "sample"),
                "missing" = getCountGenoMissing(x, "sample", TRUE, TRUE),
                "het" = getCountGenoHet(x, "sample", TRUE, TRUE),
                "raf" = getCountAlleleRef(x, "sample", TRUE, TRUE),
                "rrf" = getCountReadRef(x, "sample", TRUE, TRUE),
                "ad_ref" = getCountReadRef(x, "sample"),
                "mean_ref" = getMeanReadRef(x, "sample"),
                "sd_ref" = getSDReadRef(x, "sample"),
                "median_ref" = getMedianReadRef(x, "sample"),
                "ad_alt" = getCountReadAlt(x, "sample"),
                "mean_alt" = getMeanReadAlt(x, "sample"),
                "sd_alt" = getSDReadAlt(x, "sample"),
                "median_alt" = getMedianReadAlt(x, "sample")
            )
            if (is.null(scan)) {
                msg <- paste0('No sample summary for the statistic: ', stats)
                warning(msg)
            } else {
                scan <- data.frame(val = scan, target = "Sample")
            }
        } else {
            scan <- NULL
        }
    }
    df <- rbind(snp, scan)
    return(df)
}

# Internal function to build label information passed to ggplot().
.lab.maker <- function(stats) {
    lab <- switch(
        stats,
        "marker" = "Marker density",
        "geno" = "Genotype ratio",
        "dp" = "Total read depth",
        "ad_ref" = "Reference allelic read depth",
        "ad_alt" = "Alternative allelic read depth",
        "missing" = "Missing rate",
        "het" = "Heterozygosity",
        "raf" = "Referernce allele frequency",
        "rrf" = "Reference allele read frequency",
        "mean_ref" = "Mean of reference read depth",
        "sd_ref" = "SD of reference read depth",
        "median_ref" = "Median of reference read depth",
        "mean_alt" = "Mean of alternative read depth",
        "sd_alt" = "SD of alternative read depth",
        "median_alt" = "Median of alternative read depth",
        "mq" = "Mapping quality (MQ)",
        "fs" = "Phred-scaled p-value (strand bias) (FS)",
        "qd" = "Variant Quality by Depth (QD)",
        "sor" = "Symmetric Odds Ratio (strand bias) (SOR)",
        "mqranksum" = "Alt vs. Ref read mapping qualities (MQRankSum)",
        "readposranksum" = "Alt vs. Ref read position bias (ReadPosRankSum)",
        "baseqranksum" = "Alt Vs. Ref base qualities (BaseQRankSum)"
    )
    return(lab)
}

# Internal function to build plot limit information passed to ggplot().
.limit.maker <- function(stats) {
    lim <- switch(
        stats,
        "marker" = c(0, NA),
        "geno" = c(0, 1),
        "dp" = c(0, NA),
        "ad_ref" = c(0, NA),
        "ad_alt" = c(0, NA),
        "missing" = c(0, 1),
        "het" = c(0, 1),
        "raf" = c(0, 1),
        "rrf" = c(0, 1),
        "mean_ref" = c(0, NA),
        "sd_ref" = c(0, NA),
        "median_ref" = c(0, NA),
        "mean_alt" = c(0, NA),
        "sd_alt" = c(0, NA),
        "median_alt" = c(0, NA),
        "mq" = c(0, NA),
        "fs" = c(0, NA),
        "qd" = c(0, NA),
        "sor" = c(0, NA),
        "mqranksum" = as.numeric(c(NA, NA)),
        "readposranksum" = as.numeric(c(NA, NA)),
        "baseqranksum" = as.numeric(c(NA, NA))
    )
    return(lim)
}

# Internal function to draw a histogram.
#' @importFrom ggplot2 geom_histogram facet_wrap
.hist.maker <- function(p, stats, binwidth, color, fill) {
    val <- target <- NULL
    p <- p +
        geom_histogram(aes(x=val, color=target, fill=target),
                       binwidth=binwidth,
                       boundary=0) +
        facet_wrap( ~ target, scales="free")
    return(p)
}

# Internal function to draw a boxplot.
#' @importFrom ggplot2 geom_histogram facet_wrap
.boxplot.maker <- function(p, stats) {
    val <- NULL
    target <- NULL
    p <- p + geom_histogram(aes(x=val, color=target)) +
        facet_wrap( ~ target, scales="free")
    return(p)
}

# Internal function to draw a line plot.
#' @importFrom ggplot2 geom_line geom_histogram facet_wrap
.plot.maker <- function(p, stats, binwidth, lwd, coord) {
    val <- genotype <- target <- pos <- NULL
    if ("geno" %in% stats) {
        p <-p +
            geom_line(aes(x=pos, y=val, color=genotype),
                      size=lwd) +
            facet_wrap(~ chr, coord[1], coord[2], "free_x",
                       dir="v", strip.position="right")
    } else if ("marker" %in% stats) {
        p <- p +
            geom_histogram(aes(x=pos, fill=target, color=target),
                           binwidth=binwidth, boundary=0) +
            facet_wrap(~ chr, coord[1], coord[2], "free_x",
                       dir="v", strip.position="right")
    } else {
        p <- p +
            geom_line(aes(x=pos, y=val, color=target), size=lwd) +
            facet_wrap(~ chr, coord[1], coord[2], "free_x",
                       dir="v", strip.position="right")
    }
    return(p)
}

# Internal function to draw a scatter plot.
#' @importFrom ggplot2 geom_point facet_wrap
.pairs.maker <- function(p, size, alpha) {
    val1 <- val2 <- target <- NULL
    p <- p +
        geom_point(aes(x=val1, y=val2, color=target, fill=target),
                   size=size, alpha=alpha) +
        facet_wrap( ~ target, scales="free")
    return(p)
}

#' Draw line plots of allele dosage per marker per sample.
#'
#' This function counts a reference allele dosage per marker per sample and
#' draw line plots of them in facets for each chromosome for each sample.
#'
#' @param x A [GbsrGenotypeData] object.
#' @param coord A vector with two integer specifying the number of rows
#' and columns to draw faceted line plots for chromosomes.
#' @param chr A vector of indexes to specify chromosomes to be drawn.
#' @param ind An index to specify samples to be drawn.
#' @param node Either one of "raw" or "filt" to output raw read data, or filtered read data,
#' respectively.
#' @param showratio If `TRUE`, draw dots indicating read ratio.
#' @param line_color A string to indicate the line color in the plot.
#' @param dot_fill A vector of two strings to indicate the dot colors in the plot. The first and second elements of the vector are set as the colors for the lowest and highest values in the gradient coloring of the dots indicating total read counts par marker.
##' @param size A positive number to indicate the dot size in a plot.
#' @param alpha A positive number in 0-1 to indicate the dot opacity in a plot.
#'
#' @examples
#' # Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
#' gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
#' gds <- loadGDS(gds_fn)
#'
#' plotDosage(gds, ind = 1)
#'
#' # Close the connection to the GDS file
#' closeGDS(gds)
#'
#' @return A ggplot object.
#' @export
#' @importFrom ggplot2 ggplot aes geom_point geom_line labs
#' @importFrom ggplot2 ylim xlab ylab facet_wrap theme
#' @importFrom ggplot2 scale_colour_gradient scale_size_manual
#' @importFrom ggplot2 scale_linewidth_manual
#'
plotDosage <- function(x,
                       coord = NULL,
                       chr = NULL,
                       ind = 1,
                       node = "raw",
                       showratio = TRUE,
                       dot_fill = c("green", "darkblue"),
                       size = 0.8,
                       alpha = 0.8,
                       line_color = "magenta") {
    pos <- na <- NULL

    if (is.null(chr)) {
        chr <- rep(TRUE, nmar(x))
    } else {
        chr <- getChromosome(x) %in% chr
    }

    if(is.character(ind)){
        ind <- which(getSamID(x, parents = TRUE) %in% ind)
        id <- getSamID(x, parents = TRUE)[ind]

    } else {
        id <- getSamID(x, parents = TRUE)[ind]
    }

    if(showratio){
        ploidy <- attributes(slot(x, "sample"))[["ploidy"]]
        read <- getRead(x, node = node, valid = TRUE, parents = TRUE)
        ref <- read$ref[ind, chr]
        alt <- read$alt[ind, chr]
        dp <- ref + alt
        ad <- alt / dp * ploidy
    }

    geno <- getGenotype(x, node = "dosage", valid = TRUE, parents = TRUE)[ind, chr]
    if(all(is.na(geno))){
        warning("Missing values at all markers./n",
                "This sample might have no read at all markers.")
    }

    pos <- getPosition(x)[chr]
    chr <- getChromosome(x)[chr]
    max_pos <- tapply(pos, chr, max)
    min_pos <- tapply(pos, chr, min)
    uniq_chr <- sort(unique(chr))
    dummy <- rbind(data.frame(chr = uniq_chr, pos = max_pos, ad = 0, dp = 0),
                   data.frame(chr = uniq_chr, pos = min_pos, ad = 0, dp = 0))

    df <- data.frame(chr = chr, pos = pos, geno = geno, ad = ad, dp = dp)
    df <- df[!is.na(df$geno), ]
    ploidy <- attributes(slot(x, "sample"))[["ploidy"]]
    p <- ggplot(df) +
        geom_point(data = dummy, mapping = aes(x = pos * 10^-6, y = ad),
                   size = 0, color = NA)

    if(showratio){
        p <- p + geom_point(mapping = aes(x = pos * 10^-6, y = ad, colour = dp),
                            size = size, alpha = alpha, stroke = 0) +
            scale_colour_gradient(low = dot_fill[1], high = dot_fill[2])
    }
    p <- p + geom_line(mapping = aes(x = pos * 10^-6, y = geno, group = chr),
                       color = line_color) +
        labs(title=paste0("Alternative allele dosage: ", id)) +
        ylim(0, ploidy) +
        xlab("Physical position (Mb)") +
        ylab("Alternative allele dosage")

    p <- p + facet_wrap(~ chr, coord[1], coord[2], "free_x",
                        dir="v", strip.position="right") +
        theme(legend.position="none")
    return(p)
}

#' Draw line plots of proportion of reference allele read counts
#'  per marker per sample.
#'
#' This function calculate a proportion of reference allele read
#' counts per marker per sample and
#' draw line plots of them in facets for each chromosome for each sample.
#'
#' @param x A [GbsrGenotypeData] object.
#' @param coord A vector with two integer specifying the number of rows and
#' columns to draw faceted line plots for chromosomes.
#' @param chr A vector of indexes to specify chromosomes to be drawn.
#' @param ind A string of sample id or an index to specify the sample to be drawn.
#' @param node Either one of "raw" or "filt" to output raw read data, or filtered read data,
#' respectively.
#' @param dot_fill A vector of two strings to indicate the dot colors in the plot. The first and second elements of the vector are set as the colors for the lowest and highest values in the gradient coloring of the dots indicating total read counts par marker.
#' @param size A positive number to indicate the dot size in the plot.
#' @param alpha A positive number in 0-1 to indicate the dot opacity in the plot.
#'
#'
#' @examples
#' # Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
#' gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
#' gds <- loadGDS(gds_fn)
#'
#' plotReadRatio(gds, ind = 1)
#'
#' # Close the connection to the GDS file
#' closeGDS(gds)
#'
#' @return A ggplot object.
#' @export
#' @importFrom ggplot2 ggplot aes geom_point labs
#' @importFrom ggplot2 ylim xlab ylab facet_wrap theme
#' @importFrom ggplot2 scale_colour_gradient scale_size_manual
#'
plotReadRatio <- function(x,
                          coord = NULL,
                          chr = NULL,
                          ind = 1,
                          node = "raw",
                          dot_fill = c("green", "darkblue"),
                          size = 0.8,
                          alpha = 0.8) {
    pos <- ad <- NULL

    if (is.null(chr)) {
        chr <- rep(TRUE, nmar(x))
    } else {
        chr <- getChromosome(x) %in% chr
    }

    if(is.character(ind)){
        ind <- which(getSamID(x, parents = TRUE) %in% ind)
        id <- getSamID(x, parents = TRUE)[ind]

    } else {
        id <- getSamID(x, parents = TRUE)[ind]
    }

    read <- getRead(x, node = node, valid = TRUE, parents = TRUE)
    ref <- read$ref[ind, chr]
    alt <- read$alt[ind, chr]
    dp <- ref + alt
    ad <- alt / dp

    if(all(is.na(ad))){
        warning("Missing values at all markers./n",
                "This sample might have no read at all markers.")
    }

    pos <- getPosition(x)[chr]
    chr <- getChromosome(x)[chr]
    max_pos <- tapply(pos, chr, max)
    min_pos <- tapply(pos, chr, min)
    uniq_chr <- sort(unique(chr))
    dummy <- rbind(data.frame(chr = uniq_chr, pos = max_pos, ad = 0, dp = 0),
                   data.frame(chr = uniq_chr, pos = min_pos, ad = 0, dp = 0))

    df <- data.frame(chr = chr, pos = pos, ad = ad, dp = dp)

    p <- ggplot(df, aes(x = pos * 10^-6, y = ad, colour = dp)) +
        geom_point(data = dummy, mapping = aes(x = pos * 10^-6, y = ad),
                   size = 0, color = NA) +
        geom_point(size = size, alpha = alpha, stroke = 0) +
        scale_colour_gradient(low = dot_fill[1], high = dot_fill[2]) +
        labs(title=paste0("Alternative allele read ratio: ", id)) +
        ylim(0, 1) +
        xlab("Position (Mb)") +
        ylab("Alternative allele read ratio")

    p <- p + facet_wrap(~ chr, coord[1], coord[2], "free_x",
                        dir="v", strip.position="right") +
        theme(legend.position="none")
    return(p)
}

#' @export
print.GbsrGenotypeData <- function(x, ...) {
    show(x)
}

#' Convert a VCF file to a GDS file
#'
#' This function converts a variant call data in the VCF format.
#' The current implementation only accepts biallelic
#' single nucleotide polymorphisms.
#' Please filter out variants which are insertions and
#' deletions or multiallelic.
#' You may use "bcftools" or "vcftools" for filtering.
#'
#' @param vcf_fn A string to indicate path to an input VCF file.
#' @param out_fn A string to indicate path to an output GDS file.
#' @param gt the ID for genotypic data in the FORMAT column; "GT" by default,
#'  VCFv4.0.
#' @param info.import characters, the variable name(s) in the INFO field for
#' import; or NULL for all variables. If you specify `character(0)`, nothing
#' will be retrieved from the INFO filed.
#' @param fmt.import characters, the variable name(s) in the FORMAT field for
#' import; or NULL for all variables. If you specify `character(0)`, nothing
#' will be retrieved from the FORMAT filed, except for GT.
#' @param force A logical value to overwrite a GDS file even if
#' the file specified in "out_fn" exists.
#' @param verbose if TRUE, show information.
#'
#' @details
#' gbsrVCF2GDS converts a VCF file to a GDS file.
#' The data structure of the GDS file created via this functions is same with
#' those created by \code{\link[SeqArray]{seqVCF2GDS}} of `SeqArray`.
#'
#' @return The output GDS file path.
#'
#' @examples
#' # Create a GDS file from a sample VCF file.
#' vcf_fn <- system.file("extdata", "sample.vcf", package = "GBScleanR")
#' gds_fn <- tempfile("sample", fileext = ".gds")
#' gbsrVCF2GDS(vcf_fn = vcf_fn, out_fn = gds_fn, force = TRUE)
#'
#' # Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
#' gds <- loadGDS(gds_fn)
#'
#' # Close the connection to the GDS file.
#' closeGDS(gds)
#'
#' @export
#'
#' @importFrom SeqArray seqVCF2GDS seqOptimize seqStorageOption seqExport seqNumAllele
#'
gbsrVCF2GDS <- function(vcf_fn,
                        out_fn,
                        gt = "GT",
                        info.import = NULL,
                        fmt.import = NULL,
                        force = FALSE,
                        verbose = TRUE) {
    # Check if the out_fn already exists and whether it can be overwritten.
    if (file.exists(out_fn)) {
        message(out_fn, ' exists!')
        while (TRUE) {
            if (force) {
                file.remove(out_fn)
                break()
            }
            user <- readline("Are you sure to overwirte?(y/n)")
            if (user == "y") {
                file.remove(out_fn)
                break()
            } else if (user == "n") {
                message('Stopped by user.')
                return(out_fn)
            }
        }
    }

    # Create GDS file formatted in the SeqArray style.
    stropt <- seqStorageOption(mode = c('annotation/format/AD' = "int64",
                                        'annotation/format/DP' = "int64",
                                        'annotation/format/GQ' = "int64",
                                        'annotation/format/MIN_DP' = "int64",
                                        'annotation/format/PL' = "int64",
                                        'annotation/format/PS' = "int64",
                                        'annotation/format/RGQ' = "int64",
                                        'annotation/format/SB' = "int64"))
    if(!is.null(fmt.import)){
      fmt.import <- unique(c("AD", fmt.import))
    }
    out_fn <- seqVCF2GDS(vcf_fn, out_fn, ignore.chr.prefix = "",
                         storage.option = stropt,
                         info.import = info.import,
                         fmt.import = fmt.import,
                         genotype.var.name = gt,
                         verbose = verbose)
    gds <- seqOpen(out_fn)

    # Filter out non-biallelic markers
    n_allele <- seqNumAllele(gds)
    if(any(n_allele != 2)){
      message("Some markers are not bi-allelic.",
              "\nGBScleanR filters out those markers.")
      message("Filtering non-biallelic markers.")
      temp_fn <- tempfile("biallelic", tempdir(), ".gds")
      seqSetFilter(gds, variant.sel = n_allele == 2)
      seqExport(gds, temp_fn)
      seqClose(gds)
      file.copy(temp_fn, out_fn, overwrite = TRUE)

    } else {
      seqClose(gds)
    }
    return(out_fn)
}

#' Load a GDS file and construct a [GbsrGenotypeData] object.
#'
#' Load data stored in an input GDS file to R environment and
#' create a [GbsrGenotypeData] instance.
#' GBScleanR handles only one class [GbsrGenotypeData] and
#' conducts all data manipulation via class methods for it.
#'
#' @param x A string of the path to an input GDS file or
#' a [GbsrGenotypeData] object to reload.
#' @param load_filter A logical whether to load the filtering information made
#'  via [setSamFilter()] and [setMarFilter()] and saved in the GDS file via
#'  [closeGDS()] with `save_filter = TRUE`.
#' @param ploidy Set the ploidy of the population.
#' @param verbose if TRUE, show information.
#'
#' @return A [GbsrGenotypeData] object.
#'
#' @export
#'
#' @importFrom methods new
#' @importFrom SeqArray seqOpen seqSummary seqOptimize
#' @importFrom gdsfmt exist.gdsn delete.gdsn objdesp.gdsn setdim.gdsn add.gdsn
#'
#' @details
#' The first time to load a newly produced GDS file will take long time due to
#' data reformatting for quick access. The [GbsrGenotypeData] object returned
#' from [loadGDS()] can be also handled as \code{\link[SeqArray]{SeqVarGDSClass-class}} of the `SeqArray` package.
#'
#' @examples
#' # Create a GDS file from a sample VCF file.
#' vcf_fn <- system.file("extdata", "sample.vcf", package = "GBScleanR")
#' gds_fn <- tempfile("sample", fileext = ".gds")
#' gbsrVCF2GDS(vcf_fn = vcf_fn, out_fn = gds_fn, force = TRUE)
#'
#' # Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
#' gds <- loadGDS(gds_fn)
#'
#' # Reload data from the GDS file.
#' gds <- loadGDS(gds)
#'
#' # Close the connection to the GDS file.
#' closeGDS(gds)
#'
loadGDS <- function(x, load_filter = FALSE, ploidy = 2, verbose = TRUE) {
  if(verbose){ message('Loading GDS file.') }

  # Check input data type
  if(inherits(x = x, what = "GbsrGenotypeData")){
    if(isOpenGDS(object = x)){
      closeGDS(object = x, save_filter = FALSE)
    }
    # Leave the following connection open to build
    # the GdsGenotypeReader object with `readonly = FALSE` mode.
    gds <- seqOpen(gds.fn = x$filename, readonly = FALSE)

  } else if(is.character(x)){
    # Leave the following connection open to build
    # the GdsGenotypeReader object with `readonly = FALSE` mode.
    gds <- seqOpen(gds.fn = x, readonly = FALSE)

  } else {
    stop("x must be a file path or a GbsrGenotypeData object",
         call. = FALSE)
  }

  # Parse the GBSR output formats in VCF
  .parseGBSRformat(gds = gds, ploidy = ploidy)

  # Optimize gds nodes
  opt <- exist.gdsn(node = gds, path = "genotype/~data") &
    exist.gdsn(node = gds, path = "annotation/format/AD/~data")
  if(!opt){
    seqClose(object = gds)
    seqOptimize(gdsfile = gds$filename, target = "by.sample",
                format.var = c("AD", "FAD", "HAP", "CGT", "FGT"),
                verbose = verbose)
    gds <- seqOpen(gds.fn = gds$filename, readonly = FALSE)
  }

  # Create the GbsrGenotypeData class object
  d <- seqSummary(gdsfile = gds, varname = "genotype", verbose = FALSE)
  marker <- data.frame(valid = rep(TRUE, d$dim[3]))
  sample <- data.frame(valid = rep(TRUE, d$dim[2]))
  attributes(sample) <- c(attributes(sample), list(ploidy = ploidy))
  gds <- new(Class = "GbsrGenotypeData", gds, sample = sample, marker = marker)

  # Load filtering information if specified
  if(load_filter){
    if(exist.gdsn(gds, "sample.annotation/GFL")){
      validSam(gds) <- as.logical(read.gdsn(index.gdsn(gds, "sample.annotation/GFL")))
      validMar(gds) <- as.logical(read.gdsn(index.gdsn(gds, "annotation/info/GFL")))

    } else {
      warnings("No filtering information stored in the GDS.")
    }
  }
  return(gds)
}

.parseGBSRformat <- function(gds, ploidy){
  for(node in c("FGT", "CGT", "HAP")){
    gdsn <- paste0("annotation/format/", node)
    if(exist.gdsn(gds, gdsn)){
      message("Reformatting ", node)
      i_gdsn <- index.gdsn(gds, paste0(gdsn, "/data"))
      gdsn_dim <- objdesp.gdsn(i_gdsn)
      if(length(gdsn_dim$dim) != 3){
        if(node == "FGT"){storage <- "bit2"; na_val <- 3}
        if(node == "CGT"){storage <- "bit2"; na_val <- 3}
        if(node == "HAP"){storage <- "bit6"; na_val <- 0}

        tmp_gdsn <- add.gdsn(index.gdsn(gds, gdsn),
                             "tmp", NULL, storage, NULL,
                             replace = TRUE)
        apply.gdsn(i_gdsn, margin = 1,
                   function(x){
                     x <- unlist(strsplit(x, "\\||/"))
                     x[x == "."] <- na_val
                     x <- as.integer(x)
                     return(x)
                   },
                   as.is = "gdsnode",
                   target.node = tmp_gdsn)
        setdim.gdsn(tmp_gdsn, c(ploidy, gdsn_dim$dim[2], gdsn_dim$dim[1]))
        i_gdsn <- add.gdsn(index.gdsn(gds, gdsn),
                           "data", NULL, storage, NULL,
                           replace = TRUE)
        apply.gdsn(tmp_gdsn, margin = 2, c, as.is = "gdsnode",
                   target.node = i_gdsn)
        setdim.gdsn(i_gdsn, c(ploidy, gdsn_dim$dim[1], gdsn_dim$dim[2]))
        delete.gdsn(tmp_gdsn)
      }
    }
  }
}

vcf_fn <- system.file("extdata", "sample.vcf", package = "GBScleanR")
gds_fn <- tempfile("sample", fileext = ".gds")
gbsrVCF2GDS(vcf_fn, gds_fn, verbose = FALSE)
on.exit({unlink(gds_fn)})

test_that("Set valid markers", {
    gds <- loadGDS(gds_fn)
    all_true <- validMar(gds)
    expect_true(all(all_true))
    rundom_true <- sample(c(TRUE, FALSE), nmar(gds, FALSE), TRUE)
    validMar(gds) <- rundom_true
    expect_equal(validMar(gds), rundom_true)
    expect_equal(validMar(gds), rundom_true)
    closeGDS(gds)
})

test_that("Set valid samples", {
    gds <- loadGDS(gds_fn)
    all_true <- validSam(gds)
    expect_true(all(all_true))
    rundom_true <- sample(c(TRUE, FALSE), nsam(gds, FALSE), TRUE)
    validSam(gds) <- rundom_true
    expect_equal(validSam(gds), rundom_true)
    expect_equal(validSam(gds), rundom_true)
    closeGDS(gds)
})

test_that("Set parents", {
    gds <- loadGDS(gds_fn)
    parents <- c("Founder1", "Founder2")
    gds <- setParents(gds, parents)
    p_bool <- getParents(gds, TRUE)
    p_info <- getParents(gds)
    expect_equal(validSam(gds), !p_bool)
    expect_equal(p_info$memberID, 1:2)
    expect_equal(p_info$sampleID, parents)

    gds <- setParents(gds, parents)
    p_bool <- getParents(gds, TRUE)
    p_info <- getParents(gds)
    expect_equal(validSam(gds), !p_bool)
    expect_equal(p_info$memberID, 1:2)
    expect_equal(p_info$sampleID, parents)
    closeGDS(gds)
})

test_that("Set parents with checking monomorphic marker",{
    gds <- loadGDS(gds_fn)
    parents <- c("Founder1", "Founder2")
    gds <- setParents(gds, parents)
    gt <- getGenotype(gds, "raw", "only", FALSE, NULL)
    mono <- colSums(gt == 1) == 0
    gds <- setParents(gds, parents, mono = TRUE, bi = FALSE)
    expect_equal(validMar(gds), mono, ignore_attr = TRUE)
    gds <- setParents(gds, parents, mono = TRUE, bi = FALSE)
    expect_equal(validMar(gds), mono, ignore_attr = TRUE)
    closeGDS(gds)
})

test_that("Set parents with checking biallelic marker",{
    gds <- loadGDS(gds_fn)
    parents <- c("Founder1", "Founder2")
    gds <- setParents(gds, parents)
    geno <- getGenotype(gds, parents = "only")
    gt <- getGenotype(gds, "raw", "only", FALSE, NULL)
    bi <- colSums(gt == 0) != 0 | colSums(gt == 2) != 0
    gds <- setParents(gds, parents, mono = FALSE, bi = TRUE)
    expect_equal(validMar(gds), bi, ignore_attr = TRUE)
    gds <- setParents(gds, parents, mono = FALSE, bi = TRUE)
    expect_equal(validMar(gds), bi, ignore_attr = TRUE)
    closeGDS(gds)
})

test_that("Set parents with checking marker filtering",{
    gds <- loadGDS(gds_fn)
    parents <- c("Founder1", "Founder2")
    gds <- setParents(gds, parents)
    gt <- getGenotype(gds, "raw", "only", FALSE, NULL)
    mono <- colSums(gt == 1) == 0
    bi <- colSums(gt == 0) != 0 | colSums(gt == 2) != 0

    gds <- setParents(gds, parents, mono = TRUE, bi = TRUE)
    expect_equal(validMar(gds), bi & mono, ignore_attr = TRUE)
    closeGDS(gds)
})

vcf_fn <- system.file("extdata", "sample.vcf", package = "GBScleanR")
gds_fn <- tempfile("sample", fileext = ".gds")
gbsrVCF2GDS(vcf_fn, gds_fn, verbose = FALSE)
on.exit({unlink(gds_fn)})

test_that("Reference genotype", {
    gds <- loadGDS(gds_fn)
    gds <- countGenotype(gds)
    geno <- getGenotype(gds)
    expect_equal(getCountGenoRef(gds, "marker"), colSums(geno == 0, na.rm = TRUE),
                 ignore_attr = TRUE)
    expect_equal(getCountGenoRef(gds, "sample"), rowSums(geno == 0, na.rm = TRUE),
                 ignore_attr = TRUE)
    expect_equal(getCountGenoRef(gds, "marker", prop = TRUE),
                 colSums(geno == 0, na.rm = TRUE) / colSums(!is.na(geno)),
                 ignore_attr = TRUE)
    expect_equal(getCountGenoRef(gds, "sample", prop = TRUE),
                 rowSums(geno == 0, na.rm = TRUE)/ rowSums(!is.na(geno)),
                 ignore_attr = TRUE)

    valid_snp <- sample(c(TRUE, FALSE), nmar(gds), TRUE)
    validMar(gds) <- valid_snp
    valid_scan <- sample(c(TRUE, FALSE), nsam(gds), TRUE)
    validSam(gds) <- valid_scan
    gds <- countGenotype(gds)

    expect_equal(getCountGenoRef(gds, "marker", valid = TRUE),
                 colSums(geno[valid_scan, ] == 0, na.rm = TRUE)[valid_snp],
                 ignore_attr = TRUE)
    expect_equal(getCountGenoRef(gds, "sample", valid = TRUE),
                 rowSums(geno[, valid_snp] == 0, na.rm = TRUE)[valid_scan],
                 ignore_attr = TRUE)
    expect_equal(getCountGenoRef(gds, "marker", valid = TRUE, prop = TRUE),
                 (colSums(geno[valid_scan, ] == 0, na.rm = TRUE) /
                     colSums(!is.na(geno[valid_scan, ])))[valid_snp],
                 ignore_attr = TRUE)
    expect_equal(getCountGenoRef(gds, "sample", valid = TRUE, prop = TRUE),
                 (rowSums(geno[, valid_snp] == 0, na.rm = TRUE)/
                     rowSums(!is.na(geno[, valid_snp])))[valid_scan],
                 ignore_attr = TRUE)
    closeGDS(gds)
})

test_that("Heterozygous genotype", {
    gds <- loadGDS(gds_fn)
    gds <- countGenotype(gds)
    geno <- getGenotype(gds)
    expect_equal(getCountGenoHet(gds, "marker"), colSums(geno == 1, na.rm = TRUE),
                 ignore_attr = TRUE)
    expect_equal(getCountGenoHet(gds, "sample"), rowSums(geno == 1, na.rm = TRUE),
                 ignore_attr = TRUE)
    expect_equal(getCountGenoHet(gds, "marker", prop = TRUE),
                 colSums(geno == 1, na.rm = TRUE) / colSums(!is.na(geno)),
                 ignore_attr = TRUE)
    expect_equal(getCountGenoHet(gds, "sample", prop = TRUE),
                 rowSums(geno == 1, na.rm = TRUE)/ rowSums(!is.na(geno)),
                 ignore_attr = TRUE)

    valid_snp <- sample(c(TRUE, FALSE), nmar(gds), TRUE)
    validMar(gds) <- valid_snp
    valid_scan <- sample(c(TRUE, FALSE), nsam(gds), TRUE)
    validSam(gds) <- valid_scan
    gds <- countGenotype(gds)

    expect_equal(getCountGenoHet(gds, "marker", valid = TRUE),
                 colSums(geno[valid_scan, ] == 1, na.rm = TRUE)[valid_snp],
                 ignore_attr = TRUE)
    expect_equal(getCountGenoHet(gds, "sample", valid = TRUE),
                 rowSums(geno[, valid_snp] == 1, na.rm = TRUE)[valid_scan],
                 ignore_attr = TRUE)
    expect_equal(getCountGenoHet(gds, "marker", valid = TRUE, prop = TRUE),
                 (colSums(geno[valid_scan, ] == 1, na.rm = TRUE) /
                      colSums(!is.na(geno[valid_scan, ])))[valid_snp],
                 ignore_attr = TRUE)
    expect_equal(getCountGenoHet(gds, "sample", valid = TRUE, prop = TRUE),
                 (rowSums(geno[, valid_snp] == 1, na.rm = TRUE)/
                      rowSums(!is.na(geno[, valid_snp])))[valid_scan],
                 ignore_attr = TRUE)
    closeGDS(gds)
})


test_that("Alternative genotype", {
    gds <- loadGDS(gds_fn)
    gds <- countGenotype(gds)
    geno <- getGenotype(gds)
    expect_equal(getCountGenoAlt(gds, "marker"), colSums(geno == 2, na.rm = TRUE),
                 ignore_attr = TRUE)
    expect_equal(getCountGenoAlt(gds, "sample"), rowSums(geno == 2, na.rm = TRUE),
                 ignore_attr = TRUE)
    expect_equal(getCountGenoAlt(gds, "marker", prop = TRUE),
                 colSums(geno == 2, na.rm = TRUE) / colSums(!is.na(geno)),
                 ignore_attr = TRUE)
    expect_equal(getCountGenoAlt(gds, "sample", prop = TRUE),
                 rowSums(geno == 2, na.rm = TRUE)/ rowSums(!is.na(geno)),
                 ignore_attr = TRUE)

    valid_snp <- sample(c(TRUE, FALSE), nmar(gds), TRUE)
    validMar(gds) <- valid_snp
    valid_scan <- sample(c(TRUE, FALSE), nsam(gds), TRUE)
    validSam(gds) <- valid_scan
    gds <- countGenotype(gds)

    expect_equal(getCountGenoAlt(gds, "marker", valid = TRUE),
                 colSums(geno[valid_scan, ] == 2, na.rm = TRUE)[valid_snp],
                 ignore_attr = TRUE)
    expect_equal(getCountGenoAlt(gds, "sample", valid = TRUE),
                 rowSums(geno[, valid_snp] == 2, na.rm = TRUE)[valid_scan],
                 ignore_attr = TRUE)
    expect_equal(getCountGenoAlt(gds, "marker", valid = TRUE, prop = TRUE),
                 (colSums(geno[valid_scan, ] == 2, na.rm = TRUE) /
                      colSums(!is.na(geno[valid_scan, ])))[valid_snp],
                 ignore_attr = TRUE)
    expect_equal(getCountGenoAlt(gds, "sample", valid = TRUE, prop = TRUE),
                 (rowSums(geno[, valid_snp] == 2, na.rm = TRUE)/
                      rowSums(!is.na(geno[, valid_snp])))[valid_scan],
                 ignore_attr = TRUE)
    closeGDS(gds)
})

test_that("Missing genotype", {
    gds <- loadGDS(gds_fn)
    gds <- countGenotype(gds)
    geno <- getGenotype(gds)
    expect_equal(getCountGenoMissing(gds, "marker"), colSums(is.na(geno)),
                 ignore_attr = TRUE)
    expect_equal(getCountGenoMissing(gds, "sample"), rowSums(is.na(geno)),
                 ignore_attr = TRUE)
    expect_equal(getCountGenoMissing(gds, "marker", prop = TRUE),
                 colSums(is.na(geno)) / nrow(geno),
                 ignore_attr = TRUE)
    expect_equal(getCountGenoMissing(gds, "sample", prop = TRUE),
                 rowSums(is.na(geno))/ ncol(geno),
                 ignore_attr = TRUE)

    valid_snp <- sample(c(TRUE, FALSE), nmar(gds), TRUE)
    validMar(gds) <- valid_snp
    valid_scan <- sample(c(TRUE, FALSE), nsam(gds), TRUE)
    validSam(gds) <- valid_scan
    gds <- countGenotype(gds)

    expect_equal(getCountGenoMissing(gds, "marker"),
                 colSums(is.na(geno[valid_scan, ]))[valid_snp],
                 ignore_attr = TRUE)
    expect_equal(getCountGenoMissing(gds, "sample"),
                 rowSums(is.na(geno[, valid_snp]))[valid_scan],
                 ignore_attr = TRUE)
    expect_equal(getCountGenoMissing(gds, "marker", prop = TRUE),
                 colSums(is.na(geno[valid_scan, ]))[valid_snp] /
                     nrow(geno[valid_scan, ]),
                 ignore_attr = TRUE)
    expect_equal(getCountGenoMissing(gds, "sample", prop = TRUE),
                 rowSums(is.na(geno[, valid_snp]))[valid_scan] /
                     ncol(geno[, valid_snp]),
                 ignore_attr = TRUE)
    closeGDS(gds)
})

test_that("Reference allele", {
    gds <- loadGDS(gds_fn)
    gds <- countGenotype(gds)
    geno <- getGenotype(gds)
    expect_equal(getCountAlleleRef(gds, "marker"),
                 colSums(geno == 0, na.rm = TRUE) * 2 +
                     colSums(geno == 1, na.rm = TRUE),
                 ignore_attr = TRUE)
    expect_equal(getCountAlleleRef(gds, "sample"),
                 rowSums(geno == 0, na.rm = TRUE) * 2 +
                     rowSums(geno == 1, na.rm = TRUE),
                 ignore_attr = TRUE)
    expect_equal(getCountAlleleRef(gds, "marker", prop = TRUE),
                 (colSums(geno == 0, na.rm = TRUE) * 2 +
                     colSums(geno == 1, na.rm = TRUE)) / colSums(!is.na(geno)) / 2,
                 ignore_attr = TRUE)
    expect_equal(getCountAlleleRef(gds, "sample", prop = TRUE),
                 (rowSums(geno == 0, na.rm = TRUE) * 2 +
                     rowSums(geno == 1, na.rm = TRUE)) / rowSums(!is.na(geno)) / 2,
                 ignore_attr = TRUE)

    valid_snp <- sample(c(TRUE, FALSE), nmar(gds), TRUE)
    validMar(gds) <- valid_snp
    valid_scan <- sample(c(TRUE, FALSE), nsam(gds), TRUE)
    validSam(gds) <- valid_scan
    gds <- countGenotype(gds)

    expect_equal(getCountAlleleRef(gds, "marker", valid = TRUE),
                 (colSums(geno[valid_scan, ] == 0, na.rm = TRUE) * 2 +
                      colSums(geno[valid_scan, ] == 1, na.rm = TRUE))[valid_snp],
                 ignore_attr = TRUE)
    expect_equal(getCountAlleleRef(gds, "sample", valid = TRUE),
                 (rowSums(geno[, valid_snp] == 0, na.rm = TRUE) * 2 +
                      rowSums(geno[, valid_snp] == 1, na.rm = TRUE))[valid_scan],
                 ignore_attr = TRUE)
    expect_equal(getCountAlleleRef(gds, "marker", prop = TRUE),
                 ((colSums(geno[valid_scan, ] == 0, na.rm = TRUE) * 2 +
                      colSums(geno[valid_scan, ] == 1, na.rm = TRUE)) /
                     colSums(!is.na(geno[valid_scan, ])) / 2)[valid_snp],
                 ignore_attr = TRUE)
    expect_equal(getCountAlleleRef(gds, "sample", prop = TRUE),
                 ((rowSums(geno[, valid_snp] == 0, na.rm = TRUE) * 2 +
                      rowSums(geno[, valid_snp] == 1, na.rm = TRUE)) /
                     rowSums(!is.na(geno[, valid_snp])) / 2)[valid_scan],
                 ignore_attr = TRUE)
    closeGDS(gds)
})


test_that("Alternative allele", {
    gds <- loadGDS(gds_fn)
    gds <- countGenotype(gds)
    geno <- getGenotype(gds)
    expect_equal(getCountAlleleAlt(gds, "marker"),
                 colSums(geno == 2, na.rm = TRUE) * 2 +
                     colSums(geno == 1, na.rm = TRUE),
                 ignore_attr = TRUE)
    expect_equal(getCountAlleleAlt(gds, "sample"),
                 rowSums(geno == 2, na.rm = TRUE) * 2 +
                     rowSums(geno == 1, na.rm = TRUE),
                 ignore_attr = TRUE)
    expect_equal(getCountAlleleAlt(gds, "marker", prop = TRUE),
                 (colSums(geno == 2, na.rm = TRUE) * 2 +
                      colSums(geno == 1, na.rm = TRUE)) / colSums(!is.na(geno)) / 2,
                 ignore_attr = TRUE)
    expect_equal(getCountAlleleAlt(gds, "sample", prop = TRUE),
                 (rowSums(geno == 2, na.rm = TRUE) * 2 +
                      rowSums(geno == 1, na.rm = TRUE)) / rowSums(!is.na(geno)) / 2,
                 ignore_attr = TRUE)

    valid_snp <- sample(c(TRUE, FALSE), nmar(gds), TRUE)
    validMar(gds) <- valid_snp
    valid_scan <- sample(c(TRUE, FALSE), nsam(gds), TRUE)
    validSam(gds) <- valid_scan
    gds <- countGenotype(gds)

    expect_equal(getCountAlleleAlt(gds, "marker", valid = TRUE),
                 (colSums(geno[valid_scan, ] == 2, na.rm = TRUE) * 2 +
                      colSums(geno[valid_scan, ] == 1, na.rm = TRUE))[valid_snp],
                 ignore_attr = TRUE)
    expect_equal(getCountAlleleAlt(gds, "sample", valid = TRUE),
                 (rowSums(geno[, valid_snp] == 2, na.rm = TRUE) * 2 +
                      rowSums(geno[, valid_snp] == 1, na.rm = TRUE))[valid_scan],
                 ignore_attr = TRUE)
    expect_equal(getCountAlleleAlt(gds, "marker", prop = TRUE),
                 ((colSums(geno[valid_scan, ] == 2, na.rm = TRUE) * 2 +
                       colSums(geno[valid_scan, ] == 1, na.rm = TRUE)) /
                      colSums(!is.na(geno[valid_scan, ])) / 2)[valid_snp],
                 ignore_attr = TRUE)
    expect_equal(getCountAlleleAlt(gds, "sample", prop = TRUE),
                 ((rowSums(geno[, valid_snp] == 2, na.rm = TRUE) * 2 +
                       rowSums(geno[, valid_snp] == 1, na.rm = TRUE)) /
                      rowSums(!is.na(geno[, valid_snp])) / 2)[valid_scan],
                 ignore_attr = TRUE)
    closeGDS(gds)
})


test_that("Missing allele", {
    gds <- loadGDS(gds_fn)
    gds <- countGenotype(gds)
    geno <- getGenotype(gds)
    expect_equal(getCountAlleleMissing(gds, "marker"),
                 colSums(is.na(geno)) * 2,
                 ignore_attr = TRUE)
    expect_equal(getCountAlleleMissing(gds, "sample"),
                 rowSums(is.na(geno)) * 2,
                 ignore_attr = TRUE)
    expect_equal(getCountAlleleMissing(gds, "marker", prop = TRUE),
                 (colSums(is.na(geno)) * 2) / (nrow(geno) * 2),
                 ignore_attr = TRUE)
    expect_equal(getCountAlleleMissing(gds, "sample", prop = TRUE),
                 (rowSums(is.na(geno)) * 2) / (ncol(geno) * 2),
                 ignore_attr = TRUE)

    valid_snp <- sample(c(TRUE, FALSE), nmar(gds), TRUE)
    validMar(gds) <- valid_snp
    valid_scan <- sample(c(TRUE, FALSE), nsam(gds), TRUE)
    validSam(gds) <- valid_scan
    gds <- countGenotype(gds)

    expect_equal(getCountAlleleMissing(gds, "marker", valid = TRUE),
                 (colSums(is.na(geno[valid_scan, ])) * 2)[valid_snp],
                 ignore_attr = TRUE)
    expect_equal(getCountAlleleMissing(gds, "sample", valid = TRUE),
                 (rowSums(is.na(geno[, valid_snp])) * 2)[valid_scan],
                 ignore_attr = TRUE)
    expect_equal(getCountAlleleMissing(gds, "marker", prop = TRUE),
                 ((colSums(is.na(geno[valid_scan, ])) * 2) /
                     (nrow(geno[valid_scan, ]) * 2))[valid_snp],
                 ignore_attr = TRUE)
    expect_equal(getCountAlleleMissing(gds, "sample", prop = TRUE),
                 ((rowSums(is.na(geno[, valid_snp])) * 2) /
                     (ncol(geno[, valid_snp]) * 2))[valid_scan],
                 ignore_attr = TRUE)
    closeGDS(gds)
})

test_that("Minor allele frequency", {
    gds <- loadGDS(gds_fn)
    gds <- countGenotype(gds)
    geno <- getGenotype(gds)
    ref_f <- colSums(geno == 2, na.rm = TRUE) * 2 + colSums(geno == 1, na.rm = TRUE)
    alt_f <- colSums(geno == 0, na.rm = TRUE) * 2 + colSums(geno == 1, na.rm = TRUE)
    alt_minor <- ref_f > alt_f
    maf <- ref_f
    maf[alt_minor] <- alt_f[alt_minor]
    maf <- maf / (ref_f + alt_f)
    expect_equal(getMAF(gds, "marker"), maf, ignore_attr = TRUE)

    ref_f <- rowSums(geno == 2, na.rm = TRUE) * 2 + rowSums(geno == 1, na.rm = TRUE)
    alt_f <- rowSums(geno == 0, na.rm = TRUE) * 2 + rowSums(geno == 1, na.rm = TRUE)
    alt_minor <- ref_f > alt_f
    maf <- ref_f
    maf[alt_minor] <- alt_f[alt_minor]
    maf <- maf / (ref_f + alt_f)
    expect_equal(getMAF(gds, "sample"), maf, ignore_attr = TRUE)

    valid_snp <- sample(c(TRUE, FALSE), nmar(gds), TRUE)
    validMar(gds) <- valid_snp
    valid_scan <- sample(c(TRUE, FALSE), nsam(gds), TRUE)
    validSam(gds) <- valid_scan
    gds <- countGenotype(gds)

    ref_f <- colSums(geno[valid_scan, ] == 2, na.rm = TRUE) * 2 +
        colSums(geno[valid_scan, ] == 1, na.rm = TRUE)
    alt_f <- colSums(geno[valid_scan, ] == 0, na.rm = TRUE) * 2 +
        colSums(geno[valid_scan, ] == 1, na.rm = TRUE)
    alt_minor <- ref_f > alt_f
    maf <- ref_f
    maf[alt_minor] <- alt_f[alt_minor]
    maf <- maf / (ref_f + alt_f)
    expect_equal(getMAF(gds, "marker", valid = TRUE),
                 maf[valid_snp], ignore_attr = TRUE)

    ref_f <- rowSums(geno[, valid_snp] == 2, na.rm = TRUE) * 2 +
        rowSums(geno[, valid_snp] == 1, na.rm = TRUE)
    alt_f <- rowSums(geno[, valid_snp] == 0, na.rm = TRUE) * 2 +
        rowSums(geno[, valid_snp] == 1, na.rm = TRUE)
    alt_minor <- ref_f > alt_f
    maf <- ref_f
    maf[alt_minor] <- alt_f[alt_minor]
    maf <- maf / (ref_f + alt_f)
    expect_equal(getMAF(gds, "sample", valid = TRUE),
                 maf[valid_scan], ignore_attr = TRUE)
    closeGDS(gds)
})


test_that("Minor allele count", {
    gds <- loadGDS(gds_fn)
    gds <- countGenotype(gds)
    geno <- getGenotype(gds)
    ref_f <- colSums(geno == 2, na.rm = TRUE) * 2 + colSums(geno == 1, na.rm = TRUE)
    alt_f <- colSums(geno == 0, na.rm = TRUE) * 2 + colSums(geno == 1, na.rm = TRUE)
    alt_minor <- ref_f > alt_f
    mac <- ref_f
    mac[alt_minor] <- alt_f[alt_minor]
    expect_equal(getMAC(gds, "marker"), mac, ignore_attr = TRUE)

    ref_f <- rowSums(geno == 2, na.rm = TRUE) * 2 + rowSums(geno == 1, na.rm = TRUE)
    alt_f <- rowSums(geno == 0, na.rm = TRUE) * 2 + rowSums(geno == 1, na.rm = TRUE)
    alt_minor <- ref_f > alt_f
    mac <- ref_f
    mac[alt_minor] <- alt_f[alt_minor]
    expect_equal(getMAC(gds, "sample"), mac, ignore_attr = TRUE)

    valid_snp <- sample(c(TRUE, FALSE), nmar(gds), TRUE)
    validMar(gds) <- valid_snp
    valid_scan <- sample(c(TRUE, FALSE), nsam(gds), TRUE)
    validSam(gds) <- valid_scan
    gds <- countGenotype(gds)

    ref_f <- colSums(geno[valid_scan, ] == 2, na.rm = TRUE) * 2 +
        colSums(geno[valid_scan, ] == 1, na.rm = TRUE)
    alt_f <- colSums(geno[valid_scan, ] == 0, na.rm = TRUE) * 2 +
        colSums(geno[valid_scan, ] == 1, na.rm = TRUE)
    alt_minor <- ref_f > alt_f
    mac <- ref_f
    mac[alt_minor] <- alt_f[alt_minor]
    expect_equal(getMAC(gds, "marker", valid = TRUE),
                 mac[valid_snp], ignore_attr = TRUE)

    ref_f <- rowSums(geno[, valid_snp] == 2, na.rm = TRUE) * 2 +
        rowSums(geno[, valid_snp] == 1, na.rm = TRUE)
    alt_f <- rowSums(geno[, valid_snp] == 0, na.rm = TRUE) * 2 +
        rowSums(geno[, valid_snp] == 1, na.rm = TRUE)
    alt_minor <- ref_f > alt_f
    mac <- ref_f
    mac[alt_minor] <- alt_f[alt_minor]
    expect_equal(getMAC(gds, "sample", valid = TRUE),
                 mac[valid_scan], ignore_attr = TRUE)
    closeGDS(gds)
})

vcf_fn <- system.file("extdata", "sample.vcf", package = "GBScleanR")
gds_fn <- tempfile("sample", fileext = ".gds")
gbsrVCF2GDS(vcf_fn, gds_fn, verbose = FALSE)
on.exit({unlink(gds_fn)})

test_that("estGeno", {
    gds <- loadGDS(gds_fn)
    gds <- setParents(gds, grep("Founder", getSamID(gds), value=TRUE))
    gds <- initScheme(gds, cbind(c(1:2)))
    gds <- addScheme(gds, "self")
    gds <- estGeno(gds)
    p_hap <- getHaplotype(gds, parents = "only")
    expect_true(all(p_hap[,1,] == 1))
    expect_true(all(p_hap[,2,] == 2))
    hap <- getHaplotype(gds)
    expect_true(all(dim(hap) == c(2, nsam(gds), nmar(gds))))
    p_geno <- getGenotype(gds, node = "parents")
    expect_true(nrow(p_geno) == sum(getParents(gds, TRUE)) * 2)
    expect_true(ncol(p_geno) == nmar(gds, FALSE))
    cor_geno <- getGenotype(gds, "cor")
    expect_equal(dim(cor_geno), c(nsam(gds), nmar(gds)))
    closeGDS(gds)
})

library(SeqArray)

vcf_fn <- system.file("extdata", "sample.vcf", package = "GBScleanR")
gds_fn <- tempfile("sample", fileext = ".gds")
gbsrVCF2GDS(vcf_fn, gds_fn, verbose = FALSE)
on.exit({unlink(gds_fn)})

test_that("Number of markers",
          {
              gds <- loadGDS(gds_fn)
              expect_equal(nmar(gds),
                           length(seqGetData(gds, "chromosome")))
              expect_equal(nmar(gds, chr = 1),
                           length(seqGetData(gds, "chromosome") == 1))
              expect_equal(nmar(gds, chr = 100), 0)
              expect_equal(nmar(gds, valid=FALSE),
                           length(seqGetData(gds, "chromosome")))
              expect_equal(nmar(gds, valid=TRUE),
                           length(seqGetData(gds, "chromosome")))
              new_validity <- sample(c(TRUE, FALSE), nmar(gds, FALSE), TRUE)
              validMar(gds) <- new_validity
              expect_equal(nmar(gds, valid=FALSE),
                           length(seqGetData(gds, "chromosome")))
              expect_equal(nmar(gds, valid=TRUE), sum(new_validity))
              closeGDS(gds)
          })

test_that("Number of samples",
          {
              gds <- loadGDS(gds_fn)
              expect_equal(nsam(gds),
                           length(seqGetData(gds, "sample.id")))
              expect_equal(nsam(gds, valid=FALSE),
                           length(seqGetData(gds, "sample.id")))
              expect_equal(nsam(gds, valid=TRUE),
                           length(seqGetData(gds, "sample.id")))
              new_validity <- sample(c(TRUE, FALSE), nsam(gds, FALSE), TRUE)
              validSam(gds) <- new_validity
              expect_equal(nsam(gds, valid=FALSE),
                           length(seqGetData(gds, "sample.id")))
              expect_equal(nsam(gds, valid=TRUE), sum(new_validity))
              closeGDS(gds)
          })

test_that("Chromosome names",
          {
              gds <- loadGDS(gds_fn)
              expect_equal(getChromosome(gds),
                           seqGetData(gds, "chromosome"))
              new_validity <- sample(c(TRUE, FALSE), nmar(gds, FALSE), TRUE)
              validMar(gds) <- new_validity
              expect_equal(getChromosome(gds, valid = FALSE),
                           seqGetData(gds, "chromosome"))
              expect_equal(getChromosome(gds, valid = TRUE),
                           seqGetData(gds, "chromosome")[new_validity])
              closeGDS(gds)
          })


test_that("Marker positions",
          {
              gds <- loadGDS(gds_fn)
              expect_equal(getPosition(gds),
                           seqGetData(gds, "position"))
              expect_equal(getPosition(gds, valid=FALSE),
                           seqGetData(gds, "position"))
              expect_equal(getPosition(gds, valid=TRUE),
                           seqGetData(gds, "position"))
              new_validity <- sample(c(TRUE, FALSE), nmar(gds, FALSE), TRUE)
              validMar(gds) <- new_validity
              expect_equal(getPosition(gds, valid=FALSE),
                           seqGetData(gds, "position"))
              expect_equal(getPosition(gds, valid=TRUE),
                           seqGetData(gds, "position")[new_validity])
              chr_i <- seqGetData(gds, "chromosome") == 1
              expect_equal(getPosition(gds, valid=TRUE, chr = 1),
                           seqGetData(gds, "position")[new_validity & chr_i])
              chr_i <- seqGetData(gds, "chromosome") == 100
              expect_error(getPosition(gds, valid=TRUE, chr = 100),
                           "Nothing to return.")
              closeGDS(gds)
          })

test_that("Reference allele",
          {
              gds <- loadGDS(gds_fn)
              expect_equal(getAllele(gds),
                           seqGetData(gds, "allele"))
              expect_equal(getAllele(gds, valid=FALSE),
                           seqGetData(gds, "allele"))
              expect_equal(getAllele(gds, valid=TRUE),
                           seqGetData(gds, "allele"))
              new_validity <- sample(c(TRUE, FALSE), nmar(gds, FALSE), TRUE)
              validMar(gds) <- new_validity
              expect_equal(getAllele(gds, valid=FALSE),
                           seqGetData(gds, "allele"))
              expect_equal(getAllele(gds, valid=TRUE),
                           seqGetData(gds, "allele")[new_validity])
              chr_i <- seqGetData(gds, "chromosome") == 1
              expect_equal(getAllele(gds, valid=TRUE, chr = 1),
                           seqGetData(gds, "allele")[new_validity & chr_i])
              chr_i <- seqGetData(gds, "chromosome") == 100
              expect_error(getAllele(gds, valid=TRUE, chr = 100),
                           "Nothing to return.")
              closeGDS(gds)
          })

test_that("Marker ID",
          {
              gds <- loadGDS(gds_fn)
              expect_equal(getMarID(gds),
                           seqGetData(gds, "variant.id"))
              expect_equal(getMarID(gds, valid=FALSE),
                           seqGetData(gds, "variant.id"))
              expect_equal(getMarID(gds, valid=TRUE),
                           seqGetData(gds, "variant.id"))
              new_validity <- sample(c(TRUE, FALSE), nmar(gds), TRUE)
              validMar(gds) <- new_validity
              expect_equal(getMarID(gds, valid=FALSE),
                           seqGetData(gds, "variant.id"))
              expect_equal(getMarID(gds, valid=TRUE),
                           seqGetData(gds, "variant.id")[new_validity])
              chr_i <- seqGetData(gds, "chromosome") == 1
              expect_equal(getMarID(gds, valid=TRUE, chr = 1),
                           seqGetData(gds, "variant.id")[new_validity & chr_i])
              chr_i <- seqGetData(gds, "chromosome") == 100
              expect_error(getMarID(gds, valid=TRUE, chr = 100),
                           "Nothing to return.")
              closeGDS(gds)
          })

test_that("Sample ID",
          {
              gds <- loadGDS(gds_fn)
              expect_equal(getSamID(gds),
                           seqGetData(gds, "sample.id"))
              expect_equal(getSamID(gds, valid=FALSE),
                           seqGetData(gds, "sample.id"))
              expect_equal(getSamID(gds, valid=TRUE),
                           seqGetData(gds, "sample.id"))
              new_validity <- sample(c(TRUE, FALSE), nsam(gds), TRUE)
              validSam(gds) <- new_validity
              expect_equal(getSamID(gds, valid=FALSE),
                           seqGetData(gds, "sample.id"))
              expect_equal(getSamID(gds, valid=TRUE),
                           seqGetData(gds, "sample.id")[new_validity])
              closeGDS(gds)
          })

library(gdsfmt)
test_that("Read data",
          {
              gds <- loadGDS(gds_fn)
              expect_type(getRead(gds), "list")
              expect_equal(length(getRead(gds)), 2)
              expect_equal(names(getRead(gds)), c("ref", "alt"))
              read <- read.gdsn(index.gdsn(gds, "annotation/format/AD/data"))
              ref <- read[, c(TRUE, FALSE)]
              alt <- read[, c(FALSE, TRUE)]
              get_read <- getRead(gds, valid = FALSE)
              expect_equal(get_read$ref, ref, ignore_attr = TRUE)
              expect_equal(get_read$alt, alt, ignore_attr = TRUE)

              get_read <- getRead(gds, valid = TRUE)
              expect_equal(get_read$ref, ref, ignore_attr = TRUE)
              expect_equal(get_read$alt, alt, ignore_attr = TRUE)

              valid_snp <- sample(c(TRUE, FALSE), nmar(gds, FALSE), TRUE)
              validMar(gds) <- valid_snp
              valid_scan <- sample(c(TRUE, FALSE), nsam(gds, FALSE), TRUE)
              validSam(gds) <- valid_scan

              get_read <- getRead(gds, valid = FALSE)
              expect_equal(get_read$ref, ref, ignore_attr = TRUE)
              expect_equal(get_read$alt, alt, ignore_attr = TRUE)

              get_read <- getRead(gds, valid = TRUE)
              expect_equal(get_read$ref, ref[valid_scan, valid_snp],
                           ignore_attr = TRUE)
              expect_equal(get_read$alt, alt[valid_scan, valid_snp],
                           ignore_attr = TRUE)

              get_read <- getRead(gds, valid = TRUE, chr = 1)
              expect_equal(get_read$ref, ref[valid_scan, validMar(gds, chr = 1)],
                           ignore_attr = TRUE)
              expect_equal(get_read$alt, alt[valid_scan, validMar(gds, 1)],
                           ignore_attr = TRUE)
              closeGDS(gds)
          })


test_that("Genotype data",
          {
              gds <- loadGDS(gds_fn)
              geno <- read.gdsn(index.gdsn(gds, "genotype/data"))
              geno[geno == 3] <- NA
              geno <- apply(geno, 3, colSums)
              expect_equal(getGenotype(gds, valid = FALSE), geno, ignore_attr = TRUE)
              expect_equal(getGenotype(gds, valid = TRUE), geno, ignore_attr = TRUE)

              valid_snp <- sample(c(TRUE, FALSE), nmar(gds, FALSE), TRUE)
              validMar(gds) <- valid_snp
              valid_scan <- sample(c(TRUE, FALSE), nsam(gds, FALSE), TRUE)
              validSam(gds) <- valid_scan

              expect_equal(getGenotype(gds, valid = FALSE), geno, ignore_attr = TRUE)
              expect_equal(getGenotype(gds, valid = TRUE),
                           geno[validSam(gds), validMar(gds)],
                           ignore_attr = TRUE)

              expect_equal(getGenotype(gds, valid = TRUE, chr = 1),
                           geno[validSam(gds), validMar(gds, 1)],
                           ignore_attr = TRUE)
              expect_error(getGenotype(gds, valid = TRUE, chr = 100),
                           "Nothing to return.")
              closeGDS(gds)
              })

test_that("Hapotype data",
          {
              gds <- loadGDS(gds_fn)
              expect_error(getHaplotype(gds), "Nothing to return.")
              closeGDS(gds)
          })

test_that("gbsrGDS2VCF", {
    if(Sys.info()["sysname"] != "Windows"){
        vcf_fn <- system.file("extdata", "sample.vcf", package = "GBScleanR")
        gds_fn <- tempfile("sample", fileext = ".gds")
        gbsrVCF2GDS(vcf_fn, gds_fn)
        on.exit({unlink(gds_fn)})
        gds <- loadGDS(gds_fn)
        
        out_fn <- tempfile("out", fileext = ".vcf")
        
        valid_snp <- sample(c(TRUE, FALSE), nmar(gds), replace = TRUE)
        valid_scan <- sample(c(TRUE, FALSE), nsam(gds), replace = TRUE)
        validMar(gds) <- valid_snp
        validSam(gds) <- valid_scan
        out_fn <- tempfile("out", fileext = ".vcf")
        gbsrGDS2VCF(gds, out_fn)
        new_gds <- tempfile("newgds", fileext = ".gds")
        gbsrVCF2GDS(out_fn, new_gds)
        newgds <- loadGDS(new_gds)
        expect_equal(nmar(newgds), nmar(gds), ignore_attr = TRUE)
        expect_equal(nsam(newgds), nsam(gds), ignore_attr = TRUE)
        expect_equal(getRead(newgds), getRead(gds), ignore_attr = TRUE)
        expect_equal(getGenotype(newgds), getGenotype(gds), ignore_attr = TRUE)
        
        gds <- setCallFilter(gds, dp_qtile = c(0, 0.8))
        out_fn <- tempfile("out", fileext = ".vcf")
        gbsrGDS2VCF(gds, out_fn)
        new_gds <- tempfile("newgds", fileext = ".gds")
        gbsrVCF2GDS(out_fn, new_gds)
        newgds <- loadGDS(new_gds)
        expect_equal(nmar(newgds), nmar(gds), ignore_attr = TRUE)
        expect_equal(nsam(newgds), nsam(gds), ignore_attr = TRUE)
        expect_equal(getRead(newgds, node = "filt"),
                     getRead(gds, node = "filt"),
                     ignore_attr = TRUE)
        expect_equal(getGenotype(newgds, node = "filt"),
                     getGenotype(gds, node = "filt"),
                     ignore_attr = TRUE)
        closeGDS(newgds)
        closeGDS(gds)
    }
})

vcf_fn <- system.file("extdata", "sample.vcf", package = "GBScleanR")
gds_fn <- tempfile("sample", fileext = ".gds")
gbsrVCF2GDS(vcf_fn, gds_fn, verbose = FALSE)
on.exit({unlink(gds_fn)})

test_that("Thin out markers", {
    gds <- loadGDS(gds_fn)
    gds <- countGenotype(gds)
    range <- 10000
    expect_error(thinMarker(gds, range = -1000), "range should be")
    expect_error(thinMarker(gds, range = "1000"),"range should be")

    gds <- thinMarker(gds, range = range)
    pos <- getPosition(gds, FALSE)
    chr <- getChromosome(gds, FALSE)
    missing <- getCountGenoMissing(gds, valid = FALSE)
    valid <- tapply(seq_along(pos), chr , function(x){
        x <- seq_along(pos)
        n_snp <- length(x)
        x_pos <- pos[x]
        x_missing <- missing[x]
        valid <- rep(TRUE, n_snp)
        i <- 1
        j <- 2
        while (TRUE){
            mar1 <- x_pos[i]
            mar2 <- x_pos[j]
            if(mar2 - mar1 <= range){
                if(x_missing[i] <= x_missing[j]){
                    valid[j] <- FALSE
                    j <- j + 1
                } else {
                    valid[i] <- FALSE
                    i <- j
                    j <- j + 1
                }
            } else {
                i <- j
                j <- j + 1
            }
            if(j > n_snp){
                break
            }
        }
        return(valid)
    })
    expect_equal(validMar(gds), unlist(valid), ignore_attr = TRUE)
    closeGDS(gds)
})

test_that("Sample filtering", {
    gds <- loadGDS(gds_fn)
    gds <- countRead(gds)
    gds <- countGenotype(gds)

    expect_error(setSamFilter(gds, id = 1:100))
    omit_id <- sample(getSamID(gds), 10)
    gds <- setSamFilter(gds, id = omit_id)
    expect_false(any(getSamID(gds) %in% omit_id))

    gds <- resetSamFilter(gds)
    missing <- getCountGenoMissing(gds, "sample", FALSE, TRUE)
    expect_error(setSamFilter(gds, missing = 10))
    expect_error(setSamFilter(gds, missing = "0.2"))
    gds <- setSamFilter(gds, missing = 0.2)
    expect_equal(validSam(gds), missing <= 0.2)

    gds <- resetSamFilter(gds)
    het <- getCountGenoHet(gds, "sample", FALSE, TRUE)
    expect_error(setSamFilter(gds, het = 10))
    expect_error(setSamFilter(gds, het = "0.2"))
    gds <- setSamFilter(gds, het = c(0.25, 0.75))
    expect_equal(validSam(gds), het >= 0.25 & het <= 0.75)

    gds <- resetSamFilter(gds)
    mac <- getMAC(gds, "sample", FALSE)
    expect_error(setSamFilter(gds, mac = -10))
    expect_error(setSamFilter(gds, mac = "100"))
    gds <- setSamFilter(gds, mac = 100)
    expect_equal(validSam(gds), mac >= 100)

    gds <- resetSamFilter(gds)
    maf <- getMAF(gds, "sample", FALSE)
    expect_error(setSamFilter(gds, maf = 10))
    expect_error(setSamFilter(gds, maf = "0.2"))
    gds <- setSamFilter(gds, maf = 0.25)
    expect_equal(validSam(gds), maf >= 0.25)

    gds <- resetSamFilter(gds)
    ad_ref <- getCountReadRef(gds, "sample", FALSE)
    expect_error(setSamFilter(gds, ad_ref = -1000))
    expect_error(setSamFilter(gds, ad_ref = "1000"))
    gds <- setSamFilter(gds, ad_ref = c(1000, 2000))
    expect_equal(validSam(gds), ad_ref >= 1000 & ad_ref <= 2000)

    gds <- resetSamFilter(gds)
    ad_alt <- getCountReadAlt(gds, "sample", FALSE)
    expect_error(setSamFilter(gds, ad_alt = -100))
    expect_error(setSamFilter(gds, ad_alt = "1000"))
    gds <- setSamFilter(gds, ad_alt = c(1000, 1500))
    expect_equal(validSam(gds), ad_alt >= 1000 & ad_alt <= 1500)

    gds <- resetSamFilter(gds)
    dp <- getCountRead(gds, "sample", FALSE)
    expect_error(setSamFilter(gds, dp = -100))
    expect_error(setSamFilter(gds, dp = "1000"))
    gds <- setSamFilter(gds, dp = c(1000, 2000))
    expect_equal(validSam(gds), dp >= 1000 & dp <= 2000)

    gds <- resetSamFilter(gds)
    mean_ref <- getMeanReadRef(gds, "sample", FALSE)
    expect_error(setSamFilter(gds, mean_ref = -100))
    expect_error(setSamFilter(gds, mean_ref = "1000"))
    gds <- setSamFilter(gds, mean_ref = c(1000, 2000))
    expect_equal(validSam(gds), mean_ref >= 1000 & mean_ref <= 2000)

    gds <- resetSamFilter(gds)
    mean_alt <- getMeanReadAlt(gds, "sample", FALSE)
    expect_error(setSamFilter(gds, mean_alt = -100))
    expect_error(setSamFilter(gds, mean_alt = "1000"))
    gds <- setSamFilter(gds, mean_alt = c(1000, 1500))
    expect_equal(validSam(gds), mean_alt >= 1000 & mean_alt <= 1500)

    gds <- resetSamFilter(gds)
    sd_ref <- getSDReadRef(gds, "sample", FALSE)
    expect_error(setSamFilter(gds, sd_ref = -100))
    expect_error(setSamFilter(gds, sd_ref = "1000"))
    gds <- setSamFilter(gds, sd_ref = 2000)
    expect_equal(validSam(gds), sd_ref <= 2000)

    gds <- resetSamFilter(gds)
    sd_alt <- getSDReadAlt(gds, "sample", FALSE)
    expect_error(setSamFilter(gds, sd_alt = -100))
    expect_error(setSamFilter(gds, sd_alt = "1000"))
    gds <- setSamFilter(gds, sd_alt = 2000)
    expect_equal(validSam(gds), sd_alt <= 2000)

    gds <- resetSamFilter(gds)
    valid <- !(getSamID(gds) %in% omit_id) & missing <= 0.2 &
        het >= 0.25 & het <= 0.75 & maf >= 0.25
    gds <- setSamFilter(gds, id = omit_id, missing = 0.2,
                         het = c(0.25, 0.75), maf = 0.25)
    expect_equal(validSam(gds), valid)
    closeGDS(gds)
})


test_that("Marker filtering", {
    gds <- loadGDS(gds_fn)
    gds <- countRead(gds)
    gds <- countGenotype(gds)

    expect_error(setMarFilter(gds, id = "100"))
    omit_id <- sample(getMarID(gds), 10)
    gds <- setMarFilter(gds, id = omit_id)
    expect_false(any(getMarID(gds) %in% omit_id))

    gds <- resetMarFilter(gds)
    missing <- getCountGenoMissing(gds, "marker", FALSE, TRUE)
    expect_error(setMarFilter(gds, missing = 10))
    expect_error(setMarFilter(gds, missing = "0.2"))
    gds <- setMarFilter(gds, missing = 0.2)
    expect_equal(validMar(gds), missing <= 0.2)

    gds <- resetMarFilter(gds)
    het <- getCountGenoHet(gds, "marker", FALSE, TRUE)
    expect_error(setMarFilter(gds, het = 10))
    expect_error(setMarFilter(gds, het = "0.2"))
    gds <- setMarFilter(gds, het = c(0.25, 0.75))
    expect_equal(validMar(gds), het >= 0.25 & het <= 0.75)

    gds <- resetMarFilter(gds)
    mac <- getMAC(gds, "marker", FALSE)
    expect_error(setMarFilter(gds, mac = -10))
    expect_error(setMarFilter(gds, mac = "100"))
    gds <- setMarFilter(gds, mac = 100)
    expect_equal(validMar(gds), mac >= 100)

    gds <- resetMarFilter(gds)
    maf <- getMAF(gds, "marker", FALSE)
    expect_error(setMarFilter(gds, maf = 10))
    expect_error(setMarFilter(gds, maf = "0.2"))
    gds <- setMarFilter(gds, maf = 0.25)
    expect_equal(validMar(gds), maf >= 0.25)

    gds <- resetMarFilter(gds)
    ad_ref <- getCountReadRef(gds, "marker", FALSE)
    expect_error(setMarFilter(gds, ad_ref = -1000))
    expect_error(setMarFilter(gds, ad_ref = "1000"))
    gds <- setMarFilter(gds, ad_ref = c(1000, 2000))
    expect_equal(validMar(gds), ad_ref >= 1000 & ad_ref <= 2000)

    gds <- resetMarFilter(gds)
    ad_alt <- getCountReadAlt(gds, "marker", FALSE)
    expect_error(setMarFilter(gds, ad_alt = -100))
    expect_error(setMarFilter(gds, ad_alt = "1000"))
    gds <- setMarFilter(gds, ad_alt = c(1000, 1500))
    expect_equal(validMar(gds), ad_alt >= 1000 & ad_alt <= 1500)

    gds <- resetMarFilter(gds)
    dp <- getCountRead(gds, "marker", FALSE)
    expect_error(setMarFilter(gds, dp = -100))
    expect_error(setMarFilter(gds, dp = "1000"))
    gds <- setMarFilter(gds, dp = c(1000, 2000))
    expect_equal(validMar(gds), dp >= 1000 & dp <= 2000)

    gds <- resetMarFilter(gds)
    mean_ref <- getMeanReadRef(gds, "marker", FALSE)
    expect_error(setMarFilter(gds, mean_ref = -100))
    expect_error(setMarFilter(gds, mean_ref = "1000"))
    gds <- setMarFilter(gds, mean_ref = c(1000, 2000))
    expect_equal(validMar(gds), mean_ref >= 1000 & mean_ref <= 2000)

    gds <- resetMarFilter(gds)
    mean_alt <- getMeanReadAlt(gds, "marker", FALSE)
    expect_error(setMarFilter(gds, mean_alt = -100))
    expect_error(setMarFilter(gds, mean_alt = "1000"))
    gds <- setMarFilter(gds, mean_alt = c(1000, 1500))
    expect_equal(validMar(gds), mean_alt >= 1000 & mean_alt <= 1500)

    gds <- resetMarFilter(gds)
    sd_ref <- getSDReadRef(gds, "marker", FALSE)
    expect_error(setMarFilter(gds, sd_ref = -100))
    expect_error(setMarFilter(gds, sd_ref = "1000"))
    gds <- setMarFilter(gds, sd_ref = 2000)
    expect_equal(validMar(gds), sd_ref <= 2000)

    gds <- resetMarFilter(gds)
    sd_alt <- getSDReadAlt(gds, "marker", FALSE)
    expect_error(setMarFilter(gds, sd_alt = -100))
    expect_error(setMarFilter(gds, sd_alt = "1000"))
    gds <- setMarFilter(gds, sd_alt = 2000)
    expect_equal(validMar(gds), sd_alt <= 2000)

    gds <- resetMarFilter(gds)
    valid <- !(getMarID(gds) %in% omit_id) & missing <= 0.2 &
        het >= 0.25 & het <= 0.75 & maf >= 0.25
    gds <- setMarFilter(gds, id = omit_id, missing = 0.2,
                         het = c(0.25, 0.75), maf = 0.25)
    expect_equal(validMar(gds), valid)
    closeGDS(gds)
})

test_that("Genotype call filtering", {
    gds <- loadGDS(gds_fn)
    gds <- countRead(gds)
    gds <- countGenotype(gds)

    gds <- setCallFilter(gds, dp_count = c(5, 10))
    geno <- getGenotype(gds)
    read <- getRead(gds)
    ref <- read$ref
    alt <- read$alt
    dp <- ref + alt
    valid <- dp >= 5 & dp <= 10
    geno[!valid] <- NA
    ref[!valid] <- 0
    alt[!valid] <- 0
    expect_equal(getGenotype(gds, node = "filt"), geno, ignore_attr = TRUE)
    fread <- getRead(gds, node = "filt")
    expect_equal(fread$ref, ref, ignore_attr = TRUE)
    expect_equal(fread$alt, alt, ignore_attr = TRUE)

    gds <- resetCallFilter(gds)
    gds <- setCallFilter(gds, ref_count = c(5, 10))
    geno <- getGenotype(gds)
    read <- getRead(gds)
    ref <- read$ref
    alt <- read$alt
    valid <- ref >= 5 & ref <= 10
    geno[!valid] <- NA
    ref[!valid] <- 0
    alt[!valid] <- 0
    expect_equal(getGenotype(gds, node = "filt"), geno, ignore_attr = TRUE)
    fread <- getRead(gds, node = "filt")
    expect_equal(fread$ref, ref, ignore_attr = TRUE)
    expect_equal(fread$alt, alt, ignore_attr = TRUE)

    gds <- resetCallFilter(gds)
    gds <- setCallFilter(gds, alt_count = c(5, 10))
    geno <- getGenotype(gds)
    read <- getRead(gds)
    ref <- read$ref
    alt <- read$alt
    valid <- alt >= 5 & alt <= 10
    geno[!valid] <- NA
    ref[!valid] <- 0
    alt[!valid] <- 0
    expect_equal(getGenotype(gds, node = "filt"), geno, ignore_attr = TRUE)
    fread <- getRead(gds, node = "filt")
    expect_equal(fread$ref, ref, ignore_attr = TRUE)
    expect_equal(fread$alt, alt, ignore_attr = TRUE)

    gds <- resetCallFilter(gds)
    gds <- setCallFilter(gds, dp_qtile = c(0.1, 0.9))
    geno <- getGenotype(gds)
    read <- getRead(gds)
    ref <- read$ref
    alt <- read$alt
    dp <- ref + alt
    valid <- sapply(1:nrow(dp), function(i){
        thr <- quantile(dp[i, ], c(0.1, 0.9))
        return(dp[i, ] >= thr[1] & dp[i, ] <= thr[2])
    })
    valid <- t(valid)
    geno[!valid] <- NA
    read <- getRead(gds)
    ref <- read$ref
    alt <- read$alt
    ref[!valid] <- 0
    alt[!valid] <- 0
    expect_equal(getGenotype(gds, node = "filt"), geno, ignore_attr = TRUE)
    fread <- getRead(gds, node = "filt")
    expect_equal(fread$ref, ref, ignore_attr = TRUE)
    expect_equal(fread$alt, alt, ignore_attr = TRUE)

    gds <- resetCallFilter(gds)
    gds <- setCallFilter(gds, ref_qtile = c(0.1, 0.9))
    geno <- getGenotype(gds)
    read <- getRead(gds)
    ref <- read$ref
    alt <- read$alt
    valid <- sapply(1:nrow(ref), function(i){
        thr <- quantile(ref[i, ], c(0.1, 0.9))
        return(ref[i, ] >= thr[1] & ref[i, ] <= thr[2])
    })
    valid <- t(valid)
    geno[!valid] <- NA
    read <- getRead(gds)
    ref <- read$ref
    alt <- read$alt
    ref[!valid] <- 0
    alt[!valid] <- 0
    expect_equal(getGenotype(gds, node = "filt"), geno, ignore_attr = TRUE)
    fread <- getRead(gds, node = "filt")
    expect_equal(fread$ref, ref, ignore_attr = TRUE)
    expect_equal(fread$alt, alt, ignore_attr = TRUE)

    gds <- resetCallFilter(gds)
    gds <- setCallFilter(gds, alt_qtile = c(0.1, 0.9))
    geno <- getGenotype(gds)
    read <- getRead(gds)
    ref <- read$ref
    alt <- read$alt
    valid <- sapply(1:nrow(alt), function(i){
        thr <- quantile(alt[i, ], c(0.1, 0.9))
        return(alt[i, ] >= thr[1] & alt[i, ] <= thr[2])
    })
    valid <- t(valid)
    geno[!valid] <- NA
    read <- getRead(gds)
    ref <- read$ref
    alt <- read$alt
    ref[!valid] <- 0
    alt[!valid] <- 0
    expect_equal(getGenotype(gds, node = "filt"), geno, ignore_attr = TRUE)
    fread <- getRead(gds, node = "filt")
    expect_equal(fread$ref, ref, ignore_attr = TRUE)
    expect_equal(fread$alt, alt, ignore_attr = TRUE)
    closeGDS(gds)
})


test_that("Save and load filter info", {
    gds <- loadGDS(gds_fn)
    gds <- countRead(gds)
    gds <- countGenotype(gds)

    valid_snp <- sample(c(TRUE, FALSE), nmar(gds), replace = TRUE)
    valid_scan <- sample(c(TRUE, FALSE), nsam(gds), replace = TRUE)
    validMar(gds) <- valid_snp
    validSam(gds) <- valid_scan
    closeGDS(gds, save_filter = TRUE)
    gds <- loadGDS(gds, load_filter = TRUE)
    expect_equal(validMar(gds), valid_snp, ignore_attr = TRUE)
    expect_equal(validSam(gds), valid_scan, ignore_attr = TRUE)
    closeGDS(gds)
})

# library(GBScleanR)
# url <- "https://github.com/tomoyukif/GBSR_SupFiles/raw/main/realdata/gbs_nbolf2.vcf.gz"
# temp_dir <- tempdir()
# vcf_fn <- tempfile(pattern = "nbol_f2", tmpdir = temp_dir, fileext = ".vcf.gz")
# gds_fn <- sub(".vcf.gz", ".gds", vcf_fn)
# download.file(url = url, destfile = vcf_fn)
# on.exit({unlink(temp_dir, force = TRUE)})
# 
# test_that("debug", {
#   gbsrVCF2GDS(vcf_fn = vcf_fn, out_fn = gds_fn,
#               info.import = character(length = 0L),
#               fmt.import = "AD", force = TRUE)
#   gds <- loadGDS(x = gds_fn)
#   setCallFilter(object = gds, ref_qtile = c(0, 0.9), alt_qtile = c(0, 0.9), dp_qtile = c(0, 0.95),
#                 dp_count = c(0, 5), ref_count = c(0, 8), alt_count = c(0, 5))
#   closeGDS(object = gds, save_filter = TRUE)
# })
#   
#   

vcf_fn <- system.file("extdata", "sample.vcf", package = "GBScleanR")
gds_fn <- tempfile("sample", fileext = ".gds")
gbsrVCF2GDS(vcf_fn, gds_fn)
on.exit({unlink(gds_fn)})

test_that("Reference read count",
          {
              gds <- loadGDS(gds_fn)
              gds <- countRead(gds)
              read <- getRead(gds)
              ref <- read$ref
              alt <- read$alt
              expect_equal(getCountReadRef(gds, "marker"), colSums(ref),
                           ignore_attr = TRUE)
              expect_equal(getCountReadRef(gds, "sample"), rowSums(ref),
                           ignore_attr = TRUE)
              expect_equal(getCountReadRef(gds, "marker", prop = TRUE),
                           colSums(ref)/ (colSums(ref) + colSums(alt)),
                           ignore_attr = TRUE)
              expect_equal(getCountReadRef(gds, "sample", prop = TRUE),
                           rowSums(ref) / (rowSums(ref) + rowSums(alt)),
                           ignore_attr = TRUE)

              valid_snp <- sample(c(TRUE, FALSE), nmar(gds), TRUE)
              validMar(gds) <- valid_snp
              valid_scan <- sample(c(TRUE, FALSE), nsam(gds), TRUE)
              validSam(gds) <- valid_scan
              gds <- countRead(gds)
              ref <- read$ref
              alt <- read$alt

              expect_equal(getCountReadRef(gds, "marker", valid = TRUE),
                           colSums(ref[valid_scan, ])[valid_snp],
                           ignore_attr = TRUE)
              expect_equal(getCountReadRef(gds, "sample", valid = TRUE),
                           rowSums(ref[, valid_snp])[valid_scan],
                           ignore_attr = TRUE)

              expect_equal(getCountReadRef(gds, "marker", valid = TRUE, prop = TRUE),
                           (colSums(ref[valid_scan, ])/
                                (colSums(ref[valid_scan, ]) +
                                     colSums(alt[valid_scan, ])))[valid_snp],
                           ignore_attr = TRUE)
              expect_equal(getCountReadRef(gds, "sample", valid = TRUE, prop = TRUE),
                           (rowSums(ref[, valid_snp])/
                                (rowSums(ref[, valid_snp]) +
                                     rowSums(alt[, valid_snp])))[valid_scan],
                           ignore_attr = TRUE)
              closeGDS(gds)
          })


test_that("Alternative read count",
          {
              gds <- loadGDS(gds_fn)
              gds <- countRead(gds)
              read <- getRead(gds)
              ref <- read$ref
              alt <- read$alt
              expect_equal(getCountReadAlt(gds, "marker"), colSums(alt),
                           ignore_attr = TRUE)
              expect_equal(getCountReadAlt(gds, "sample"), rowSums(alt),
                           ignore_attr = TRUE)
              expect_equal(getCountReadAlt(gds, "marker", prop = TRUE),
                           colSums(alt)/ (colSums(alt) + colSums(ref)),
                           ignore_attr = TRUE)
              expect_equal(getCountReadAlt(gds, "sample", prop = TRUE),
                           rowSums(alt) / (rowSums(alt) + rowSums(ref)),
                           ignore_attr = TRUE)

              valid_snp <- sample(c(TRUE, FALSE), nmar(gds), TRUE)
              validMar(gds) <- valid_snp
              valid_scan <- sample(c(TRUE, FALSE), nsam(gds), TRUE)
              validSam(gds) <- valid_scan
              gds <- countRead(gds)
              ref <- read$ref
              alt <- read$alt

              expect_equal(getCountReadAlt(gds, "marker", valid = TRUE),
                           colSums(alt[valid_scan, ])[valid_snp],
                           ignore_attr = TRUE)
              expect_equal(getCountReadAlt(gds, "sample", valid = TRUE),
                           rowSums(alt[, valid_snp])[valid_scan],
                           ignore_attr = TRUE)

              expect_equal(getCountReadAlt(gds, "marker", valid = TRUE, prop = TRUE),
                           (colSums(alt[valid_scan, ])/
                                (colSums(ref[valid_scan, ]) +
                                     colSums(alt[valid_scan, ])))[valid_snp],
                           ignore_attr = TRUE)
              expect_equal(getCountReadAlt(gds, "sample", valid = TRUE, prop = TRUE),
                           (rowSums(alt[, valid_snp])/
                                (rowSums(ref[, valid_snp]) +
                                     rowSums(alt[, valid_snp])))[valid_scan],
                           ignore_attr = TRUE)
              closeGDS(gds)
          })

test_that("Total read count", {
    gds <- loadGDS(gds_fn)
    gds <- countRead(gds)
    read <- getRead(gds)
    ref <- read$ref
    alt <- read$alt
    dp <- ref + alt
    expect_equal(getCountRead(gds, "marker"), colSums(dp),
                 ignore_attr = TRUE)
    expect_equal(getCountRead(gds, "sample"), rowSums(dp),
                 ignore_attr = TRUE)

    valid_snp <- sample(c(TRUE, FALSE), nmar(gds), TRUE)
    validMar(gds) <- valid_snp
    valid_scan <- sample(c(TRUE, FALSE), nsam(gds), TRUE)
    validSam(gds) <- valid_scan
    gds <- countRead(gds)
    ref <- read$ref
    alt <- read$alt

    expect_equal(getCountRead(gds, "marker", valid = TRUE),
                 colSums(dp[valid_scan, ])[valid_snp],
                 ignore_attr = TRUE)
    expect_equal(getCountRead(gds, "sample", valid = TRUE),
                 rowSums(dp[, valid_snp])[valid_scan],
                 ignore_attr = TRUE)
    closeGDS(gds)
})

object <- loadGDS("~/hdd5/ngsData/gbs/20230309_yamamotoTP/mcptaggr/genotype.gds", ploidy = 4, load_filter = TRUE)

recomb_rate <- 0.04
error_rate <- 0.0025
call_threshold <- 0.9
het_parent <- FALSE
optim <- TRUE
iter <- 4
n_threads <- 5
dummy_reads <- 10
fix_bias <- NULL
fix_mismap <- NULL
chr_i <- "chr01"

object <- initScheme(object = object)
object <- addScheme(object = object, crosstype = "self")
object <- addScheme(object = object, crosstype = "self")
object <- addScheme(object = object, crosstype = "self")
object <- addScheme(object = object, crosstype = "self")
object <- addScheme(object = object, crosstype = "self")
object <- addScheme(object = object, crosstype = "self")
object <- addScheme(object = object, crosstype = "self")
object <- addScheme(object = object, crosstype = "self")

closeGDS(object = object)
w1 <- 0.5
ploidy <- 4
ref = 10
alt = 1
for(g in 0:4){
    denomi = w1 * (ploidy - g) + (1 - w1) * g
    prob <- w1 * (ploidy - g) / denomi
    # print(prob^ref * (1 - prob)^alt)
    print(prob)
}

calcGenoprobR(ref = 10, alt = 5, eseq0 = 0.9975, eseq1 = 0.0025, w1 = 0.5, het = TRUE, ploidy = 4)

c(4.9414e-69,
  3.2589e-10,
  0.00531277,
  0.994687,
  5.16783e-17) + 0.0005/
sum(c(4.9414e-69,
      3.2589e-10,
      0.00531277,
      0.994687,
      5.16783e-17)) + 0.0005 * 5

#' Class `GbsrScheme`
#'
#' [GBScleanR] uses breeding scheme information to set the expected
#' number of cross overs in a chromosome which is a required parameter
#' for the genotype error correction with the hidden Markov model
#' implemented in the [estGeno()] function. This class stores those
#' information including ID of parental samples, type crosses
#' performed at each generation of breeding and population
#' sizes of each generation. This class is not exported.
#'
#' @slot crosstype A vector of strings indicating the type of
#' crossing done at each generation.
#' @slot mating A list of matrices showing combinations member
#' IDs of samples mated.
#' @slot parents A vector of member IDs of parents.
#' @slot progenies A vector of memeber IDs of progenies produced
#' at each generation.
#' @slot samples A vector of member IDs of samples indicating which samples are
#' derived from which pedigrees.
#'
#' @rdname GbsrScheme-class
#' @aliases GbsrScheme-class GbsrScheme
#' @importFrom methods setClass slot
#' @exportClass GbsrScheme
#' @seealso [GbsrGenotypeData] dnd [loadGDS()].
#'
#' @examples
#' # [loadGDS()] initialize a `GbsrScheme` object internally and
#' # attache it to the shceme slot of a [GbsrGenotypeData] object.
#'
#' # Load data in the GDS file and instantiate
#' # a [GbsrGenotypeData] object.
#' gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
#' gds <- loadGDS(gds_fn)
#'
#' # Print the information stored in the `GbsrScheme` object.
#' showScheme(gds)
#'
#' # Close the connection to the GDS file.
#' closeGDS(gds)
#'
setClass(Class = "GbsrScheme",
         slots = c(crosstype = "list",
                   mating = "list",
                   parents = "numeric",
                   progenies = "list",
                   samples = "numeric"))


#' Class [GbsrGenotypeData]
#'
#' The [GbsrGenotypeData] class is the main class of [GBScleanR] and
#' user work with this class object.
#'
#' @details
#' The [GbsrGenotypeData] class is an extention of \code{\link[SeqArray]{SeqVarGDSClass-class}} in the
#' `SeqArray` package to store summary data of genotypes and reads and a
#' [GbsrScheme] object that contains mating scheme information of the given
#' population..
#' The slots `marker` and `sample` store a [data.frame] object for variant-wise
#' and sample-wise summary information, respectively. The `scheme` slot holds a
#' [GbsrScheme] object. The function [loadGDS()] initialize the
#' [GbsrGenotypeData] class.
#'
#' @importClassesFrom SeqArray SeqVarGDSClass
#' @aliases  GbsrGenotypeData-class GbsrGenotypeData
#' @slot marker A [data.frame] object.
#' @slot sample A [data.frame] object.
#' @slot scheme A [GbsrScheme] object.
#'
#' @examples
#' # [loadGDS()] initialize the [GbsrGenotypeData] object.
#'
#' # Load a GDS file and instantiate a [GbsrGenotypeData] object.
#' gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
#' gds <- loadGDS(gds_fn)
#'
#' # Close connection to the GDS file.
#' closeGDS(gds)
#'
#' @exportClass GbsrGenotypeData
#' @importFrom methods setClass slot
#'
setClass(Class = "GbsrGenotypeData",
         contains = "SeqVarGDSClass",
         slots = c(marker = "data.frame",
                   sample = "data.frame",
                   scheme = "GbsrScheme"))

#' @param parents Indices of parental lines.
#' @rdname initScheme
#'
setMethod("initScheme",
          "GbsrScheme",
          function(object, mating, parents) {
              if (!all(parents %in% mating)) {
                  stop('All parents should be listed in the matrix ",
                       "specified as the "mating" argument.',
                       call. = FALSE)
              }
              if (!all(mating %in% parents)) {
                  stop('Invalid member ID(s) specified to mating.',
                       call. = FALSE)
              }
              object@parents <- parents
              object@crosstype <- list(rep(x = "pairing", times = ncol(mating)))
              object@mating <- list(mating)
              object@progenies <- list(seq(max(parents) + 1, by = 1,
                                           length.out = ncol(mating)))
              object@samples <- numeric()
              return(object)
          })

.validMating <- function(crosstype, mating){
    if(crosstype == "pairing"){
        if(any(mating[1] == mating[2])){
            stop('The same member ID was specified to ',
                 'mating for "crosstype = pairing"',
                 call. = FALSE)
        }
    }
    if(crosstype == "sibling"){
        if(any(mating[1] != mating[2])){
            stop('Different member IDs were specified to ',
                 'mating for "crosstype = sibling"',
                 call. = FALSE)
        }
    }
    if(crosstype == "selfing"){
        if(any(mating[1] != mating[2])){
            stop('Different member IDs were specified to ',
                 'mating for "crosstype = selfing"',
                 call. = FALSE)
        }
    }
    return(TRUE)
}

#'
#' @importFrom utils tail
#' @rdname addScheme
#'
setMethod("addScheme",
          "GbsrScheme",
          function(object, crosstype, mating) {
              crosstype <- vapply(X = crosstype,
                                  FUN.VALUE = character(length = 1L),
                                  FUN = match.arg,
                                  choices = c("pairing", "selfing", "sibling"))

              last_gen <- unlist(tail(object@progenies, 1))
              n_crosstype <- length(crosstype)
              if(n_crosstype != 1){
                  stop("length(crosstype) should be 1.", call. = FALSE)
              }
              is_na_mating <- any(is.na(mating))

              if(n_crosstype == 1){
                  if(is_na_mating){
                      if (crosstype == "pairing") {
                          mating <- t(expand.grid(last_gen, last_gen))
                          mating <- apply(X = mating, MARGIN = 2, FUN = sort)
                          mating <- unique(t(mating))
                          mating <- t(mating[mating[, 1] != mating[, 2], ])
                          message("As `mating` was not specified,",
                                  " set the following mating design.")
                          print(mating)
                          crosstype <- rep(x = crosstype, times = ncol(mating))

                      } else {
                          mating <- matrix(data = rep(x = last_gen, each = 2),
                                           nrow = 2)
                          message("As `mating` was not specified,",
                                  " set the following mating design.")
                          print(mating)
                          crosstype <- rep(x = crosstype, times = ncol(mating))
                      }
                  } else {
                      crosstype <- rep(x = crosstype, times = ncol(mating))
                  }
              } else {
                  if(length(crosstype) != ncol(mating)){
                      stop("length(crosstype) and ncol(mating) should be same",
                           " if length(crosstype) > 1.",
                           call. = FALSE)
                  }
              }
              if (!all(mating %in% last_gen)) {
                  stop('Invalid member ID(s) specified to mating.',
                       call. = FALSE)
              }
              check <- vapply(X = seq_along(crosstype),
                              FUN.VALUE = logical(length = 1L),
                              FUN = function(i){
                                  .validMating(crosstype[i], mating[, i])
                              })
              object@crosstype <- c(object@crosstype, list(crosstype))
              object@mating <- c(object@mating, list(mating))
              object@progenies <- c(object@progenies,
                                    list(seq(max(last_gen) + 1,
                                             by = 1,
                                             length.out = ncol(mating))))
              return(object)
          })


#'
#' @rdname assignScheme
setMethod("assignScheme",
          "GbsrScheme",
          function(object, id) {
              valid_id <- unlist(slot(object = object, name = "progenies"))
              if(!all(id %in% valid_id)){
                  stop("Invalid specification of member ID(s) to sample(s)!\n",
                       "You can asign only progenies' member ID(s) to sample(s).\n",
                       "Progenies' member ID(s) are: ", paste(valid_id, collapse = ", "),
                       call. = FALSE)
              }
              slot(object = object, name = "samples") <- id
              return(object)
          })

#'
#' @param parents_name A vector of strings to indicate names
#' of parental samples. This argument is used internally by showScheme()
#' for the gbsrGenotypeData object.
#' @param pedigree A integer vector indicating the member
#' ID assignment to samples. This argument is used internally by
#' showScheme() for the gbsrGenotypeData object.
#' @rdname showScheme
#'
setMethod("showScheme",
          "GbsrScheme",
          function(object, parents_name, pedigree) {
              if(length(object@crosstype) == 0){
                  message("No scheme information.\nRun initScheme().")
              }
              n_gen <- length(object@progenies)

              for(i in seq_len(n_gen)){
                  if (i == 1) {
                      message('\nGeneration: ', appendLF = FALSE)
                      cat("Parents")

                      parents <- object@parents
                      message('\nThe number of parents: ', appendLF = FALSE)
                      cat(length(unique(parents)))

                      message('\nSample IDs: ', appendLF = FALSE)
                      cat(parents_name)

                      message('\nMember IDs: ', appendLF = FALSE)
                      cat(parents)

                      message('\nCross type: ', appendLF = FALSE)
                      cat(object@crosstype[[i]])

                      message('\nMating: ')
                      mating <- object@mating[[i]]
                      rownames(mating) <-
                          paste("mate", seq_len(2), sep = "")
                      colnames(mating) <-
                          paste("combination", seq_len(ncol(mating)), sep = "")
                      print(mating)

                      message('Member IDs of progenites: ', appendLF = FALSE)
                      cat(object@progenies[[i]])

                  } else {
                      message("")
                      message("-------------------------")
                      message('Generation: ', appendLF = FALSE)
                      cat(i - 1)

                      members <- object@progenies[[i - 1]]
                      message('\nThe number of members: ', appendLF = FALSE)
                      cat(length(members))

                      message('\nMember IDs: ', appendLF = FALSE)
                      cat(members)

                      message('\nCross type: ', appendLF = FALSE)
                      cat(object@crosstype[[i]])

                      message('\nMating: ')
                      mating <- object@mating[[i]]
                      rownames(mating) <-
                          paste("mate", seq_len(2), sep = "")
                      colnames(mating) <-
                          paste("combination", seq_len(ncol(mating)), sep = "")
                      print(mating)

                      message('Member IDs of progenites: ', appendLF = FALSE)
                      cat(object@progenies[[i]])
                  }

                  if(i == n_gen){
                      message('\nAssigned member IDs to samples: ',
                              appendLF = FALSE)
                      if(length(object@samples) == 0){
                          cat("Not assigned.")

                      } else {
                          message('')
                          txt <- apply(X = pedigree, MARGIN = 1,
                                       FUN = paste, collapse = ":")
                          n_txt <- length(txt)
                          for(i in seq_len(n_txt)){
                              if(i == n_txt){
                                  cat(txt[i])

                              } else {
                                  if(i %% 6 == 0){
                                      cat(paste0(txt[i], "\n"))

                                  } else {
                                      cat(paste0(txt[i], ", "))
                                  }
                              }
                          }
                      }
                  }
              }
          })

source("~/11_wd2/gbscleanr/v1/ForManuscript/script/compareGeno.R")
devtools::load_all(path = "~/01_wd/softDevel/SimPop/")
devtools::load_all(path = "~/01_wd/softDevel/GBScleanR/")

dirs <- grep("simpop", list.dirs("~/11_wd2/gbscleanr/v1/ForManuscript", recursive = F), value = T)

# homoP2 F2
rec1 <- NULL
vcf_files <- list.files(dirs[3], ".vcf", full.names = TRUE)
vcf_files <- grep("_LB", vcf_files, invert = TRUE, value = TRUE)
gds_files <- list.files(dirs[3], "_gbsr.gds", full.names = TRUE)
gbsrVCF2GDS(vcf_fn = vcf_files[51], out_fn = gds_files[51], force = TRUE)
gds <- loadGDS(gds_files[51])
parents <- grep("Founder", getSamID(gds), value = TRUE)
gds <- setParents(gds, parents)
gds <- initScheme(gds, matrix(1:2, 2))
gds <- addScheme(gds, "self")
runtime1 <- system.time({gds <- estGeno(object = gds,
                                        iter = 4,
                                        het_parent = FALSE,
                                        n_threads = 50)
})
parents <- grep("Founder", getSamID(gds), value = TRUE)
geno <- getGenotype(gds, node = "cor")
pop_file <- sub("_gbsr.gds", "_SimPop.Rdata", gds_files[51])
load(pop_file)
true <- SimPop::getGenotype(pop, gen = "last", fam = "all", sib = "all")
true <- t(sapply(true, colSums))
df <- compareGeno(geno, true)
apply(df$ind, 2, mean, na.rm = TRUE)
# correct     miscall     missing
# 0.983185484 0.003167742 0.013646774
closeGDS(gds)
print(runtime1)
# user  system elapsed
# 220.487  25.499  13.710

# hetP2 F1
rec2 <- NULL
vcf_files <- list.files(dirs[1], ".vcf", full.names = TRUE)
gds_files <- list.files(dirs[1], "_gbsr.gds", full.names = TRUE)
gbsrVCF2GDS(vcf_fn = vcf_files[51], out_fn = gds_files[51], force = TRUE)
gds <- loadGDS(gds_files[51])
parents <- grep("Founder", getSamID(gds), value = TRUE)
gds <- setParents(gds, parents[1])
gds <- initScheme(gds, matrix(1:2, 2))
runtime2 <- system.time({gds <- estGeno(object = gds,
                                        iter = 4,
                                        het_parent = TRUE,
                                        n_threads = 50)
})
parents <- grep("Founder", getSamID(gds), value = TRUE)
geno <- getGenotype(gds, node = "cor")
pop_file <- sub("_gbsr.gds", "_SimPop.Rdata", gds_files[51])
load(pop_file)
true <- SimPop::getGenotype(pop, gen = "last", fam = "all", sib = "all")
true <- t(sapply(true, colSums))
df <- compareGeno(geno, true)
apply(df$ind, 2, mean, na.rm = TRUE)
# correct    miscall    missing
# 0.92197419 0.06662097 0.01140484
closeGDS(gds)
print(runtime2)
# user   system  elapsed
# 1688.315   18.408   48.784

# hetP8 RIL
vcf_files <- list.files(dirs[5], ".vcf", full.names = TRUE)
gds_files <- list.files(dirs[5], "_gbsr.gds", full.names = TRUE)
gbsrVCF2GDS(vcf_fn = vcf_files[51], out_fn = gds_files[51], force = TRUE)
gds <- loadGDS(gds_files[51])
parents <- grep("Founder", getSamID(gds), value = TRUE)
gds <- setParents(gds, parents)
gds <- initScheme(gds, matrix(1:8, 2))
gds <- addScheme(gds, "pairing", matrix(9:12, 2))
gds <- addScheme(gds, "pairing", matrix(13:14, 2))
gds <- addScheme(gds, "self")
gds <- addScheme(gds, "self")
gds <- addScheme(gds, "self")
gds <- addScheme(gds, "self")
gds <- addScheme(gds, "self")
runtime3 <- system.time({gds <- estGeno(object = gds,
                                        iter = 1,
                                        het_parent = FALSE,
                                        n_threads = 50)
})
parents <- grep("Founder", getSamID(gds), value = TRUE)
geno <- getGenotype(gds, node = "cor")
pop_file <- sub("_gbsr.gds", "_SimPop.Rdata", gds_files[51])
load(pop_file)
true <- SimPop::getGenotype(pop, gen = "last", fam = "all", sib = "all")
true <- t(sapply(true, colSums))
df <- compareGeno(geno, true)
apply(df$ind, 2, mean, na.rm = TRUE)
# correct    miscall    missing
# 0.97278548 0.01157903 0.01563548
closeGDS(gds)
print(runtime3)
# user  system elapsed
# 382.115  35.309  15.115

###############################################################################
#' @importFrom gdsfmt exist.gdsn apply.gdsn objdesp.gdsn readex.gdsn
.filtData <- function(object, node, filters, reduce = FALSE){
    # Check if the specified node exists
    if(!exist.gdsn(node = object, path = node)){
        stop("The GDS node ", node, " does not exists.", call. = FALSE)
    }
    if(any(vapply(X = filters, FUN = sum, FUN.VALUE = numeric(1)) == 0)){
        stop('Nothing to return.')
    }

    # Prepare filtered output
    target_node <- index.gdsn(node = object, path = node)
    obj <- objdesp.gdsn(target_node)
    dim <- obj$dim
    if(length(dim) == 1){
        if(grepl("sample\\.id", node)){
            sel <- list(filters$sam)

        } else {
            sel <- list(filters$mar)
        }

    } else if(length(dim) == 2){
        sel <- list(filters$sam, filters$mar)

    } else {
        sel <- list(rep(TRUE, dim[1]), filters$sam, filters$mar)
    }
    out <- readex.gdsn(node = target_node, sel = sel)

    if(reduce){
        if(length(sel) == 2){
            stop("'reduce' is applicable when the data has 3 dimentions.")
        }
        # Reduce the dimensions of the output array
        out[out == 3] <- NA
        dim_out <- dim(out)
        if(length(dim_out) == 3){
            command <- paste0("out <- ", paste(paste0("out[", seq_len(dim_out[1]), ",,]"), collapse = " + "))
            eval(expr = parse(text = command))

        } else {

            command <- paste0("out <- ", paste(paste0("out[", seq_len(dim_out[1]), ",]"), collapse = " + "))
            eval(expr = parse(text = command))
            dim(out) <- c(dim_out[2], 1)
        }
    }

    return(out)
}

#' @importFrom SeqArray seqGetData
.makeFilter <- function(object, valid = FALSE, parents = FALSE, chr = NULL){
    # Initialize filters
    filt_mar <- rep(x = TRUE, times = nmar(object = object, valid = FALSE))
    filt_sam <- rep(x = TRUE, times = nsam(object = object, valid = FALSE))

    # Set validity filter
    if(valid){
        filt_mar <- filt_mar & validMar(object = object)
        filt_sam <- filt_sam & validSam(object = object, parents = parents)
    }

    # Set parent filter
    if(parents == "only"){
        filt_sam <- filt_sam & validSam(object = object, parents = parents)
    }

    # Set chromosome filter
    if(!is.null(chr)){
        if(length(chr) > 1){
            warning("More than one values were specified to chr,",
                    " but use the first one")
        }
        chr_filter <- seqGetData(gdsfile = object, var.name = "chromosome") == chr[1]
        filt_mar <- filt_mar & chr_filter
    }
    return(list(mar = filt_mar, sam = filt_sam))
}

.getStatsData <- function(object, var, target, valid){
    # Retrieve sample-wise or marker-wise stats data
    target <- match.arg(arg = target, choices = c("marker", "sample"))
    stopifnot(is.logical(valid))
    df <- slot(object = object, name = target)
    out <- df[[var]]
    if(valid){
        out <- out[df$valid]
    }
    return(out)
}

###############################################################################
## Internally used functions to control the GDS file.

## Decompress GDS file nodes.
#' @importFrom gdsfmt compression.gdsn ls.gdsn index.gdsn
.gds_decomp <- function(object){
    ls_gdsn <- ls.gdsn(node = object, include.hidden = TRUE,
                       recursive = TRUE, include.dirs = FALSE)
    for(i in ls_gdsn){
        compression.gdsn(node = index.gdsn(node = object, path = i), compress = "")
    }
}

## Compress GDS file nodes.
#' @importFrom gdsfmt readmode.gdsn ls.gdsn index.gdsn compression.gdsn
.gds_comp <- function(object){
    ls_gdsn <- ls.gdsn(node = object, include.hidden = TRUE,
                       recursive = TRUE, include.dirs = FALSE)
    for(i in ls_gdsn){
        i_node <- index.gdsn(node = object, path = i)
        compression.gdsn(node = i_node, compress = "ZIP_RA")
        readmode.gdsn(node = i_node)
    }
}

## Create a GDS node
#' @importFrom gdsfmt addfolder.gdsn
.create_gdsn <- function(root_node,
                         target_node,
                         new_node,
                         val,
                         storage,
                         valdim,
                         replace,
                         attr){

    check <- exist.gdsn(node = root_node, path = target_node)
    if(!check){ stop(target_node, "does not exist!") }
    target_node_index <- index.gdsn(node = root_node,
                                    path = target_node)
    new_node_index <- addfolder.gdsn(node = target_node_index,
                                     name = new_node,
                                     replace = replace)
    add.gdsn(node = new_node_index, name = "data",
             val = val, storage = storage, valdim = valdim,
             replace = replace)
    .putAttrGdsn(node = new_node_index, attr = attr)
}

.putAttrGdsn <- function(node, attr){
    for(i in seq_along(attr)){
        put.attr.gdsn(node = node,
                      name = names(attr)[i], val = attr[[i]])
    }
}

# Compress GDS nodes
.compressNodes <- function(object, node, decomp = FALSE){
    for(i in seq_along(node)){
        node_index <- index.gdsn(node = object$root, path = node[i])
        if(decomp){
            compress <- ""
        } else {
            compress <- "ZIP_RA"
        }
        compression.gdsn(node = node_index, compress = compress)
        readmode.gdsn(node = node_index)
    }
}

###############################################################################
## Exported getter and setter functions which return basic information of the data.

## Get the logical vector indicating valid markers.
#' @importFrom SeqArray seqGetData
#' @rdname validMar
setMethod("validMar",
          "GbsrGenotypeData",
          function(object, chr){
              out <- slot(object = object, name = "marker")[["valid"]]
              if(!is.null(chr)){
                  if(length(chr) > 1){
                      warning("More than one values were specified to chr,",
                              " but use the first one")
                  }
                  chr_data <- seqGetData(gdsfile = object, var.name = "chromosome")
                  out <- out[chr_data == chr[1]]
              }
              return(out)
          })

#' @rdname validMar
#' @importFrom methods slot<-
setMethod("validMar<-",
          "GbsrGenotypeData",
          function(object, value){
              if(length(value) != nmar(object, FALSE)){
                  stop("The length of the given vector should match",
                       " with the number of markers.", call. = FALSE)
              }
              slot(object = object, name = "marker")[["valid"]] <- value
              return(object)
          })

## Get the logical vector indicating valid samples.
#' @rdname validSam
setMethod("validSam",
          "GbsrGenotypeData",
          function(object, parents){
              if(parents == "only"){
                  if(is.null(slot(object = object, name = "sample")[["parents"]])){
                      stop("No parents info.", call. = FALSE)
                  } else {
                      out <- slot(object = object, name = "sample")[["parents"]] != 0
                  }

              } else {
                  out <- slot(object = object, name = "sample")[["valid"]]
                  if(parents){
                      parents <- slot(object = object, name = "sample")[["parents"]]
                      out[parents != 0] <- TRUE
                  }
              }
              return(out)
          })

#' @rdname validSam
#' @importFrom methods slot<-
setMethod("validSam<-",
          "GbsrGenotypeData",
          function(object, value){
              if(length(value) != nsam(object, FALSE)){
                  stop("The length of the given vector should match",
                       " with the number of samples", call. = FALSE)
              }
              slot(object = object, name = "sample")[["valid"]] <- value
              return(object)
          })

## Get the number of markers.
#' @rdname nmar
setMethod("nmar",
          "GbsrGenotypeData",
          function(object, valid, chr){
              out <- validMar(object = object, chr = chr)
              out <- ifelse(test = valid, yes = sum(out), no = length(out))
              return(out)
          })

## Get the number of samples.
#' @rdname nsam
setMethod("nsam",
          "GbsrGenotypeData",
          function(object, valid, parents){
              out <- validSam(object = object, parents = parents)
              out <- ifelse(test = valid, yes = sum(out), no = length(out))
              return(out)
          })


## Get the chromosome names in actual strings, indices, or levels.
#' @rdname getChromosome
setMethod("getChromosome",
          "GbsrGenotypeData",
          function(object, valid){
              filters <- .makeFilter(object = object, valid = valid)
              out <- .filtData(object = object,
                               node = "chromosome",
                               filters = filters)
              return(out)
          })

## Get the marker positions.
#' @rdname getPosition
setMethod("getPosition",
          "GbsrGenotypeData",
          function(object, valid, chr){
              filters <- .makeFilter(object = object, valid = valid, chr = chr)
              out <- .filtData(object = object,
                               node = "position",
                               filters =  filters)
              return(out)
          })

## Get the reference alleles of markers.
#' @rdname getAllele
setMethod("getAllele",
          "GbsrGenotypeData",
          function(object, valid, chr){
              filters <- .makeFilter(object = object, valid = valid, chr = chr)
              out <- .filtData(object = object,
                               node = "allele",
                               filters = filters)
              return(out)
          })

## Get the marker IDs.
#' @rdname getMarID
setMethod("getMarID",
          "GbsrGenotypeData",
          function(object, valid, chr){
              filters <- .makeFilter(object = object, valid = valid, chr = chr)
              out <- .filtData(object = object,
                               node = "variant.id",
                               filters = filters)
              return(out)
          })

## Get the sample IDs.
#' @rdname getSamID
setMethod("getSamID",
          "GbsrGenotypeData",
          function(object, valid, parents){
              filters <- .makeFilter(object = object,
                                     valid = valid,
                                     parents = parents)
              out <- .filtData(object = object,
                               node = "sample.id",
                               filters = filters)
              return(out)
          })

## Get the values of a variable in the "annotation/info" directory.
#' @rdname getInfo
setMethod("getInfo",
          "GbsrGenotypeData",
          function(object, var, valid, chr){
              node <- paste0("annotation/info/", var)
              filters <- .makeFilter(object = object, valid = valid, chr = chr)
              out <- .filtData(object = object, node = node, filters = filters)
              return(out)
          })

## Get read count data from the annotation/format/AD/data node
## in the GDS file connected to the GbsrGenotypeData object.
#' @rdname getRead
#' @importFrom gdsfmt index.gdsn read.gdsn
setMethod("getRead",
          "GbsrGenotypeData",
          function(object, node, parents, valid, chr){
              node <- match.arg(arg = node, choices = c("raw", "filt"))
              if(node == "raw"){ node <- "annotation/format/AD/data" }
              if(node == "filt"){ node <- "annotation/format/FAD/data" }

              if(!exist.gdsn(node = object, path = node)){
                  stop("The GDS node annotation/format/FAD does not exists.\n",
                       "Run setCallFilter() if needed.")
              }

              filters <- .makeFilter(object = object, parents = parents,
                                     valid = valid, chr = chr)

              sample_id <- .filtData(object = object,
                                     node = "sample.id",
                                     filters = filters)
              variant_id <- .filtData(object = object,
                                      node = "variant.id",
                                      filters = filters)
              at_data_node <- sub("data", "@data", node)
              at_data <- read.gdsn(index.gdsn(node = object,
                                              path = at_data_node))
              at_data <- vapply(X = seq_along(at_data),
                                FUN.VALUE = list(1),
                                FUN = function(i){
                                    return(list(rep(i, at_data[i])))
                                })
              at_data <- unlist(at_data)
              filters$mar <- filters$mar[at_data]
              out <- .filtData(object = object, node = node, filters = filters)
              if(!is.matrix(out)){
                  out <- matrix(out, nrow = 1)
              }
              ref <- subset(out, select = c(TRUE, FALSE))
              alt <- subset(out, select = c(FALSE, TRUE))
              rownames(ref) <- rownames(alt) <- sample_id
              colnames(ref) <- colnames(alt) <- variant_id

              ref[is.na(ref)] <- 0
              alt[is.na(alt)] <- 0
              return(list(ref = ref, alt = alt))
          })

## Get read count data from one of the nodes `genotype`,
## `corrected.genotype`, or `parents.genotype` in the GDS file
## connected to the GbsrGenotypeData object.
#' @importFrom SeqArray seqGetData
#' @rdname getGenotype
setMethod("getGenotype",
          "GbsrGenotypeData",
          function(object, node, parents, valid, chr, phased){
              node <- match.arg(arg = node,
                                choices =  c("raw", "filt", "cor",
                                             "parents", "dosage"))

              # If node == "parents", output estimated parental genotypes
              # stored at the PGT node
              if(node == "parents"){
                  out <- .getParentGenotype(object = object,
                                            valid = valid,
                                            chr = chr)
                  if(!is.matrix(out) & !is.array(out)){
                      out <- matrix(out, nrow = 1)
                  }
                  return(out)

              }

              # Set FALSE to reduce if phased == TRUE
              if(phased){
                  reduce <- FALSE
                  if(node == "raw"){
                      message("GBScleanR gives no guarantee on",
                              " phasing information for raw genotypes.")
                  }

              } else {
                  if(node == "dosage"){
                      reduce <- FALSE

                  } else {
                      reduce <- TRUE
                  }
              }

              # Set the node from which the data is retrieved
              switch(node,
                     raw = node <- "genotype/data",
                     filt = node <- "annotation/format/FGT/data",
                     cor = node <- "annotation/format/CGT/data",
                     dosage = node <- "annotation/format/EDS/data")

              # Check whether the specified node exists
              if(!exist.gdsn(node = object, path = node)){
                  if(grepl(pattern = "FGT", x = node, fixed = TRUE)){
                      stop("Nothing to return.",
                           "\nRun setCallFilter() if needed.")

                  } else {
                      stop("Nothing to return.\nRun estGeno() to obtain the",
                           " phased corrected genotype data.")
                  }
              }

              # Prepare the output data
              filters <- .makeFilter(object = object, parents = parents,
                                     valid = valid, chr = chr)
              out <- .filtData(object = object, node = node,
                               filters = filters, reduce = reduce)
              if(!is.matrix(out) & !is.array(out)){
                  out <- matrix(out, nrow = 1)
              }
              # Set numerically expressed missing values to NA
              if(grepl(pattern = "EDS", x = node)){
                  out[out == 63] <- NA

              } else {
                  if(!reduce){
                      out[out == 3] <- NA
                  }
              }

              # Set row and col names of the output
              sample_id <- .filtData(object = object,
                                     node = "sample.id",
                                     filters = filters)
              variant_id <- .filtData(object = object,
                                      node = "variant.id",
                                      filters = filters)

              if(length(dim(out)) == 2){
                  rownames(out) <- sample_id
                  colnames(out) <- variant_id

              } else {
                  dimnames(out) <- list(phase = seq_len(dim(out)[1]),
                                        sample = sample_id,
                                        marker = variant_id)
              }
              return(out)
          })

.getParentGenotype <- function(object, valid, chr){
    node <-  "annotation/info/PGT"

    # Check whether the node exists
    if(!exist.gdsn(node = object, path = node)){
        stop("Nothing to return. Run estGeno() to obtain the ",
             "corrected genotype data.")
    }

    # Get parental sample information
    p_id <- getParents(object = object, verbose = FALSE)
    if(is.null(p_id)){
        member_id <- c("dummy1", "dummy2")

    } else {
        member_id <- p_id$memberID
    }

    # Get the ploidy information
    sample_ann <- slot(object = object, name = "sample")

    # Make filters
    if(valid){
        filt_mar <- validMar(object = object)

    } else {
        filt_mar <- rep(x = TRUE,
                        times = nmar(object = object, valid = valid))
    }

    if(!is.null(chr)){
        if(length(chr) > 1){
            warning("More than one values were specified to chr,",
                    " but use the first one")
        }
        chr_data <- seqGetData(gdsfile = object, var.name = "chromosome")
        filt_mar <- filt_mar & chr_data == chr[1]
    }

    # Prepare the output
    pgt_index <- index.gdsn(node = object, path = node)
    objdesp <- objdesp.gdsn(pgt_index)
    sel <- list(rep(x = TRUE, times = objdesp$dim[1]), filt_mar)
    out <- readex.gdsn(node = pgt_index, sel = sel)
    p_info <- getParents(object = object)
    if(!is.null(p_info)){
        p_indices <- rbind(p_info$memberID * 2 - 1, p_info$memberID * 2)
        out <- out[as.vector(p_indices), ]
        n_ploidy <- nrow(out) / length(p_info$sampleID)
        rownames(out) <- paste(rep(p_info$sampleID, each = n_ploidy),
                               seq_len(n_ploidy), sep = "_")

    } else {
        rownames(out) <- NULL
    }

    # Set row and col names
    filters <- .makeFilter(object = object, parents = TRUE,
                           valid = valid, chr = chr)
    colnames(out) <- .filtData(object = object,
                               node = "variant.id",
                               filters = filters)
    return(out)
}

#' @importFrom gdsfmt readex.gdsn index.gdsn
#' @rdname getHaplotype
setMethod("getHaplotype",
          "GbsrGenotypeData",
          function(object, parents, valid, chr){
              node <-  "annotation/format/HAP/data"

              # Check whether the node exists
              if(!exist.gdsn(node = object, path = node)){
                  stop("Nothing to return.\nRun estGeno() to obtain the ",
                       "estimated haplotype data.")
              }

              # Make filters
              filters <- .makeFilter(object = object, parents = parents,
                                     valid = valid, chr = chr)

              # Get the ploidy information
              sample_ann <- slot(object = object, name = "sample")
              ploidy <- attributes(sample_ann)[["ploidy"]]

              # Prepare the output
              out <- readex.gdsn(index.gdsn(node = object, path = node),
                                 sel = list(rep(x = TRUE, time = ploidy),
                                            filters$sam, filters$mar))

              # Set the numerically expressed missing values to NA
              out[out == 0] <- NA
              return(out)
          })

###############################################################################
## Exported getter functions which return
## statistical summary information obtained via
## countGenotype(), countRead(), and calcReadStats().

## Get the number of reference reads per marker and per sample.
#' @rdname getCountReadRef
setMethod("getCountReadRef",
          "GbsrGenotypeData",
          function(object, target, valid, prop){
              out <- .getStatsData(object = object, var = "countReadRef",
                                   target = target, valid = valid)

              if(is.null(out)){
                  stop("Nothing to rerurn. Run countRead().")
              }

              if(prop){
                  tmp <- .getStatsData(object = object, var = "countReadAlt",
                                       target = target, valid = valid)
                  out <- out / (out + tmp)
              }
              return(out)
          })

## Get the number of alternative reads per marker and per sample.
#' @rdname getCountReadAlt
setMethod("getCountReadAlt",
          "GbsrGenotypeData",
          function(object, target, valid, prop){
              out <- .getStatsData(object = object, var = "countReadAlt",
                                   target = target, valid = valid)

              if(is.null(out)){
                  stop("Nothing to rerurn. Run countRead().")
              }

              if(prop){
                  tmp <- .getStatsData(object = object, var = "countReadRef",
                                       target = target, valid = valid)
                  out <- out / (out + tmp)
              }
              return(out)
          })

## Get the number of total reads per marker and per sample.
#' @rdname getCountRead
setMethod("getCountRead",
          "GbsrGenotypeData",
          function(object, target, valid){
              ref <- .getStatsData(object = object, var = "countReadRef",
                                   target = target, valid = valid)
              alt <- .getStatsData(object = object, var = "countReadAlt",
                                   target = target, valid = valid)
              if(is.null(ref)){
                  stop("Nothing to rerurn. Run countRead().")
              }
              out <- ref + alt
              return(out)
          })

## Get the number of reference homozygous genotype calls
## per marker and per sample.
#' @rdname getCountGenoRef
setMethod("getCountGenoRef",
          "GbsrGenotypeData",
          function(object, target, valid, prop){
              out <- .getStatsData(object = object, var = "countGenoRef",
                                   target = target, valid = valid)
              if(is.null(out)){
                  stop("Nothing to rerurn. Run countGenotype().")
              }

              stopifnot(is.logical(prop))
              if(prop){
                  tmp <- .getStatsData(object = object, var = "countGenoMissing",
                                       target = target, valid = valid)
                  if(target == "marker"){
                      nonmissing <- nsam(object = object, valid = valid) - tmp

                  } else {
                      nonmissing <- nmar(object = object, valid = valid) - tmp
                  }
                  out <- out / nonmissing
              }
              return(out)
          })

## Get the number of heterozygous genotype calls per marker and per sample.
#' @rdname getCountGenoHet
setMethod("getCountGenoHet",
          "GbsrGenotypeData",
          function(object, target, valid, prop){
              out <- .getStatsData(object = object, var = "countGenoHet",
                                   target = target, valid = valid)
              if(is.null(out)){
                  stop("Nothing to rerurn. Run countGenotype().")
              }

              stopifnot(is.logical(prop))
              if(prop){
                  tmp <- .getStatsData(object = object, var = "countGenoMissing",
                                       target = target, valid = valid)
                  if(target == "marker"){
                      nonmissing <- nsam(object = object, valid = valid) - tmp

                  } else {
                      nonmissing <- nmar(object = object, valid = valid) - tmp
                  }
                  out <- out / nonmissing
              }
              return(out)
          })

## Get the number of alternative homozygous genotype calls
## per marker and per sample.
#' @rdname getCountGenoAlt
setMethod("getCountGenoAlt",
          "GbsrGenotypeData",
          function(object, target, valid, prop){
              stopifnot(is.logical(prop))

              out <- .getStatsData(object = object, var = "countGenoAlt",
                                   target = target, valid = valid)
              if(is.null(out)){
                  stop("Nothing to rerurn. Run countGenotype().")
              }

              if(prop){
                  tmp <- .getStatsData(object = object, var = "countGenoMissing",
                                       target = target, valid = valid)
                  if(target == "marker"){
                      nonmissing <- nsam(object = object, valid = valid) - tmp

                  } else {
                      nonmissing <- nmar(object = object, valid = valid) - tmp
                  }
                  out <- out / nonmissing
              }
              return(out)
          })

## Get the number of missing genotype calls per marker and per sample.
#' @rdname getCountGenoMissing
setMethod("getCountGenoMissing",
          "GbsrGenotypeData",
          function(object, target, valid, prop){
              stopifnot(is.logical(prop))

              out <- .getStatsData(object = object, var = "countGenoMissing",
                                   target = target, valid = valid)
              if(is.null(out)){
                  stop("Nothing to rerurn. Run countGenotype().")
              }

              if(prop){
                  if(target == "marker"){
                      out <- out / nsam(object = object, valid = valid)
                  } else {
                      out <- out / nmar(object = object, valid = valid)
                  }
              }
              return(out)
          })

## Get the number of reference alleles per marker and per sample.
#' @rdname getCountAlleleRef
setMethod("getCountAlleleRef",
          "GbsrGenotypeData",
          function(object, target, valid, prop){
              stopifnot(is.logical(prop))

              out <- .getStatsData(object = object, var = "countAlleleRef",
                                   target = target, valid = valid)
              if(is.null(out)){
                  stop("Nothing to rerurn. Run countGenotype().")
              }

              if(prop){
                  tmp <- .getStatsData(object = object, var = "countAlleleMissing",
                                       target = target, valid = valid)
                  if(target == "marker"){
                      nonmissing <- nsam(object = object, valid = valid) * 2 - tmp
                  } else {
                      nonmissing <- nmar(object = object, valid = valid) * 2 - tmp
                  }
                  out <- out / nonmissing
              }
              return(out)
          })

## Get the number of alternative alleles per marker and per sample.
#' @rdname getCountAlleleAlt
setMethod("getCountAlleleAlt",
          "GbsrGenotypeData",
          function(object, target, valid, prop){
              stopifnot(is.logical(prop))

              out <- .getStatsData(object = object, var = "countAlleleAlt",
                                   target = target, valid = valid)
              if(is.null(out)){
                  stop("Nothing to rerurn. Run countGenotype().")
              }

              if(prop){
                  tmp <- .getStatsData(object = object, var = "countAlleleMissing",
                                       target = target, valid = valid)
                  if(target == "marker"){
                      nonmissing <- nsam(object = object, valid = valid) * 2 - tmp
                  } else {
                      nonmissing <- nmar(object = object, valid = valid) * 2 - tmp
                  }
                  out <- out / nonmissing
              }
              return(out)
          })

## Get the number of missing alleles per marker and per sample.
#' @rdname getCountAlleleMissing
setMethod("getCountAlleleMissing",
          "GbsrGenotypeData",
          function(object, target, valid, prop){
              stopifnot(is.logical(prop))

              out <- .getStatsData(object = object, var = "countAlleleMissing",
                                   target = target, valid = valid)
              if(is.null(out)){
                  stop("Nothing to rerurn. Run countGenotype().")
              }

              if(prop){
                  if(target == "marker"){
                      out <- out / (nsam(object = object, valid = valid) * 2)
                  } else {
                      out <- out / (nmar(object = object, valid = valid) * 2)
                  }
              }
              return(out)
          })

## Get the number of mean reference allele reads per marker and per sample.
#' @rdname getMeanReadRef
setMethod("getMeanReadRef",
          "GbsrGenotypeData",
          function(object, target, valid){
              out <- .getStatsData(object = object, var = "meanReadRef",
                                   target = target, valid = valid)
              if(is.null(out)){
                  stop("Nothing to rerurn. Run countRead().")
              }

              return(out)
          })

## Get the number of mean alternative allele reads per marker and per sample.
#' @rdname getMeanReadAlt
setMethod("getMeanReadAlt",
          "GbsrGenotypeData",
          function(object, target, valid){
              out <- .getStatsData(object = object, var = "meanReadAlt",
                                   target = target, valid = valid)
              if(is.null(out)){
                  stop("Nothing to rerurn. Run countRead().")
              }

              return(out)
          })

## Get SD of the number of reference allele reads per marker and per sample.
#' @rdname getSDReadRef
setMethod("getSDReadRef",
          "GbsrGenotypeData",
          function(object, target, valid){
              out <- .getStatsData(object = object, var = "sdReadRef",
                                   target = target, valid = valid)
              if(is.null(out)){
                  stop("Nothing to rerurn. Run countRead().")
              }

              return(out)
          })

## Get SD of the number of alternative allele reads per marker and per sample.
#' @rdname getSDReadAlt
setMethod("getSDReadAlt",
          "GbsrGenotypeData",
          function(object, target, valid){
              out <- .getStatsData(object = object, var = "sdReadAlt",
                                   target = target, valid = valid)
              if(is.null(out)){
                  stop("Nothing to rerurn. Run countRead().")
              }

              return(out)
          })


## Get the number of mean reference allele reads per marker and per sample.
#' @rdname getMedianReadRef
setMethod("getMedianReadRef",
          "GbsrGenotypeData",
          function(object, target, valid){
              out <- .getStatsData(object = object, var = "medianReadRef",
                                   target = target, valid = valid)
              if(is.null(out)){
                  stop("Nothing to rerurn. Run countRead().")
              }

              return(out)
          })

## Get the number of mean alternative allele reads per marker and per sample.
#' @rdname getMedianReadAlt
setMethod("getMedianReadAlt",
          "GbsrGenotypeData",
          function(object, target, valid){
              out <- .getStatsData(object = object, var = "medianReadAlt",
                                   target = target, valid = valid)
              if(is.null(out)){
                  stop("Nothing to rerurn. Run countRead().")
              }

              return(out)
          })

## Get minor allele frequencies per marker and per sample.
#' @rdname getMAF
setMethod("getMAF",
          "GbsrGenotypeData",
          function(object, target, valid){
              out <- getCountAlleleRef(object = object, target = target,
                                       valid = valid, prop = TRUE)
              out <- 0.5 - abs(out - 0.5)
              return(out)
          })

## Get minor allele counts per marker and per sample.
#' @rdname getMAC
setMethod("getMAC",
          "GbsrGenotypeData",
          function(object, target, valid){
              ref <- getCountAlleleRef(object = object, target = target,
                                       valid = valid, prop = FALSE)
              alt <- getCountAlleleAlt(object = object, target = target,
                                       valid = valid, prop = FALSE)
              out <- ref
              alt_minor <- ref > alt
              out[alt_minor] <- alt[alt_minor]
              return(out)
          })

## Get the information of the parents.
#' @rdname getParents
setMethod("getParents",
          "GbsrGenotypeData",
          function(object, bool, verbose = TRUE){
              parents <- slot(object, "sample")[["parents"]]

              if(is.null(parents)){
                  if(verbose){
                      warning("No parents specified.", call. = FALSE)
                  }
                  return(NULL)
              }

              parents_node <- index.gdsn(object$root, "parents/data")
              parent_info <- read.gdsn(parents_node)
              if(bool){
                  return(parent_info != 0)
              }

              sample_id <- getSamID(object, valid = FALSE)
              parents_id <- sample_id[parent_info != 0]
              out <- data.frame(sampleID = parents_id,
                                memberID = parent_info[parent_info != 0],
                                indexes = which(parent_info != 0))
              return(out)
          })

###############################################################################
## Exported getter functions which return a boolen value.

## Check if the connection to the GDS file is open.
#' @rdname isOpenGDS
#' @importFrom gdsfmt diagnosis.gds
setMethod("isOpenGDS",
          "GbsrGenotypeData",
          function(object){
              tryout <- try(diagnosis.gds(gds = object),
                            silent = TRUE)
              if(is.list(tryout)){
                  out <- TRUE

              } else if(grepl(pattern = "The GDS file is closed", x = tryout)){
                  out <- FALSE

              } else {
                  out <- tryout[1]
              }
              return(out)
          })

###############################################################################
# Setter for sample annotation information

## Set parental samples.
#' @rdname setParents
#' @importFrom methods slot<-
setMethod("setParents",
          "GbsrGenotypeData",
          function(object, parents, nonmiss, mono, bi){
              parents <- unique(parents)
              if(length(parents) == 0 | any(is.na(parents))){
                  stop('Specify valid sample names as parents.', call. = FALSE)
              }

              if(inherits(x = parents, what = "numeric")){
                  parents <- getSamID(object = object)[parents]
              }

              if(!inherits(x = parents, what = "character")){
                  stop('Specify valid sample names as parents.', call. = FALSE)
              }

              if(!is.null(slot(object = object, name = "sample")[["parents"]])){
                  message("Overwrite the previous parents information.")
                  slot(object = object, name = "sample")[["parents"]] <- NULL
              }

              # Get indices for specified parental samples
              id <- getSamID(object = object, valid = FALSE)
              p_index <- match(x = parents, table = id)
              if(any(is.na(p_index))){
                  missing_id <- parents[is.na(p_index)]
                  stop("No sample named: ", missing_id, call. = FALSE)
              }

              # Check if specified parental samples have been set as replicates
              replicates <- getReplicates(object = object, parents = TRUE)
              p_replicates <- replicates[p_index]
              if(any(duplicated(p_replicates))){
                  stop("Some specified samples have been set as replicates.",
                       "\nSpecify one of the sample IDs for the replicates as",
                       " a parent.",
                       "\nSee the vignette for more information.")
              }

              # Set replicates to have the same index
              n_parents <- length(p_index)
              p_vec <- integer(nsam(object = object, valid = FALSE))
              if(is.null(slot(object = object, name = "sample")[["replicates"]])){
                  p_vec[p_index] <- seq_len(n_parents)

              } else {
                  replicates <- slot(object = object, name = "sample")[["replicates"]]
                  p_rep_id <- replicates[p_index]
                  rep_hit <- match(x = replicates, table = p_rep_id)
                  p_vec[!is.na(rep_hit)] <- na.omit(rep_hit)
              }

              # Set parental samples to be invalid to let GBScleanR ignore them
              # from stats calculations
              valid_sam <- validSam(object = object, parents = FALSE)
              valid_sam[p_vec != 0] <- FALSE
              validSam(object = object) <- valid_sam
              slot(object = object, name = "sample")[["parents"]] <- p_vec
              .create_gdsn(root_node = object$root,
                           target_node = "",
                           new_node = "parents",
                           val = p_vec,
                           storage = "int",
                           valdim = nsam(object = object, valid = FALSE),
                           replace = TRUE, attr = NULL)

              if(n_parents == 1){
                  mono <- FALSE
                  bi <- TRUE
              }
              # Parental genotype based marker filtering
              if(mono | bi){
                  object <- .pGenoFilt(object = object,
                                       nonmiss = nonmiss, mono = mono, bi = bi)
              }

              # Update the scheme object
              scheme <- slot(object = object, name = "scheme")
              if(length(slot(object = scheme, name = "parents")) != 0){
                  parents <- getParents(object = object)
                  slot(scheme, "parents") <- parents$memberID
                  slot(object, "scheme") <- scheme
              }

              return(object)
          })

.pGenoFilt <- function(object, nonmiss, mono, bi){
    p_id <- getParents(object = object)

    # Sum up reads if replicates for parental samples exist
    if(length(unique(p_id$memberID)) != length(p_id$memberID)){
        ad <- getRead(object = object, node = "raw", parents = "only",
                      valid = FALSE, chr = NULL)
        rep_id <- getReplicates(object = object, parents = "only")
        ad <- .pileupAD(ad = ad, rep_id = rep_id)
        gt <- .recalcGT(ad = ad)

    } else {
        gt <- getGenotype(object = object, node = "raw", parents = "only",
                          valid = FALSE, chr = NULL)

    }

    if(nonmiss){
        nonmiss <- colSums(is.na(gt)) == 0
    } else {
        nonmiss <- rep(x = TRUE, times = nmar(object = object, valid = FALSE))
    }

    if(mono){
        mono <- colSums(gt == 1) == 0
        mono[is.na(mono)] <- FALSE
    } else {
        mono <- rep(x = TRUE, times = nmar(object = object, valid = FALSE))
    }

    if(bi){
        bi <- colSums(gt == 0) != nrow(gt) & colSums(gt == 2) != nrow(gt)
        bi[is.na(bi)] <- FALSE
    } else {
        bi <- rep(TRUE, nmar(object, FALSE))
    }

    validMar(object = object) <- nonmiss & mono & bi & validMar(object = object)
    return(object)
}

.pileupAD <- function(ad, rep_id){
    dup <- duplicated(rep_id)
    if(sum(dup) == 0){
        return(ad)
    }
    names2id <- data.frame(id = as.character(rep_id[!dup]),
                           names = names(rep_id)[!dup])
    ad_ref <- tapply(X = seq_along(rep_id), INDEX = rep_id, FUN = function(i){
        if(length(i) == 1){
            return(ad$ref[i, ])

        } else {
            return(colSums(ad$ref[i, ]))
        }
    })
    row_names <- names(ad_ref)
    ad_ref <- do.call(what = "rbind", args = ad_ref)
    hit <- match(row_names, names2id$id)
    rownames(ad_ref) <- names2id$names[hit]
    ad_alt <- tapply(X = seq_along(rep_id), INDEX = rep_id, FUN = function(i){
        if(length(i) == 1){
            return(ad$alt[i, ])

        } else {
            return(colSums(ad$alt[i, ]))
        }
    })
    ad_alt <- do.call(what = "rbind", args = ad_alt)
    rownames(ad_alt) <- names2id$names[hit]
    return(list(ref = ad_ref, alt = ad_alt))
}

.recalcGT <- function(ad = ad, seq_error = 0.0025){
    gt <- matrix(data = NA, nrow = nrow(ad$ref), ncol = ncol(ad$ref))
    pl_ref <- log10(1 - seq_error) * ad$ref + log10(seq_error) * ad$alt
    pl_het <- log10(0.5) * (ad$ref + ad$alt)
    pl_alt <- log10(seq_error) * ad$ref + log10(1 - seq_error) * ad$alt

    gt[pl_ref > pl_het & pl_ref > pl_alt] <- 0
    gt[pl_het > pl_ref & pl_het > pl_alt] <- 1
    gt[pl_alt > pl_het & pl_alt > pl_ref] <- 2
    return(gt)
}

## Set replicates
#' @rdname setReplicates
setMethod("setReplicates",
          "GbsrGenotypeData",
          function(object, replicates){

              n_samples <- nsam(object = object, valid = FALSE)
              if(sum(n_samples) != length(replicates)){
                  stop("\nThe length of the vector specified to the replicates",
                       " argument does not match the number of total samples ",
                       "obtained by nsam(object = object, valid = FALSE).",
                       "\nReplicate IDs should be set to all samples.",
                       "\nSee the vignette for more information.",
                       call. = FALSE)
              }
              replicates <- as.numeric(factor(replicates))
              sample <- slot(object = object, name = "sample")
              sample$replicates <- replicates
              slot(object = object, name = "sample") <- sample

              p_info <- getParents(object = object)
              if(!is.null(p_info)){
                  n_p <- length(unique(p_info$memberID))
                  object <- setParents(object = object,
                                       parents = p_info$sampleID)
                  p_info <- getParents(object = object)
                  n_p_updated <- length(unique(p_info$memberID))

                  if(n_p != n_p_updated){
                      warning("The number of parents was changed",
                              " after setting replicates.",
                              "\nCheck the parent information with 'getParents()'.")
                  }
              }

              return(object)
          })

## Get replicates
#' @rdname getReplicates
setMethod("getReplicates",
          "GbsrGenotypeData",
          function(object, parents){
              out <- slot(object = object, name = "sample")[["replicates"]]
              sample_id <- getSamID(object = object, valid = FALSE)
              if(is.null(out)){
                  out <- seq_along(sample_id)

              } else {
                  out <- slot(object = object, name = "sample")[["replicates"]]
              }
              names(out) <- sample_id
              out <- out[validSam(object = object, parents = parents)]
              return(out)
          })

###############################################################################
## Show the GbsrGenotypeData object.
#' @importFrom methods show
setMethod("show",
          "GbsrGenotypeData",
          function(object){
              print(object$root)
              message("No of samples: ", nsam(object = object))
              message("No of markers: ", nmar(object = object))
              sample_ann <- slot(object = object, name = "sample")
              message("Data in the sample slot: ", paste(names(sample_ann),
                                                         collapse = ", "))
              marker_ann <- slot(object = object, name = "marker")
              message("Data in the marker slot: ", paste(names(marker_ann),
                                                         collapse = ", "))
              message("No of generations in the scheme object: ",
                      length(object@scheme@mating))
          })

###############################################################################
## Functions to communicate with the GDS file.

## Close the connection to the GDS file.
#' @rdname closeGDS
#' @importFrom SeqArray seqClose seqAddValue
setMethod("closeGDS",
          "GbsrGenotypeData",
          function(object, save_filter, verbose){
              if(save_filter){
                  seqAddValue(gdsfile = object, varnm = "annotation/info/GFL",
                              val = validMar(object = object),
                              replace = TRUE, compress = "ZIP_RA",
                              verbose = FALSE)
                  seqAddValue(gdsfile = object, varnm = "sample.annotation",
                              val = data.frame(GFL = validSam(object = object)),
                              replace = TRUE, compress = "ZIP_RA",
                              verbose = FALSE)
                  gfl_gdsn <- index.gdsn(node = object,
                                         path = "annotation/info/GFL")
                  attr <- list(Number = "1",
                               Type = "Integer",
                               Description = "Filtering information generated by GBScleanR")
                  .putAttrGdsn(node = gfl_gdsn, attr = attr)
              }
              seqClose(object = object)
              if(verbose){
                  message('The connection to the GDS file was closed.')
              }
          })

## Close the connection to the GDS file.
#' @rdname reopenGDS
#' @importFrom SeqArray seqOpen
setMethod("reopenGDS",
          "GbsrGenotypeData",
          function(object){
              gds_fn <- object$filename
              if(isOpenGDS(object = object)){
                  closeGDS(object = object, save_filter = FALSE)
              }
              object <- new("GbsrGenotypeData",
                            seqOpen(gds.fn = gds_fn, readonly = FALSE),
                            marker = slot(object = object, name = "marker"),
                            sample = slot(object = object, name = "sample"),
                            scheme = slot(object = object, name = "scheme"))
              return(object)
          })


###############################################################################
## Functions to calculate statistical summaries of
## genotype calls and read counts.

## Calculate the numbers of each genotype and each allele per marker and
## per sample.
#' @importFrom gdsfmt exist.gdsn apply.gdsn
#' @rdname countGenotype
setMethod("countGenotype",
          "GbsrGenotypeData",
          function(object, target, node){
              node <- match.arg(arg = node, choices = c("raw", "cor", "filt"))
              switch(node,
                     raw = node <- "genotype/data",
                     cor = node <- "annotation/format/CGT/data",
                     filt = node <- "annotation/format/FGT/data"
              )

              if(!exist.gdsn(node = object, path = node)){
                  if(grepl(pattern = "FGT", x = node)){
                      stop("Nothing to return.",
                           " Run setCallFilter() if needed.")

                  } else {
                      stop("Nothing to return. Run estGeno() to obtain the",
                           " corrected genotype data.")
                  }
              }

              # Counts per sample
              if(target %in% c("both", "sample")){
                  object <- .countGeno(object = object, node = node,
                                       margin = 2, slotid = "sample")
              }

              # Counts per marker
              if(target %in% c("both", "marker")){
                  object <- .countGeno(object = object, node = node,
                                       margin = 3, slotid = "marker")
              }

              # Clean up RAM
              gc()
              return(object)
          })

#' @importFrom gdsfmt apply.gdsn
#' @importFrom methods slot<-
.countGeno <- function(object, node, margin, slotid){

    # Make filters
    sel <- list(rep(x = TRUE, times = 2),
                validSam(object = object),
                validMar(object = object))

    # Apply the Cpp-coded count_geno function
    out <- apply.gdsn(node = index.gdsn(node = object, path = node),
                      margin = margin, FUN = count_geno,
                      selection = sel, as.is = "list")
    out <- do.call(what = "rbind", args = out)

    # Organize output
    if(margin == 2){
        df <- matrix(data = NA,
                     nrow = nsam(object = object, valid = FALSE), ncol = 7)
        df[validSam(object = object), ] <- out

    } else {
        df <- matrix(data = NA, nmar(object = object, valid = FALSE), ncol = 7)
        df[validMar(object = object), ] <- out
    }

    # Put the output into the slot
    slot(object = object, name = slotid)$countGenoRef <- df[, 1]
    slot(object = object, name = slotid)$countGenoHet <- df[, 2]
    slot(object = object, name = slotid)$countGenoAlt <- df[, 3]
    slot(object = object, name = slotid)$countGenoMissing <- df[, 4]
    slot(object = object, name = slotid)$countAlleleRef <- df[, 5]
    slot(object = object, name = slotid)$countAlleleAlt <- df[, 6]
    slot(object = object, name = slotid)$countAlleleMissing <- df[, 7]
    return(object)
}

## Calculate the numbers of reads of each allele per marker and per sample.
#' SeqArray seqSetFilter
#' @rdname countRead
setMethod("countRead",
          "GbsrGenotypeData",
          function(object, target, node){
              node <- match.arg(arg = node, choices = c("raw", "filt"))
              switch(node,
                     raw = node <- "annotation/format/AD",
                     filt = node <- "annotation/format/FAD"
              )

              if(!exist.gdsn(node = object, path = node)){
                  stop("Nothing to return.",
                       " Run setCallFilter() if needed.")
              }

              # Set filtering to specify the markers to be counted
              seqSetFilter(object = object,
                           variant.sel = validMar(object = object),
                           sample.sel = validSam(object),
                           action = "push+intersect", verbose = FALSE)

              # Get max read counts in the data
              tot_read <- seqApply(gdsfile = object, var.name = node,
                                   FUN = sum, margin = "by.sample",
                                   as.is = "integer")

              # Counts per sample
              if(target %in% c("both", "sample")){
                  object <- .countRead(object = object, node = node,
                                       margin = "by.sample", slotid = "sample",
                                       tot_read = tot_read)
              }

              # Counts per marker
              if(target %in% c("both", "marker")){
                  object <- .countRead(object = object, node = node,
                                       margin = "by.variant", slotid = "marker",
                                       tot_read = tot_read)
              }

              # Reset filters
              seqSetFilter(object = object, action = "pop", verbose = FALSE)

              # Clean up RAM
              gc()
              return(object)
          })

#' @importFrom SeqArray seqApply
.countRead <- function(object, node, margin, slotid, tot_read){
    if(margin == "by.sample"){
        tot_read <- 0
    }

    # Apply the Cpp-coded count_read function
    out <- seqApply(gdsfile = object, var.name = node, FUN = count_read,
                    margin = margin, as.is = "list", tot_read = tot_read)
    out <- do.call(what = "rbind", args = out)

    # Organize the output
    if(margin == "by.sample"){
        df <- matrix(data = NA,
                     nrow = nsam(object = object, valid = FALSE), ncol = 8)
        df[validSam(object = object), ] <- out

    } else {
        df <- matrix(data = NA,
                     nrow = nmar(object = object, valid = FALSE), ncol = 8)
        df[validMar(object = object), ] <- out
    }

    # Put the output into the slot
    slot(object = object, name = slotid)$countReadRef <- df[, 1]
    slot(object = object, name = slotid)$countReadAlt <- df[, 2]
    slot(object = object, name = slotid)$meanReadRef <- df[, 3]
    slot(object = object, name = slotid)$meanReadAlt <- df[, 4]
    slot(object = object, name = slotid)$sdReadRef <- df[, 5]
    slot(object = object, name = slotid)$sdReadAlt <- df[, 6]
    slot(object = object, name = slotid)$medianReadRef <- df[, 7]
    slot(object = object, name = slotid)$medianReadAlt <- df[, 8]
    return(object)
}

###############################################################################
## Filtering functions.

## Thinout markers.
#' @rdname thinMarker
setMethod("thinMarker",
          "GbsrGenotypeData",
          function(object, range){

              # Check if the genotype missing rate is available
              marker_ann <- slot(object = object, name = "marker")
              if(is.null(marker_ann[["countGenoMissing"]])){
                  stop('Run countGenotype() first.', call. = FALSE)
              }

              # Check input parameter validity
              if(!{is.numeric(range) & length(range) == 1 & range >= 0}){
                  stop("range should be a number greater or equal to zero.",
                       call. = FALSE)
              }

              # Get missing count par marker
              missing_count <- getCountGenoMissing(object = object)

              # Thinout markers
              chr <- as.integer(factor(getChromosome(object = object)))
              pos <- getPosition(object = object)
              out <- thinout_marker(chr = chr, pos = pos,
                                    missing_count = missing_count, range = range)

              # Update marer validity information
              cur_valid <- validMar(object = object)
              cur_valid[cur_valid] <- out
              validMar(object = object) <- cur_valid
              return(object)
          })

## Filter out genotype calls meet the criteria.
#' @importFrom gdsfmt put.attr.gdsn
#' @importFrom SeqArray seqOptimize
#' @rdname setCallFilter
setMethod("setCallFilter",
          "GbsrGenotypeData",
          function(object,
                   dp_count,
                   ref_count,
                   alt_count,
                   dp_qtile,
                   ref_qtile,
                   alt_qtile){

              # Create the nodes to store the filtered data
              .create_gdsn(root_node = object$root,
                           target_node = "annotation/format",
                           new_node = "FAD",
                           val = 0L,
                           storage = "int64",
                           valdim = c(nsam(object = object, valid = FALSE),
                                      nmar(object = object, valid = FALSE) * 2),
                           replace = TRUE,
                           attr = list(Number = "2",
                                       Type = "Integer",
                                       Description = "Call-filtered read counts generated by GBScleanR"))
              add.gdsn(node = index.gdsn(node = object$root,
                                         path = "annotation/format/FAD"),
                       name = "@data",
                       val = rep(x = 2,
                                 times = nmar(object = object, valid = FALSE)),
                       storage = "dInt32", compress = "ZIP_RA",
                       closezip = TRUE, visible = FALSE)

              .create_gdsn(root_node = object$root,
                           target_node = "annotation/format",
                           new_node = "FGT",
                           val = 0L,
                           storage = "bit2",
                           valdim = c(2,
                                      nsam(object = object, valid = FALSE),
                                      nmar(object = object, valid = FALSE)),
                           replace = TRUE,
                           attr = list(Number = "1",
                                       Type = "Integer",
                                       Description = "Call-filtered genotype generated by GBScleanR"))

              # Validate the given filtering settings
              filt_list <- list(dp_count = dp_count, ref_count = ref_count,
                                alt_count = alt_count, dp_qtile = dp_qtile,
                                ref_qtile = ref_qtile, alt_qtile = alt_qtile)
              .checkCallArgValid(filt_list = filt_list)

              # Generate filtered AD data
              .applySampleCallFilter(object = object, filt_list = filt_list)

              # Optimize the nodes
              closeGDS(object = object, verbose = FALSE)
              seqOptimize(gdsfile = object$filename, target = "by.sample",
                          format.var = c("FAD", "FGT"),
                          verbose = FALSE)
              object <- reopenGDS(object = object)
              .compressNodes(object = object,
                             node = c("annotation/format/FAD/data",
                                      "annotation/format/FAD/~data",
                                      "annotation/format/FGT/data",
                                      "annotation/format/FGT/~data"))
              return(object)
          })

.checkCallArgValid <- function(filt_list){
    check <- FALSE
    for(i in names(filt_list)){
        if(grepl(pattern = "count", x = i)){
            if(!{is.numeric(filt_list[[i]]) & length(filt_list[[i]]) == 2 &
                    all(filt_list[[i]] >= 0)}){
                stop(i, " should be two numbers greater than zero.",
                     call. = FALSE)

            } else if(filt_list[[i]][1] > filt_list[[i]][2]){
                stop(i, "[1] should be smaller than", i, "[2].", call. = FALSE)
            }
            check <- check | any(filt_list[[i]] != c(0, Inf))
        }

        if(grepl(pattern = "qtile", x = i)){
            if(!{is.numeric(filt_list[[i]]) &
                    length(filt_list[[i]]) == 2 &
                    all(filt_list[[i]] <= 1) &
                    all(filt_list[[i]] >= 0)}){
                stop(i, " should be two numbers in [0-1].", call. = FALSE)

            } else if(filt_list[[i]][1] > filt_list[[i]][2]){
                stop(i, "[1] should be smaller than", i, "[2].", call. = FALSE)
            }
            check <- check | any(filt_list[[i]] != c(0, 1))
        }
    }
    if(!check){
        stop("Nothing to filter out. Check the filtering criteria.")
    }
}

#' @importFrom stats quantile
.applySampleCallFilter <- function(object, filt_list){
    read <- getRead(object = object, node = "raw")
    read$dp <- read$ref + read$alt

    # Record valid calls
    valid_sam <- validSam(object = object)
    valid_mar <- validMar(object = object)
    filter_matrix <- matrix(data = TRUE,
                            nrow = length(valid_sam),
                            ncol = length(valid_mar))

    # Set filtering parameters
    val <- c("dp", "ref", "alt", "dp", "ref", "alt")
    filt <- c("dp_count", "ref_count", "alt_count",
              "dp_qtile", "ref_qtile", "alt_qtile")
    def <- list(c(0, Inf), c(0, Inf), c(0, Inf), c(0, 1), c(0, 1), c(0, 1))

    # Apply filtering
    for(i in seq_along(filt)){
        if(any(def[[i]] != filt_list[[filt[i]]])){
            if(grepl("qtile", filt[i])){
                threshold <- t(vapply(X = seq_len(nrow(read[[val[i]]])),
                                      FUN.VALUE = numeric(length = 2L),
                                      FUN = function(j){
                                          read_j <- read[[val[i]]][j, ]
                                          out <- quantile(x = read_j,
                                                          probs = filt_list[[filt[i]]])
                                          return(out)
                                      }))
            } else {
                threshold <- filt_list[[filt[i]]]
            }
            filter_out <- .calcSubFilter(variable = read[[val[i]]],
                                         threshold = threshold,
                                         default = def[[i]],
                                         greater = TRUE, equal = TRUE)
            filter_matrix[valid_sam, valid_mar] <- filter_matrix[valid_sam, valid_mar] & filter_out
        }
    }

    # Create filtered data
    rm(read)
    gc()
    .makeCallFilterData(object = object, filter_matrix = filter_matrix)
}

#' @importFrom gdsfmt write.gdsn index.gdsn read.gdsn
.makeCallFilterData <- function(object, filter_matrix){
    read <- getRead(object = object, node = "raw", parents = TRUE, valid = FALSE)

    # Create filtered allele read depth data
    fad_data <- index.gdsn(node = object$root,
                           path = "annotation/format/FAD/data")
    val <- matrix(data = 0L, nrow = nrow(read$ref), ncol = ncol(read$ref) * 2)
    read$ref[!filter_matrix] <- 0
    read$alt[!filter_matrix] <- 0
    val[, c(TRUE, FALSE)] <- read$ref
    val[, c(FALSE, TRUE)] <- read$alt
    write.gdsn(node = fad_data, val = val)
    rm(read, val)

    # Create filtered genotype call data
    gt_data <- index.gdsn(node = object$root, path = "genotype/data")
    gt <- read.gdsn(node = gt_data)
    gt[1,,][!filter_matrix] <- 3
    gt[2,,][!filter_matrix] <- 3
    fgt_data <- index.gdsn(node = object$root,
                           path = "annotation/format/FGT/data")
    write.gdsn(node = fgt_data, val = gt)
}

.calcSubFilter <- function(variable, threshold, default, greater, equal){
    if(is.null(variable)){
        return(TRUE)
    }

    if(is.matrix(threshold)){
        # When the input to be evaluated is a matrix,
        # vectorized evaluation will applied
        output <- .compareValues(x = variable, y = threshold[, 1],
                                 greater = greater, equal = equal) &
            .compareValues(x = variable, y = threshold[, 2],
                           greater = !greater, equal = equal)

    } else {
        if(length(default) == 1){
            # If the input to be evaluated has the length of 1,
            # handle it as following.
            if("comp" %in% threshold[1]){
                output <- .compareValues(x = variable, y = default,
                                         greater = greater, equal = FALSE)

            } else if(threshold != default){
                output <- .compareValues(x = variable, y = threshold,
                                         greater = greater, equal = equal)

            } else {
                output <- TRUE
            }

        } else if(length(default) == 2){
            if("comp" %in% threshold[1]){
                output <- .compareValues(x = variable, y = default[1],
                                         greater = greater, equal = FALSE) &
                    .compareValues(x = variable, y = default[2],
                                   greater = !greater, equal = FALSE)

            } else if(any(threshold != default)){
                output <- .compareValues(x = variable, y = threshold[1],
                                         greater = greater, equal = equal) &
                    .compareValues(x = variable, y = threshold[2],
                                   greater = !greater, equal = equal)

            } else {
                output <- TRUE
            }
        }
    }
    return(output)
}

.compareValues <- function(x, y, greater, equal){
    if(greater & equal){
        out <- x >= y

    } else if(greater & !equal){
        out <- x > y

    } else if(!greater & equal){
        out <- x <= y

    } else if(!greater & !equal){
        out <- x < y
    }
    out[is.na(out)] <- TRUE
    return(out)
}

## Filtering on samples.
#' @rdname setSamFilter
setMethod("setSamFilter",
          "GbsrGenotypeData",
          function(object,
                   id,
                   missing,
                   het,
                   mac,
                   maf,
                   ad_ref,
                   ad_alt,
                   dp,
                   mean_ref,
                   mean_alt,
                   sd_ref,
                   sd_alt){
              filt_list <- list(id = id,
                                missing = missing,
                                het = het,
                                mac = mac,
                                maf = maf,
                                ad_ref = ad_ref,
                                ad_alt = ad_alt,
                                dp = dp,
                                mean_ref = mean_ref,
                                mean_alt = mean_alt,
                                sd_ref = sd_ref,
                                sd_alt = sd_alt)

              # Sample-wise stats based filtering
              out <- .makeStatsFilter(object = object,
                                      filt_list = filt_list,
                                      target = "sample")

              # Update sample filtering information
              cur_valid <- validSam(object = object)
              cur_valid[cur_valid] <- out
              validSam(object = object) <- cur_valid
              return(object)
          })

## Filtering on markers.
#' @rdname setMarFilter
setMethod("setMarFilter",
          "GbsrGenotypeData",
          function(object,
                   id,
                   missing,
                   het,
                   mac,
                   maf,
                   ad_ref,
                   ad_alt,
                   dp,
                   mean_ref,
                   mean_alt,
                   sd_ref,
                   sd_alt){
              filt_list <- list(id = id,
                                missing = missing,
                                het = het,
                                mac = mac,
                                maf = maf,
                                ad_ref = ad_ref,
                                ad_alt = ad_alt,
                                dp = dp,
                                mean_ref = mean_ref,
                                mean_alt = mean_alt,
                                sd_ref = sd_ref,
                                sd_alt = sd_alt)

              # Marker-wise stats based filtering
              out <- .makeStatsFilter(object = object,
                                      filt_list = filt_list,
                                      target = "marker")

              # Update marker filtering infromation
              cur_valid <- validMar(object = object)
              cur_valid[cur_valid] <- out
              validMar(object = object) <- cur_valid
              return(object)
          })

.checkArgValid <- function(filt_list, target){
    if(target == "sample"){
        if(!is.character(filt_list$id)){
            stop("id should be a character vector.", call. = FALSE)
        }
    } else {
        if(!is.numeric(filt_list$id)){
            stop("id should be a integer vector.", call. = FALSE)
        }
    }

    if(!{is.numeric(filt_list$missing) & length(filt_list$missing) == 1 &
            filt_list$missing <= 1 & filt_list$missing >= 0}){
        stop("missing should be a number in [0-1].",
             call. = FALSE)
    }

    if(!{is.numeric(filt_list$het) & length(filt_list$het) == 2 &
            all(filt_list$het <= 1) & all(filt_list$het >= 0)}){
        stop("het should be two numbers in [0-1].",
             call. = FALSE)

    } else if(filt_list$het[1] > filt_list$het[2]){
        stop("het[1] should be smaller than het[2].",
             call. = FALSE)
    }

    if(!{is.numeric(filt_list$mac) &
            length(filt_list$mac) == 1 & filt_list$mac >= 0}){
        stop("mac should be a number greater or equal to zero.",
             call. = FALSE)
    }

    if(!{is.numeric(filt_list$maf) & length(filt_list$maf) == 1 &
            filt_list$maf <= 1 & filt_list$maf >= 0}){
        stop("maf should be a number in [0-1].",
             call. = FALSE)
    }

    if(!{is.numeric(filt_list$ad_ref) &
            length(filt_list$ad_ref) == 2 & all(filt_list$ad_ref >= 0)}){
        stop("ad_ref should be two numbers greater or equal to zero.",
             call. = FALSE)

    } else if(filt_list$ad_ref[1] > filt_list$ad_ref[2]){
        stop("ad_ref[1] should be smaller than ad_ref[2].",
             call. = FALSE)
    }

    if(!{is.numeric(filt_list$ad_alt) &
            length(filt_list$ad_alt) == 2 & all(filt_list$ad_alt >= 0)}){
        stop("ad_alt should be two numbers greater or equal to zero.",
             call. = FALSE)
    } else if(filt_list$ad_alt[1] > filt_list$ad_alt[2]){
        stop("ad_alt[1] should be smaller than ad_alt[2].",
             call. = FALSE)
    }

    if(!{is.numeric(filt_list$dp) &
            length(filt_list$dp) == 2 & all(filt_list$dp >= 0)}){
        stop("dp should be two numbers greater or equal to zero.",
             call. = FALSE)

    } else if(filt_list$dp[1] > filt_list$dp[2]){
        stop("dp[1] should be smaller than dp[2].",
             call. = FALSE)
    }

    if(!{is.numeric(filt_list$mean_ref) &
            length(filt_list$mean_ref) == 2 & all(filt_list$mean_ref >= 0)}){
        stop("mean_ref should be two numbers greater or equal to zero.",
             call. = FALSE)

    } else if(filt_list$mean_ref[1] > filt_list$mean_ref[2]){
        stop("mean_ref[1] should be smaller than mean_ref[2].",
             call. = FALSE)
    }

    if(!{is.numeric(filt_list$mean_alt) &
            length(filt_list$mean_alt) == 2 & all(filt_list$mean_alt >= 0)}){
        stop("mean_alt should be two numbers greater or equal to zero.",
             call. = FALSE)

    } else if(filt_list$mean_alt[1] > filt_list$mean_alt[2]){
        stop("mean_alt[1] should be smaller than mean_alt[2].",
             call. = FALSE)
    }

    if(!{is.numeric(filt_list$sd_ref) &
            length(filt_list$sd_ref) == 1 & all(filt_list$sd_ref >= 0)}){
        stop("sd_ref should be two numbers greater or equal to zero.",
             call. = FALSE)
    }

    if(!{is.numeric(filt_list$sd_alt) &
            length(filt_list$sd_alt) == 1 & all(filt_list$sd_alt >= 0)}){
        stop("sd_alt should be two numbers greater or equal to zero.",
             call. = FALSE)
    }
}

.checkDefault <- function(filt_list){
    return(list(id = !all(filt_list$id %in% c(NA_character_, NA_character_)),
                missing = filt_list$missing != 1,
                het = any(filt_list$het != c(0, 1)),
                mac = filt_list$mac != 0,
                maf = filt_list$maf != 0,
                ad_ref = any(filt_list$ad_ref != c(0, Inf)),
                ad_alt = any(filt_list$ad_alt != c(0, Inf)),
                dp = any(filt_list$dp != c(0, Inf)),
                mean_ref = any(filt_list$mean_ref != c(0, Inf)),
                mean_alt = any(filt_list$mean_alt != c(0, Inf)),
                sd_ref = filt_list$sd_ref != Inf,
                sd_alt = filt_list$sd_alt != Inf))
}

.makeStatsFilter <- function(object, filt_list, target){
    .checkArgValid(filt_list = filt_list, target = target)
    check_list <- .checkDefault(filt_list = filt_list)

    # Initialize the output filter object
    if(target == "sample"){
        if(check_list$id){
            v <- !getSamID(object = object) %in% filt_list$id

        } else {
            v <- rep(TRUE, nsam(object, TRUE))
        }

    } else {
        if(check_list$id){
            v <- !getMarID(object = object) %in% filt_list$id

        } else {
            v <- rep(x = TRUE, times = nmar(object = object, valid = TRUE))
        }
    }

    # Filtering for samples.
    ## Missing rate
    if(check_list$missing){
        v <- v & .calcSubFilter(variable = getCountGenoMissing(object = object,
                                                               target = target,
                                                               valid = TRUE,
                                                               prop = TRUE),
                                threshold = filt_list$missing,
                                default = 1,
                                greater = FALSE,
                                equal = TRUE)
    }

    ## Heterozygosity
    if(check_list$het){
        v <- v & .calcSubFilter(variable = getCountGenoHet(object = object,
                                                           target = target,
                                                           valid = TRUE,
                                                           prop = TRUE),
                                threshold = filt_list$het,
                                default = c(0, 1),
                                greater = TRUE, equal = TRUE)
    }

    ## Minor allele count
    if(check_list$mac){
        v <- v & .calcSubFilter(variable = getMAC(object = object,
                                                  target = target,
                                                  valid = TRUE),
                                threshold = filt_list$mac,
                                default = 0,
                                greater = TRUE,
                                equal = TRUE)
    }

    ## Minor allele frequency
    if(check_list$maf){
        v <- v & .calcSubFilter(variable = getMAF(object = object,
                                                  target = target,
                                                  valid = TRUE),
                                threshold = filt_list$maf,
                                default = 0,
                                greater = TRUE,
                                equal = TRUE)
    }

    ## Reference allele read count
    if(check_list$ad_ref){
        v <- v & .calcSubFilter(variable = getCountReadRef(object = object,
                                                           target = target,
                                                           valid = TRUE,
                                                           prop = FALSE),
                                threshold = filt_list$ad_ref,
                                default = c(0, Inf),
                                greater = TRUE,
                                equal = TRUE)
    }

    ## Alternative allele read count
    if(check_list$ad_alt){
        v <- v & .calcSubFilter(variable = getCountReadAlt(object = object,
                                                           target = target,
                                                           valid = TRUE,
                                                           prop = FALSE),
                                threshold = filt_list$ad_alt,
                                default = c(0, Inf),
                                greater = TRUE,
                                equal = TRUE)
    }

    ## Total read count
    if(check_list$dp){
        v <- v & .calcSubFilter(variable = getCountRead(object = object,
                                                        target = target,
                                                        valid = TRUE),
                                threshold = filt_list$dp,
                                default = c(0, Inf),
                                greater = TRUE,
                                equal = TRUE)
    }

    ## Mean reference allele read count
    if(check_list$mean_ref){
        v <- v & .calcSubFilter(variable = getMeanReadRef(object = object,
                                                          target = target,
                                                          valid = TRUE),
                                threshold = filt_list$mean_ref,
                                default = c(0, Inf),
                                greater = TRUE,
                                equal = TRUE)
    }

    ## Mean alternative allele read count
    if(check_list$mean_alt){
        v <- v & .calcSubFilter(variable = getMeanReadAlt(object = object,
                                                          target = target,
                                                          valid = TRUE),
                                threshold = filt_list$mean_alt,
                                default = c(0, Inf),
                                greater = TRUE,
                                equal = TRUE)
    }

    ## SD of reference allele read count
    if(check_list$sd_ref){
        v <- v & .calcSubFilter(variable = getSDReadRef(object = object,
                                                        target = target,
                                                        valid = TRUE),
                                threshold = filt_list$sd_ref,
                                default = Inf,
                                greater = FALSE,
                                equal = TRUE)
    }

    ## SD of alternative allele read count
    if(check_list$sd_alt){
        v <- v & .calcSubFilter(variable = getSDReadAlt(object = object,
                                                        target = target,
                                                        valid = TRUE),
                                threshold = filt_list$sd_alt,
                                default = Inf,
                                greater = FALSE,
                                equal = TRUE)
    }

    return(v)
}

## Filtering on marker based on quality scores.
#' @rdname setInfoFilter
setMethod("setInfoFilter",
          "GbsrGenotypeData",
          function(object,
                   mq,
                   fs,
                   qd,
                   sor,
                   mqranksum,
                   readposranksum,
                   baseqranksum){
              filt_list <- list(mq = mq,
                                fs = fs,
                                qd = qd,
                                sor = sor,
                                mqranksum = mqranksum,
                                readposranksum = readposranksum,
                                baseqranksum = baseqranksum)
              .checkInfoArgValid(filt_list = filt_list)

              # Apply filtering on the values recorded in the INFO field
              out <- .makeInfoFilter(object = object, filt_list = filt_list)

              # Update marker filter information
              cur_valid <- validMar(object = object)
              cur_valid[cur_valid] <- out
              validMar(object = object) <- cur_valid
              return(object)
          })

.checkInfoArgValid <- function(filt_list){
    if(!{is.numeric(filt_list$mq) & length(filt_list$mq) == 1 &
            filt_list$mq >= 0}){
        stop("mq should be a number greater than 0.",
             call. = FALSE)
    }

    if(!{is.numeric(filt_list$fs) & length(filt_list$fs) == 1 &
            all(filt_list$fs >= 0)}){
        stop("fs should be a number greater than 0.",
             call. = FALSE)
    }

    if(!{is.numeric(filt_list$qd) & length(filt_list$qd) == 1 &
            all(filt_list$qd >= 0)}){
        stop("qd should be a number greater than 0.",
             call. = FALSE)
    }

    if(!{is.numeric(filt_list$sor) & length(filt_list$sor) == 1 &
            all(filt_list$sor >= 0)}){
        stop("sor should be a number greater than 0.",
             call. = FALSE)
    }

    if(!{is.numeric(filt_list$mqranksum) & length(filt_list$mqranksum) == 2}){
        stop("mqranksum should be two numbers.",
             call. = FALSE)

    } else if(filt_list$mqranksum[1] > filt_list$mqranksum[2]){
        stop("mqranksum[1] should be smaller than mqranksum[2].",
             call. = FALSE)
    }

    if(!{is.numeric(filt_list$readposranksum) &
            length(filt_list$readposranksum) == 2}){
        stop("readposranksum should be two numbers.",
             call. = FALSE)

    } else if(filt_list$readposranksum[1] > filt_list$readposranksum[2]){
        stop("readposranksum[1] should be smaller than readposranksum[2].",
             call. = FALSE)
    }

    if(!{is.numeric(filt_list$baseqranksum) &
            length(filt_list$baseqranksum) == 2}){
        stop("baseqranksum should be two numbers.",
             call. = FALSE)

    } else if(filt_list$baseqranksum[1] > filt_list$baseqranksum[2]){
        stop("baseqranksum[1] should be smaller than baseqranksum[2].",
             call. = FALSE)
    }
}

.makeInfoFilter <- function(object, filt_list){
    v <- rep(x = TRUE, times = nmar(object = object))
    # Filtering for samples.
    ## MQ
    info_gdsn <- ls.gdsn(node = index.gdsn(node = object,
                                           path = "annotation/info"))
    if(filt_list$mq != 0){
        if("MQ" %in% info_gdsn){
            v <- v & .calcSubFilter(variable = getInfo(object = object, var = "MQ"),
                                    threshold = filt_list$mq,
                                    default = 0,
                                    greater = TRUE,
                                    equal = TRUE)
        } else {
            warning("Filtering on MQ was specified but no MQ in the GDS.")
        }
    }

    ## FS
    if(filt_list$fs != Inf){
        if("FS" %in% info_gdsn){
            v <- v & .calcSubFilter(variable = getInfo(object = object, var = "FS"),
                                    threshold = filt_list$fs,
                                    default = Inf,
                                    greater = FALSE,
                                    equal = TRUE)
        } else {
            warning("Filtering on FS was specified but no FS in the GDS.")
        }
    }

    ## QD
    if(filt_list$qd != 0){
        if("QD" %in% info_gdsn){
            v <- v & .calcSubFilter(variable = getInfo(object = object, var = "QD"),
                                    threshold = filt_list$qd,
                                    default = 0,
                                    greater = TRUE,
                                    equal = TRUE)
        } else {
            warning("Filtering on QD was specified but no QD in the GDS.")
        }
    }

    ## SOR
    if(filt_list$sor != Inf){
        if("SOR" %in% info_gdsn){
            v <- v & .calcSubFilter(variable = getInfo(object = object, var = "SOR"),
                                    threshold = filt_list$sor,
                                    default = Inf,
                                    greater = FALSE,
                                    equal = TRUE)
        } else {
            warning("Filtering on SOR was specified but no SOR in the GDS.")
        }
    }

    ## MQRankSum
    if(any(filt_list$mqranksum != c(-Inf, Inf))){
        if("MQRankSum" %in% info_gdsn){
            v <- v & .calcSubFilter(variable = getInfo(object = object,
                                                       var = "MQRankSum"),
                                    threshold = filt_list$mqranksum,
                                    default = c(-Inf, Inf),
                                    greater = TRUE,
                                    equal = TRUE)
        } else {
            warning("Filtering on MQRankSum was specified but no MQRankSum in the GDS.")
        }
    }

    ## Alternative allele read count
    if(any(filt_list$readposranksum != c(-Inf, Inf))){
        if("ReadPosRankSum" %in% info_gdsn){
            v <- v & .calcSubFilter(variable = getInfo(object = object,
                                                       var = "ReadPosRankSum"),
                                    threshold = filt_list$readposranksum,
                                    default = c(-Inf, Inf),
                                    greater = TRUE,
                                    equal = TRUE)
        } else {
            warning("Filtering on ReadPosRankSum was specified but no ReadPosRankSum in the GDS.")
        }
    }

    ## Total read count
    if(any(filt_list$baseqranksum != c(-Inf, Inf))){
        if("BaseQRankSum" %in% info_gdsn){
            v <- v & .calcSubFilter(variable = getInfo(object = object,
                                                       var = "BaseQRankSum"),
                                    threshold = filt_list$baseqranksum,
                                    default = c(-Inf, Inf),
                                    greater = TRUE,
                                    equal = TRUE)
        } else {
            warning("Filtering on BaseQRankSum was specified but no BaseQRankSum in the GDS.")
        }
    }
    return(v)
}

###############################################################################
## Set fixed bias markers
#' @rdname setPloidy
#' @importFrom methods slot<-
setMethod("setPloidy",
          "GbsrGenotypeData",
          function(object, ploidy = 2){
              attributes(slot(object, "sample"))$ploidy <- ploidy
              return(object)
          }
)

###############################################################################
## Set fixed bias markers
#' @rdname getPloidy
#' @importFrom methods slot
setMethod("getPloidy",
          "GbsrGenotypeData",
          function(object){
              return(attributes(slot(object, "sample"))$ploidy)
          }
)

###############################################################################
## Set fixed bias markers
#' @rdname setFixedParameter
#' @importFrom methods slot<-
setMethod("setFixedParameter",
          "GbsrGenotypeData",
          function(object, bias, mismap, parent_geno){
              valid_marker <- validMar(object = object)

              if(is.null(bias)){
                  slot(object = object, name = "marker")[["bias"]] <- NULL

              } else {
                  out <- rep(NA, length(valid_marker))
                  out[valid_marker] <- bias
                  slot(object = object, name = "marker")[["bias"]] <- out
              }

              if(is.null(mismap)){
                  slot(object = object, name = "marker")[["mismap_ref"]] <- NULL
                  slot(object = object, name = "marker")[["mismap_alt"]] <- NULL

              } else {
                  out <- rep(NA, length(valid_marker))
                  out[valid_marker] <- mismap[, 1]
                  slot(object = object, name = "marker")[["mismap_ref"]] <- out
                  out <- rep(NA, length(valid_marker))
                  out[valid_marker] <- mismap[, 2]
                  slot(object = object, name = "marker")[["mismap_alt"]] <- out
              }

              if(parent_geno){
                  out <- t(getGenotype(object, node = "parents", valid = FALSE))
                  for(i in seq_len(ncol(out))){
                      colname <- paste0("parent", i)
                      slot(object = object, name = "marker")[[colname]] <- out[, i]
                  }
              } else {
                  marker_df <- slot(object = object, name = "marker")
                  hit <- grep("parent[0-9]", names(marker_df))
                  slot(object = object, name = "marker")[hit] <- NULL
              }
              return(object)
          })

#' @rdname getFixedParameter
setMethod("getFixedParameter",
          "GbsrGenotypeData",
          function(object, valid, chr){
              mslot <- slot(object = object, name = "marker")
              hit <- grepl("bias|mismap|parent[0-9]", names(mslot))
              out <- mslot[, hit]
              if(valid){
                  out <- out[validMar(object = object), ]
              }
              if(!is.null(chr)){
                  out <- out[getChromosome(object = object, valid = valid) %in% chr, ]
              }
              if(ncol(out) == 0){
                  return(NULL)
              }
              return(out)
          })

###############################################################################
## Functions to reset filters.

## Reset filters on samples
#' @rdname resetSamFilter
#' @importFrom methods slot<-
setMethod("resetSamFilter",
          "GbsrGenotypeData",
          function(object){
              slot(object = object, name = "sample")[["valid"]] <- TRUE
              slot(object = object, name = "sample")[["parents"]] <- NULL
              return(object)
          })

## Reset filters on markers.
#' @rdname resetMarFilter
#' @importFrom methods slot<-
setMethod("resetMarFilter",
          "GbsrGenotypeData",
          function(object){
              slot(object = object, name = "marker")[["valid"]] <- TRUE
              return(object)
          })

## Reset all filters.
#' @importFrom SeqArray seqDelete
#' @importFrom gdsfmt exist.gdsn
#' @rdname resetCallFilter
setMethod("resetCallFilter",
          "GbsrGenotypeData",
          function(object){
              if(exist.gdsn(node = object, path = "annotation/format/CGT/data")){
                  seqDelete(gdsfile = object, fmt.var = c("FGT", "FAD"),
                            verbose = FALSE)
              }
              return(object)
          })

## Reset all filters.
#' @rdname resetFilter
setMethod("resetFilter",
          "GbsrGenotypeData",
          function(object){
              object <- resetCallFilter(object = object)
              object <- resetSamFilter(object = object)
              object <- resetMarFilter(object = object)
              return(object)
          })

###############################################################################
## Function to output a VCF file data stored in the GDS file.

#' @rdname gbsrGDS2VCF
#' @importFrom gdsfmt ls.gdsn index.gdsn createfn.gds copyto.gdsn closefn.gds
#' @importFrom SeqArray seqSetFilter
setMethod("gbsrGDS2VCF",
          "GbsrGenotypeData",
          function(object,
                   out_fn,
                   node,
                   info.export,
                   fmt.export,
                   parents){

              # Check if the node exists
              node <- match.arg(arg = node, choices = c("raw", "cor"))
              if(node == "cor"){
                  if(!exist.gdsn(node = object, path = "annotation/format/CGT")){
                      stop('`node = "cor"` was specified, but no corrected',
                           ' genotype data.',
                           'Run estGeno() to get corrected genotype data.')
                  }
              }

              # Check if parents have been specified
              if(is.null(slot(object = object, name = "sample")[["parents"]])){
                  parents <- FALSE
                  message("No parents info.")
              }

              # Prepare the temporary GDS file to reorganize data to be output
              check <- .checkNodes(object = object)
              tmp_gds <- tempfile(pattern = "tmp", fileext = ".gds")
              tmpgds <- createfn.gds(filename = tmp_gds, allow.duplicate = TRUE)

              # Check data type because VL_Int causes a fatal error.
              gdsn_ls <- ls.gdsn(node = object$root, include.hidden = TRUE,
                                 recursive = TRUE, include.dirs = FALSE)
              rm_gdsn <- NULL
              for(i in gdsn_ls){
                  input_node <- index.gdsn(node = object$root,
                                           path = i)
                  objdesp <- objdesp.gdsn(node = input_node)
                  if(objdesp$trait == "VL_Int"){
                      rm_gdsn <- c(rm_gdsn, i)
                  }
              }

              if(!is.null(rm_gdsn)){
                  rm_gdsn <- unique(dirname(rm_gdsn))
                  message("VL_Int type data causes a corruption of the GDS file",
                          "while writing out a VCF file from a GDS in the ",
                          "current implementation.",
                          "\nThus, the following data will be removed ",
                          "from the GDS files.\n",
                          paste(rm_gdsn, collapse = "\n"))
                  for(i in rm_gdsn){
                      input_node <- index.gdsn(node = object$root,
                                               path = i)
                      objdesp <- objdesp.gdsn(node = input_node)
                      delete.gdsn(node = input_node, force = TRUE)
                  }
              }

              gdsn_ls <- ls.gdsn(node = object$root, include.hidden = TRUE)
              for(i in gdsn_ls){
                  copyto.gdsn(node = tmpgds,
                              source = index.gdsn(object$root, i))
              }

              closefn.gds(tmpgds)
              tmpgds <- seqOpen(gds.fn = tmp_gds, readonly = FALSE)

              # Replace genotype call data if node == "cor" was specified
              if(node == "cor"){
                  .replaceGT(object = tmpgds)
                  check[3] <- FALSE
                  fmt.export <- fmt.export[fmt.export != "CGT"]
              }

              # Reformat data to be output
              .modGDS(object = tmpgds, check = check)

              # Make filters
              sam_sel <- validSam(object = object, parents = parents)
              mar_sel <- validMar(object = object)

              # Apply filters
              seqSetFilter(object = tmpgds,
                           variant.sel = mar_sel,
                           sample.sel = sam_sel,
                           action = "push+intersect",
                           verbose = FALSE)

              # Generate the output VCF file
              seqGDS2VCF(gdsfile = tmpgds,
                         vcf.fn = out_fn,
                         info.var = info.export,
                         fmt.var = fmt.export,
                         verbose = FALSE)
              seqClose(object = tmpgds)
              return(out_fn)
          })

.checkNodes <- function(object){
    check <- c(exist.gdsn(node = object, path = "annotation/info/PGT"),
               exist.gdsn(node = object, path = "annotation/format/HAP"),
               exist.gdsn(node = object, path = "annotation/format/CGT"),
               exist.gdsn(node = object, path = "annotation/format/FGT"),
               exist.gdsn(node = object, path = "annotation/info/ADB"),
               exist.gdsn(node = object, path = "annotation/info/MR"))
    return(check)
}

#' @importFrom gdsfmt moveto.gdsn setdim.gdsn append.gdsn
.modGDS <- function(object, check){

    # Reformat PGT data
    if(check[1]){
        data_gdsn <- index.gdsn(node = object, path = "annotation/info/PGT")
        obj <- objdesp.gdsn(node = data_gdsn)

        if(length(obj$dim) == 2){
            tmp_gdsn <- add.gdsn(node = index.gdsn(node = object,
                                                   path = "annotation/info"),
                                 name = "tmp",
                                 storage = "string", replace = TRUE)
            apply.gdsn(node = data_gdsn, margin = 2,
                       as.is = "gdsnode", target.node = tmp_gdsn,
                       FUN = function(x){
                           x[x == 3] <- "."
                           return(paste(x, collapse = "|"))
                       })
            moveto.gdsn(node = tmp_gdsn,
                        loc.node = data_gdsn,
                        relpos = "replace+rename")
            fld_gdsn <- index.gdsn(node = object, path = "annotation/info/PGT")
            attr <- list(Number = "1",
                         Type = "String",
                         Description = "Estimated allele of parental haplotype by GBScleanR")
            .putAttrGdsn(node = fld_gdsn, attr = attr)
        }
    }

    # Reformat HAP data
    if(check[2]){
        data_gdsn <- index.gdsn(node = object, path = "annotation/format/HAP/data")
        obj <- objdesp.gdsn(node = data_gdsn)

        if(length(obj$dim) == 3){
            tmp_gdsn <- add.gdsn(node = index.gdsn(node = object,
                                                   path = "annotation/format/HAP"),
                                 name = "tmp",
                                 storage = "string", replace = TRUE)
            apply.gdsn(node = data_gdsn, margin = 3,
                       as.is = "gdsnode", target.node = tmp_gdsn,
                       FUN = function(x){
                           x[x == 0] <- "."
                           apply(X = x, MARGIN = 2, FUN = paste, collapse = "|")
                       })
            setdim.gdsn(node = tmp_gdsn, valdim = obj$dim[-1])
            moveto.gdsn(node = tmp_gdsn,
                        loc.node = data_gdsn,
                        relpos = "replace+rename")
            fld_gdsn <- index.gdsn(node = object, path = "annotation/format/HAP")
            attr <- list(Number = "1",
                         Type = "String",
                         Description = "Estimated haplotype data by GBScleanR")
            .putAttrGdsn(node = fld_gdsn, attr = attr)
        }
    }

    # Reformat CGT data
    if(check[3]){
        data_gdsn <- index.gdsn(node = object, path = "annotation/format/CGT/data")
        obj <- objdesp.gdsn(node = data_gdsn)
        if(length(obj$dim) == 3){
            tmp_gdsn <- add.gdsn(node = index.gdsn(node = object,
                                                   path = "annotation/format/CGT"),
                                 name = "tmp",
                                 storage = "string", replace = TRUE)
            apply.gdsn(node = data_gdsn, margin = 3,
                       as.is = "gdsnode", target.node = tmp_gdsn,
                       FUN = function(x){
                           x[x == 3] <- "."
                           apply(X = x, MARGIN = 2, FUN = paste, collapse = "|")
                       })
            setdim.gdsn(node = tmp_gdsn, valdim = obj$dim[-1])
            moveto.gdsn(node = tmp_gdsn,
                        loc.node = data_gdsn,
                        relpos = "replace+rename")
            fld_gdsn <- index.gdsn(node = object, path = "annotation/format/CGT")
            attr <- list(Number = "1",
                         Type = "String",
                         Description = "Corrected genotype data by GBScleanR")
            .putAttrGdsn(node = fld_gdsn, attr = attr)
        }
    }

    # Reformat FGT data
    if(check[4]){
        data_gdsn <- index.gdsn(node = object, path = "annotation/format/FGT/data")
        obj <- objdesp.gdsn(node = data_gdsn)
        if(length(obj$dim) == 3){
            tmp_gdsn <- add.gdsn(node = index.gdsn(node = object,
                                                   path = "annotation/format/FGT"),
                                 name = "tmp",
                                 storage = "string", replace = TRUE)
            apply.gdsn(node = data_gdsn, margin = 3,
                       as.is = "gdsnode", target.node = tmp_gdsn,
                       FUN = function(x){
                           x[x == 3] <- "."
                           apply(X = x, MARGIN = 2, FUN = paste, collapse = "/")
                       })
            setdim.gdsn(node = tmp_gdsn, valdim = obj$dim[-1])
            moveto.gdsn(node = tmp_gdsn,
                        loc.node = data_gdsn,
                        relpos = "replace+rename")
            fld_gdsn <- index.gdsn(node = object, path = "annotation/format/FGT")
            attr <- list(Number = "1",
                         Type = "String",
                         Description = "Filtered genotype data by GBScleanR")
            .putAttrGdsn(node = fld_gdsn, attr = attr)
        }
    }

    # Put the header information for ADB
    if(check[5]){
        data_gdsn <- index.gdsn(object, "annotation/info/ADB")
        attr <- list(Number = "1",
                     Type = "Float",
                     Description = "Estimated allele read bias by GBScleanR")
        .putAttrGdsn(node = fld_gdsn, attr = attr)
    }

    # Put the header information for MR
    if(check[6]){
        data_gdsn <- index.gdsn(object, "annotation/info/MR")
        attr <- list(Number = "2",
                     Type = "Float",
                     Description = "Estimated mismapping rate by GBScleanR")
        .putAttrGdsn(node = fld_gdsn, attr = attr)
    }
}

#' @importFrom gdsfmt copyto.gdsn
.replaceGT <- function(object){
    delete.gdsn(node = index.gdsn(node = object, path = "genotype/data"))
    copyto.gdsn(node = index.gdsn(node = object, path = "genotype"),
                source = index.gdsn(node = object,
                                    path = "annotation/format/CGT/data"),
                name = "data")
    delete.gdsn(node = index.gdsn(node = object, path = "genotype/~data"))
    copyto.gdsn(node = index.gdsn(node = object, path = "genotype"),
                source = index.gdsn(node = object,
                                    path = "annotation/format/CGT/~data"),
                name = "~data")
    delete.gdsn(node = index.gdsn(node = object,
                                  path = "annotation/format/CGT/data"))
    delete.gdsn(node = index.gdsn(node = object,
                                  path = "annotation/format/CGT/~data"))
    delete.gdsn(node = index.gdsn(node = object,
                                  path = "annotation/format/CGT"))
}


###############################################################################
#' @rdname gbsrGDS2CSV
#' @importFrom utils write.table
#'
setMethod("gbsrGDS2CSV",
          "GbsrGenotypeData",
          function(object,
                   out_fn,
                   node,
                   incl_parents,
                   bp2cm,
                   format,
                   read){

              # Convert physical marker distances to genetic distances (cM)
              if(is.null(bp2cm)){
                  if(format == "qtl"){
                      bp2cm <- 4e-06

                  } else {
                      bp2cm <- 1
                  }
              }

              # Check if the parents have been specified
              parents <- getParents(object = object)
              if(is.null(parents)){
                  incl_parents <- FALSE
              }
              n_parents <- length(unique(parents$memberID))
              if(n_parents != 2){
                  format <- ""
              }

              node <- match.arg(arg = node,
                                choices = c("raw", "filt", "cor", "hap", "dosage"))

              # Prepare output genotype/haplotype data
              if(node == "hap"){
                  geno <- getHaplotype(object = object, parents = incl_parents)
                  if(format == "qtl"){
                      ploidy <- slot(object = object, name = "sample")$ploidy
                      if(attributes(ploidy == 2)){
                          geno <- apply(X = geno - 1, MARGIN = c(2, 3), FUN = sum)

                      } else {
                          stop("Haplotype data for non-diploid population can",
                               " not be exported in the R/QTL format")
                      }
                  } else {
                      geno <- apply(X = geno, MARGIN = c(2, 3),
                                    FUN = paste, collapse = "|")
                  }
              } else {
                  geno <- getGenotype(object = object, node = node,
                                      parents = incl_parents)
              }

              # Prepare marker information
              chr <- getChromosome(object = object)
              pos <- getPosition(object = object)
              id <- getSamID(object = object, valid = FALSE)
              if(incl_parents){
                  id <- id[validSam(object = object, parents = TRUE)]
              } else {
                  id <- id[validSam(object = object, parents = FALSE)]
              }

              # Convert genotype data to the r/qtl format
              if(format == "qtl"){
                  geno[geno == 0] <- "A"
                  geno[geno == 1] <- "H"
                  geno[geno == 2] <- "B"
                  geno <- rbind(paste(chr, pos, sep = "_"),
                                chr, pos * bp2cm, geno)
                  geno <- cbind(c("id", "", "", id), geno)
                  write.table(x = geno, file = out_fn, quote = FALSE,
                              row.names = FALSE, col.names = FALSE, sep = ",")

              } else {
                  # Prepare read count data
                  if(read){
                      if(grepl(pattern = "filt", x = node)){
                          node <- "filt"
                      } else {
                          node <- "raw"
                      }
                      read <- getRead(object = object, node = node,
                                      parents = incl_parents)
                      dim_geno <- dim(geno)

                      # Combine genotype and read information
                      geno <- vapply(X = seq_along(geno),
                                     FUN.VALUE = character(1),
                                     FUN = function(i){
                                         paste(geno[i],
                                               paste(read$ref[i],
                                                     read$alt[i],
                                                     sep = ","),
                                               sep = ":")
                                     })
                      geno <- matrix(data = geno,
                                     nrow = dim_geno[1],
                                     ncol = dim_geno[2])
                  }
                  geno <- rbind(chr, pos * bp2cm, geno)
                  rownames(geno) <- c("Chr", "Pos", id)
                  write.table(x = geno,file = out_fn, quote = TRUE,
                              row.names = TRUE, col.names = FALSE, sep = ",")
              }

              return(out_fn)
          })

###############################################################################
## Functions to handle the GbsrScheme object in the GbsrGenotypeData object.

## Initialize the GbsrScheme object.
#' @rdname initScheme
#' @importFrom methods slot<-
setMethod("initScheme",
          "GbsrGenotypeData",
          function(object, mating){
              parents <- getParents(object = object, verbose = FALSE)

              if(is.null(parents)){
                  message("Set no parents in the given data.")
                  message("estGeno() will work in the parentless mode unless you specify parents by setParents().")
                  message("See the help of estGeno() for the details of the parentless mode.")
                  p_id <- c(1, 2)
                  mating <- cbind(c(1, 2))

              } else {
                  p_id <- parents$memberID
              }
              scheme <- initScheme(object = slot(object = object, name = "scheme"),
                                   mating = mating,
                                   parents = p_id)

              if(is.null(parents)){
                  slot(object = scheme, name = "parents") <- c(NA_real_, NA_real_)
              }
              slot(object = object, name = "scheme") <- scheme
              return(object)
          })

## Add information to the GbsrScheme object.
#' @rdname addScheme
#' @importFrom methods slot<-
setMethod("addScheme",
          "GbsrGenotypeData",
          function(object, crosstype, mating){
              if(missing(mating)){
                  mating <- cbind(c(NA, NA))
              }
              scheme <- addScheme(object = slot(object = object, name = "scheme"),
                                  crosstype = crosstype,
                                  mating = mating)
              slot(object = object, name = "scheme") <- scheme
              return(object)
          })

## Add information to the GbsrScheme object.
#' @rdname makeScheme
#' @importFrom methods slot<-
setMethod("makeScheme",
          "GbsrGenotypeData",
          function(object, generation, crosstype){
              parents <- getParents(object = object)
              if(is.null(parents)){
                  stop("Parents have not been set.\n Run setParents().",
                       call. = FALSE)
              }
              if(!length(unique(parents$memberID)) %in% 2^(seq_len(10))){
                  stop("The number of parents should be the Nth power of 2.",
                       call. = FALSE)
              }
              mating <- matrix(data = seq_along(unique(parents$memberID)),
                               nrow = 2,
                               byrow = TRUE)
              object <- initScheme(object = object, mating = mating)
              if(ncol(mating) > 1){
                  while(TRUE){
                      next_id <- max(mating) + 1
                      n_pair <- ncol(mating) / 2
                      mating <- matrix(data = seq(from = next_id,
                                                  length.out = n_pair),
                                       nrow = 2,
                                       byrow = TRUE)
                      object <- addScheme(object = object,
                                          crosstype = "pairing",
                                          mating = mating)

                      if(ncol(mating) == 1){
                          break
                      }
                  }
              }
              if(generation > 1){
                  for(i in seq_len(generation - 1)){
                      object <- addScheme(object = object,
                                          crosstype = crosstype)
                  }
              }
              return(object)
          })

#'
#' @rdname assignScheme
#' @importFrom methods slot<-
setMethod("assignScheme",
          "GbsrGenotypeData",
          function(object, id) {
              if(nsam(object) != length(id)){
                  stop("`length(id)` should match with the number of valid ",
                       "samples obtained by nsam().",
                       call. = FALSE)
              }
              scheme <- assignScheme(object = slot(object = object,
                                                   name = "scheme"),
                                     id = id)
              slot(object = object, name = "scheme") <- scheme
              sample <- slot(object = object, name = "sample")
              sample$pedigree <- NA
              sample$pedigree[validSam(object = object)] <- id
              slot(object = object, name = "sample") <- sample
              return(object)
          })

## Show the information stored in the GbsrScheme object.
#' @rdname showScheme
setMethod("showScheme",
          "GbsrGenotypeData",
          function(object){
              parents <- getParents(object = object, verbose = FALSE)
              if(is.null(parents)){
                  parents_name <- c(NA, NA)
              } else {
                  parents_name <- parents$sampleID
              }
              sample <- slot(object = object, name = "sample")
              pedigree <- cbind(getSamID(object = object),
                                sample$pedigree[validSam(object = object)])
              showScheme(object = slot(object = object, name = "scheme"),
                         parents_name = parents_name,
                         pedigree = pedigree)
          })

# Generated by using Rcpp::compileAttributes() -> do not edit by hand
# Generator token: 10BE3573-1514-4C36-9D1C-5A225CD40393

run_fb <- function(ref, alt, eseq_in, bias, mismap, possiblehap, trans_prob, init_prob, nonzero_prob, n_pgeno, n_hap, n_offspring, n_marker, n_nonzero_prob, pedigree, p_geno, ploidy) {
    .Call(`_GBScleanR_run_fb`, ref, alt, eseq_in, bias, mismap, possiblehap, trans_prob, init_prob, nonzero_prob, n_pgeno, n_hap, n_offspring, n_marker, n_nonzero_prob, pedigree, p_geno, ploidy)
}

get_genocall <- function(ref, alt, eseq_in, bias, mismap, n_o, n_m, ploidy) {
    .Call(`_GBScleanR_get_genocall`, ref, alt, eseq_in, bias, mismap, n_o, n_m, ploidy)
}

count_geno <- function(geno) {
    .Call(`_GBScleanR_count_geno`, geno)
}

count_read <- function(read, tot_read) {
    .Call(`_GBScleanR_count_read`, read, tot_read)
}

thinout_marker <- function(chr, pos, missing_count, range) {
    .Call(`_GBScleanR_thinout_marker`, chr, pos, missing_count, range)
}

run_viterbi <- function(p_ref, p_alt, ref, alt, eseq_in, bias, mismap, trans_prob, init_prob, nonzero_prob, n_pgeno, n_hap, n_offspring, n_founder, n_marker, n_nonzero_prob, het, pedigree, possiblehap, possiblegeno, p_geno_fix, ploidy) {
    .Call(`_GBScleanR_run_viterbi`, p_ref, p_alt, ref, alt, eseq_in, bias, mismap, trans_prob, init_prob, nonzero_prob, n_pgeno, n_hap, n_offspring, n_founder, n_marker, n_nonzero_prob, het, pedigree, possiblehap, possiblegeno, p_geno_fix, ploidy)
}

#' Return a logical vector indicating which are valid SNP markers.
#'
#' @param object A [GbsrGenotypeData] object.
#' @param chr A index to spefcify chromosome to get information.
#' @param ... Unused.
#'
#' @return A logical vector of the same length with
#' the number of total SNP markers
#'
#' @examples
#' # Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
#' gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
#' gds <- loadGDS(gds_fn)
#'
#' validMar(gds)
#'
#' # Close the connection to the GDS file.
#' closeGDS(gds)
#'
#' @export
#'
setGeneric("validMar", function(object, chr = NULL, ...)
    standardGeneric("validMar"))

#' @rdname validMar
#' @param value A logical vector indicating valid markers with the length
#' matching with the number of markers.
#' @export
setGeneric("validMar<-", function(object, value)
    standardGeneric("validMar<-"))


#' Return a logical vector indicating which are valid samples.
#'
#' @param object A [GbsrGenotypeData] object.
#' @param parents A logical value to indicate to set FALSE or TRUE
#' to parental samples. If you specify `parents = "only"`, this
#' function returns a logical vector indicating TRUE for only parental samples.
#' @param ... Unused.
#'
#' @return A logical vector of the same length
#' with the number of total samples.
#'
#' @examples
#' # Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
#' gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
#' gds <- loadGDS(gds_fn)
#'
#' validSam(gds)
#'
#' # Close the connection the GDS file.
#' closeGDS(gds)
#'
#' @export
#'
setGeneric("validSam", function(object, parents = FALSE, ...)
    standardGeneric("validSam"))

#' @rdname validSam
#' @param value A logical vector indicating valid samples with the length
#' matching with the number of samples
#' @export
setGeneric("validSam<-", function(object, value)
    standardGeneric("validSam<-"))

#' Return the number of SNPs.
#'
#' This function returns the number of SNPs recorded in the GDS file
#' connected to the given [GbsrGenotypeData] object.
#'
#' @param object A [GbsrGenotypeData] object.
#' @param valid A logical value. See details.
#' @param chr A index to spefcify chromosome to get information.
#' @param ... Unused.
#'
#' @details
#' If `valid = TRUE`, the number of markers which are labeled `TRUE` in the
#' "valid" column of the "marker" slot will be returned. If you need the number
#' of over all markers, set `valid = FALSE`. [validMar()] tells you
#' which markers are valid.
#'
#' @return An integer value to indicate the number of SNP markers.
#'
#' @examples
#' # Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
#' gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
#' gds <- loadGDS(gds_fn)
#'
#' nmar(gds)
#'
#' # Close the connection to the GDS file.
#' closeGDS(gds)
#'
#' @seealso [validMar()]
#'
#' @export
#'
setGeneric("nmar", function(object, valid = TRUE, chr = NULL, ...)
    standardGeneric("nmar"))


#' Return the number of samples.
#'
#' This function returns the number of samples recorded in the GDS file
#' connected to the given [GbsrGenotypeData] object.
#'
#' @param object A [GbsrGenotypeData] object.
#' @param valid A logical value. See details.
#' @param parents A logical value whether to include to parental samples or not.
#' @param ... Unused.
#'
#' @details
#' If `valid = TRUE`, the number of the samples which are labeled `TRUE`
#' in the "valid" column of the "sample" slot will be returned. If you need
#' the number of over all samples, set `valid = FALSE`.
#' [validSam()] tells you which samples are valid.
#'
#' @return An integer value to indicate the number of samples.
#'
#' @examples
#' # Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
#' gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
#' gds <- loadGDS(gds_fn)
#'
#' nsam(gds)
#'
#' # Close the connection to the GDS file.
#' closeGDS(gds)
#'
#' @seealso [validSam()]
#'
#'@export
#'
setGeneric("nsam", function(object, valid = TRUE, parents = FALSE, ...)
    standardGeneric("nsam"))


#' Obtain chromosome IDs of markers
#'
#' This function returns chromosome IDs of markers.
#'
#' @param object A [GbsrGenotypeData] object.
#' @param valid A logical value. See details.
#' @param ... Unused.
#'
#' @return A vector of factors indicating chromosome IDs.
#'
#' @details
#' If `valid = TRUE`, the chromosome IDs of the markers which are labeled `TRUE`
#' in the "valid" column of the "marker" slot will be returned. If you need the
#' number of over all markers, set `valid = FALSE`. [validMar()] tells you
#' which markers are valid.
#'
#' @examples
#' # Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
#' gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
#' gds <- loadGDS(gds_fn)
#'
#' getChromosome(gds)
#'
#' # Close the connection to the GDS file.
#' closeGDS(gds)
#'
#' @export
#'
#'
setGeneric("getChromosome", function(object, valid = TRUE, ...)
    standardGeneric("getChromosome"))


#' Obtain marker positions
#'
#' This function returns physical positions of markers.
#'
#' @param object A [GbsrGenotypeData] object.
#' @param valid A logical value. See details.
#' @param chr A integer or string to specify chromosome to get information.
#' @param ... Unused.
#'
#' @return An integer vector indicating the physical positions of markers.
#'
#' @details
#' If `valid = TRUE`, the positions of the markers which are labeled `TRUE` in
#' the "valid" column of the "marker" slot will be returned. If you need the
#' positions of over all markers, set `valid = FALSE`. [validMar()] tells you
#' which markers are valid.
#'
#' @examples
#' # Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
#' gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
#' gds <- loadGDS(gds_fn)
#'
#' getPosition(gds)
#'
#' # Close the connection to the GDS file.
#' closeGDS(gds)
#'
#' @export
#'
setGeneric("getPosition", function(object, valid = TRUE, chr = NULL, ...)
    standardGeneric("getPosition"))


#' Obtain reference allele information of markers
#'
#' This function returns the reference allele and alternative allele(s).
#'
#' @param object A [GbsrGenotypeData] object.
#' @param valid A logical value. See details.
#' @param chr A index to spefcify chromosome to get information.
#' @param ... Unused.
#' @return A vector of strings each of which is a "/" separated string and
#' indicates the reference allele and the alternative allele(s) at a marker.
#'
#' @details
#' If `valid = TRUE`, the alleles of markers which are labeled `TRUE` in the
#' "valid" column of the "marker" slot will be returned. If you need the number
#' of over all markers, set `valid = FALSE`. [validMar()] tells you
#' which markers are valid.
#'
#' @examples
#' # Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
#' gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
#' gds <- loadGDS(gds_fn)
#'
#' getAllele(gds)
#'
#' # Close the connection to the GDS file.
#' closeGDS(gds)
#'
#' @export
#'
setGeneric("getAllele", function(object, valid = TRUE, chr = NULL, ...)
    standardGeneric("getAllele"))


#' Obtain the marker IDs
#'
#' @param object A [GbsrGenotypeData] object.
#' @param valid A logical value. See details.
#' @param chr A index to specify chromosome to get information.
#' @param ... Unused.
#'
#' @return A integer vector of marker IDs.
#'
#' @details
#' If `valid = TRUE`, the IDs of markers which are labeled `TRUE` in the "valid"
#' column of the "marker" slot will be returned. If you need the number
#' of over all markers, set `valid = FALSE`. [validMar()] tells you
#' which markers are valid.
#'
#' @examples
#' # Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
#' gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
#' gds <- loadGDS(gds_fn)
#'
#' getMarID(gds)
#'
#' # Close the connection to the GDS file.
#' closeGDS(gds)
#'
#' @export
#'
setGeneric("getMarID", function(object, valid = TRUE, chr = NULL, ...)
    standardGeneric("getMarID"))


#' Obtain the sample IDs
#'
#' This function returns sample IDs.
#'
#' @param object A [GbsrGenotypeData] object.
#' @param valid A logical value. See details.
#' @param parents A logical value whether to include data for parents or not.
#' @param ... Unused.
#'
#' @return A character vector of sample IDs.
#'
#' @details
#' If `valid = TRUE`, the IDs of samples which are labeled `TRUE` in the "valid"
#' column of the "sample" slot will be returned. If you need the number
#' of over all samples, set `valid = FALSE`. [validSam()] tells you
#' which samples are valid.
#'
#' @examples
#' # Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
#' gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
#' gds <- loadGDS(gds_fn)
#'
#' getSamID(gds)
#'
#' # Close the connection to the GDS file.
#' closeGDS(gds)
#'
#' @export
#'
setGeneric("getSamID", function(object, valid = TRUE, parents = FALSE, ...)
    standardGeneric("getSamID"))


#' Obtain information stored in the "annotation/info" node
#'
#' The "annotation/info" node stores annotation infromation of markers obtained
#' via SNP calling tools like bcftools and GATK.
#'
#' @param object A [GbsrGenotypeData] object.
#' @param var A string to indicate which annotation info should be retrieved.
#' @param valid A logical value. See details.
#' @param chr A index to specify chromosome to get information.
#' @param ... Unused.
#'
#' @return A numeric vector of data stored in INFO node of the GDS file.
#'
#' @details
#' If `valid = TRUE`, the information of the markers which are labeled `TRUE`
#' in the "valid" column of the "marker" slot will be returned. If you need the
#' number of over all markers, set `valid = FALSE`. [validMar()] tells you
#' which markers are valid.
#'
#' @examples
#' # Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
#' gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
#' gds <- loadGDS(gds_fn)
#'
#' # Get mapping qualities (MQ) of markers.
#' mq <- getInfo(gds, "MQ")
#'
#' # Close the connection to the GDS file.
#' closeGDS(gds)
#' @export
#'
setGeneric("getInfo", function(object, var, valid = TRUE, chr = NULL, ...)
    standardGeneric("getInfo"))



#' Get read count data.
#'
#' Read counts for reference allele and alternative allele are retrieved
#' from the GDS file linked to the given [GbsrGenotypeData] object.
#'
#' @param object A [GbsrGenotypeData] object.
#' @param node Either of "raw" and "filt". See details.
#' @param parents A logical value or "only" whether to include data for
#' parents or not or to get data only for parents.
#' @param valid A logical value. See details.
#' @param chr An integer vector of indexes indicating
#' chromosomes to get read count data.
#' @param ... Unused.
#'
#' @return A named list with two elements "ref" and "alt" storing
#' a matrix of reference allele read counts and a matrix of
#' alternative read counts for all markers in all samples.
#'
#' @details
#' When `node = "raw`, the raw read counts stored in the
#' "annotation/format/AD/data" node will be returned, while `node = "filt` make
#' the function to return the filtered read counts stored in the
#' "annotation/format/FAD/data" that can be generated via the [setCallFilter()]
#' function.
#' If `valid = TRUE`, read counts for only valid marker and valid samples will
#' be obtained.
#'
#' @examples
#' # Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
#' gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
#' gds <- loadGDS(gds_fn)
#'
#' read <- getRead(gds)
#'
#' # Close the connection to the GDS file.
#' closeGDS(gds)
#'
#' @seealso [setCallFilter()]
#'
#' @export
#'
setGeneric("getRead", function(object, node = "raw", parents = FALSE,
                               valid = TRUE, chr = NULL, ...)
    standardGeneric("getRead"))


#' Get genotype call data.
#'
#' Genotype calls are retrieved from the GDS file linked to the given
#' [GbsrGenotypeData] object.
#'
#' @param object A [GbsrGenotypeData] object.
#' @param node Either of "raw", "filt", "cor", and "parents". See details.
#' @param parents A logical value or "only" whether to include data for
#' parents or not or to get data only for parents. Ignored if `node = "parents`.
#' @param valid A logical value. See details.
#' @param chr A integer vector of indexes indicating chromosomes
#' to get read count data.
#' @param phased If set `TRUE` to `phased`, the function will return phased
#' genotype data in a P x N x M array where P, N, and M are the ploidy, number
#' of samples, and number of markers.
#' @param ... Unused.
#'
#' @return An integer matrix of genotype data which is represented
#' by the number of alternative alleles at each marker of each sample.
#'
#' @details
#' When `node = "raw`, the raw genotype data stored in the "genotype/data" node
#' will be returned, while `node = "filt` make the function to return the
#' filtered genotype data stored in the "annotation/format/FGT/data" that can
#' be generated via the [setCallFilter()] function. `node = "cor` indicates to
#' get the corrected genotype data stored in the "annotation/format/CGT/data"
#' that can be generated via the [estGeno()] function. The estimated parental
#' genotypes, which also can be generated via the [estGeno()] function and
#' stored in the "annotation/info/PGT" node, can be obtained with
#' `node = "parents"`.
#' If `valid = TRUE`, genotype calls for only valid marker and valid samples
#' will be obtained.
#'
#' @examples
#' # Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
#' gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
#' gds <- loadGDS(gds_fn)
#'
#' geno <- getGenotype(gds)
#'
#' # Close the connection to the GDS file.
#' closeGDS(gds)
#'
#'
#' @seealso [setCallFilter()] and [estGeno()]
#'
#' @export
#'
setGeneric("getGenotype", function(object,
                                   node = "raw",
                                   parents = FALSE,
                                   valid = TRUE,
                                   chr = NULL,
                                   phased = FALSE,
                                   ...)
    standardGeneric("getGenotype"))


#' Get haplotype call data.
#'
#' Haplotype calls are retrieved from the GDS file linked to the given
#' [GbsrGenotypeData] object.
#'
#' @param object A [GbsrGenotypeData] object.
#' @param valid A logical value. See details.
#' @param chr A integer vector of indexes indicating chromosomes
#' to get read count data.
#' @param parents A logical value or "only" to include data for
#' parents or to get data only for parents.
#' @param ... Unused.
#'
#' @details
#' Haplotype call data can be obtained from the "estimated.haplotype" node of
#' the GDS file which can be generated via the [estGeno()] function.
#' Thus, this function is valid only after having executed [estGeno()].
#' If `valid = TRUE`, read counts for only valid marker and valid samples will
#' be obtained.
#'
#' @return An integer array of haplotype data. The array have 2 x M x N
#' dimensions, where M is the number of markers and N is the number of
#' samples. Each integer values represent the origin of the haplotype.
#' For example, in the population with two inbred founders, values take
#' either 1 or 2 indicating the hapotype descent from founder 1 and 2.
#' If two outbred founders, values take 1, 2, 3, or 4 indicating
#' the first and second haplotype in founder 1 and the first and
#' second haplotype in founder 2.
#'
#' @examples
#' # Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
#' gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
#' gds <- loadGDS(gds_fn)
#'
#' # Find the IDs of parental samples.
#' parents <- grep("Founder", getSamID(gds), value = TRUE)
#'
#' # Set the parents and flip allele information
#' # if the reference sample (Founder1 in our case) has homozygous
#' # alternative genotype at some markers of which alleles will
#' # be swapped to make the reference sample have homozygous
#' # reference genotype.
#' gds <- setParents(gds, parents = parents)
#'
#' # Initialize a scheme object stored in the slot of the GbsrGenotypeData.
#' # We chose `crosstype = "pair"` because two inbred founders were mated
#' # in our breeding scheme.
#' # We also need to specify the mating matrix which has two rows and
#' # one column with integers 1 and 2 indicating a sample (founder)
#' # with the memberID 1 and a sample (founder) with the memberID 2
#' # were mated.
#' gds <- initScheme(gds, mating = cbind(c(1:2)))
#'
#' # Add information of the next cross conducted in our scheme.
#' # We chose 'crosstype = "selfing"', which do not require a
#' # mating matrix.
#' gds <- addScheme(gds, crosstype = "selfing")
#'
#' # Execute error correction by estimating genotype and haplotype of
#' # founders and offspring.
#' gds <- estGeno(gds)
#'
#' hap <- getHaplotype(gds)
#'
#' # Close the connection to the GDS file.
#' closeGDS(gds)
#'
#' @seealso [estGeno()]
#'
#' @export
#'
setGeneric("getHaplotype", function(object, parents = FALSE, valid = TRUE,
                                    chr = NULL, ...)
    standardGeneric("getHaplotype"))


#' Obtain total reference read counts per SNP or per sample
#'
#' @param object A [GbsrGenotypeData] object.
#' @param target Either of "marker" and "sample".
#' @param valid A logical value. See details.
#' @param prop A logical value whether to return values as proportions of
#' total reference read counts in total read counts per SNP or not.
#' @param ... Unused.
#'
#' @return A numeric vector of (proportion of) reference read
#' counts per marker.
#'
#' @details
#' You need to execute [countRead()] to calculate sumaary statisticsto be
#' obtained via this function.
#' If `valid = TRUE`, the chromosome information of markers which are
#' labeled `TRUE` in the [sample] slot will be returned.
#' [validMar()] tells you which samples are valid.
#'
#' @examples
#' # Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
#' gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
#' gds <- loadGDS(gds_fn)
#' gds <- countRead(gds)
#'
#' getCountReadRef(gds)
#'
#' # Close the connection to the GDS file.
#' closeGDS(gds)
#'
#' @export
#'
setGeneric("getCountReadRef", function(object,
                                       target = "marker",
                                       valid = TRUE,
                                       prop = FALSE,
                                       ...)
    standardGeneric("getCountReadRef"))


#' Obtain total alternative read counts per SNP or per sample
#'
#' @param object A [GbsrGenotypeData] object.
#' @param target Either of "marker" and "sample".
#' @param valid A logical value. See details.
#' @param prop A logical value whether to return values as proportions
#' of total alternative read counts in total read counts per SNP or not.
#' @param ... Unused.
#'
#' @return A numeric vector of (proportion of) alternative
#' allele read counts per marker.
#'
#' @details
#' You need to execute [countRead()] to calculate sumaary statisticsto be
#' obtained via this function.
#' If `valid = TRUE`, the chromosome information of markers which are
#' labeled `TRUE` in the [sample] slot will be returned.
#' [validMar()] tells you which samples are valid.
#'
#' @examples
#' # Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
#' gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
#' gds <- loadGDS(gds_fn)
#' gds <- countRead(gds)
#'
#' getCountReadAlt(gds)
#'
#' # Close the connection to the GDS file.
#' closeGDS(gds)
#'
#' @export
#'
setGeneric("getCountReadAlt", function(object,
                                       target = "marker",
                                       valid = TRUE,
                                       prop = FALSE,
                                       ...)
    standardGeneric("getCountReadAlt"))


#' Obtain total read counts per SNP or per sample
#'
#' @param object A [GbsrGenotypeData] object.
#' @param target Either of "marker" and "sample".
#' @param valid A logical value. See details.
#' @param ... Unused.
#'
#' @details
#' You need to execute [countRead()] to calculate sumaary statisticsto be
#' obtained via this function.
#' If `valid = TRUE`, the chromosome information of markers which are
#' labeled `TRUE` in the [sample] slot will be returned.
#' [validMar()] tells you which samples are valid.
#'
#' @return A integer vector of total read counts
#' (reference allele reads + alternative allele reads) per marker.
#'
#' @examples
#' # Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
#' gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
#' gds <- loadGDS(gds_fn)
#' gds <- countRead(gds)
#'
#' getCountRead(gds)
#'
#' # Close the connection to the GDS file.
#' closeGDS(gds)
#'
#' @export
#'
setGeneric("getCountRead", function(object,
                                    target = "marker",
                                    valid = TRUE,
                                    ...)
    standardGeneric("getCountRead"))


#' Obtain total reference genotype counts per SNP or per sample
#'
#' @param object A [GbsrGenotypeData] object.
#' @param target Either of "marker" and "sample".
#' @param prop A logical value whether to return values as
#' proportions of total reference genotype counts to total
#' non missing genotype counts or not.
#' @param valid A logical value. See details.
#' @param ... Unused.
#'
#' @details
#' You need to execute [countGenotype()] to calculate sumaary statisticsto be
#' obtained via this function.
#' If `valid = TRUE`, the chromosome information of markers which are
#' labeled `TRUE` in the [sample] slot will be returned.
#' [validMar()] tells you which samples are valid.
#'
#' @return A numeric vector of (proportion of) homozygous reference
#' genotype calls per marker.
#' @examples
#' # Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
#' gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
#' gds <- loadGDS(gds_fn)
#'
#' # Summarize the genotype count information and store them in the
#' # [marker] and [sample] slots of the [GbsrGenotypeData] object.
#' gds <- countGenotype(gds)
#'
#' getCountGenoRef(gds)
#'
#' # Close the connection to the GDS file.
#' closeGDS(gds)
#'
#' @export
#'
setGeneric("getCountGenoRef", function(object,
                                       target = "marker",
                                       valid = TRUE,
                                       prop = FALSE,
                                       ...)
    standardGeneric("getCountGenoRef"))


#' Obtain total heterozygote counts per SNP or per sample
#'
#' @param object A [GbsrGenotypeData] object.
#' @param target Either of "marker" and "sample".
#' @param prop A logical value whether to return values as proportions of
#' total heterozygote counts to total non missing genotype counts or not.
#' @param valid A logical value. See details.
#' @param ... Unused.
#'
#' @details
#' You need to execute [countGenotype()] to calculate sumaary statisticsto be
#' obtained via this function.
#' If `valid = TRUE`, the chromosome information of markers which are
#' labeled `TRUE` in the [sample] slot will be returned.
#' [validMar()] tells you which samples are valid.
#'
#' @return A numeric vector of (proportion of) heterozugous
#' genotype calls per marker.
#' @examples
#' # Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
#' gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
#' gds <- loadGDS(gds_fn)
#'
#' # Summarize the genotype count information and store them in the
#' # [marker] and [sample] slots of the [GbsrGenotypeData] object.
#' gds <- countGenotype(gds)
#'
#' getCountGenoHet(gds)
#'
#' # Close the connection to the GDS file.
#' closeGDS(gds)
#'
#' @export
#'
setGeneric("getCountGenoHet", function(object,
                                       target = "marker",
                                       valid = TRUE,
                                       prop = FALSE,
                                       ...)
    standardGeneric("getCountGenoHet"))


#' Obtain total alternative genotype counts per SNP or per sample
#'
#' @param object A [GbsrGenotypeData] object.
#' @param target Either of "marker" and "sample".
#' @param prop A logical value whether to return values as
#' proportions of total alternative genotype counts to total
#' non missing genotype counts or not.
#' @param valid A logical value. See details.
#' @param ... Unused.
#'
#' @details
#' You need to execute [countGenotype()] to calculate sumaary statisticsto be
#' obtained via this function.
#' If `valid = TRUE`, the chromosome information of markers which are
#' labeled `TRUE` in the [sample] slot will be returned.
#' [validMar()] tells you which samples are valid.
#'
#' @return A numeric vector of (proportion of) homozygous alternative
#' genotype calls per marker.
#' @examples
#' # Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
#' gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
#' gds <- loadGDS(gds_fn)
#'
#' # Summarize the genotype count information and store them in the
#' # [marker] and [sample] slots of the [GbsrGenotypeData] object.
#' gds <- countGenotype(gds)
#'
#' getCountGenoAlt(gds)
#'
#' # Close the connection to the GDS file
#' closeGDS(gds)
#'
#' @export
#'
setGeneric("getCountGenoAlt", function(object,
                                       target = "marker",
                                       valid = TRUE,
                                       prop = FALSE,
                                       ...)
    standardGeneric("getCountGenoAlt"))


#' Obtain total missing genotype counts per SNP or per sample
#'
#' @param object A [GbsrGenotypeData] object.
#' @param target Either of "marker" and "sample".
#' @param prop A logical value whether to return values as proportions
#' of total missing genotype counts to the total genotype calls or not.
#' @param valid A logical value. See details.
#' @param ... Unused.
#'
#' @details
#' You need to execute [countGenotype()] to calculate sumaary statisticsto be
#' obtained via this function.
#' If `valid = TRUE`, the chromosome information of markers which are
#' labeled `TRUE` in the [sample] slot will be returned.
#' [validMar()] tells you which samples are valid.
#'
#' @return A numeric vector of (proportion of)
#' missing genotype calls per marker.
#' @examples
#' gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
#' gds <- loadGDS(gds_fn)
#' gds <- countGenotype(gds)
#' getCountGenoMissing(gds)
#' closeGDS(gds) # Close the connection to the GDS file
#'
#' @export
#'
setGeneric("getCountGenoMissing", function(object,
                                           target = "marker",
                                           valid = TRUE,
                                           prop = FALSE,
                                           ...)
    standardGeneric("getCountGenoMissing"))


#' Obtain total reference allele counts per SNP or per sample
#'
#' @param object A [GbsrGenotypeData] object.
#' @param target Either of "marker" and "sample".
#' @param prop A logical value whether to return values as proportions
#' of total reference allele counts to total non missing allele counts or not.
#' @param valid A logical value. See details.
#' @param ... Unused.
#'
#' @details
#' You need to execute [countGenotype()] to calculate sumaary statisticsto be
#' obtained via this function.
#' If `valid = TRUE`, the chromosome information of markers which are
#' labeled `TRUE` in the [sample] slot will be returned.
#' [validMar()] tells you which samples are valid.
#'
#' @return A numeric vector of (proportion of) reference alleles per marker.
#' @examples
#' # Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
#' gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
#' gds <- loadGDS(gds_fn)
#'
#' # Summarize the genotype count information and store them in the
#' # [marker] and [sample] slots of the [GbsrGenotypeData] object.
#' gds <- countGenotype(gds)
#'
#' getCountAlleleRef(gds)
#'
#' # Close the connection to the GDS file.
#' closeGDS(gds)
#'
#' @export
#'
setGeneric("getCountAlleleRef", function(object,
                                         target = "marker",
                                         valid = TRUE,
                                         prop = FALSE,
                                         ...)
    standardGeneric("getCountAlleleRef"))


#' Obtain total alternative allele counts per SNP or per sample
#'
#' @param object A [GbsrGenotypeData] object.
#' @param target Either of "marker" and "sample".
#' @param prop A logical value whether to return values as proportions
#' of total alternative allele counts to total non missing allele
#' counts or not.
#' @param valid A logical value. See details.
#' @param ... Unused.
#'
#' @details
#' You need to execute [countGenotype()] to calculate sumaary statisticsto be
#' obtained via this function.
#' If `valid = TRUE`, the chromosome information of markers which are
#' labeled `TRUE` in the [sample] slot will be returned.
#' [validMar()] tells you which samples are valid.
#'
#' @return A numeric vector of (proportion of) alternative alleles per marker.
#' @examples
#' gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
#' gds <- loadGDS(gds_fn)
#' gds <- countGenotype(gds)
#' getCountAlleleAlt(gds)
#' closeGDS(gds) # Close the connection to the GDS file
#'
#' @export
#'
setGeneric("getCountAlleleAlt", function(object,
                                         target = "marker",
                                         valid = TRUE,
                                         prop = FALSE,
                                         ...)
    standardGeneric("getCountAlleleAlt"))


#' Obtain total missing allele counts per SNP or per sample
#'
#' @param object A [GbsrGenotypeData] object.
#' @param target Either of "marker" and "sample".
#' @param prop A logical value whether to return values as proportions of
#' total missing allele counts to the total allele number or not.
#' @param valid A logical value. See details.
#' @param ... Unused.
#'
#' @details
#' You need to execute [countGenotype()] to calculate sumaary statisticsto be
#' obtained via this function.
#' If `valid = TRUE`, the chromosome information of markers which are
#' labeled `TRUE` in the [sample] slot will be returned.
#' [validMar()] tells you which samples are valid.
#'
#' @return A numeric vector of (proportion of) missing alleles per marker.
#' @examples
#' # Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
#' gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
#' gds <- loadGDS(gds_fn)
#'
#' # Summarize the genotype count information and store them in the
#' # [marker] and [sample] slots of the [GbsrGenotypeData] object.
#' gds <- countGenotype(gds)
#'
#' getCountAlleleMissing(gds)
#'
#' # Close the connection to the GDS file.
#' closeGDS(gds)
#'
#' @export
#'
setGeneric("getCountAlleleMissing", function(object,
                                             target = "marker",
                                             valid = TRUE,
                                             prop = FALSE,
                                             ...)
    standardGeneric("getCountAlleleMissing"))


#' Obtain mean values of total reference read counts per
#' SNP or per sample
#'
#' @param object A [GbsrGenotypeData] object.
#' @param target Either of "marker" and "sample".
#' @param valid A logical value. See details.
#' @param ... Unused.
#'
#' @details
#' You need to execute [countRead()] to calculate summary statistics to be
#' obtained via this function.
#' If `valid = TRUE`, the chromosome information of markers which are
#' labeled `TRUE` in the [sample] slot will be returned.
#' [validMar()] tells you which samples are valid.
#'
#' @return A numeric vector of the mean values of
#' reference allele reads per marker.
#' @examples
#' gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
#' gds <- loadGDS(gds_fn)
#' gds <- countRead(gds)
#' getMeanReadRef(gds)
#' closeGDS(gds) # Close the connection to the GDS file
#'
#' @export
#'
setGeneric("getMeanReadRef", function(object,
                                      target = "marker",
                                      valid = TRUE,
                                      ...)
    standardGeneric("getMeanReadRef"))


#' Obtain mean values of total alternative read counts
#' per SNP or per sample
#'
#' @param object A [GbsrGenotypeData] object.
#' @param target Either of "marker" and "sample".
#' @param valid A logical value. See details.
#' @param ... Unused.
#'
#' @details
#' You need to execute [countRead()] to calculate sumaary statisticsto be
#' obtained via this function.
#' If `valid = TRUE`, the chromosome information of markers which are
#' labeled `TRUE` in the [sample] slot will be returned.
#' [validMar()] tells you which samples are valid.
#'
#' @return A numeric vector of the mean values of
#' alternative allele reads per marker.
#' @examples
#' # Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
#' gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
#' gds <- loadGDS(gds_fn)
#'
#' # Calculate means, standard deviations, quantiles of read counts
#' # per marker and per sample with or without standardization of
#' # the counts and store them in the [marker] and [sample] slots
#' # of the [GbsrGenotypeData] object.
#' gds <- countRead(gds)
#'
#' getMeanReadAlt(gds)
#'
#' # Close the connection to the GDS file.
#' closeGDS(gds)
#'
#' @export
#'
setGeneric("getMeanReadAlt", function(object,
                                      target = "marker",
                                      valid = TRUE,
                                      ...)
    standardGeneric("getMeanReadAlt"))


#' Obtain standard deviations of total reference read counts
#' per SNP or per sample
#'
#' @param object A [GbsrGenotypeData] object.
#' @param target Either of "marker" and "sample".
#' @param valid A logical value. See details.
#' @param ... Unused.
#'
#' @details
#' You need to execute [countRead()] to calculate summary statistics to be
#' obtained via this function.
#' If `valid = TRUE`, the chromosome information of markers which are
#' labeled `TRUE` in the [sample] slot will be returned.
#' [validMar()] tells you which samples are valid.
#'
#'
#' @return A numeric vector of the standard deviations of
#' reference allele reads per marker.
#' @examples
#' # Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
#' gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
#' gds <- loadGDS(gds_fn)
#'
#' # Calculate means, standard deviations, quantiles of read counts
#' # per marker and per sample with or without standardization of
#' # the counts and store them in the [marker] and [sample] slots
#' # of the [GbsrGenotypeData] object.
#' gds <- countRead(gds)
#'
#' getSDReadRef(gds)
#'
#' # Close the connection to the GDS file.
#' closeGDS(gds)
#'
#' @export
#'
setGeneric("getSDReadRef", function(object,
                                    target = "marker",
                                    valid = TRUE,
                                    ...)
    standardGeneric("getSDReadRef"))


#' Obtain standard deviations of total alternative read counts per
#' SNP or per sample
#'
#' @param object A [GbsrGenotypeData] object.
#' @param target Either of "marker" and "sample".
#' @param valid A logical value. See details.
#' @param ... Unused.
#'
#' @details
#' You need to execute [countRead()] to calculate sumaary statisticsto be
#' obtained via this function.
#' If `valid = TRUE`, the chromosome information of markers which are
#' labeled `TRUE` in the [sample] slot will be returned.
#' [validMar()] tells you which samples are valid.
#'
#' @return A numeric vector of the standard deviations of
#' alternative allele reads per marker.
#' @examples
#' # Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
#' gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
#' gds <- loadGDS(gds_fn)
#'
#' # Calculate means, standard deviations, quantiles of read counts
#' # per marker and per sample with or without standardization of
#' # the counts and store them in the [marker] and [sample] slots
#' # of the [GbsrGenotypeData] object.
#' gds <- countRead(gds)
#'
#' getSDReadAlt(gds)
#'
#' # Close the connection to the GDS file.
#' closeGDS(gds)
#'
#' @export
#'
setGeneric("getSDReadAlt", function(object,
                                    target = "marker",
                                    valid = TRUE,
                                    ...)
    standardGeneric("getSDReadAlt"))


#' Obtain quantile values of total reference read counts per
#' SNP or per sample
#'
#' @param object A [GbsrGenotypeData] object.
#' @param target Either of "marker" and "sample".
#' @param valid A logical value. See details.
#' @param ... Unused.
#'
#' @details
#' You need to execute [countRead()] to calculate sumaary statisticsto be
#' obtained via this function.
#' If `valid = TRUE`, the chromosome information of markers which are
#' labeled `TRUE` in the [sample] slot will be returned.
#' [validMar()] tells you which samples are valid.
#'
#' @return A numeric vector of the quantile values of
#' alternative allele reads per marker.
#' @examples
#' # Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
#' gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
#' gds <- loadGDS(gds_fn)
#'
#' # Calculate means, standard deviations, quantiles of read counts
#' # per marker and per sample with or without standardization of
#' # the counts and store them in the [marker] and [sample] slots
#' # of the [GbsrGenotypeData] object.
#' gds <- countRead(gds)
#'
#' getMedianReadRef(gds)
#'
#' # Close the connection to the GDS file.
#' closeGDS(gds)
#'
#' @export
#'
setGeneric("getMedianReadRef", function(object,
                                        target = "marker",
                                        valid = TRUE,
                                        ...)
    standardGeneric("getMedianReadRef"))


#' Obtain quantile values of total alternative read counts per
#' SNP or per sample
#'
#' @param object A [GbsrGenotypeData] object.
#' @param target Either of "marker" and "sample".
#' @param valid A logical value. See details.
#' @param ... Unused.
#'
#' @details
#' You need to execute [countRead()] to calculate sumaary statisticsto be
#' obtained via this function.
#' If `valid = TRUE`, the chromosome information of markers which are
#' labeled `TRUE` in the [sample] slot will be returned.
#' [validMar()] tells you which samples are valid.
#'
#' @return A numeric vector of the quantile values of
#' alternative allele reads per marker.
#' @examples
#' # Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
#' gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
#' gds <- loadGDS(gds_fn)
#'
#' # Calculate means, standard deviations, quantiles of read counts
#' # per marker and per sample with or without standardization of
#' # the counts and store them in the [marker] and [sample] slots
#' # of the [GbsrGenotypeData] object.
#' gds <- countRead(gds)
#'
#' getMedianReadAlt(gds)
#'
#' # Close the connection to the GDS file.
#' closeGDS(gds)
#'
#' @export
#'
setGeneric("getMedianReadAlt", function(object,
                                        target = "marker",
                                        valid = TRUE,
                                        ...)
    standardGeneric("getMedianReadAlt"))


#' Obtain minor allele frequencies per SNP or per sample
#'
#' @param object A [GbsrGenotypeData] object.
#' @param target Either of "marker" and "sample".
#' @param valid A logical value. See details.
#' @param ... Unused.
#'
#' @details
#' You need to execute [countGenotype()] to calculate sumaary statisticsto be
#' obtained via this function.
#' If `valid = TRUE`, the chromosome information of markers which are
#' labeled `TRUE` in the [sample] slot will be returned.
#' [validMar()] tells you which samples are valid.
#'
#' @return A numeric vector of the minor allele frequencies per marker.
#' @examples
#' # Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
#' gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
#' gds <- loadGDS(gds_fn)
#'
#' # Summarize the genotype count information and store them in the
#' # [marker] and [sample] slots of the [GbsrGenotypeData] object.
#' gds <- countGenotype(gds)
#'
#' getMAF(gds)
#'
#' # Close the connection to the GDS file
#' closeGDS(gds)
#'
#' @export
#'
setGeneric("getMAF", function(object,
                              target = "marker",
                              valid = TRUE,
                              ...)
    standardGeneric("getMAF"))


#' Obtain minor allele counts per SNP or per sample
#'
#' @param object A [GbsrGenotypeData] object.
#' @param target Either of "marker" and "sample".
#' @param valid A logical value. See details.
#' @param ... Unused.
#'
#' @details
#' You need to execute [countGenotype()] to calculate sumaary statisticsto be
#' obtained via this function.
#' If `valid = TRUE`, the chromosome information of markers which are
#' labeled `TRUE` in the [sample] slot will be returned.
#' [validMar()] tells you which samples are valid.
#'
#' @return A numeric vector of the minor allele counts per marker.
#' @examples
#' # Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
#' gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
#' gds <- loadGDS(gds_fn)
#'
#' # Summarize the genotype count information and store them in the
#' # [marker] and [sample] slots of the [GbsrGenotypeData] object.
#' gds <- countGenotype(gds)
#'
#' getMAC(gds)
#'
#' # Close the connection to the GDS file.
#' closeGDS(gds)
#'
#' @export
#'
setGeneric("getMAC", function(object,
                              target = "marker",
                              valid = TRUE,
                              ...)
    standardGeneric("getMAC"))


#' Get parental sample information
#'
#' This function returns sample IDs, member IDs and indexes of parental samples
#' set via [setParents()]. Sample IDs are IDs given by user or obtained from the
#' original VCF file. Member IDs are serial numbers assigned by [setParents()].
#'
#' @param object A [GbsrGenotypeData] object.
#' @param bool If TRUE, the function returns a logical vector indicating
#' which samples have been set as parents.
#' @param verbose If FALSE, the function does not print a warning message even
#' when parents were not specified in the given [GbsrGenotypeData] object. The
#' setting `verbose = FALSE` is used in the other functions to call
#' `getParents()` without evoking unnecessary warnings to users.
#' @param ... Unused.
#'
#' @export
#'
#' @return A data frame of parents information indicating sampleIDs, memberIDs
#' and indexes of parental lines assigned via [setParents()].
#'
#' @examples
#' # Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
#' gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
#' gds <- loadGDS(gds_fn)
#'
#' # Find the IDs of parental samples.
#' parents <- grep("Founder", getSamID(gds), value = TRUE)
#'
#' # Set the parents.
#' gds <- setParents(gds, parents = parents)
#'
#' # Get the information of parents.
#' getParents(gds)
#'
#' # Close the connection to the GDS file.
#' closeGDS(gds)
#'
#'
setGeneric("getParents", function(object,
                                  bool = FALSE,
                                  verbose = TRUE,
                                  ...)
    standardGeneric("getParents"))


#' Reopen the connection to the GDS file.
#'
#' @param object A [GbsrGenotypeData] object.
#'
#' @details The GbsrGenotypeData object stores the file path of the GDS file
#' even after closing the connection the file. This function open again the
#' connection to the GDS file at the file path stored in the GbsrGenotypeData
#' object. If the GbsrGenotypeData object witch has an open connection to
#' the GDS file, this function will reopen the connection. The data stored in
#' the marker and sample slots will not be changed.
#' Thus, you can open a connection with the GDS file with keeping information
#' of filtering and summary statistics.
#'
#' @return A [GbsrGenotypeData] object.
#' @param ... Unused.
#'
#' @export
#'
#' @examples
#' # Use a GDS file of example data.
#' gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
#'
#' # Instantiation of [GbsrGenotypeData]
#' gds <- loadGDS(gds_fn)
#'
#' # Close the connection to the GDS file
#' closeGDS(gds)
#'
#' gds <- reopenGDS(gds)
#'
#' # Close the connection to the GDS file
#' closeGDS(gds)

setGeneric("reopenGDS", function(object, ...) standardGeneric("reopenGDS"))


#' Check if a GDS file has been opened or not.
#'
#' @param object A [GbsrGenotypeData] object.
#' @param ... Unused.
#'
#' @return `TRUE` if the GDS file linked to the input [GbsrGenotypeData] object
#'  has been opened, while `FALSE` if closed.
#'
#' @examples
#' # Use a GDS file of example data.
#' gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
#'
#' # Instantiation of [GbsrGenotypeData]
#' gds <- loadGDS(gds_fn)
#'
#' # Check connection to the GDS file
#' isOpenGDS(gds)
#'
#' # Close the connection to the GDS file
#' closeGDS(gds)
#'
#'@export
#'
setGeneric("isOpenGDS", function(object, ...)
    standardGeneric("isOpenGDS"))


#' Close the connection to the GDS file
#'
#' Close the connection to the GDS file linked to the given
#'  [GbsrGenotypeData] object.
#'
#' @param object A [GbsrGenotypeData] object.
#' @param save_filter A logical whether to save the filtering information made
#'  via [setSamFilter()] and [setMarFilter()] in the GDS file. The saved
#'  filter information can be reused if set `load_filter = TRUE` for
#'  [loadGDS()].
#' @param verbose if TRUE, show information.
#' @param ... Unused.
#'
#' @return NULL.
#'
#' @examples
#' # Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
#' gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
#' gds <- loadGDS(gds_fn)
#'
#' # Close the connection to the GDS file
#' closeGDS(gds)
#'
#'@export
#'
setGeneric("closeGDS", function(object, save_filter = FALSE, verbose = TRUE, ...)
    standardGeneric("closeGDS"))


#' Set labels to samples which should be recognized as
#' parents of the population to be subjected to error correction.
#'
#' Specify two or more samples in the dataset as parents
#' of the population. Markers will be filtered out up on your specification.
#'
#' @param object A [GbsrGenotypeData] object.
#' @param parents A vector of strings with at least length two.
#' The specified strings should match with the samples
#' ID available via [getSamID()].
#' @param nonmiss A logical value whether to filter out markers which
#' are missing in parents.
#' @param mono A logical value whether to filter out markers which
#' are not monomorphic in parents.
#' @param bi A logical value whether to filter out marekrs which
#' are not biallelic between parents.
#' @param ... Unused.
#'
#' @details
#' The `clean` function of [GBScleanR] uses read count information of
#' samples and their parents separately to estimate most probable
#' genotype calls of them. Therefore, you must specify proper samples
#' as parents via this function. If you would like to remove SNP markers
#' which are not biallelic and/or not monomorphic in each parent,
#' set `mono = TRUE` and `bi = TRUE`. The replicates of parental samples
#' specified to the `repliate` argument of [setParents()] will have the same
#' genotypes at all markers in the estimated genotypes obtained via [estGeno()].
#' In the genotype estimation by [estGeno()], the Viterbi scores for each
#' possible genotype at each marker for the replicates will be replaced with
#' the average score for the replicates.
#'
#' @return A [GbsrGenotypeData] object with parents information.
#'
#' @examples
#' # Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
#' gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
#' gds <- loadGDS(gds_fn)
#'
#' # Find the IDs of parental samples.
#' parents <- grep("Founder", getSamID(gds), value = TRUE)
#'
#' # Set the parents and flip allele information
#' # if the reference sample (Founder1 in our case) has homozygous
#' # alternative genotype at some markers of which alleles will
#' # be swapped to make the reference sample have homozygous
#' # reference genotype.
#' gds <- setParents(gds, parents = parents)
#'
#' # Initialize a scheme object stored in the slot of the GbsrGenotypeData.
#' # We chose `crosstype = "pair"` because two inbred founders were mated
#' # in our breeding scheme.
#' # We also need to specify the mating matrix which has two rows and
#' # one column with integers 1 and 2 indicating a sample (founder)
#' # with the memberID 1 and a sample (founder) with the memberID 2
#' # were mated.
#' gds <- initScheme(gds, mating = cbind(c(1:2)))
#'
#' # Add information of the next cross conducted in our scheme.
#' # We chose 'crosstype = "selfing"', which do not require a
#' # mating matrix.
#' gds <- addScheme(gds, crosstype = "selfing")
#'
#' # Execute error correction by estimating genotype and haplotype of
#' # founders and offspring.
#' gds <- estGeno(gds)
#'
#' # Close the connection to the GDS file.
#' closeGDS(gds)
#'
#' @export
#'
setGeneric("setParents", function(object,
                                  parents,
                                  nonmiss = FALSE,
                                  mono = FALSE,
                                  bi = FALSE,
                                  ...)
    standardGeneric("setParents"))


#' Set identifiers to indicates which samples are replicates.
#'
#' Not implemented yet.
#' This function assign identifiers that indicates which samples are replicates
#' those which should have the same genotypes at all markers.
#'
#' @param object A [GbsrGenotypeData] object.
#' @param replicates A vector of integers, numbers, or characters to indicate
#' grouping of samples as replicates.
#' @param ... Unused.
#'
#' @details
#' The replicates of samples specified in [setReplicates()] will have the same
#' genotypes at all markers in the estimated genotypes obtained via [estGeno()].
#' In the genotype estimation by [estGeno()], the Viterbi scores for each
#' possible genotype (haplotype) at each marker for the replicates will be
#' replaced with the average score for the replicates.
#'
#' @return A [GbsrGenotypeData] object with genotype count information.
#'
#' @examples
#' # Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
#' gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
#' gds <- loadGDS(gds_fn)
#'
#' gds <- setParents(gds, parents = c("Founder1", "Founder2"))
#'
#' # When your data has 100 samples, two replicates for each offspring,
#' # and the samples are ordered as the 1st replicate followed by the 2nd
#' # replicate, you can specify replicates as below.
#' # gds <- setReplicates(gds, replicates = rep(1:50, each = 2))
#'
#' # If you need to confirm the order of samples, run the following code.
#' # id <- getSamID(gds)
#'
#' # Replicate IDs should be set also to parents. Therefore, please include
#'
#' # Close the connection to the GDS file.
#' closeGDS(gds)
#'
#' @export
#'
setGeneric("setReplicates", function(object,
                                     replicates,
                                     ...)
    standardGeneric("setReplicates"))

#' Get identifiers to indicates which samples are replicates.
#'
#' Not implemented yet.
#' This function assign identifiers that indicates which samples are replicates
#' those which should have the same genotypes at all markers.
#'
#' @param object A [GbsrGenotypeData] object.
#' @param parents A logical value to indicate whether to include replicate IDs
#' for parental samples in the output. If you specify `parents = "only"`, this
#' function returns replicate IDs only for parental samples.
#' @param ... Unused.
#'
#' @details
#' The replicates of samples specified in [setReplicates()] will have the same
#' genotypes at all markers in the estimated genotypes obtained via [estGeno()].
#' In the genotype estimation by [estGeno()], the Viterbi scores for each
#' possible genotype (haplotype) at each marker for the replicates will be
#' replaced with the average score for the replicates.
#'
#' @return A [GbsrGenotypeData] object with genotype count information.
#'
#' @seealso [setReplicates()]
#'
#' @examples
#' # Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
#' gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
#' gds <- loadGDS(gds_fn)
#'
#' gds <- setParents(gds, parents = c("Founder1", "Founder2"))
#'
#' # When your data has 100 samples, two replicates for each offspring,
#' # and the samples are ordered as the 1st replicate followed by the 2nd
#' # replicate, you can specify replicates as below.
#' # gds <- setReplicates(gds, replicates = rep(1:50, each = 2))
#'
#' # If you need to confirm the order of samples, run the following code.
#' # id <- getSamID(gds)
#'
#' # Replicate IDs should be set also to parents. Therefore, please include
#'
#'
#' # getReplicates(gds)
#'
#' # Close the connection to the GDS file.
#' closeGDS(gds)
#'
#' @export
#'
setGeneric("getReplicates", function(object,
                                     parents = FALSE,
                                     ...)
    standardGeneric("getReplicates"))

#' Count genotype calls and alleles per sample and per marker.
#'
#' This function calculates several summary statistics of
#' genotype calls and alleles per marker and per sample.
#' Those values will be stored in the SnpAnnotaionDataFrame slot
#' and the [sample] slot and obtained via getter
#' functions, e.g.s
#' [getCountGenoRef()], [getCountAlleleRef()], and [getMAF()].
#'
#' @param object A [GbsrGenotypeData] object.
#' @param target Either of "marker" and "sample".
#' @param node Either of "raw", "filt", and "cor". See details.
#' @param ... Unused.
#'
#' @details
#' #' Genotype call data can be obtained from the "genotype" node,
#' the "filt.genotype" node, or the "corrected.genotype" node of
#' the GDS file with `node = "raw"`, `node = "filt"`, or `node = "raw"`,
#' respectively.
#' The [setCallFilter()] function generate filtered genotype call data in the
#' "filt.genotype" node which can be accessed as mentioned above.
#' On the other hand, the "corrected.genotype" node can be generated
#' via the [estGeno()] function.
#'
#' @return A [GbsrGenotypeData] object with genotype count information.
#'
#' @examples
#' # Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
#' gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
#' gds <- loadGDS(gds_fn)
#'
#' # Summarize the genotype count information and store them in the
#' # [marker] and [sample] slots of the [GbsrGenotypeData] object.
#' gds <- countGenotype(gds)
#'
#' # Get the proportion of missing genotype per sample.
#' sample_missing_rate <- getCountGenoMissing(gds,
#'                                            target = "sample",
#'                                            prop = TRUE)
#'
#' # Get the minor allele frequency per marker.
#' marker_minor_allele_freq <- getMAF(gds, target = "marker")
#'
#' # Draw histograms of the missing rate per sample and marker.
#' histGBSR(gds, stats = "missing")
#'
#' # Close the connection to the GDS file.
#' closeGDS(gds)
#'
#' @export
#'
setGeneric("countGenotype", function(object,
                                     target = "both",
                                     node = "raw",
                                     ...)
    standardGeneric("countGenotype"))


#' Count reads per sample and per marker.
#'
#' This function calculates several summary statistics of read counts
#' per marker and per sample. Those values will be stored
#' in the SnpAnnotaionDataFrame slot and the [sample] slot
#' and obtained via getter functions, e.g.
#' [getCountReadRef()] and [getCountReadAlt()].
#' This function first calculates normalized allele read counts by dividing
#' allele read counts at each marker in each sample by the total allele read
#' of the sample followed by multiplication by 10^6. In other words, it
#' calculates reads per million (rpm). Then, the function calculates
#' mean, standard deviation, quantile values of rpm per marker and per sample.
#' The results will be stored in the SnpAnnotaionDataFrame slot and the
#' [sample] slot and obtained via getter functions, e.g.
#' [getMeanReadRef()] and [getMedianReadAlt()].
#'
#' @param object A [GbsrGenotypeData] object.
#' @param target Either of "marker" and "sample".
#' @param node Either of "raw" and "filt". See details.
#' @param ... Unused.
#'
#' @details
#' Read count data can be obtained from the "annotation/format/AD/data" node
#' or the "annotation/format/AD/filt.data" node of the GDS file
#' with `node = "raw"` or `node = "filt"`, respectively.
#' The [setCallFilter()] function generate filtered read count data
#' in the "annotation/format/AD/filt.data" node which can be accessed as
#' mentioned above.
#'
#' @return A [GbsrGenotypeData] object with read count information.
#'
#' @examples
#' # Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
#' gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
#' gds <- loadGDS(gds_fn)
#'
#' # Summarize the read count information and store them in the
#' # [marker] and [sample] slots of the [GbsrGenotypeData] object.
#' gds <- countRead(gds)
#'
#' # Get the total read counts per marker
#' read_depth_per_marker <- getCountRead(gds, target = "marker")
#'
#' # Get the proportion of reference allele rads per marker.
#' reference_read_freq <- getCountReadRef(gds, target = "marker", prop = TRUE)
#'
#' # Draw histgrams of reference allele read counts per sample and marker.
#' histGBSR(gds, stats = "ad_ref")
#'
#' # Close the connection to the GDS file.
#' closeGDS(gds)
#'
#' @export
#'
setGeneric("countRead", function(object,
                                 target = "both",
                                 node = "raw",
                                 ...)
    standardGeneric("countRead"))

#' Remove markers potentially having redundant information.
#'
#' Markers within the length of the sequenced reads
#' (usually ~ 150 bp, up to your sequencer)
#' potentially have redundant information and
#' those will cause unexpected errors
#' in error correction which assumes
#' independency of markers each other.
#' This function only retains the first marker or
#' the least missing rate marker
#' from the markers locating within the specified stretch.
#'
#' @param object A [GbsrGenotypeData] object.
#' @param range A integer value to indicate the stretch to search markers.
#' @param ... Unused.
#'
#' @details
#' This function search valid markers from the first marker
#' of each chromosome and
#' compare its physical position with a neighbor marker.
#' If the distance between those
#' markers are equal or less then `range`, one of them
#' which has a larger missing rate
#' will be removed (labeled as invalid marker).
#' When the first marker was retained and
#' the second marker was removed as invalid marker,
#' next the distance between the first marker
#' and the third marker will be checked and
#' this cycle is repeated until reaching the
#' end of each chromosome. Run [validMar()]
#' to check the valid SNP markers.
#'
#' @return A [GbsrGenotypeData] object with filters on markers.
#'
#' @examples
#' # Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
#' gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
#' gds <- loadGDS(gds_fn)
#'
#' # Summarize genotype count information to be used in thinMarker().
#' gds <- countGenotype(gds)
#' gds <- thinMarker(gds, range = 150)
#'
#' closeGDS(gds) # Close the connection to the GDS file
#' @export
#'
setGeneric("thinMarker", function(object, range = 150, ...)
    standardGeneric("thinMarker"))

#' Filter out each genotype call meeting criteria
#'
#' Perform filtering of each genotype call, neither markers
#' nor samples. Each genotype call is supported by its read counts
#' for the reference allele and the alternative allele of
#' a marker of a sample. `setCallFilter()` set missing to
#' the genotype calls which are not reliable enough and set zero
#' to reference and alternative read counts of the genotype calls.
#'
#' @param object A [GbsrGenotypeData] object.
#' @param dp_count A numeric vector with length two specifying lower and
#' upper limit of total read counts (reference reads + alternative reads).
#' @param ref_count A numeric vector with length two specifying lower and
#' upper limit of reference read counts.
#' @param alt_count A numeric vector with length two specifying lower and
#' upper limit of alternative read counts.
#' @param dp_qtile A numeric vector with length two specifying lower
#' and upper limit of quantile of total read counts in each sample.
#'@param ref_qtile A numeric vector with length two specifying lower
#'and upper limit of quantile of reference read counts in each sample.
#' @param alt_qtile A numeric vector with length two specifying lower
#' and upper limit of quantile of alternative read counts in each
#' sample.
#' @param ... Unused.
#'
#' @details
#' `dp_qtile`, `ref_qtile`,
#' and `alt_qtile` use quantile values of read counts
#' of each sample to decide the lower and upper limit of read counts.
#' This function generate two new nodes in the GDS file linked with
#' the given [GbsrGenotypeData] object. The filtered read counts and genotype
#' calls will be stored in the data node in the "FAD" folder and the data node
#' in the "FGT" folder, while the data node in the "CFT" stores call fitering
#' informatin.
#' To reset the filter applied by setCallFilter(), run [resetCallFilter()].
#'
#' @return A [GbsrGenotypeData] object with filters on genotype calls.
#'
#' @examples
#' # Create a GDS file from a sample VCF file.
#' vcf_fn <- system.file("extdata", "sample.vcf", package = "GBScleanR")
#' gds_fn <- tempfile("sample", fileext = ".gds")
#' gbsrVCF2GDS(vcf_fn = vcf_fn, out_fn = gds_fn, force = TRUE)
#'
#' # Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
#' gds <- loadGDS(gds_fn)
#'
#' # Filter out genotype calls supported by less than 5 reads.
#' gds <- setCallFilter(gds, dp_count = c(5, Inf))
#'
#' # Filter out genotype calls supported by reads less than
#' # the 20 percentile of read counts per marker in each sample.
#' gds <- setCallFilter(gds, dp_qtile = c(0.2, 1))
#'
#' # Reset the filter
#' gds <- resetCallFilter(gds)
#'
#' # Close the connection to the GDS file.
#' closeGDS(gds)
#'
#' @export
#'
setGeneric("setCallFilter", function(object,
                                     dp_count = c(0, Inf),
                                     ref_count = c(0, Inf),
                                     alt_count = c(0, Inf),
                                     dp_qtile = c(0, 1),
                                     ref_qtile = c(0, 1),
                                     alt_qtile = c(0, 1),
                                     ...)
    standardGeneric("setCallFilter"))


#' Filter out samples
#'
#' Search samples which do not meet the criteria and label them as "invalid".
#'
#' @param object A [GbsrGenotypeData] object.
#' @param id A vector of strings matching with sample ID which can
#' be retrieve by `getSamID()`. The samples with the specified IDs
#' will be filtered out.
#' @param missing A numeric value \[0-1\] to specify the maximum
#' missing genotype call rate per sample.
#' @param het A vector of two numeric values \[0-1\] to specify
#' the minimum and maximum heterozygous genotype call rate per sample.
#' @param mac A integer value to specify the minimum minor
#' allele count per sample.
#' @param maf A numeric value to specify the minimum minor
#' allele frequency per sample.
#' @param ad_ref A numeric vector with length two specifying lower
#' and upper limit of reference read counts per sample.
#' @param ad_alt A numeric vector with length two specifying lower
#' and upper limit of alternative read counts per sample.
#' @param dp A numeric vector with length two specifying lower
#' and upper limit of total read counts per sample.
#' @param mean_ref A numeric vector with length two specifying lower
#' and upper limit of mean of reference read counts per sample.
#' @param mean_alt A numeric vector with length two specifying lower
#' and upper limit of mean of alternative read counts per sample.
#' @param sd_ref A numeric value specifying the upper limit of
#' standard deviation of reference read counts per sample.
#' @param sd_alt A numeric value specifying the upper limit of
#' standard deviation of alternative read counts per sample.
#' @param ... Unused.
#'
#' @details
#' For `mean_ref`, `mean_alt`, `sd_ref`, and `sd_alt`,
#' this function calculate mean and standard deviation of reads
#' obtained at SNP markers of each sample. If a mean read counts
#' of a sample was smaller than the specified lower limit or larger
#' than the upper limit, this function labels the sample as "invalid".
#' In the case of `sd_ref` and `sd_alt`, standard deviations of read counts
#' of each sample are checked and the samples having
#' a larger standard deviation will be labeled as "invalid".
#' To check valid and invalid samples, run [validSam()].
#'
#' @return A [GbsrGenotypeData] object with filters on samples.
#'
#' @examples
#' # Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
#' gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
#' gds <- loadGDS(gds_fn)
#'
#' # Summarize the information needed for filtering.
#' gds <- countGenotype(gds)
#' gds <- countRead(gds)
#'
#' gds <- setSamFilter(gds,
#'                        id = getSamID(gds)[1:10],
#'                        missing = 0.2,
#'                        dp = c(5, Inf))
#'
#' # Close the connection to the GDS file.
#' closeGDS(gds)
#'
#' @export
#'
setGeneric("setSamFilter", function(object,
                                    id = NA_character_,
                                    missing = 1,
                                    het = c(0, 1),
                                    mac = 0,
                                    maf = 0,
                                    ad_ref = c(0, Inf),
                                    ad_alt = c(0, Inf),
                                    dp = c(0, Inf),
                                    mean_ref = c(0, Inf),
                                    mean_alt = c(0, Inf),
                                    sd_ref = Inf,
                                    sd_alt = Inf,
                                    ...)
           standardGeneric("setSamFilter"))


#' Filter out markers
#'
#' Search markers which do not meet the criteria and label them as "invalid".
#'
#' @param object A [GbsrGenotypeData] object.
#' @param id A vector of integers matching with snp ID which can
#' be retrieve by `getMarID()`. The markers with the specified IDs
#' will be filtered out.
#' @param missing A numeric value \[0-1\] to specify
#' the maximum missing genotype call rate per marker
#' @param het A numeric vector with length two \[0-1\] to specify
#' the minimum and maximum heterozygous genotype call rate per marker
#' @param mac A integer value to specify the minimum minor allele
#' count per marker
#' @param maf A numeric value to specify the minimum minor allele
#'  frequency per marker.
#' @param ad_ref A numeric vector with length two specifying lower
#' and upper limit of reference read counts per marker.
#' @param ad_alt A numeric vector with length two specifying lower
#' and upper limit of alternative read counts per marker.
#' @param dp A numeric vector with length two specifying lower
#' and upper limit of total read counts per marker.
#' @param mean_ref A numeric vector with length two specifying lower
#' and upper limit of mean of reference read counts per marker.
#' @param mean_alt A numeric vector with length two specifying lower
#' and upper limit of mean of alternative read counts per marker.
#' @param sd_ref A numeric value specifying the upper limit of
#' standard deviation of reference read counts per marker.
#' @param sd_alt A numeric value specifying the upper limit of
#' standard deviation of alternative read counts per marker.
#' @param ... Unused.
#'
#' @details
#' For `mean_ref`, `mean_alt`, `sd_ref`, and `sd_alt`, this function
#' calculate mean and standard deviation of reads obtained for samples
#' at each SNP marker. If a mean read counts of a marker was smaller
#' than the specified lower limit or larger than the upper limit,
#' this function labels the marker as "invalid". In the case of `sd_ref`
#' and `sd_alt`, standard deviations of read counts of each marker are
#' checked and the markers having a larger standard deviation will be
#' labeled as "invalid". To check valid and invalid
#' markers, run [validMar()].
#'
#' @return A [GbsrGenotypeData] object with filters on markers.
#'
#' @examples
#' # Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
#' gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
#' gds <- loadGDS(gds_fn)
#'
#' # Summarize the information needed for filtering.
#' gds <- countGenotype(gds)
#' gds <- countRead(gds)
#'
#' gds <- setMarFilter(gds,
#'                       id = getMarID(gds)[1:100],
#'                       missing = 0.2,
#'                       dp = c(5, Inf))
#'
#' # Close the connection to the GDS file.
#' closeGDS(gds)
#'
#' @export
#'
setGeneric("setMarFilter", function(object,
                                    id = NA_integer_,
                                    missing = 1,
                                    het = c(0, 1),
                                    mac = 0,
                                    maf = 0,
                                    ad_ref = c(0, Inf),
                                    ad_alt = c(0, Inf),
                                    dp = c(0, Inf),
                                    mean_ref = c(0, Inf),
                                    mean_alt = c(0, Inf),
                                    sd_ref = Inf,
                                    sd_alt = Inf,
                                    ...)
           standardGeneric("setMarFilter"))


#' Filter out markers based on marker quality metrics
#'
#' A VCF file usually has marker quality metrics in
#' the INFO filed and those are stored in
#' a GDS file created via [GBScleanR]. This function filter
#' out markers based on those marker
#' quality metrics.
#'
#' @param object A [GbsrGenotypeData] object.
#' @param mq A numeric value to specify minimum mapping
#' quality (shown as MQ in the VCF format).
#' @param fs A numeric value to specify maximum Phred-scaled
#' p-value (strand bias) (shown as FS in the VCF format).
#' @param qd A numeric value to specify minimum Variant
#' Quality by Depth (shown as QD in the VCF format).
#' @param sor A numeric value to specify maximum
#' Symmetric Odds Ratio (strand bias) (shown as SOR in the VCF format).
#' @param mqranksum A numeric values to specify the lower
#' and upper limit of Alt vs. Ref read mapping
#' qualities (shown as MQRankSum in the VCF format).
#' @param readposranksum A numeric values to specify the lower
#' and upper limit of Alt vs. Ref read position
#' bias (shown as ReadPosRankSum in the VCF format).
#' @param baseqranksum A numeric values to specify the lower
#' and upper limit of Alt Vs. Ref base
#' qualities (shown as BaseQRankSum in the VCF format).
#' @param ... Unused.
#'
#' @details
#' Detailed explanation of each metric can be found
#' in [GATK's web site](https://gatk.broadinstitute.org/hc/en-us).
#'
#' @return A [GbsrGenotypeData] object with filters on markers.
#'
#' @examples
#' # Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
#' gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
#' gds <- loadGDS(gds_fn)
#'
#' gds <- setInfoFilter(gds, mq = 40, qd = 20)
#'
#' # Close the connection to the GDS file.
#' closeGDS(gds)
#' @export
#'
setGeneric("setInfoFilter", function(object,
                                     mq = 0 ,
                                     fs = Inf,
                                     qd = 0,
                                     sor = Inf,
                                     mqranksum = c(-Inf, Inf),
                                     readposranksum = c(-Inf, Inf),
                                     baseqranksum = c(-Inf, Inf),
                                     ...)
    standardGeneric("setInfoFilter"))

#' Set ploidy
#'
#' Set the ploidy of a given population in the input [GbsrGenotypeData] object.
#'
#' @param object A [GbsrGenotypeData] object.
#' @param ploidy A integer value to specify the ploidy of the given population.
#' @param ... Unused.
#'
#' @details
#' The genotype estimation by [estGeno()] would be performed with the assumption
#' of the ploidy specified through this function or the `ploidy` argument of
#' [loadGDS()].
#' When an odd number was specified as `ploidy`, the ploidy of intermediate
#' generations would be treated as `ploidy` + 1 to properly list up possible
#' descendent haplotype patterns in the process by [estGeno()].
#'
#' @return A [GbsrGenotypeData] object with filters on markers.
#'
#' @seealso [getPloidy()]
#'
#' @examples
#' # Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
#' gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
#' gds <- loadGDS(gds_fn)
#'
#' gds <- setPloidy(gds, ploidy = 4)
#'
#' # Close the connection to the GDS file.
#' closeGDS(gds)
#'
#' @export
#'
setGeneric("setPloidy", function(object, ploidy = 2, ...)
    standardGeneric("setPloidy"))

#' Get ploidy
#'
#' Get the ploidy of a given population in the input [GbsrGenotypeData] object.
#'
#' @param object A [GbsrGenotypeData] object.
#' @param ... Unused.
#'
#' @return An integer value.
#'
#' @seealso [setPloidy()]
#'
#' @examples
#' # Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
#' gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
#' gds <- loadGDS(gds_fn)
#'
#' ploidy <- getPloidy(gds)
#' print(ploidy)
#'
#' # Close the connection to the GDS file.
#' closeGDS(gds)
#'
#' @export
#'
setGeneric("getPloidy", function(object, ...)
    standardGeneric("getPloidy"))

#' Set fixed allele read biases and mismapping rate
#'
#' Set fixed allele read biases and mismapping rates of markers
#'
#' @param object A [GbsrGenotypeData] object.
#' @param bias A numeric vector of fixed allele read biases to be assigned to
#' valid markers. The length of `bias` vector should match the number of valid
#' markers.
#' @param mismap A numeric matrix of fixed reference and alternative read
#'  mismapping rates to be assigned to valid markers. The number of rows of the
#'  given matrix should match the number of valid markers and should have two
#'  columns that are for reference and alternative read mismapping rates,
#'  respectively.
#' @param parent_geno A logical value indicating whether to use fixed parental
#' genotypes in the genoype estimation by [estGeno()]. This mode requires the
#' estimated genotypes for parental samples that were estimated by [estGeno()]
#' and stored in the GDS file linked to the input [GbsrGenotypeData] object.
#' @param ... Unused.
#'
#' @return A [GbsrGenotypeData] object after adding dominant marker information
#'
#' @export
#'
#' @details
#' If you have already executed genotype estimation and want to reuse the
#' marker-wise allele read biases and mismapping rates estimated in the
#' completed run of estGeno(), you can use them in the next genotype estimation
#' run.
#' For example, if you want to estimate genotypes with different argument
#' settings of setGeno(), it is worth to set fixed parameters and run
#' estGeno() with setting `optim = FALSE` to skip time-consuming iterative
#' parameter optimization steps but use the estimated parameters from the first
#' run to incorporate the marker-wise error parameters.
#' Since the bias set by [setFixedParameter()] function is the reference allele read
#' bias, the values 0 and 1 mean that the marker only gives alternative
#' and reference allele reads, respectively.
#' The values in the `bias` vector are assigned to the valid markers.
#' Similarly, the values in the `mismap` matrix are
#' assigned to the valid markers in the order they appear in the rows.
#'
#' @examples
#' # Create a GDS file from a sample VCF file.
#' vcf_fn <- system.file("extdata", "sample.vcf", package = "GBScleanR")
#' gds_fn <- tempfile("sample", fileext = ".gds")
#' gbsrVCF2GDS(vcf_fn = vcf_fn, out_fn = gds_fn, force = TRUE)
#'
#' # Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
#' gds <- loadGDS(gds_fn)
#'
#' # Not run.
#' # Run estGeno() and reuse the estimated parameters in the second run.
#' # gds <- makeScheme(gds, generation = 2, crosstype = "self")
#' # gds <- estGeno(gds)
#' # fixed_param <- getFixedParameter(gds)
#' # gds <- setFixedParameter(gds,
#' #                          bias = fixed_param$bias,
#' #                          mismap = fixed_param$mismap)
#' # gds <- estGeno(gds, optim = FALSE, call_threshold = 0.5)
#'
#' # You can also set arbitrary values.
#' bias <- sample(seq(0, 1, 0.01), nmar(gds), replace = TRUE)
#' mismap <- cbind(sample(seq(0, 0.2, 0.01), nmar(gds), replace = TRUE),
#'                 sample(seq(0, 0.2, 0.01), nmar(gds), replace = TRUE))
#' gds <- setFixedParameter(gds, bias = bias, mismap = mismap)
#'
#' # Close the connection to the GDS file
#' closeGDS(gds)
#'
#'
setGeneric("setFixedParameter", function(object, bias = NULL, mismap = NULL, parent_geno = FALSE, ...)
    standardGeneric("setFixedParameter"))


#' Get fixed allele read biases and mismapping rate
#'
#' Get fixed allele read biases and mismapping rates of markers
#'
#' @param object A [GbsrGenotypeData] object.
#' @param valid A logical value. See details.
#' @param chr A integer or string to specify chromosome to get information.
#' @param ... Unused.
#'
#' @return A numeric vector of fixed allele read biases.
#'
#' @details
#' If `valid = TRUE`, A logical vector for the markers which are labeled `TRUE` in
#' the "valid" column of the "marker" slot will be returned. If you need check
#' the dominant markers in all markers, set `valid = FALSE`. [validMar()] tells you
#' which markers are valid.
#'
#' @return A [GbsrGenotypeData] object after adding dominant marker information
#'
#' @seealso [setFixedParameter()]
#'
#' @export
#'
#' @examples
# # Create a GDS file from a sample VCF file.
#' vcf_fn <- system.file("extdata", "sample.vcf", package = "GBScleanR")
#' gds_fn <- tempfile("sample", fileext = ".gds")
#' gbsrVCF2GDS(vcf_fn = vcf_fn, out_fn = gds_fn, force = TRUE)
#'
#' # Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
#' gds <- loadGDS(gds_fn)
#'
#' # Not run.
#' # Run estGeno() and reuse the estimated parameters in the second run.
#' # gds <- makeScheme(gds, generation = 2, crosstype = "self")
#' # gds <- estGeno(gds)
#' # fixed_param <- getFixedParameter(gds)
#' # gds <- setFixedParameter(gds,
#' #                          bias = fixed_param$bias,
#' #                          mismap = fixed_param$mismap)
#' # gds <- estGeno(gds, optim = FALSE, call_threshold = 0.5)
#'
#' # Close the connection to the GDS file
#' closeGDS(gds)
#'
setGeneric("getFixedParameter", function(object, valid = TRUE, chr = NULL, ...)
    standardGeneric("getFixedParameter"))

#' Reset the filter made by [setSamFilter()]
#'
#' Remove "invalid" labels put on samples and make all samples valid.
#'
#' @param object A [GbsrGenotypeData] object.
#' @param ... Unused.
#'
#' @return A [GbsrGenotypeData] object after removing
#' all filters on samples.
#'
#' @examples
#' # Create a GDS file from a sample VCF file.
#' vcf_fn <- system.file("extdata", "sample.vcf", package = "GBScleanR")
#' gds_fn <- tempfile("sample", fileext = ".gds")
#' gbsrVCF2GDS(vcf_fn = vcf_fn, out_fn = gds_fn, force = TRUE)
#'
#' # Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
#' gds <- loadGDS(gds_fn)
#'
#' # Summarize the information needed for filtering.
#' gds <- countGenotype(gds)
#' gds <- countRead(gds)
#'
#' gds <- setSamFilter(gds,
#'                        id = getSamID(gds)[1:10],
#'                        missing = 0.2,
#'                        dp = c(5, Inf))
#'
#' # Reset all filters applied above.
#' gds <- resetSamFilter(gds)
#'
#' # Close the connection to the GDS file
#' closeGDS(gds)
#'
#' @export
#'
setGeneric("resetSamFilter", function(object, ...)
    standardGeneric("resetSamFilter"))


#' Reset the filter made by [setMarFilter()]
#'
#' Remove "invalid" labels put on markers and make all markers valid.
#'
#' @param object A [GbsrGenotypeData] object.
#' @param ... Unused.
#'
#' @return A [GbsrGenotypeData] object after removing all filters on markers.
#'
#' @examples
#' # Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
#' gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
#' gds <- loadGDS(gds_fn)
#'
#' # Check the number of markers.
#' nmar(gds)
#'
#' # Summarize the information needed for filtering.
#' gds <- countGenotype(gds)
#' gds <- countRead(gds)
#'
#' # filter out some markers meeting the criteria.
#' gds <- setMarFilter(gds,
#'                       id = getMarID(gds)[1:100],
#'                       missing = 0.2,
#'                       dp = c(5, Inf))
#'
#' # Check the number of the retained markers.
#' nmar(gds)
#'
#' # Reset all filters applied above.
#' gds <- resetMarFilter(gds)
#'
#' # Check the number of the markers again.
#' nmar(gds)
#'
#' # Close the connection to the GDS file.
#' closeGDS(gds)
#' @export
#'
setGeneric("resetMarFilter", function(object, ...)
    standardGeneric("resetMarFilter"))


#' Reset all filters made by [setSamFilter()], [setMarFilter()],
#' and [setCallFilter()].
#'
#' Return all data intact.
#'
#' @param object A [GbsrGenotypeData] object.
#' @param ... Unused.
#'
#' @return A [GbsrGenotypeData] object after removing all filters.
#'
#'
#' @return A [GbsrGenotypeData] object after removing all filters on markers.
#'
#' @examples
#' # Create a GDS file from a sample VCF file.
#' vcf_fn <- system.file("extdata", "sample.vcf", package = "GBScleanR")
#' gds_fn <- tempfile("sample", fileext = ".gds")
#' gbsrVCF2GDS(vcf_fn = vcf_fn, out_fn = gds_fn, force = TRUE)
#'
#' # Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
#' gds <- loadGDS(gds_fn)
#'
#' # `setCallFilter()` do not require summarized information of
#' # genotype counts and read counts.
#' gds <- setCallFilter(gds, dp_count = c(5, Inf))
#'
#' # `setSamFilter()` and `setMarFilter()` needs information of
#' # the genotype count summary and the read count summary.
#' gds <- countGenotype(gds)
#' gds <- countRead(gds)
#'
#' gds <- setSamFilter(gds,
#'                        id = getSamID(gds)[1:10],
#'                        missing = 0.2,
#'                        dp = c(5, Inf))
#'
#' gds <- setMarFilter(gds,
#'                       id = getMarID(gds)[1:100],
#'                       missing = 0.2,
#'                       dp = c(5, Inf))
#'
#' gds <- setInfoFilter(gds, mq = 40, qd = 20)
#'
#' # Reset all filters applied above.
#' gds <- resetFilter(gds)
#'
#' # Close the connection to the GDS file.
#' closeGDS(gds)
#' @export
#'
setGeneric("resetFilter", function(object, ...)
    standardGeneric("resetFilter"))


#' Set the origina; data to be used in GBScleanR's functions
#'
#' Set the "genotype" node and the "data" node
#' as primary nodes for genotype
#' data and read count data. The data stored
#' in the primary nodes are used in the
#' functions of GBScleanR.
#'
#' @param object A [GbsrGenotypeData] object.
#' @param ... Unused.
#'
#' @details
#' A [GbsrGenotypeData] object storing information of
#' the primary node of genotype data and
#' read count data. All of the functions implemented
#' in [GBScleanR] check the primary nodes
#' and use data stored in those nodes.
#' [setCallFilter()] create new nodes storing
#' filtered genotype calls and read counts in
#' a GDS file and change the primary nodes to
#' "filt.genotype" and "filt.data" for genotype and
#' read count data, respectively.
#' [resetCallFilter()] set back the nodes to
#' the original, those are "genotype" and "data" for
#' genotype and read count data, respectively.
#'
#' @return A [GbsrGenotypeData] object.
#'
#' @examples
#' # Create a GDS file from a sample VCF file.
#' vcf_fn <- system.file("extdata", "sample.vcf", package = "GBScleanR")
#' gds_fn <- tempfile("sample", fileext = ".gds")
#' gbsrVCF2GDS(vcf_fn = vcf_fn, out_fn = gds_fn, force = TRUE)
#'
#' # Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
#' gds <- loadGDS(gds_fn)
#'
#' # Filter out set zero to read counts and
#' # missing to genotype calls of which meet the criteria.
#' gds <- setCallFilter(gds, dp_count = c(5, Inf))
#'
#' # Now any functions of [GBScleanR] reference the genotype data
#' # stored in the "filt.genotype" node of the GDS file.
#'
#' # If you need to set the "genotype" node, where store the raw genotype data
#' # as genotype to be referenced by the functions of GBScleanR,
#' # run the following.
#' gds <- resetCallFilter(gds)
#'
#' # Reopening the connection to the GDS file also set the raw genotype again.
#' gds <- loadGDS(gds)
#'
#' # Close the connection to the GDS file
#' closeGDS(gds)
#' @export
#'
setGeneric("resetCallFilter", function(object, ...)
    standardGeneric("resetCallFilter"))


#' Write a VCF file based on data in a GDS file
#'
#' Write out a VCF file with raw, filtered, or corrected genotype data
#' stored in a GDS file. The output VCF file contains the GT, AD, and DP fields.
#'
#' @param object A [GbsrGenotypeData] object.
#' @param out_fn A string to specify the path to an output VCF file.
#' @param node Either one of "raw" or "cor" to output raw genotype data or
#' corrected genotype data, respectively.
#' @param info.export characters, the variable name(s) in the INFO node for
#' export; or NULL for all variables. If you specify `character(0)`, nothing
#' will be exported from the INFO node.
#' @param fmt.export characters, the variable name(s) in the FORMAT node for
#' import; or NULL for all variables. If you specify `character(0)`, nothing
#' will be exported from the FORMAT node, except for GT.
#' @param parents A logical value to specify whether parental
#' samples should be included in an output VCF file or not.
#' @param ... Unused.
#' @export
#'
#' @return The path to the VCF file.
#'
#' @details Create a VCF file at location specified by out_fn.
#' The connection to the GDS file of the input [GbsrGenotypeData] object will be
#' automatically closed for internal file handling in this function. Please use
#' [reopenGDS()] to open the connection again. If you use [loadGDS()], summary
#' statistics and filtering information will be discarded.
#'
#' @importFrom SeqArray seqSNP2GDS seqGDS2VCF seqOpen
#'
#' @examples
#' # Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
#' gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
#' gds <- loadGDS(gds_fn)
#'
#' # Create a VCF file with data from the GDS file
#' #  connected to the [GbsrGenotypeData] oobject.
#' out_fn <- tempfile("sample_out", fileext = ".vcf.gz")
#' # gbsrGDS2VCF(gds, out_fn)
#'
#' # Close the connection to the GDS file.
#' closeGDS(gds)
#'
setGeneric("gbsrGDS2VCF", function(object,
                                   out_fn,
                                   node = "raw",
                                   info.export = NULL,
                                   fmt.export = NULL,
                                   parents = TRUE, ...)
    standardGeneric("gbsrGDS2VCF"))


#' Write a CSV file based on data in a GDS file
#'
#' Write out a CSV file with raw, filtered, corrected genotype data or
#' estimated haplotype data
#' stored in a GDS file.
#'
#' @param object A [GbsrGenotypeData] object.
#' @param out_fn A string to specify the path to an output VCF file.
#' @param node Either one of "raw", "filt", "cor", "hap", "dosage to output raw
#' genotype data, filtered genotype data, corrected genotype data, estimated
#' haplotype data, and estimated allele dosage data, respectively.
#' @param incl_parents A logical value to specify whether parental
#' samples should be included in an output VCF file or not.
#' @param bp2cm A numeric value to convert positions in basepairs (bp) to
#' centiMorgan (cm). The specified here is used to multiply position values. The
#' default is NULL and then internally sets `bp2cm = 4e-06` when
#' `format = "qtl`. If not `format = "qtl`, 1 is set to `bp2cm` as default.
#' @param format A string to indicate the output format. See details.
#' @param read A logical value to indicate whether read counts should be output
#' with genotype data or not. See details.
#' @param ... Unused.
#' @export
#'
#' @return The path to the CSV file.
#'
#' @details Create a CSV file at location specified by out_fn. The setting
#' `format = "qtl"` makes the function export the data in the r/qtl format
#' that can be loaded using read.cross as `format = "csvs"` with a phenotype
#' data. If you have executed [estGeno()] and your population is a biparental
#' population, set 'node = "dosage"' to export a r/qtl format CSV in which
#' homozygoutes of the alleles of Parent 1 and 2, which have been specified by
#' [setParents()], are represented by A and B, respectively. If 'node = "raw"',
#' 'node = "fill"', and 'node = "cor"', A and B in the r/qtl format CSV indicate
#' homozygoutes of reference and alternative alleles shown in a given VCF file.
#' This means that if Parent 1 has the alternative allele homozygoute at
#' Marker 1 and Offspring 1 has the same genotype with Parent 1, the genotype of
#' Offspring 1 at Marker 1 will be B in the r/qtl format CSV. On the other hand,
#' if you set 'node = "dosage"', the genotype of Offspring 1 at Marker 1 will be
#' A in the r/qtl format CSV.
#' The output CSV file has the rows indicating chromosome ID and positions
#' of markers followed by the rows indicating genotype or haplotype data of
#' samples.
#' If `read = TRUE`, the output of each genotype call would be in
#' the form of `GT:ADR,ADA` where GT, ADR, and ADA represent genotype,
#' referenece read count, and alternative read count, respectively.
#' If `format = "qtl"`, `read = TRUE` will be ignored.
#'
#' @examples
#' # Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
#' gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
#' gds <- loadGDS(gds_fn)
#'
#' # Create a CSV file with data from the GDS file
#' #  connected to the [GbsrGenotypeData] oobject.
#' out_fn <- tempfile("sample_out", fileext = ".csv")
#' gbsrGDS2CSV(gds, out_fn)
#'
#' # Close the connection to the GDS file.
#' closeGDS(gds)
#'
setGeneric("gbsrGDS2CSV", function(object,
                                   out_fn,
                                   node = "raw",
                                   incl_parents = TRUE,
                                   bp2cm = NULL,
                                   format = "",
                                   read = FALSE,
                                   ...)
    standardGeneric("gbsrGDS2CSV"))














#' Genotype estimation using a hiden Morkov model
#'
#' Clean up genotype data by error correction based on
#' genotype estimation using a hidden Markov model.
#'
#' @param object A [GbsrGenotypeData] object.
#' @param node Either "raw" or "filt" to indicate whether raw or filtered read
#' counts are used for genotype estimation. See [setCallFilter()] for the
#' details of filtered read counts.
#' @param recomb_rate A numeric value to indicate the expected
#' recombination frequency per chromosome per megabase pairs.
#' @param error_rate A numeric value of the expected sequence error rate.
#' @param call_threshold A numeric value of the probability threshold
#' to accept estimated genotype calls.
#' @param het_parent A logical value to indicate whether parental
#' samples are outbred or inbred. If FALSE, this function assume all
#' true genotype of markers in parents are homozygotes.
#' @param optim A logical value to specify whether to
#' conduct parameter optimization for
#' error correction.
#' @param iter An integer value to specify the number of
#' iterative parameter updates.
#' @param n_threads An integer value to specify the number of
#' threads used for the calculation. The default is 1 and if `n_threads = NULL`,
#' automatically set half the number of available threads on the computer.
#' @param dummy_reads An integer to specify the number of dummy reads to assign
#' to dummy parental samples for genotype estimation. See details.
#' @param ... Unused.
#'
#' @return A [GbsrGenotypeData] object in which the "estimated.haplotype",
#' "corrected.genotype" and
#' "parents.genotype" nodes were added.
#'
#' @importFrom RcppParallel setThreadOptions defaultNumThreads
#' @importFrom expm expm
#' @importFrom stats cor
#'
#' @details If you have not set parental samples by [setParents()] and
#' initialized the scheme object using [initScheme()], you have the scheme
#' object without explicit parental information that is assumed to be a
#' bi-parental population. In this case, [estGeno()] will run in the parentless
#' mode. In the parentless mode, the algorithm assumes that the given population
#' is a bi-parental population. The number of reference allele reads and
#' the number of alternative allele reads of the dummy parents are set based on
#' `dummy_reads`, respectively. Dummy parent 1 has `dummy_reads` of the
#' reference allele reads and 0 alternative allele reads at all markers, while
#' dummy parent 2 has 0 and `dummy_reads` of reference and alternative allele
#' reads at all markers. If the parents of your population were outbred lines or
#' you cannot assume one of the parents has completely reference homozygotes and
#' another has laternative homozygotes at all markers, Set `dummy_reads = 0` to
#' leave uncertainty to estimate parental genotypes based on the offspring
#' genotypes. Nevertheless, the parentless mode is less accurate and has more
#' chance to get a genotype estimate randomly selected from the equally likely
#' genotype estimates.
#'
#' @examples

#' # Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
#' gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
#' gds <- loadGDS(gds_fn)
#'
#' # Find the IDs of parental samples.
#' parents <- grep("Founder", getSamID(gds), value = TRUE)
#'
#' # Set the parents and flip allele information
#' # if the reference sample (Founder1 in our case) has homozygous
#' # alternative genotype at some markers of which alleles will
#' # be swapped to make the reference sample have homozygous
#' # reference genotype.
#' gds <- setParents(gds, parents = parents)
#'
#' # Initialize a scheme object stored in the slot of the GbsrGenotypeData.
#' # We chose `crosstype = "pair"` because two inbred founders were mated
#' # in our breeding scheme.
#' # We also need to specify the mating matrix which has two rows and
#' # one column with integers 1 and 2 indicating a sample (founder)
#' # with the memberID 1 and a sample (founder) with the memberID 2
#' # were mated.
#' gds <- initScheme(gds, mating = cbind(c(1:2)))
#'
#' # Add information of the next cross conducted in our scheme.
#' # We chose 'crosstype = "selfing"', which do not require a
#' # mating matrix.
#' gds <- addScheme(gds, crosstype = "selfing")
#'
#' # Execute error correction by estimating genotype and haplotype of
#' # founders and offspring.
#' gds <- estGeno(gds)
#'
#' # Close the connection to the GDS file.
#' closeGDS(gds)
#'
#' @export
#'
setGeneric("estGeno", function(object,
                               node = "raw",
                               recomb_rate = 0.04,
                               error_rate = 0.0025,
                               call_threshold = 0.9,
                               het_parent = FALSE,
                               optim = TRUE,
                               iter = 4,
                               n_threads = 1,
                               dummy_reads = 5,
                               ...)
           standardGeneric("estGeno"))


#' Build a [GbsrScheme] object
#'
#' [GBScleanR] uses breeding scheme information to set the expected
#' number of cross overs in a chromosome which is a required parameter
#' for the genotype error correction with the hidden Markov model
#' implemented in the [estGeno()] function.
#' This function build the object storing
#' type crosses performed at each generation of breeding and population sizes.
#'
#' @param object A [GbsrGenotypeData] object.
#' @param mating An integer matrix to indicate mating combinations.
#' The each element should match with IDs of
#' parental samples which are 1 to N. see Details.
#' @param ... Unused.
#'
#' @return A [GbsrGenotypeData] object storing
#' a [GbsrScheme] object in the "scheme" slot.
#'
#' @details
#' A [GbsrScheme] object stores information of a population size,
#' mating combinations and
#' a type of cross applied to each generation of the breeding process
#' to generate the population which you are going to subject
#' to the [estGeno()] function.
#' The first generation should be parents of the population.
#' It is supposed that
#' [setParents()] has been already executed and parents
#' are labeled in the
#' [GbsrGenotypeData] object. The number of parents
#' are automatically recognized.
#' The "crosstype" of the first generation can be
#' "pairing" or "random" with
#' `pop_size = N`, where N is the number of parents.
#' You need to specify a matrix indicating combinations
#' of `mating`, in which each column shows
#' a pair of parental samples. For example, if you have
#' only two parents, the `mating` matrix
#' is `mating = cbind(c(1:2))`. The indices used in the matrix
#' should match with the IDs labeled to parental samples by [setParents()].
#' The created [GbsrScheme] object is set
#' in the `scheme` slot of the [GbsrGenotypeData] object.
#'
#' @export
#'
#' @seealso [addScheme()] and [showScheme()]
#'
#' @examples
#' # Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
#' gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
#' gds <- loadGDS(gds_fn)
#'
#' # Biparental F2 population.
#' gds <- setParents(gds, parents = c("Founder1", "Founder2"))
#'
#' # setParents gave member ID 1 and 2 to Founder1 and Founder2, respectively.
#' gds <- initScheme(gds, mating = cbind(c(1:2)))
#'
#' # Now the progenies of the cross above have member ID 3.
#' # If `crosstype = "selfing"` or `"sibling"`, you can omit a `mating` matrix.
#' gds <- addScheme(gds, crosstype = "self")
#'
#' # Now you can execute `estGeno()` which requires a [GbsrScheme] object.
#'
#' # Close the connection to the GDS file
#' closeGDS(gds)
#'
setGeneric("initScheme", function(object, mating, ...)
    standardGeneric("initScheme"))


#' #' Build a [GbsrScheme] object
#'
#' [GBScleanR] uses breeding scheme information to set the expected
#' number of cross overs in a chromosome which is a required parameter
#' for the genotype error correction with the Hidden Markov model
#' implemented in the `estGeno()` function.
#' This function build the object storing
#' type crosses performed at each generation of breeding and population sizes.
#'
#' @param object A [GbsrGenotypeData] object.
#' @param crosstype A string to indicate the type of
#' cross conducted with a given generation.
#' @param mating An integer matrix to indicate mating combinations.
#' The each element should match with member IDs of the last generation.
#' @param ... Unused.
#'
#' @return A [GbsrGenotypeData] object storing
#' a [GbsrScheme] object in the "scheme" slot.
#'
#' @details
#' A scheme object is just a data.frame indicating a population size and
#' a type of cross applied to each generation of the breeding process
#' to generate the population which you are going to subject
#' to the [estGeno()] function.
#' The `crosstype` can take either of "selfing", "sibling",
#' "pairing", and "random".
#' When you set `crosstype = "random"`, you need to
#' specify `pop_size` to indicate how many
#' individuals were crossed in the random mating.
#' You also need to specify a matrix indicating
#' combinations of `mating`, in which
#' each column shows a pair of member IDs indicating
#' parental samples of the cross.
#' Member IDs are serial numbers starts from 1 and
#' automatically assigned by
#' [initScheme()] and [addScheme()]. To check the member IDs,
#' run [showScheme()].
#' Please see the examples section for more details of
#' specifying a `mating` matrix.
#' The created [GbsrScheme] object is set in the `scheme`
#' slot of the [GbsrGenotypeData] object.
#'
#' @export
#'
#' @seealso [addScheme()] and [showScheme()]
#'
#' @examples
#' # Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
#' gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
#' gds <- loadGDS(gds_fn)
#'
#' # Biparental F2 population.
#' gds <- setParents(gds, parents = c("Founder1", "Founder2"))
#'
#' # setParents gave member ID 1 and 2 to Founder1 and Founder2, respectively.
#' gds <- initScheme(gds, mating = cbind(c(1:2)))
#'
#' # Now the progenies of the cross above have member ID 3.
#' # If `crosstype = "selfing"` or `"sibling"`, you can omit a `mating` matrix.
#' gds <- addScheme(gds, crosstype = "self")
#'
#' ############################################################################
#' # Now you can execute `estGeno()` which requires a [GbsrScheme] object.
#'
#' # Close the connection to the GDS file
#' closeGDS(gds)
setGeneric("addScheme", function(object, crosstype, mating, ...)
    standardGeneric("addScheme"))


#' Automate a [GbsrScheme] object building.
#'
#' [GBScleanR] uses breeding scheme information to set the expected
#' number of cross overs in a chromosome which is a required parameter
#' for the genotype error correction with the Hidden Markov model
#' implemented in the `estGeno()` function.
#' This function automates the building of a [GbsrScheme] object.
#'
#' @param object A [GbsrGenotypeData] object.
#' @param crosstype A string to indicate the type of
#' cross conducted with a given generation.
#' @param generation An integer to indicate which generation of selfing or
#' sibling-crossing your population is.
#' @param ... Unused.
#'
#' @return A [GbsrGenotypeData] object storing
#' a [GbsrScheme] object in the "scheme" slot.
#'
#' @details
#' A scheme object is just a data.frame indicating a population size and
#' a type of cross applied to each generation of the breeding process
#' to generate the population which you are going to subject
#' to the [estGeno()] function.
#' The `crosstype` specified to [makeScheme()] can take "selfing" and "sibling".
#' When your population has $2^n$ parents specified by [setParents()],
#' [makeScheme()] assumes those parents were crossed in the "funnel" design in
#' which $2^n$ parents are crossed to obtain $2^n/2$ F1 hybrids followed by
#' successive intercrossings (pairings) of the hybrids to combine the genomes
#' of all parents in one family of siblings. The [makeScheme()] function assumes
#' that the parents that were assigned an odd number member ID (N) in
#' [setParents()] had been crossed with the parent that were assigned an even
#' number (N+1). For example, if you set parents as shown below. The
#' [makeScheme()] function prepare a scheme information that indicates the
#' intercrossings of "p1 x p2", "p3 x p4", "p5 x p6", and "p7 x p8" followed by
#' crossing of "p1xp2_F1 x p3xp4_F1" and "p5xp6_F1 x p7xp8_F1" and then crossing
#' of the two 4-way crossed liens to produce 8-way crossed hybrid lines. If,
#' for example, `generation = 5` indicating an F5 generation was specified to
#' [makeScheme()], the function adds 4 successive selfing or sibling crossings
#' in the scheme. The created [GbsrScheme] object will be set in the `scheme`
#' slot of the [GbsrGenotypeData] object.
#'
#' @export
#'
#' @seealso [initScheme()], [addScheme()], and [showScheme()]
#'
#' @examples
#' # Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
#' gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
#' gds <- loadGDS(gds_fn)
#'
#' # Biparental F2 population.
#' gds <- setParents(gds, parents = c("Founder1", "Founder2"))
#'
#' gds <- makeScheme(gds, generation = 2, crosstype = "self")
#'
#' ############################################################################
#' # Now you can execute `estGeno()` which requires a [GbsrScheme] object.
#'
#' # Close the connection to the GDS file
#' closeGDS(gds)
setGeneric("makeScheme", function(object, generation, crosstype, ...)
    standardGeneric("makeScheme"))

#' Assign member IDs to samples
#'
#' [GBScleanR] uses breeding scheme information to set the expected
#' number of cross overs in a chromosome which is a required parameter
#' for the genotype error correction with the Hidden Markov model
#' implemented in the `estGeno()` function.
#' This function assign member IDs to indicate which samples were derived from
#' which pedigree that recorded in the [GbsrScheme] object.
#'
#' @param object A [GbsrGenotypeData] object.
#' @param id A numeric vector indicating member IDs to assign to samples.
#' @param ... Unused.
#'
#' @return A [GbsrGenotypeData] object storing
#' a [GbsrScheme] object in the "scheme" slot.
#'
#' @details
#' Member IDs can be shown by [showScheme()]. Only the member IDs assigned to
#' progenies (not parents) are available to assign to samples. If the last
#' generation recorded in the [GbsrScheme] object has only one member ID that
#' should be assigned to all samples in your population, you can omit assigning
#' IDs by [assignScheme()]. In that case, [estGeno()] automatically assign the
#' only one member ID to all samples.
#'
#' @export
#'
#' @seealso [addScheme()] and [showScheme()]
#'
#' @examples
#' # Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
#' gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
#' gds <- loadGDS(gds_fn)
#'
#' # Biparental F2 population.
#' gds <- setParents(gds, parents = c("Founder1", "Founder2"))
#'
#' # setParents gave member ID 1 and 2 to Founder1 and Founder2, respectively.
#' gds <- initScheme(gds, mating = cbind(c(1:2)))
#'
#' # Now the progeny of the cross above have member ID 3.
#' # If `crosstype = "selfing"` or `"sibling"`, you can omit a `mating` matrix.
#' gds <- addScheme(gds, crosstype = "self")
#'
#' # The progeny of the selfing above has member ID 4.
#' # To execute genotype estimation for your samples, you need to assign a member
#' # ID to each of the samples.
#'
#' # Check IDs of samples to be assigned member IDs if necessary.
#' getSamID(gds)
#'
#' # The assignScheme() assign member IDs `id` to the samples in order.
#' # Please confirm the order of the member IDs in `id` and the order of the
#' # sample IDs shown by getSamID(gds).
#' gds <- assignScheme(gds, rep(4, nsam(gds)))
#'
#' # If your population has samples all of which belong to only one pedigree,
#' # you can omit assignScheme() and let estGeno() automatically assign the
#' # last member ID to all samples.
#'
#' ############################################################################
#' # Now you can execute `estGeno()` which requires a [GbsrScheme] object.
#'
#' # Close the connection to the GDS file
#' closeGDS(gds)
setGeneric("assignScheme", function(object, id, ...)
    standardGeneric("assignScheme"))

#' Show the information stored in a [GbsrScheme] object
#'
#' Print the information of each generation in
#' a [GbsrScheme] object in the scheme
#' slot of a [GbsrGenotypeData] object.
#' A [GbsrScheme] object stores information of a population size,
#' mating combinations and
#' a type of cross applied to each generation of the breeding process
#' to generate the population which you are going to
#' subject to the `estGeno()` function.
#'
#' @param object A [GbsrGenotypeData] object.
#' @param ... Unused.
#'
#' @return NULL. Print the scheme information on the R console.
#'
#' @export
#'
#' @seealso [initScheme()] and [addScheme()]
#'
#' @examples
#' # Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
#' gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
#' gds <- loadGDS(gds_fn)
#'
#' # Biparental F2 population.
#' gds <- setParents(gds, parents = c("Founder1", "Founder2"))
#'
#' # setParents gave member ID 1 and 2 to Founder1 and Founder2, respectively.
#' gds <- initScheme(gds, mating = cbind(c(1:2)))
#'
#' # Now the progenies of the cross above have member ID 3.
#' # If `crosstype = "selfing"` or `"sibling"`, you can omit a `mating` matrix.
#' gds <- addScheme(gds, crosstype = "self")
#'
#' # Now you can execute `estGeno()` which requires a [GbsrScheme] object.
#'
#' # Close the connection to the GDS file
#' closeGDS(gds)
#'
setGeneric("showScheme", function(object, ...)
    standardGeneric("showScheme"))

#' @importFrom SeqArray seqOptimize
#' @importFrom gdsfmt put.attr.gdsn index.gdsn
#' @rdname estGeno
setMethod("estGeno",
          "GbsrGenotypeData",
          function(object,
                   node,
                   recomb_rate,
                   error_rate,
                   call_threshold,
                   het_parent,
                   optim,
                   iter,
                   n_threads,
                   dummy_reads) {

              # Check the validity of the registered scheme
              object <- .checkScheme(object = object)

              # Check if the parents have been specified
              parents <- slot(object = slot(object = object, name = "scheme"),
                              name = "parents")
              parentless <- all(is.na(parents))
              n_parents <- length(unique(parents))
              if(!parentless){
                  if(n_parents == 1 & !het_parent){
                      stop("het_parent must be TRUE when the given population has a single parental line.",
                           call. = FALSE)
                  }
              }

              # Set the number of threads
              .setThreads(n_threads = n_threads)

              message("Start cleaning...")

              # Validate parents information
              if(parentless){
                  n_parents <- 2

              } else {
                  parents <- getParents(object = object)
                  n_parents <- length(unique(parents$memberID))
              }
              n_samples <- length(unique(getReplicates(object = object)))
              n_alleles <- 2
              n_ploidy <- attributes(slot(object = object, name = "sample"))$ploidy

              # initialize the output nodes
              .initGDS(object = object,
                       het_parent = het_parent,
                       n_parents = n_parents)

              # Generate genotype pattern list
              message("Preparing genotype and haplotype pattern table...")
              pat <- .makePattern(n_parents = n_parents, n_ploidy = n_ploidy,
                                  n_alleles = n_alleles, n_samples = n_samples,
                                  het_parent = het_parent,
                                  scheme = slot(object = object, name = "scheme"))

              .showPattern(pat = pat)

              # Get chromosome information to loop over chromosomes
              chr <- getChromosome(object = object, valid = FALSE)
              chr_levels <- unique(chr)
              no_eds <- FALSE
              for(chr_i in chr_levels) {
                  if(nmar(object = object, valid = TRUE, chr = chr_i) < 2){
                      message("Skip the genotype estimation for ", chr_i,
                              " that has less than two valid markers.")
                      no_valid_marker <- TRUE

                  } else {
                      no_valid_marker <- FALSE

                      message("\nNow cleaning chr ", chr_i, "...")
                      clean_out <- .cleanEachChr(object = object,
                                                 chr_i = chr_i,
                                                 node = node,
                                                 error_rate = error_rate,
                                                 recomb_rate = recomb_rate,
                                                 call_threshold = call_threshold,
                                                 het_parent = het_parent,
                                                 optim = optim,
                                                 iter = iter,
                                                 parentless = parentless,
                                                 dummy_reads = dummy_reads,
                                                 pat = pat)
                      # ### Debug
                      # return(clean_out)
                      # ###
                  }


                  # Make filters to store the output into the nodes
                  if(parentless){
                      sel <- list(mar = validMar(object = object, chr = chr_i),
                                  sam = validSam(object = object))
                      clean_out$best_hap <- clean_out$best_hap[, -seq_len(2), ]
                      clean_out$best_geno <- clean_out$best_geno[, -seq_len(2), ]

                  } else {
                      sel <- list(mar = validMar(object = object, chr = chr_i),
                                  sam = validSam(object = object, parents = TRUE))
                  }

                  # Output values to the nodes
                  .saveOutput(object = object,
                              clean_out = clean_out,
                              sel = sel,
                              no_valid_marker = no_valid_marker,
                              n_parents = n_parents)

                  # Output the dosage data if available
                  if(n_parents == 2 & !het_parent){
                      .saveEDS(object = object,
                               clean_out = clean_out,
                               sel = sel,
                               no_valid_marker = no_valid_marker)
                  }
              }

              # Optimize the nodes
              if(n_parents == 2 & !het_parent){
                  opt_node <- c("HAP", "CGT", "EDS")
                  comp_node <- c("format/HAP/data", "format/CGT/data",
                                 "format/EDS/data",
                                 "info/PGT", "info/ADB", "info/MR")

              } else {
                  opt_node <- c("HAP", "CGT")
                  comp_node <- c("format/HAP/data", "format/CGT/data",
                                 "info/PGT", "info/ADB", "info/MR")
              }

              closeGDS(object = object, verbose = FALSE)
              seqOptimize(gdsfile = object$filename, target = "by.sample",
                          format.var = opt_node, verbose = FALSE)
              object <- reopenGDS(object = object)
              .compressNodes(object = object,
                             node = paste0("annotation/", comp_node))

              # Clean up RAM
              gc()
              return(object)
          })

################################################################################
# Validate the scheme object
.checkScheme <- function(object){
    scheme <- slot(object = object, name = "scheme")
    if(length(slot(object = scheme, name = "progenies")) == 0){
        stop("No scheme information.",
             "\n",
             "Build scheme information with ",
             "initScheme() and addScheme().",
             call. = FALSE)
    }

    if(length(slot(object = scheme, name = "samples")) == 0){
        id <- unlist(tail(slot(object = scheme, name = "progenies"), 1))
        if(length(id) == 1){
            message("Member IDs were not assigned to samples.",
                    "\n",
                    "Assign ", id, " to all samples as member ID.")
            object <- assignScheme(object = object,
                                   id = rep(x = id, times = nsam(object)))

        } else {
            stop("Member IDs were not assigned to samples.",
                 "\n",
                 "Assign member IDs to samples using assignScheme().",
                 call. = FALSE)
        }
    }
    return(object)
}

################################################################################
################################################################################
# Set the number of threads
.setThreads <- function(n_threads){
    max_threads <- defaultNumThreads()
    if (is.null(n_threads)) { n_threads <- max_threads / 2 }

    if (max_threads <= n_threads) {
        warning("You are going to use all threads",
                "of your computer for the calculation.")
        answer <- ""
        while (answer != "y") {
            answer <- readline("Are you sure to use all threads?(y/n)")
            if (answer == "n") { stop("Stopped by user.") }
        }
        n_threads <- max_threads
    }

    message("Set the number of threads: ", n_threads)
    setThreadOptions(numThreads = n_threads)
}

################################################################################
################################################################################
# Initialize output nodes in the GDS file
#' @importFrom gdsfmt addfolder.gdsn
.initGDS <- function(object, het_parent, n_parents) {
    hap <- addfolder.gdsn(node = index.gdsn(node = object,
                                            path = "annotation/format"),
                          name = "HAP",
                          replace = TRUE)
    add.gdsn(node = hap, name = "data",
             storage = "bit6", compress = "", replace = TRUE)

    if(n_parents == 2 & !het_parent){
        eds <- addfolder.gdsn(node = index.gdsn(node = object,
                                                path = "annotation/format"),
                              name = "EDS",
                              replace = TRUE)
        add.gdsn(node = eds, name = "data",
                 storage = "bit6", compress = "", replace = TRUE)
    }

    cgt <- addfolder.gdsn(node = index.gdsn(node = object,
                                            path = "annotation/format"),
                          name = "CGT",
                          replace = TRUE)
    add.gdsn(node = cgt, name = "data",
             storage = "bit2", compress = "", replace = TRUE)

    pgt <- add.gdsn(node = index.gdsn(node = object,
                                      path = "annotation/info"), name = "PGT",
                    storage = "bit2", compress = "", replace = TRUE)

    adb <- add.gdsn(node = index.gdsn(node = object,
                                      path = "annotation/info"), name = "ADB",
                    storage = "single", compress = "", replace = TRUE)

    mr <- add.gdsn(node = index.gdsn(node = object,
                                     path = "annotation/info"), name = "MR",
                   storage = "single", compress = "", replace = TRUE)
}

################################################################################
################################################################################
# Save the ouput to the GDS file
.saveOutput <- function(object, clean_out, sel, no_valid_marker, n_parents){
    .saveHap(object = object,
             clean_out = clean_out,
             sel = sel,
             no_valid_marker = no_valid_marker)
    .saveGeno(object = object,
              clean_out = clean_out,
              sel = sel,
              no_valid_marker = no_valid_marker)
    .savePGeno(object = object,
               clean_out = clean_out,
               sel = sel,
               no_valid_marker = no_valid_marker,
               n_parents = n_parents)
    .saveADB(object = object,
             clean_out = clean_out,
             sel = sel,
             no_valid_marker = no_valid_marker)
    .saveMR(object = object,
            clean_out = clean_out,
            sel = sel,
            no_valid_marker = no_valid_marker)
}

#' @importFrom gdsfmt append.gdsn
.saveHap <- function(object, clean_out, sel, no_valid_marker) {
    n_ploidy <- dim(clean_out$best_hap)[1]
    output <- array(data = 0,
                    dim = c(n_ploidy, length(sel$sam), length(sel$mar)))

    if(!no_valid_marker){
        rep_id <- getReplicates(object = object, parents = TRUE)
        rep_id_names <- names(rep_id)
        id_hit <- match(x = rep_id_names, table = clean_out$mapping_id)
        if(sum(is.na(id_hit)) > 0){
            na_id_hit <- match(x = id_hit[is.na(id_hit)],
                               table = id_hit[!is.na(id_hit)])
            rep_id_names[is.na(id_hit)] <- rep_id_names[!is.na(id_hit)][na_id_hit]
            id_hit <- match(x = rep_id_names, table = clean_out$mapping_id)
        }
        output[, sel$sam, sel$mar] <- clean_out$best_hap[, id_hit,]
    }

    hap_gdsn <- index.gdsn(node = object, path = "annotation/format/HAP/data")
    gdsn_dim <- objdesp.gdsn(node = hap_gdsn)$dim
    if (gdsn_dim[1] == 0) {
        add.gdsn(node = index.gdsn(node = object, path = "annotation/format/HAP"),
                 name = "data", val = output,
                 storage = "bit6", compress = "", replace = TRUE)
    } else {
        append.gdsn(node = hap_gdsn, val = output)
    }
}

.saveEDS <- function(object, clean_out, sel, no_valid_marker) {
    n_ploidy <- dim(clean_out$best_hap)[1]
    output <- array(data = NA, dim = c(n_ploidy, length(sel$sam), length(sel$mar)))

    if(!no_valid_marker){
        rep_id <- getReplicates(object = object, parents = TRUE)
        rep_id_names <- names(rep_id)
        id_hit <- match(x = rep_id_names, table = clean_out$mapping_id)
        if(sum(is.na(id_hit)) > 0){
            na_id_hit <- match(x = id_hit[is.na(id_hit)],
                               table = id_hit[!is.na(id_hit)])
            rep_id_names[is.na(id_hit)] <- rep_id_names[!is.na(id_hit)][na_id_hit]
            id_hit <- match(x = rep_id_names, table = clean_out$mapping_id)
        }
        output[, sel$sam, sel$mar] <- clean_out$best_hap[, id_hit,]
    }

    output[output == 0] <- NA
    output <- apply(X = output - 1, MARGIN = c(2, 3), FUN = sum)
    output[is.na(output)] <- 63

    eds_gdsn <- index.gdsn(node = object, path = "annotation/format/EDS/data")
    gdsn_dim <- objdesp.gdsn(node = eds_gdsn)$dim
    if (gdsn_dim[1] == 0) {
        add.gdsn(node = index.gdsn(node = object, path = "annotation/format/EDS"),
                 name = "data", val = output,
                 storage = "bit6", compress = "", replace = TRUE)
    } else {
        append.gdsn(node = eds_gdsn, val = output)
    }
}

#' @importFrom gdsfmt append.gdsn
.saveGeno <- function(object, clean_out, sel, no_valid_marker) {
    n_ploidy <- dim(clean_out$best_geno)[1]
    output <- array(data = 3, dim = c(n_ploidy, length(sel$sam), length(sel$mar)))

    if(!no_valid_marker){
        rep_id <- getReplicates(object = object, parents = TRUE)
        rep_id_names <- names(rep_id)
        id_hit <- match(x = rep_id_names, table = clean_out$mapping_id)
        if(sum(is.na(id_hit)) > 0){
            na_id_hit <- match(x = id_hit[is.na(id_hit)],
                               table = id_hit[!is.na(id_hit)])
            rep_id_names[is.na(id_hit)] <- rep_id_names[!is.na(id_hit)][na_id_hit]
            id_hit <- match(x = rep_id_names, table = clean_out$mapping_id)
        }
        output[, sel$sam, sel$mar] <- clean_out$best_geno[, id_hit,]
    }

    out_gdsn <-index.gdsn(node = object, path = "annotation/format/CGT/data")
    gdsn_dim <- objdesp.gdsn(node = out_gdsn)$dim
    if (gdsn_dim[1] == 0) {
        add.gdsn(node = index.gdsn(node = object, path = "annotation/format/CGT"),
                 name = "data", val = output,
                 storage = "bit2", compress = "", replace = TRUE)
    } else {
        append.gdsn(node = out_gdsn, val = output)
    }
}

#' @importFrom gdsfmt append.gdsn
.savePGeno <- function(object, clean_out, sel, no_valid_marker, n_parents) {
    n_row <- dim(clean_out$p_geno)[1]
    if(n_parents == 1){
        n_row <- n_row / 2
    }
    output <- matrix(data = 3, nrow = n_row, length(sel$mar))

    if(!no_valid_marker){
        output[, sel$mar] <- clean_out$p_geno[seq_len(n_row), ]
    }

    out_gdsn <- index.gdsn(node = object, path = "annotation/info/PGT")
    gdsn_dim <- objdesp.gdsn(node = out_gdsn)$dim
    if (gdsn_dim[1] == 0) {
        add.gdsn(node = index.gdsn(node = object, path = "annotation/info"),
                 name = "PGT", val = output,
                 storage = "bit2", compress = "", replace = TRUE)

    } else {
        append.gdsn(node = out_gdsn, val = output)
    }
}

#' @importFrom gdsfmt append.gdsn
.saveADB <- function(object, clean_out, sel, no_valid_marker) {
    output <- rep(-1, length(sel$mar))

    if(!no_valid_marker){
        output[sel$mar] <- t(clean_out$bias)
    }

    out_gdsn <- index.gdsn(node = object, path = "annotation/info/ADB")
    gdsn_dim <- objdesp.gdsn(node = out_gdsn)$dim
    if (gdsn_dim[1] == 0) {
        add.gdsn(node = index.gdsn(node = object, path = "annotation/info"),
                 name = "ADB", val = output,
                 storage = "single", compress = "", replace = TRUE)

    } else {
        append.gdsn(node = out_gdsn, val = output)
    }
}

#' @importFrom gdsfmt append.gdsn
.saveMR <- function(object, clean_out, sel, no_valid_marker) {
    output <- matrix(-1, nrow = 2, ncol = length(sel$mar))

    if(!no_valid_marker){
        output[, sel$mar] <- t(clean_out$mismap)
    }

    out_gdsn <- index.gdsn(object, "annotation/info/MR")
    gdsn_dim <- objdesp.gdsn(out_gdsn)$dim
    if (gdsn_dim[1] == 0) {
        add.gdsn(index.gdsn(object, "annotation/info"), "MR", output,
                 "single", compress = "", replace = TRUE)
    } else {
        append.gdsn(out_gdsn, output)
    }
}

################################################################################
################################################################################
# Prepare read count data
.loadReadCounts <- function(object, chr_i, node, parentless, dummy_reads) {
    ad_node <- "raw"
    if (exist.gdsn(node = object, path = "annotation/format/FAD")) {
        if(node == "filt"){
            ad_node <- "filt"
        }
    }

    reads <- getRead(object = object, node = ad_node,
                     parents = FALSE, valid = TRUE, chr = chr_i)
    rep_id <- getReplicates(object = object, parents = FALSE)
    reads <- .pileupAD(ad = reads, rep_id = rep_id)

    if(parentless){
        ref_read <- matrix(data = c(dummy_reads, 0),
                           nrow = 2,
                           ncol = ncol(reads$ref))
        alt_read <- matrix(data = c(0, dummy_reads),
                           nrow = 2,
                           ncol = ncol(reads$ref))
        p_reads <- list(ref = ref_read, alt = alt_read)

    } else {
        p_reads <- getRead(object = object, node = ad_node,
                           parents = "only", valid = TRUE, chr = chr_i)
        rep_id <- getReplicates(object = object, parents = "only")
        p_reads <- .pileupAD(ad = p_reads, rep_id = rep_id)
        p_reads <- .orderParents(object = object, p_reads = p_reads)
        if(nrow(p_reads$ref) == 1){
            p_reads$ref <- rbind(p_reads$ref, p_reads$ref)
            p_reads$alt <- rbind(p_reads$alt, p_reads$alt)
        }
    }
    # p_reads <- .bumpOverRepReads(reads = p_reads)
    # reads <- .bumpOverRepReads(reads = reads)
    return(list(p_ref = p_reads$ref,
                p_alt = p_reads$alt,
                ref = reads$ref,
                alt = reads$alt))
}
#
# .bumpOverRepReads <- function(reads){
#     r_homo <- reads$ref > 0 & reads$alt == 0
#     a_homo <- reads$ref == 0 & reads$alt > 0
#     het <- reads$ref > 0 & reads$alt > 0
#     r_homo_over <- reads$ref[r_homo] > 50
#     reads$ref[r_homo][r_homo_over] <- 50
#     a_homo_over <- reads$alt[a_homo] > 50
#     reads$alt[a_homo][a_homo_over] <- 50
#     het_dp <- reads$ref[het] + reads$alt[het]
#     het_dp_over <- het_dp > 50
#     reads$ref[het][het_dp_over] <- round(reads$ref[het][het_dp_over] / het_dp[het_dp_over] * 50)
#     reads$alt[het][het_dp_over] <- round(reads$alt[het][het_dp_over] / het_dp[het_dp_over] * 50)
#     return(reads)
# }

#' @importFrom stats na.omit
.orderParents <- function(object, p_reads){
    p_id <- getParents(object = object)
    rep_id <- getReplicates(object = object, parents = "only")
    p_indices <- validSam(object = object, parents = "only")
    sam_id <- getSamID(object = object, valid = FALSE)[p_indices]
    id_hit <- match(x = sam_id, table = p_id$sampleID)
    p_id$rep_id[na.omit(id_hit)] <- rep_id[!is.na(id_hit)]
    member_id <- p_id$memberID[match(x = rownames(p_reads$ref),
                                     table = p_id$sampleID)]
    p_reads$ref <- p_reads$ref[order(member_id), , drop = FALSE]
    p_reads$alt <- p_reads$alt[order(member_id), , drop = FALSE]
    return(p_reads)
}

################################################################################
################################################################################
# Make genotype and haplotype pattern list
.makeGenoPat <- function(n_ploidy, alleles){
    out <- NULL
    for (i in seq_len(n_ploidy)) {
        out <- c(out, list(alleles))
    }
    out <- expand.grid(out)
    out <- t(apply(X = out, MARGIN = 1, FUN = sort))
    out <- rowSums(out[!duplicated(out),])
    return(out)
}

.makeGenoParents <- function(n_parents, n_ploidy, alleles, het_parent){
    out <- NULL
    for (i in seq_len(n_parents * n_ploidy)) {
        out <- c(out, list(alleles))
    }
    out <- expand.grid(out, KEEP.OUT.ATTRS = FALSE)
    if(n_parents == 1){
        out <- cbind(out, out)
    }
    valid_pat <- apply(X = out, MARGIN = 1,
                       FUN = function(x) length(unique(x)) > 1)
    out <- as.matrix(out[valid_pat, ])
    if (!het_parent) {
        valid <- tapply(X = seq_len(ncol(out)),
                        INDEX = rep(seq_len(n_parents), each = n_ploidy),
                        FUN = function(i){
                            mono <- apply(out[, i], 1, function(x){
                                return(length(unique(x)) == 1)
                            })
                            return(mono)
                        })
        valid <- do.call("rbind", valid)
        valid <- apply(valid, 2, all)
        out <- out[valid, ]
    }
    attributes(out) <- list(dim = dim(out))
    return(out)
}

.progenyPattern <- function(zygotes, index, mt, n_ploidy){
    gamete_ploidy <- n_ploidy / 2
    rev_index <- rev(seq_len(gamete_ploidy))

    out <- vapply(X = seq_len(ncol(mt[[index]])),
                  FUN = .mateGametes,
                  FUN.VALUE = list(0),
                  zygotes = zygotes,
                  mate = mt[[index]],
                  n_ploidy = n_ploidy,
                  gamete_ploidy = gamete_ploidy,
                  rev_index = rev_index)
    out <- c(zygotes, out)

    return(out)
}

#' @importFrom utils combn
.mateGametes <- function(index, zygotes, mate, n_ploidy, gamete_ploidy, rev_index){
    i_mate <- mate[, index]
    zygote1 <- zygotes[[i_mate[1]]]
    zygote2 <- zygotes[[i_mate[2]]]
    comb1 <- combn(seq_len(n_ploidy), gamete_ploidy)
    comb2 <- combn(seq_len(n_ploidy), gamete_ploidy)
    if(length(rev_index) > 1){
        comb1 <- cbind(comb1, comb1[rev_index, ])
        comb2 <- cbind(comb2, comb2[rev_index, ])
    }
    gamete1 <- matrix(apply(zygote1, 1, "[", comb1), nrow = gamete_ploidy)
    gamete1 <- unique(t(gamete1))
    gamete2 <- matrix(apply(zygote2, 1, "[", comb2), nrow = gamete_ploidy)
    gamete2 <- unique(t(gamete2))
    comb <- expand.grid(seq_len(nrow(gamete1)), seq_len(nrow(gamete2)))
    if(nrow(comb) == 1){
        comb <- rbind(comb, comb)
    }
    zygotes <- unique(rbind(cbind(gamete1[comb[, 1], ],
                                  gamete2[comb[, 2], ]),
                            cbind(gamete2[comb[, 1], ],
                                  gamete1[comb[, 2], ])))
    return(list(zygotes))
}

.getValidPat <- function(scheme, het_parent, n_parents, n_ploidy) {
    target_pedigree <- mem_id <- sort(unique(slot(object = scheme, name = "samples")))
    mt <- slot(object = scheme, name = "mating")
    xtype <- slot(object = scheme, name = "crosstype")
    pg <- slot(object = scheme, name = "progenies")

    if(n_parents == 1){
        n_parents <- 2
        mt <- list(rbind(1, 2))
        target_pedigree <- target_pedigree + 1
    }

    even_ploidy <- n_ploidy %% 2 != 0
    if(even_ploidy){
        n_ploidy_minus <- n_ploidy - 1
        possible_zygotes_ids <- lapply(seq_len(n_parents), function(i){
            n <- seq(n_ploidy_minus * (i - 1) + 1, length.out = n_ploidy_minus)
            if(!het_parent){
                n <- rep(n[1], n_ploidy_minus)
            }
            return(t(n))
        })
        n_ploidy <- n_ploidy + 1
    }

    # Simulate possible zygotes and gametes
    # Founder zygotes
    zygotes <- lapply(seq_len(n_parents), function(i){
        n <- seq(n_ploidy * (i - 1) + 1, length.out = n_ploidy)
        if(!het_parent){
            n <- rep(n[1], n_ploidy)
        }
        return(t(n))
    })

    # Progeny zygotes
    for(i in seq_along(mt)) {
        zygotes <- .progenyPattern(zygotes = zygotes,
                                   index = i,
                                   mt = mt,
                                   n_ploidy = n_ploidy)
    }

    out <- zygotes[as.numeric(target_pedigree)]
    if(even_ploidy){
        id_table <- lapply(seq_along(possible_zygotes_ids), function(i){
            possible_zygotes_ids_i <- as.vector(possible_zygotes_ids[[i]])
            possible_zygotes_ids_i <- c(possible_zygotes_ids_i,
                                        possible_zygotes_ids_i)
            possible_zygotes_ids_i <- possible_zygotes_ids_i[seq_along(zygotes[[i]])]
            return(cbind(as.vector(zygotes[[i]]), possible_zygotes_ids_i))
        })
        id_table <- do.call("rbind", id_table)
        out <- lapply(out, function(x){
            hit <- match(x, id_table[, 1])
            x <- matrix(id_table[hit, 2], nrow = nrow(x))
            x <- x[, -1]
            x <- rbind(x, t(apply(x, 1, rev)))
            return(unique(x))
        })
    }
    names(out) <- mem_id

    return(out)
}

.getPossibleHap <- function(hap_progeny, geno_parents, geno_pat, n_ploidy){
    hap_vec <- as.vector(t(hap_progeny))

    derived_geno <- apply(X = geno_parents, MARGIN = 1,
                          FUN = function(x){
                              x <- x[hap_vec]
                              x <- matrix(x, nrow = n_ploidy)
                              x <- colSums(x)
                              return(x)
                          })
    derived_geno <- as.vector(derived_geno)
    out <- rep(derived_geno, n_ploidy + 1)
    out <- matrix(out, nrow = n_ploidy + 1, byrow = TRUE)
    out <- out == geno_pat
    out <- apply(X = out, MARGIN = 2, FUN = which)
    return(out)
}

.getPossibleGeno <- function(geno_parents, geno_pat, n_ploidy){
    derived_geno <- apply(X = geno_parents, MARGIN = 1, FUN = function(x) {
        x <- matrix(x, nrow = n_ploidy)
        x <- colSums(x)
        return(x)
    })
    derived_geno <- as.vector(derived_geno)
    out <- rep(derived_geno, n_ploidy + 1)
    out <- matrix(out, nrow = n_ploidy + 1, byrow = TRUE)
    out <- out == geno_pat[seq_len(n_ploidy + 1)]
    out <- apply(X = out, MARGIN = 2, FUN = which)
    return(out)
}

.makePattern <- function(n_parents,
                         n_ploidy,
                         n_alleles,
                         n_samples,
                         het_parent,
                         scheme) {
    alleles <- seq(0, length.out = n_alleles)

    geno_pat <- .makeGenoPat(n_ploidy = n_ploidy, alleles = alleles)

    even_ploidy <- n_ploidy %% 2 != 0
    if(even_ploidy){
        n_ploidy <- n_ploidy - 1
    }
    geno_parents <- .makeGenoParents(n_parents = n_parents,
                                     n_ploidy = n_ploidy,
                                     alleles = alleles,
                                     het_parent = het_parent)

    possiblegeno <- .getPossibleGeno(geno_parents = geno_parents,
                                     geno_pat = geno_pat,
                                     n_ploidy = n_ploidy)

    if(even_ploidy){
        n_ploidy <- n_ploidy + 1
    }
    hap_progeny <- .getValidPat(scheme = scheme,
                                het_parent = het_parent,
                                n_parents = n_parents,
                                n_ploidy = n_ploidy)

    possiblehap <- lapply(X = hap_progeny,
                          FUN = .getPossibleHap,
                          geno_parents = geno_parents,
                          geno_pat = geno_pat,
                          n_ploidy = n_ploidy)

    n_p_pat <- nrow(geno_parents)
    n_hap_pat <- vapply(X = seq_along(hap_progeny),
                        FUN.VALUE = numeric(1),
                        FUN = function(i){
                            return(nrow(hap_progeny[[i]]))
                        })
    return(list(alleles = alleles,
                geno_pat = geno_pat,
                geno_parents = geno_parents,
                hap_progeny = hap_progeny,
                possiblehap = possiblehap,
                possiblegeno = possiblegeno,
                n_p_pat = n_p_pat,
                n_hap_pat = n_hap_pat,
                n_samples = n_samples))
}

.showPattern <- function(pat){
    message("Possible allele dosages: ", paste(pat$geno_pat, collapse = " "))
    message("Number of possible founder genotypes: ", pat$n_p_pat)
    message("Member ID(s) to be processed: ", paste(names(pat$hap_progeny), collapse = " "))
    message("Number of offspring haplotypes: ", paste(pat$n_hap_pat, collapse = " "))
}

################################################################################
################################################################################
# Prepare the transition provability matrix
.getJnum <- function(scheme, n_origin, het_parent, i) {
    xtype <- vapply(X = slot(object = scheme, name = "crosstype"),
                    FUN.VALUE = character(length = 1),
                    FUN = function(x){
                        return(x[1])
                    })
    n_x <- length(xtype)

    if(n_x > 1){
        for(j in seq(n_x, 2)){
            if(xtype[j] == "pairing"){
                j_mating <- slot(object = scheme, name = "mating")[[j]]
                i_mating <- j_mating[, i]
                prev_mating <- slot(object = scheme, name = "mating")[[j - 1]]
                prev_max <- max(prev_mating)
                j_matings <- prev_mating[, i_mating - prev_max]

                if(any(j_matings[, 1] %in% j_matings[, 2])){
                    xtype[j] <- "sibling"
                }
            }
        }
    }

    i_pairing <- grep(pattern = "pairing", x = xtype)
    if (length(i_pairing) == 0) {
        n_pairing  <- 0

    } else {
        n_pairing <- max(i_pairing)
    }

    if (n_pairing == 0) {
        jnum <- .initJnum(n_origin = n_origin)

    } else {
        next_crosstype <- xtype[n_pairing + 1]
        if(is.na(next_crosstype)){
            next_crosstype <- "selfing"
        }
        jnum <- .initJnum(n_origin = n_origin,
                          n_pairing = n_pairing + het_parent,
                          next_crosstype = next_crosstype)
    }

    s_gen <- n_pairing + 1
    n_gen <- length(xtype)
    if(s_gen <= n_gen){
        for (i in s_gen:n_gen) {
            jnum <- .calcNextJnum(crosstype = xtype[i], prob_df = jnum)
        }
    }
    return(jnum)
}

.initJnum <- function(n_origin, n_pairing, next_crosstype) {
    jnum <- data.frame(a12 = 0,
                       b12 = 1,
                       a123 = 0,
                       b123 = 0,
                       r = 0,
                       j1232 = 0,
                       k1232 = 0,
                       j1122 = 0,
                       k1122 = 0,
                       j1222 = 0)
    if (n_origin > 2) {
        jnum$b123 <- 1
    }
    if (!missing(n_pairing)) {
        jnum$a12 <- 1
        if (next_crosstype == "selfing") {
            jnum$j1232 <- jnum$r <- n_pairing - 1

        } else {
            r <- ifelse(test = n_pairing == 1, yes = 0, no = n_pairing - 2)
            jnum$j1232 <- jnum$k1232 <- jnum$r <- r

            if (n_origin > 2) {
                jnum$a123 <- 1
            } else {
                jnum$b12 <- 0.5
            }
            if (next_crosstype == "sibling") {
                while (n_pairing > 1) {
                    jnum <- .calcNextJnum(crosstype = "sibling", prob_df = jnum)
                    n_pairing <- n_pairing - 1
                }
            }
        }
    }
    return(jnum)
}

.calcNextJnum <- function(crosstype, prob_df) {
    coal <- switch(crosstype,
                   "pairing" = c(0, 0),
                   "selfing" = c(1, 0),
                   "sibling" = c(0.5, 0))
    s <- coal[1]
    q <- coal[2]
    if (crosstype == "selfing") {
        next_a12 <- 0.5 * prob_df$a12
        next_b12 <- 0
        next_a123 <- 0
        next_b123 <- 0
        next_r <- prob_df$r + prob_df$a12
        next_j1232 <- 0.5 * prob_df$j1232
        next_k1232 <- 0
        next_j1122 <- 0.5 * prob_df$j1122 + 0.5 * prob_df$r
        next_k1122 <- 0
        next_j1222 <- 0.5 * (next_r - next_j1122 - next_j1232)

    } else {
        next_a12 <- prob_df$b12
        next_b12 <- 0.5 * s * prob_df$a12 + (1 - s) * prob_df$b12
        next_a123 <- s * prob_df$a123 + (1 - 2 * s) * prob_df$b123
        next_b123 <-
            1.5 * q * prob_df$a123 + (1 - s - 2 * q) * prob_df$b123
        next_r <- prob_df$r + prob_df$a12
        next_j1232 <- prob_df$k1232 + prob_df$a123
        next_k1232 <-
            0.5 * s * prob_df$j1232 + (1 - s) * (prob_df$k1232 + prob_df$a123)
        next_j1122 <- prob_df$k1122
        next_k1122 <-
            0.5 * s * (prob_df$r + prob_df$j1122) + (1 - s) * prob_df$k1122
        next_j1222 <- 0.5 * (next_r - next_j1122 - next_j1232)
    }
    return(data.frame(a12 = next_a12,
                      b12 = next_b12,
                      a123 = next_a123,
                      b123 = next_b123,
                      r = next_r,
                      j1232 = next_j1232,
                      k1232 = next_k1232,
                      j1122 = next_j1122,
                      k1122 = next_k1122,
                      j1222 = next_j1222))
}

.getXoFreq <- function(jnum, n_origin) {
    r00 <- jnum$j1232 / jnum$a12 / (n_origin - 2)
    r01 <- jnum$j1222 / jnum$a12
    r10 <- jnum$j1222 / (1 - jnum$a12) / (n_origin - 1)
    r11 <- jnum$j1122 / (1 - jnum$a12) / (n_origin - 1)
    return(data.frame(r00, r01, r10, r11))
}

.transitionProb <- function(pat, pos, recomb_rate,
                            scheme, het_parent, n_ploidy){
    if(n_ploidy %% 2 != 0){
        even_ploidy <- TRUE

    } else {
        even_ploidy <- FALSE
    }

    out <- lapply(X = seq_along(pat$hap_progeny),
                  FUN = function(i){
                      hap_progeny_i <- pat$hap_progeny[[i]]
                      n_origin <- length(unique(as.vector(hap_progeny_i)))
                      jnum <- .getJnum(scheme = scheme,
                                       n_origin = n_origin,
                                       het_parent = het_parent,
                                       i = i)
                      jrate <- .getXoFreq(jnum = jnum, n_origin = n_origin)
                      jrate[is.na(jrate)] <- 0
                      q_mat <- apply(X = hap_progeny_i,
                                     MARGIN = 1,
                                     FUN = function(x) {
                                         apply(X = hap_progeny_i,
                                               MARGIN = 1,
                                               FUN = function(y) {

                                                   # If no change in adjacent genotypes, set NA.
                                                   # These NAs will be replaced with negated rowSums() values of each row of q_mat.
                                                   no_change <- x == y
                                                   if(sum(no_change) == n_ploidy){
                                                       out <- NA

                                                   } else {
                                                       # If more than two patterns of crossing overs were observed, set zero.
                                                       # We do not assume multiple crossing overs at one joint.
                                                       joint_pat <- paste(x, y, sep = "_")
                                                       joint_pat <- joint_pat[!no_change]
                                                       if(length(unique(joint_pat)) > 1){
                                                           out <- 0

                                                       } else {
                                                           # If only one pattern of crossing over in multiple chromosomes were found,
                                                           # set the r11 value to the power of the inverse of the number of crossing over chromosomes.
                                                           if(length(joint_pat) > 1){
                                                               out <- jrate$r11^(1/length(joint_pat))

                                                           } else {

                                                               # Check the number of the major haplotype before and after the joint
                                                               check1 <- max(table(x))
                                                               check2 <- max(table(y))
                                                               if(even_ploidy){
                                                                   if(check1 == check2){
                                                                       if(check1 != n_ploidy){
                                                                           check2 <- check2 - 1
                                                                       }
                                                                   }
                                                               }

                                                               # If the major joint decreased, set r01 that is the rate to get an additional non-ibd state.
                                                               if(check1 > check2){
                                                                   out <- jrate$r01

                                                                   # If the major joint increased, set r10 that is the rate to get an additional non-ibd state.
                                                               } else if(check1 < check2){
                                                                   out <- jrate$r10

                                                               } else {
                                                                   out <- jrate$r00
                                                               }
                                                           }
                                                       }
                                                   }
                                                   return(out)
                                               })
                                     })
                      diag(q_mat) <- -rowSums(q_mat, na.rm = TRUE)
                      mar_dist <- diff(pos)
                      if(any(mar_dist < 0)){
                          stop("Negative value(s) was obtained in the calculation of marker distances \n",
                               "based on physical positions of the given markers.",
                               "\nThe order of the markers might not be valid.",
                               call. = FALSE)
                      }
                      rf <- mar_dist * 1e-6 * recomb_rate
                      prob <- vapply(X = rf,
                                     FUN = function(x) {
                                         out <- expm(q_mat * x, "Higham08")
                                         out <- out[q_mat != 0]
                                         return(out)
                                     },
                                     FUN.VALUE = numeric(length(q_mat[q_mat != 0])))
                      non_zero <- q_mat != 0
                      return(list(prob = prob,
                                  non_zero = non_zero,
                                  n_hap_pat = pat$n_hap_pat))
                  })
    return(out)
}

.getInitProb <- function(prob, n_samples) {
    full_mat <- matrix(data = 0, nrow = prob$n_hap_pat, ncol = prob$n_hap_pat)
    full_mat[prob$non_zero] <- prob$prob[, 1]
    ev1 <- eigen(t(full_mat))$vectors[, 1]
    init <- ev1 / sum(ev1)
    return(init)
}

################################################################################
################################################################################
# Make parameter lists
.getPedigree <- function(object){
    vaild_sam <- validSam(object = object)
    out <- slot(object = object, name = "sample")$pedigree[vaild_sam]
    return(out)
}

.getParams <- function(object, chr_i, node, error_rate, recomb_rate,
                       call_threshold, het_parent,
                       parentless, dummy_reads, pat) {
    reads <- .loadReadCounts(object = object, chr_i = chr_i, node = node,
                             parentless = parentless,
                             dummy_reads = dummy_reads)

    if(parentless){
        n_parents <- 2

    } else {
        parents <- getParents(object = object)
        n_parents <- length(unique(parents$memberID))
        if(n_parents == 1){
            n_parents <- 2
        }
    }
    n_samples <- length(unique(getReplicates(object = object)))
    n_alleles <- 2
    n_ploidy <- attributes(slot(object = object, name = "sample"))$ploidy

    pos <- getPosition(object = object, valid = TRUE, chr = chr_i)
    n_mar <- nmar(object = object, valid = TRUE, chr = chr_i)
    trans_prob <- .transitionProb(pat = pat, pos = pos,
                                  recomb_rate = recomb_rate,
                                  scheme = slot(object = object, name = "scheme"),
                                  het_parent = het_parent,
                                  n_ploidy = n_ploidy)
    init_prob <- lapply(X = trans_prob,
                        FUN = .getInitProb,
                        n_samples = n_samples)

    fixed_param <- getFixedParameter(object = object, valid = TRUE, chr = chr_i)
    if(!is.null(fixed_param$bias)){
        bias <- fixed_param$bias

    } else {
        bias <- rep(x = 0.5, times = n_mar)
    }

    if(!is.null(fixed_param$mismap_ref)){
        mismap <- cbind(fixed_param$mismap_ref, fixed_param$mismap_alt)

    } else {
        mismap <-  matrix(data = 0.005, nrow = n_mar, ncol = 2)
    }

    if(!is.null(fixed_param$parent1)){
        p_geno_fix <- apply(fixed_param[, grepl("parent[0-9]", names(fixed_param))],
                            1,
                            function(x){
                                return(which(colSums(t(pat$geno_parents) == x) == length(x)))
                            })
    } else {
        p_geno_fix <- -1
    }


    return(list(n_parents = n_parents,
                n_samples = n_samples,
                parents_ids = rownames(reads$p_ref),
                sample_ids = rownames(reads$ref),
                n_alleles = n_alleles,
                n_ploidy = n_ploidy,
                n_mar = n_mar,
                n_pedigree = length(trans_prob),
                pedigree = .getPedigree(object = object),
                het_parent = het_parent,
                error_rate = c(1 - error_rate, error_rate),
                recomb_rate = recomb_rate,
                call_threshold = call_threshold,
                reads = reads,
                pat = pat,
                bias = bias,
                mismap = mismap,
                fixed_param = fixed_param,
                trans_prob = trans_prob,
                init_prob = init_prob,
                count = 0,
                p_geno_fix = p_geno_fix,
                flip = FALSE))
}

################################################################################
################################################################################
# Execute the Viterbi algorithm
.getBestSeq <- function(param_list, outprob) {
    trans_prob <- lapply(param_list$trans_prob, function(x){
        return(as.vector(x$prob))
    })
    trans_prob <- log10(unlist(trans_prob))
    init_prob <- log10(unlist(param_list$init_prob))
    nonzero_prob <- lapply(param_list$trans_prob, function(x){
        return(x$non_zero)
    })
    nonzero_prob <- unlist(nonzero_prob)
    n_nonzero_prob <- vapply(X = param_list$trans_prob,
                             FUN.VALUE = integer(length = 1L),
                             FUN = function(x){
                                 return(sum(x$non_zero))
                             })
    possiblehap <- unlist(param_list$pat$possiblehap)
    pedigree <- match(x = param_list$pedigree,
                      table = names(param_list$pat$hap_progeny))

    out_list <- run_viterbi(p_ref = param_list$reads$p_ref,
                            p_alt = param_list$reads$p_alt,
                            ref = param_list$reads$ref,
                            alt = param_list$reads$alt,
                            eseq_in = param_list$error_rate,
                            bias = param_list$bias,
                            mismap = param_list$mismap,
                            trans_prob = trans_prob,
                            init_prob = init_prob,
                            nonzero_prob = nonzero_prob,
                            n_pgeno = param_list$pat$n_p_pat,
                            n_hap = param_list$pat$n_hap_pat,
                            n_offspring = param_list$n_samples,
                            n_founder = param_list$n_parents,
                            n_marker = param_list$n_mar,
                            n_nonzero_prob = n_nonzero_prob,
                            het = param_list$het_parent,
                            pedigree = pedigree - 1,
                            possiblehap = possiblehap - 1,
                            possiblegeno = param_list$pat$possiblegeno - 1,
                            p_geno_fix = param_list$p_geno_fix - 1,
                            ploidy = param_list$n_ploidy)

    if (outprob) {
        prob <- run_fb(ref = param_list$reads$ref,
                       alt = param_list$reads$alt,
                       eseq_in = param_list$error_rate,
                       bias = param_list$bias,
                       mismap = param_list$mismap,
                       possiblehap = possiblehap - 1,
                       trans_prob = trans_prob,
                       init_prob = init_prob,
                       nonzero_prob = nonzero_prob,
                       n_pgeno = param_list$pat$n_p_pat,
                       n_hap = param_list$pat$n_hap_pat,
                       n_offspring = param_list$n_samples,
                       n_marker = param_list$n_mar,
                       n_nonzero_prob = n_nonzero_prob,
                       pedigree = pedigree - 1,
                       p_geno = out_list$p_geno,
                       ploidy = param_list$n_ploidy)
        prob <- array(data = apply(X = prob,
                                   MARGIN = 3,
                                   FUN = function(x) return(t(x))),
                      dim = c(param_list$n_ploidy + 1,
                              param_list$n_samples,
                              param_list$n_mar))
        out_list$prob <- prob

    } else {
        out_list$prob <- NULL
    }

    out_list$best_seq <- out_list$best_seq + 1
    out_list$p_geno <- out_list$p_geno + 1
    return(out_list)
}

################################################################################
################################################################################
# Convert data format the Viterbi algorithm's output to the GBScleanR style
.pat2hap <- function(best_hap, param_list) {
    n_parents_chr <- param_list$n_parents * param_list$n_ploidy

    if(param_list$het_parent){
        parent_hap <- rep(x = seq_len(n_parents_chr), each = param_list$n_mar)

    } else {
        parent_hap <- rep(x = seq(1, by = param_list$n_ploidy,
                                  length.out = param_list$n_parents),
                          each = param_list$n_ploidy * param_list$n_mar)
    }
    parent_hap <- matrix(data = parent_hap, nrow = n_parents_chr, byrow = TRUE)
    sample_pat <- best_hap$best_seq
    pat_i <- match(x = param_list$pedigree,
                   table = names(param_list$pat$hap_progeny))
    sample_hap <- vapply(X = seq_len(param_list$n_samples),
                         FUN.VALUE = numeric(param_list$n_ploidy * param_list$n_mar),
                         FUN = function(i) {
                             hap_i <- param_list$pat$hap_progeny[[pat_i[i]]]
                             out <- as.vector(hap_i[sample_pat[, i], ])
                             return(out)
                         })
    sample_hap <- matrix(data = sample_hap,
                         nrow = param_list$n_samples * param_list$n_ploidy,
                         ncol = param_list$n_mar,
                         byrow = TRUE)
    out_hap <- rbind(parent_hap, sample_hap)
    out_hap <- array(data = out_hap,
                     dim = c(param_list$n_ploidy,
                             param_list$n_parents + param_list$n_samples,
                             param_list$n_mar))
    return(out_hap)
}

.parentPat2Geno <- function(best_hap, param_list) {
    p_pat <- best_hap$p_geno
    p_geno <- t(param_list$pat$geno_parents[p_pat, ])
    return(p_geno)
}

.hap2geno <- function(hap, p_geno, param_list) {
    n <- param_list$n_ploidy * (param_list$n_samples + param_list$n_parents)
    out_geno <- vapply(X = seq_len(param_list$n_mar),
                       FUN.VALUE = numeric(n),
                       FUN = function(x) {
                           return(p_geno[hap[,, x], x])
                       })
    out_geno <- array(data = out_geno,
                      dim = c(param_list$n_ploidy,
                              param_list$n_samples + param_list$n_parents,
                              param_list$n_mar))

    return(out_geno)
}

.halfJoint <- function(best_pat_f, best_pat_r, param_list) {
    n_mar <- param_list$n_mar
    n_sample <- param_list$n_samples
    half <- round(n_mar / 2)
    first <- (n_mar:1)[seq_len(half)]
    latter <- (half + 1):n_mar

    best_seq <- rbind(best_pat_r$best_seq[first,],
                      best_pat_f$best_seq[latter,])
    p_geno <- c(best_pat_r$p_geno[first], best_pat_f$p_geno[latter])

    prob <- c(best_pat_r$prob[, , first],
              best_pat_f$prob[, , latter])
    prob <- array(data = prob, dim = dim(best_pat_f$prob))
    prob <- apply(X = prob, MARGIN = 2, FUN = function(x) return(x))
    prob <- array(data = prob, dim = c(param_list$n_ploidy + 1, n_mar, n_sample))
    out_list <- list(best_seq = best_seq,
                     p_geno = p_geno,
                     prob = prob)
    return(out_list)
}

.solveBorderConflict <- function(best_hap, param_list){
    half <- round(param_list$n_mar / 2)
    flip_i <- vapply(X = seq_len(dim(best_hap)[2]),
                     FUN = .checkBorder,
                     best_hap = best_hap,
                     param_list = param_list,
                     half = half,
                     FUN.VALUE = logical(length = 1L))
    half_m <- -seq(1, half)
    reorder <- rev(seq_len(param_list$n_ploidy))
    best_hap[, flip_i, half_m] <- best_hap[reorder, flip_i, half_m]
    return(best_hap)
}

.checkBorder <- function(i, best_hap, param_list, half){
    if(i <= param_list$n_parents){
        return(FALSE)
    }
    i_redigree <- param_list$pedigree[i - param_list$n_parents]
    i_pedigree <- names(param_list$pat$hap_progeny) %in% i_redigree
    i_pedigree <- which(i_pedigree)
    i_hap_progeny <- t(param_list$pat$hap_progeny[[i_pedigree]])
    hap1 <- which(colSums(i_hap_progeny == best_hap[, i, half]) == param_list$n_ploidy)
    hap2 <- which(colSums(i_hap_progeny == best_hap[, i, half + 1]) == param_list$n_ploidy)
    re <- rev(seq_along(best_hap[, i, half + 1]))
    hap3 <- which(colSums(i_hap_progeny == best_hap[re, i, half + 1]) == param_list$n_ploidy)
    n_hap_pat <- param_list$trans_prob[[i_pedigree]]$n_hap_pat
    prob <- matrix(data = 0, nrow = n_hap_pat, ncol = n_hap_pat)
    non_zero <- param_list$trans_prob[[i_pedigree]]$non_zero
    prob_half <- param_list$trans_prob[[i_pedigree]]$prob[, half]
    prob[non_zero] <- prob_half
    prob1 <- prob[hap1, hap2]
    if(length(hap3) != 0){
        prob2 <- prob[hap1, hap3]
        if(prob1 < prob2){
            out <- TRUE

        } else {
            out <- FALSE
        }
    } else {
        out <- FALSE
    }
    return(out)
}

.minimizeRecombination <- function(best_hap){
    for(i in seq_len(dim(best_hap)[2])){
        recomb <- apply(X = best_hap[, i,], MARGIN = 1, FUN = diff) != 0
        n_recomb <- rowSums(recomb)
        recomb_pos <- which(n_recomb >= 1)
        for(j in seq_along(recomb_pos)){
            if(j == 1){
                prev_xo <- recomb[recomb_pos[j], ]

            } else {
                is_homo_j <- all(diff(best_hap[, i, recomb_pos[j]]) == 0)
                if(is_homo_j){
                    j_xo <- recomb[recomb_pos[j], ]
                    if(all(j_xo == prev_xo)){
                        re_order <- c(seq(2, length(j_xo)), 1)
                        prev_xo <- j_xo[re_order]
                        flip_i <- -seq(1, recomb_pos[j])
                        best_hap[, i, flip_i] <- best_hap[re_order, i, flip_i]
                    }
                }
            }
        }
    }
    return(best_hap)
}

.summarizeEst <- function(best_hap, best_geno, pat_prob, param_list) {
    n_mar <- param_list$n_mar
    n_sample <- param_list$n_samples
    n_levels <- param_list$n_ploidy + 1
    i_sample <- -seq_len(param_list$n_parents)
    sample_geno <- apply(X = best_geno[, i_sample, ], MARGIN = 2, FUN = colSums)
    sample_geno <- as.vector(sample_geno + 1)
    sample_geno <- sample_geno + seq(0, by = n_levels, length.out = n_mar * n_sample)
    log10_th <- log10(param_list$call_threshold)
    geno_prob <- matrix(data = pat_prob[sample_geno],
                        nrow = n_mar,
                        ncol = n_sample)
    geno_prob <- t(geno_prob <= log10_th)
    for(i in seq_len(param_list$n_ploidy)){
        best_geno[i, i_sample, ][geno_prob] <- 3
    }
    if (!param_list$het_parent) {
        if(param_list$n_ploidy %% 2 == 0){
            new_num <- ceiling(best_hap[best_hap != 1] / param_list$n_ploidy)

        } else {
            new_num <- ceiling(best_hap[best_hap != 1] / (param_list$n_ploidy - 1))
        }
        best_hap[best_hap != 1] <- new_num
    }

    for(i in seq_len(param_list$n_ploidy)){
        best_hap[i, i_sample, ][geno_prob] <- 0
    }
    out_list <- list(best_hap = best_hap, best_geno = best_geno)
    return(out_list)
}

################################################################################
################################################################################
# Marker specific error rate estimation
.getBias <- function(best_seq, type, ref, alt, n_ploidy) {
    if (type == 1) {
        est_het <- !best_seq %in% c(0, n_ploidy)
        ref[!est_het] <- NA
        ref <- colSums(ref, na.rm = TRUE)
        best_seq[!est_het] <- NA
        n_ref <- colSums(n_ploidy - best_seq, na.rm = TRUE)
        ref_prop <- ref / n_ref
        alt[!est_het] <- NA
        alt <- colSums(alt, na.rm = TRUE)
        n_alt <- colSums(best_seq, na.rm = TRUE)
        alt_prop <- alt / n_alt
        bias <- ref_prop / (ref_prop + alt_prop)

    } else {
        est_ref <- best_seq == 0
        ref[!est_ref] <- NA
        ref <- colSums(ref, na.rm = TRUE)
        n_ref <- colSums(est_ref, na.rm = TRUE) * n_ploidy
        ref_prop <- ref / n_ref

        est_alt <- best_seq == n_ploidy
        alt[!est_alt] <- NA
        alt <- colSums(alt, na.rm = TRUE)
        n_alt <- colSums(est_alt, na.rm = TRUE) * n_ploidy
        alt_prop <- alt / n_alt
        bias <- ref_prop / (ref_prop + alt_prop)
    }
    return(list(bias = bias,
                ref = ref,
                alt = alt,
                n_ref = n_ref,
                n_alt = n_alt))
}

.sumUpBias <- function(bias1, bias2) {
    ref_prop <- (bias1$ref + bias2$ref) / (bias1$n_ref + bias2$n_ref)
    alt_prop <- (bias1$alt + bias2$alt) / (bias1$n_alt + bias2$n_alt)
    bias <- ref_prop / (ref_prop + alt_prop)
    return(bias)
}

.calcReadBias <- function(best_seq, param_list) {
    ref <- rbind(param_list$reads$p_ref, param_list$reads$ref)
    alt <- rbind(param_list$reads$p_alt, param_list$reads$alt)

    bias1 <- .getBias(best_seq = best_seq, type = 1,
                      ref = ref, alt = alt, n_ploidy = param_list$n_ploidy)
    bias2 <- .getBias(best_seq = best_seq, type = 2,
                      ref = ref, alt = alt, n_ploidy = param_list$n_ploidy)
    bias_cor <- cor(x = bias1$bias, y = bias2$bias, use = "pair")
    if (!is.na(bias_cor) & bias_cor > 0.7) {
        bias <- .sumUpBias(bias1 = bias1, bias2 = bias2)

    } else {
        bias <- bias1$bias
    }
    bias[is.na(bias)] <- 0.5
    return(bias)
}

.calcMissmap <- function(best_seq, param_list) {
    geno_call <- get_genocall(ref = param_list$reads$ref,
                              alt = param_list$reads$alt,
                              eseq_in = param_list$error_rate,
                              bias = param_list$bias,
                              mismap = param_list$mismap,
                              n_o = param_list$n_samples,
                              n_m = param_list$n_mar,
                              ploidy = param_list$n_ploidy)
    missing <- param_list$reads$ref == 0 & param_list$reads$alt == 0
    geno_call[missing] <- FALSE

    i_samples <- -seq_len(param_list$n_parents)
    est <- best_seq[i_samples, ] == 0
    n_ref <- colSums(est, na.rm = TRUE)
    alt <- param_list$reads$alt > 0
    alt[!est] <- FALSE
    alt[!geno_call] <- FALSE
    alt_mis <- colSums(alt, na.rm = TRUE) / n_ref

    est <- best_seq[i_samples, ] == param_list$n_ploidy
    n_alt <- colSums(est, na.rm = TRUE)
    ref <- param_list$reads$ref > 0
    ref[!est] <- FALSE
    ref[!geno_call] <- FALSE
    ref_mis <- colSums(ref, na.rm = TRUE) / n_alt

    return(cbind(alt_mis, ref_mis))
}

.calcErrors <- function(best_seq, param_list) {
    best_seq <- apply(X = best_seq, MARGIN = 3, FUN = colSums)
    bias <- .calcReadBias(best_seq = best_seq, param_list = param_list)
    mismap <- .calcMissmap(best_seq = best_seq, param_list = param_list)
    return(list(bias = bias, mismap = mismap))
}

.bindErrors <- function(error_f, error_r) {
    nmar <- length(error_f$bias)
    bias <- colMeans(rbind(error_f$bias, error_r$bias), na.rm = TRUE)
    bias[is.na(bias)] <- 0.5

    mismap <- cbind(colMeans(rbind(error_f$mismap[, 1],
                                   error_r$mismap[, 1]), na.rm = TRUE),
                    colMeans(rbind(error_f$mismap[, 2],
                                   error_r$mismap[, 2]), na.rm = TRUE))
    mismap[is.na(mismap)] <- 0
    return(list(bias = bias, mismap = mismap))
}

################################################################################
################################################################################
# Flip parameter lists for the reverse-direction round
.flipParam <- function(param_list) {
    n_mar <- param_list$n_mar
    param_list$trans_prob <- lapply(X = param_list$trans_prob,
                                    FUN = function(x){
                                        x$prob <- x$prob[, (n_mar - 1):1]
                                        return(x)
                                    })
    param_list$reads$p_ref <- param_list$reads$p_ref[, n_mar:1]
    param_list$reads$p_alt <- param_list$reads$p_alt[, n_mar:1]
    param_list$reads$ref <- param_list$reads$ref[, n_mar:1]
    param_list$reads$alt <- param_list$reads$alt[, n_mar:1]
    param_list$bias <- param_list$bias[n_mar:1]
    param_list$mismap <- param_list$mismap[n_mar:1,]
    param_list$p_geno_fix <- param_list$p_geno_fix[length(param_list$p_geno_fix):1]
    return(param_list)
}


################################################################################
################################################################################
# Run the iterative estimation
.runCycle <- function(param_list, outprob, outgeno) {
    param_list$count <- param_list$count + 1
    cycle <- paste0("Cycle ", param_list$count, ": ")
    message("\r", cycle)
    message("\r", "Forward round of genotype estimation ...")

    if(!is.null(param_list$fixed_param$parent1)){
        message("\r",
                "Use fixed parental genotypes ...")
    }

    if (param_list$flip) {
        best_pat_r <- .getBestSeq(param_list = .flipParam(param_list),
                                  outprob = outprob)
        best_hap_r <- .pat2hap(best_hap = best_pat_r, param_list = param_list)
        p_geno_r <- .parentPat2Geno(best_hap = best_pat_r, param_list = param_list)
        best_geno_r <- .hap2geno(hap = best_hap_r,
                                 p_geno = p_geno_r,
                                 param_list = param_list)
        last_half <- (round(param_list$n_mar / 2) + 1):param_list$n_mar
        if(is.null(param_list$fixed_param$parent1)){
            param_list$p_geno_fix <- best_pat_r$p_geno[last_half]
        }

    } else {
        best_pat_f <- .getBestSeq(param_list = param_list, outprob = outprob)
        best_hap_f <- .pat2hap(best_hap = best_pat_f, param_list = param_list)
        p_geno_f <- .parentPat2Geno(best_hap = best_pat_f, param_list = param_list)
        best_geno_f <- .hap2geno(hap = best_hap_f,
                                 p_geno = p_geno_f,
                                 param_list = param_list)
        last_half <- (round(param_list$n_mar / 2) + 1):param_list$n_mar
        if(is.null(param_list$fixed_param$parent1)){
            param_list$p_geno_fix <- rev(best_pat_f$p_geno[last_half])
        }
    }

    message("\r", "Backward round of genotype estimation  ...")
    if (param_list$flip) {
        best_pat_f <- .getBestSeq(param_list = param_list, outprob = outprob)
        best_hap_f <- .pat2hap(best_hap = best_pat_f, param_list = param_list)
        p_geno_f <- .parentPat2Geno(best_hap = best_pat_f, param_list = param_list)
        best_geno_f <- .hap2geno(hap = best_hap_f,
                                 p_geno = p_geno_f,
                                 param_list = param_list)
        if(is.null(param_list$fixed_param$parent1)){
            param_list$p_geno_fix <- -1
        }

    } else {
        best_pat_r <- .getBestSeq(param_list = .flipParam(param_list = param_list),
                                  outprob = outprob)
        best_hap_r <- .pat2hap(best_hap = best_pat_r, param_list = param_list)
        p_geno_r <- .parentPat2Geno(best_hap = best_pat_r, param_list = param_list)
        best_geno_r <- .hap2geno(hap = best_hap_r,
                                 p_geno = p_geno_r,
                                 param_list = param_list)
        if(is.null(param_list$fixed_param$parent1)){
            param_list$p_geno_fix <- -1
        }
    }

    # ### Debug
    # return(list(best_geno_f, best_geno_r, param_list))
    # ###

    if (!outprob) {
        if(!is.null(param_list$fixed_param$bias) & !is.null(param_list$fixed_param$mismap_ref)){
            message("\r",
                    "Skip paramter optimization and use fixed parameters ...")

        } else {
            message("\r",
                    "Paramter optimization ...")
            error_f <- .calcErrors(best_seq = best_geno_f, param_list = param_list)
            error_r <- .calcErrors(best_seq = best_geno_r[,,param_list$n_mar:1],
                                   param_list = param_list)
            error <- .bindErrors(error_f = error_f, error_r = error_r)

            if(!is.null(param_list$fixed_param$bias)){
                message("\r",
                        "Use fixed bias values ...")

            } else {
                check <- error$bias > param_list$error_rate[1]
                error$bias[check] <- param_list$error_rate[1]
                check <- error$bias < param_list$error_rate[2]
                error$bias[check] <- param_list$error_rate[2]
                param_list$bias <- error$bias
            }

            if(!is.null(param_list$fixed_param$mismap_ref)){
                message("\r", "Use fixed mismapping rates ...")

            } else {
                param_list$mismap <- error$mismap
            }
        }
    }

    if (outgeno) {
        message("\r", "Summarizing output ...")
        best_pat <- .halfJoint(best_pat_f = best_pat_f,
                               best_pat_r = best_pat_r,
                               param_list = param_list)
        p_geno <- .parentPat2Geno(best_hap = best_pat, param_list = param_list)
        best_hap <- .pat2hap(best_hap = best_pat, param_list = param_list)
        best_hap <- .solveBorderConflict(best_hap = best_hap,
                                         param_list = param_list)
        best_hap <- .minimizeRecombination(best_hap = best_hap)
        best_geno <- .hap2geno(hap = best_hap,
                               p_geno = p_geno,
                               param_list = param_list)
        out_list <- .summarizeEst(best_hap = best_hap,
                                  best_geno = best_geno,
                                  pat_prob = best_pat$prob,
                                  param_list = param_list)
        out_list$pat_prob <- best_pat$prob
        out_list$p_geno <- p_geno
        out_list$bias <- param_list$bias
        out_list$mismap <- param_list$mismap
        out_list$mapping_id <- c(param_list$parents_ids, param_list$sample_ids)

        message("\r", "Done!")
        return(out_list)
    } else {
        return(param_list)
    }
}

################################################################################
################################################################################
# Check data to avoid no reads for founders at the first marker
.checkPread <- function(param_list) {
    param_list$flip <- FALSE
    p_read_s <- sum(param_list$reads$p_ref[, 1] == 0 &
                        param_list$reads$p_alt[, 1] == 0)
    p_read_e <- sum(param_list$reads$p_ref[, param_list$n_mar] == 0 &
                        param_list$reads$p_alt[, param_list$n_mar] == 0)
    if (p_read_s < p_read_e) {
        param_list$flip <- TRUE

    } else if (p_read_s == p_read_e) {
        p_read_s <- sum(param_list$reads$p_ref[, 1] +
                            param_list$reads$p_alt[, 1])
        p_read_e <- sum(param_list$reads$p_ref[, param_list$n_mar] +
                            param_list$reads$p_alt[, param_list$n_mar])
        if (p_read_s < p_read_e) {
            param_list$flip <- TRUE

        } else if (p_read_s == p_read_e) {
            p_read_s <- sum(param_list$reads$p_ref[, 1] +
                                param_list$reads$p_alt[, 1])
            p_read_e <- sum(param_list$reads$p_ref[, param_list$n_mar] +
                                param_list$reads$p_alt[, param_list$n_mar])
            if (p_read_s < p_read_e) {
                param_list$flip <- TRUE
            }
        }
    }
    return(param_list)
}

################################################################################
################################################################################
# Run genotype estimation per chromosome
.cleanEachChr <- function(object,
                          chr_i,
                          node,
                          error_rate,
                          recomb_rate,
                          call_threshold,
                          het_parent,
                          optim,
                          iter,
                          parentless,
                          dummy_reads,
                          pat) {
    param_list <- .getParams(object = object,
                             chr_i = chr_i,
                             node = node,
                             error_rate = error_rate,
                             recomb_rate = recomb_rate,
                             call_threshold = call_threshold,
                             het_parent = het_parent,
                             parentless = parentless,
                             dummy_reads = dummy_reads,
                             pat = pat)
    param_list <- .checkPread(param_list = param_list)

    # ### Debug
    # out <- .runCycle(param_list, FALSE, FALSE)
    # return(out)
    # ###

    if(iter == 1){ optim <- FALSE }

    if(optim){
        param_list <- .runCycle(param_list = param_list,
                                outprob = FALSE,
                                outgeno = FALSE)

        for (i in 2:iter) {
            if (i == iter) {
                out_list <- .runCycle(param_list = param_list,
                                      outprob = TRUE,
                                      outgeno = TRUE)

            } else {
                param_list <- .runCycle(param_list = param_list,
                                        outprob = FALSE,
                                        outgeno = FALSE)
            }
        }
    } else {
        out_list <- .runCycle(param_list = param_list,
                              outprob = TRUE,
                              outgeno = TRUE)
    }

    return(out_list)
}

---
title: "Basic usage of GBScleanR"
author: 
  -name: "Tomoyuki Furuta"
  affiliation: Institute of Plant Science and Resources, Okayama University, Okayama, Japan
  email: f.tomoyuki@okayama-u.ac.jp
date: "Aug 27, 2024"
package: GBScleanR
output: 
  BiocStyle::html_document:
    toc: true
    toc_float: true
bibliography: references.bib
vignette: >
  %\VignetteIndexEntry{Basic usage of GBScleanR}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---
```{r global_options, include=FALSE}
knitr::opts_chunk$set(fig.pos = 'H', fig.align = "center", warning = FALSE, message = FALSE)
```

# Introduction
The `r Biocpkg("GBScleanR")` package has been developed to conduct error correction on genotype data obtained via NGS-based genotyping methods such as RAD-seq and GBS [@Miller2007; @Elshire2011]. It is designed to estimate true genotypes along chromosomes from given allele read counts in the VCF file generated by SNP callers like GATK and TASSEL-GBS [@McKenna2010; @Glaubitz2014]. The current implementation supports genotype data of a mapping population derived from two or more diploid parents followed by selfings, sibling crosses, or random crosses. e.g. F$_2$ and 8-way RILs. Our method supposes markers to be biallelic and ordered along chromosomes by mapping reads on a reference genome sequence. To support smooth access to large size genotype data, every input VCF file is first converted to a Genomic Data Structure (GDS) file [@Zheng2012]. The current implementation does not allow non-biallelic markers, and those markers in an input VCF file will be automatically removed from a resultant GDS file. `r Biocpkg("GBScleanR")` also provides functions for data visualization, filtering, and loading/writing a VCF file. Furthermore, the data structure of the GDS file created via this package is compatible with those used in the `r Biocpkg("SNPRelate")`, `r Biocpkg("GWASTools")` and `r Biocpkg("GENESIS")` packages those are designed to handle large variant data and conduct downstream analyses including regression analysis [@Zheng2012; @Gogarten2012; @Gogarten2019]. In this document, we first walk through the utility functions implemented in `r Biocpkg("GBScleanR")` to introduce a basic usage. Then, the core function of `r Biocpkg("GBScleanR")` which estimates true genotypes for error correction will be introduced.

# New Functions in GBScleanR Version 2
The latest release of `r Biocpkg("GBScleanR")` is version 2. The major update in this version is that `r Biocpkg("GBScleanR")` supports polyploid populations. `r Biocpkg("GBScleanR")` tries to estimate the haplotype phases of founder and offspring samples based on given read counts. To process your data as of a polyploid population, set the `ploidy` argument in the `loadGDS()` function.
```{r eval = FALSE}
gds <- loadGDS(x = "/path/to/your/gds", ploidy = 4) # For tetraploid
gds <- loadGDS(x = "/path/to/your/gds", ploidy = 6) # For hexaploid
```
You can use any other functions in the `r Biocpkg("GBScleanR")` package for your polyploid population in the same way for diploids.
\  

In addition, the `setDominantMarkers()` function enables you to force `r Biocpkg("GBScleanR")` to treat some markers as dominant markers. In the iterative parameter optimization of the genotype estimation step, `r Biocpkg("GBScleanR")` calculates the marker-wise reference-read-bias. We can assume that reads of either reference or alternative allele only can be observed at dominant markers and the marker-wise reference-read-bias must be 1 or 0 for dominant markers that give only reference or alternative allele reads, respectively.
\  

As another important change in estGeno() since version 2, the function now requires the node argument to explicitly specify whether raw or filtered read counts should be used for genotype estimation. If setCallFilter() has not been executed, the user-specified node argument will be ignored, and the "raw" node will be used by default.
\  

The data visualization by `r Biocpkg("GBScleanR")` was also enhanced by new plot functions: `plotReadRatio()` and `plotDosage()`. See the "[Plot Read Ratio and Dosage](#plot_dosage)" section for the details.


# Prerequisites
This package internally uses the following packages.  
- `r CRANpkg("ggplot2")`  
- `r CRANpkg("dplyr")`  
- `r CRANpkg("tidyr")`  
- `r CRANpkg("expm")`  
- `r Biocpkg("gdsfmt")`  
- `r Biocpkg("SeqArray")`  
\  

# Installation
You can install `r Biocpkg("GBScleanR")` from the Bioconductor repository with the following code.
```{r eval=FALSE}
if (!requireNamespace("BiocManager", quietly = TRUE))
    install.packages("BiocManager")

BiocManager::install("GBScleanR")
```
\  

The code below let you install the package from the github repository.
The package released in the github usually get frequent update more than that in Bioconductor due to the release schedule.
```{r eval=FALSE}
if (!requireNamespace("devtools", quietly = TRUE))
    install.packages("devtools")
devtools::install_github("tomoyukif/GBScleanR", build_vignettes = TRUE)
```

# Error while Handling a GDS File
You may face to the following error message or similar one if you killed the process that 
was accessing a GDS file. 
```{r eval=FALSE}
Stream Read Error, need 12 byte(s) but receive 0
```
This error message indicates the corruption of the GDS file and you cannot access it anymore.
In this case, please remake a GDS file using the `gbsrVCF2GDS()` function.

# Loading Data
The main class of the `r Biocpkg("GBScleanR")` package is `GbsrGenotypData` which inherits the `GenotypeData` class in the `r Biocpkg("SeqArray")` package. The `gbsrGenotypeData` class object has three slots: `sample`, `marker`, and `scheme`. The `data` slot holds genotype data as a `gds.class` object which is defined in the `gdsfmt` package while `snpAnnot` and `scanAnnot` contain objects storing annotation information of SNPs and samples, which are the `SnpAnnotationDataFrame` and `ScanAnnotationDataFrame` objects defined in the `r Biocpkg("GWASTools")` package. See the vignette of `r Biocpkg("GWASTools")` for more detail. `r Biocpkg("GBScleanR")` follows the way of `r Biocpkg("GWASTools")` in which a unique genotyping instance (genotyped sample) is called "scan".
\ 

Load the package.
```{r warning=FALSE, message=FALSE}
library("GBScleanR")
```
\ 

`r Biocpkg("GBScleanR")` only supports a VCF file as input. As an example data, we use sample genotype data for a biparental F2 population derived from inbred parents.
```{r}
vcf_fn <- system.file("extdata", "sample.vcf", package = "GBScleanR")
gds_fn <- tempfile("sample", fileext = ".gds")
```
\ 

As mentioned above, the `GbsrGenotypeData` class requires genotype data in the `gds.class` object which enable us quick access to the genotype data without loading the whole data on RAM. At the beginning of the processing, we need to convert data format of our genotype data from VCF to GDS. This conversion can be achieved using `gbsrVCF2GDS()` as shown below. A compressed VCF file (.vcf.gz) is also acceptable. 
```{r}
# `force = TRUE` allow the function to over write the GDS file,
# even if a GDS file exists at `out_fn`.
gbsrVCF2GDS(vcf_fn = vcf_fn, out_fn = gds_fn, force = TRUE, verbose = FALSE)
```
\ 

Once we converted the VCF to the GDS, we can create a `GbsrGenotypeData` instance for our data.
```{r}
gds <- loadGDS(gds_fn, verbose = FALSE)
```
The first time to load a newly produced GDS file will take long time due to data
reformatting for quick access.


# Utility Methods
## Getters
Getter functions allow you to retrieve basic information of genotype data, e.g. the number of SNPs and samples, chromosome names, physical position of SNPs and alleles.
```{r}
# Number of samples
nsam(gds)
```
\ 
```{r}
# Number of SNPs
nmar(gds) 
```
\ 
```{r}
# Indices of chromosome ID of all markers
head(getChromosome(gds)) 
```
\ 
```{r}
# Chromosome names of all markers
head(getChromosome(gds)) 
```
\ 
```{r}
# Position (bp) of all markers
head(getPosition(gds)) 
```
\ 
```{r}
# Reference allele of all markers
head(getAllele(gds)) 
```
\ 
```{r}
# SNP IDs
head(getMarID(gds)) 
```
\ 
```{r}
# sample IDs
head(getSamID(gds)) 
```
\ 

The function `getGenotype()` returns genotype call data in which integer numbers 0, 1, and 2 indicate the number of reference allele.
```{r}
geno <- getGenotype(gds)
```
\ 

The function `getRead()` returns read count data as a list with two elements `ref` and `alt` containing reference read counts and alternative read counts, respectively.
```{r}
geno <- getRead(gds)
```



## Data Summarization
### Collect Basic Summary Statistics
`countGenotype()` and `countRead()` are class methods of `GbsrGenotypeData` and they summarize genotype counts and read counts per marker and per sample. 
```{r}
gds <- countGenotype(gds)
gds <- countRead(gds)
```
\ 

### Visualize Basic Summary Statistics
These summary statistics can be visualized via plotting functions.
With the values obtained via `countGenotype()`, we can plot histograms of missing rate , heterozygosity, reference allele frequency as shown below.
```{r fig.alt="Missing rate per marker and per sample."}
# Histgrams of missing rate
histGBSR(gds, stats = "missing") 
```
\ 
```{r fig.alt="Heterozygosity per marker and per sample."}
# Histgrams of heterozygosity
histGBSR(gds, stats = "het") 
```
\ 
```{r fig.alt="Reference allele frequency per marker and per sample."}
# Histgrams of reference allele frequency
histGBSR(gds, stats = "raf") 
```
\ 

With the values obtained via `countRead()`, we can plot histograms of total read depth , allele read depth , reference read frequency as shown below.
```{r fig.alt="Total read depth per marker and per sample."}
# Histgrams of total read depth
histGBSR(gds, stats = "dp") 
```
\ 
```{r fig.alt="Reference read depth per marker and per sample."}
# Histgrams of allelic read depth
histGBSR(gds, stats = "ad_ref") 
```
\ 
```{r fig.alt="Alternative read depth per marker and per sample."}
# Histgrams of allelic read depth
histGBSR(gds, stats = "ad_alt") 
```
\ 
```{r fig.alt="Reference read per marker and per sample."}
# Histgrams of reference allele frequency
histGBSR(gds, stats = "rrf") 
```
\ 
```{r fig.alt="Mean of reference read depth per marker and per sample."}
# Histgrams of mean allelic read depth
histGBSR(gds, stats = "mean_ref") 
```
\ 
```{r fig.alt="SD of reference read depth per marker and per sample."}
# Histgrams of standard deviation of read depth
histGBSR(gds, stats = "sd_ref") 
```
\ 
```{r fig.alt="SD of alternative read depth per marker and per sample."}
# Histgrams of standard deviation of read depth
histGBSR(gds, stats = "sd_ref") 
```
\ 

`plotGBSR()` and `pairsGBSR()` provide other ways to visualize statistics. `plotGBSR()` draws a line plot of a specified statistics per marker along each chromosome. `pairsGBSR()` give us a two-dimensional scatter plot to visualize relationship between statistics.
```{r}
plotGBSR(gds, stats = "missing")
```
\ 

```{r}
plotGBSR(gds, stats = "geno")
```
\ 

```{r}
pairsGBSR(gds, stats1 = "missing", stats2 = "dp")
```
\ 

### Getter Methods for Summary Statistics
The statistics obtained via `countGenotype()`, `countReat()`, and `calcReadStats()` are sotred in the `snpAnnot` and `scanAnnot` slots. They can be retrieved using getter functions as follows.
```{r}
# Reference genotype count per marker
head(getCountGenoRef(gds, target = "marker")) 
# Reference genotype count per sample
head(getCountGenoRef(gds, target = "sample")) 
```
\ 
```{r}
# Heterozygote count per marker
head(getCountGenoHet(gds, target = "marker")) 
# Heterozygote count per sample
head(getCountGenoHet(gds, target = "sample")) 
```
\ 
```{r}
# Alternative genotype count per marker
head(getCountGenoAlt(gds, target = "marker")) 
# Alternative genotype count per sample
head(getCountGenoAlt(gds, target = "sample"))
```
\ 
```{r}
# Missing count per marker
head(getCountGenoMissing(gds, target = "marker")) 
# Missing count per sample
head(getCountGenoMissing(gds, target = "sample")) 
```
\ 
```{r}
# Reference allele count per marker
head(getCountAlleleRef(gds, target = "marker")) 
# Reference allele count per sample
head(getCountAlleleRef(gds, target = "sample")) 
```
\ 
```{r}
# Alternative allele count per marker
head(getCountAlleleAlt(gds, target = "marker")) 
# Alternative allele count per sample
head(getCountAlleleAlt(gds, target = "sample")) 
```
\ 
```{r}
# Missing allele count per marker
head(getCountAlleleMissing(gds, target = "marker")) 
# Missing allele count per sample
head(getCountAlleleMissing(gds, target = "sample")) 
```
\ 
```{r}
# Reference read count per marker
head(getCountReadRef(gds, target = "marker")) 
# Reference read count per sample
head(getCountReadRef(gds, target = "sample")) 
```
\ 
```{r}
# Alternative read count per marker
head(getCountReadAlt(gds, target = "marker")) 
# Alternative read count per sample
head(getCountReadAlt(gds, target = "sample")) 
```
\ 
```{r}
# Sum of reference and alternative read counts per marker
head(getCountRead(gds, target = "marker")) 
# Sum of reference and alternative read counts per sample
head(getCountRead(gds, target = "sample")) 
```
\ 
```{r}
# Mean of reference allele read count per marker
head(getMeanReadRef(gds, target = "marker")) 
# Mean of reference allele read count per sample
head(getMeanReadRef(gds, target = "sample"))
```
\ 
```{r}
# Mean of Alternative allele read count per marker
head(getMeanReadAlt(gds, target = "marker")) 
# Mean of Alternative allele read count per sample
head(getMeanReadAlt(gds, target = "sample")) 
```
\ 
```{r}
# SD of reference allele read count per marker
head(getSDReadRef(gds, target = "marker")) 
# SD of reference allele read count per sample
head(getSDReadRef(gds, target = "sample")) 
```
\ 
```{r}
# SD of Alternative allele read count per marker
head(getSDReadAlt(gds, target = "marker")) 
# SD of Alternative allele read count per sample
head(getSDReadAlt(gds, target = "sample"))
```
\ 
```{r}
# Minor allele frequency per marker
head(getMAF(gds, target = "marker")) 
# Minor allele frequency per sample
head(getMAF(gds, target = "sample")) 
```
\ 
```{r}
# Minor allele count per marker
head(getMAC(gds, target = "marker")) 
# Minor allele count per sample
head(getMAC(gds, target = "sample")) 
```
\ 

You can get the proportion of each genotype call with `prop = TRUE`.
```{r}
head(getCountGenoRef(gds, target = "marker", prop = TRUE))
head(getCountGenoHet(gds, target = "marker", prop = TRUE))
head(getCountGenoAlt(gds, target = "marker", prop = TRUE))
head(getCountGenoMissing(gds, target = "marker", prop = TRUE))
```
\ 

The proportion of each allele counts.
```{r}
head(getCountAlleleRef(gds, target = "marker", prop = TRUE))
head(getCountAlleleAlt(gds, target = "marker", prop = TRUE))
head(getCountAlleleMissing(gds, target = "marker", prop = TRUE))
```
\ 

The proportion of each allele read counts.
```{r}
head(getCountReadRef(gds, target = "marker", prop = TRUE))
head(getCountReadAlt(gds, target = "marker", prop = TRUE))
```


# Filtering and Subsetting
## Filtering Data
Based on the statistics we obtained, we can filter out less reliable markers and samples using `setMarFilter()` and `setSamFilter()`, respectively.
```{r}
gds <- setMarFilter(gds, missing = 0.2, het = c(0.1, 0.9), maf = 0.05)
gds <- setSamFilter(gds, missing = 0.8, het = c(0.25, 0.75))
```
\ 

`setCallFilter()` is another type of filtering which works on each genotype call that is a data point at a marker in a sample. We can replace some genotype calls with missing based on the specified criteria. If you would like to filter out less reliable genotype calls that are only supported by less than 5 reads, set the arguments as below.
```{r}
gds <- setCallFilter(gds, dp_count = c(5, Inf))
```
\ 

If needed to remove genotype calls supported by too many reads, which might be the results of mismapping from repetitive sequences, set as follows.
```{r}
# Filtering genotype calls based on total read counts
gds <- setCallFilter(gds, dp_qtile = c(0, 0.9))

# Filtering genotype calls based on reference read counts 
# and alternative read counts separately.
gds <- setCallFilter(gds, ref_qtile = c(0, 0.9), alt_qtile = c(0, 0.9))
```
\ 

Usually reference reads and alternative reads show different data distributions. Thus, we can set the different thresholds for them via `dp_qtile`, `ref_qtile`, and `alt_qtile` to filter out genotype calls based on quantiles of total, reference, and alternative read counts in each sample.
\ 

Here, the following codes filter out calls supported by less than 5 reads and then filter out markers showing a missing rate of more than 20%.
```{r}
gds <- setCallFilter(gds, dp_count = c(5, Inf))
gds <- setMarFilter(gds, missing = 0.2)
```
\

#### Important Instruction for Filtering
Based on our study using simulation data and real data for a rice F2 population derived from a cross between distant relatives (cultivar x wild species), we recommend the setting of `ref_qtile = c(0, 0.9), alt_qtile = c(0, 0.9)` to filter out markers with over represented reads. If your population contains samples that have only either of reference or alternative reads at the majority of markers, filtering with `ref_qtile = c(0, 0.9), alt_qtile = c(0, 0.9)` will set missing to a large portion of markers for the samples. In that case, it is better to set `dp_qtile = c(0, 0.9)`. In addition, the error correction by GBScleanR does not require any filtering for markers based on missing rate, heterozygosity, and allele frequency. Therefore, `setMarFilter()` and `setSamFilter()` will be used only when you have specific markers and samples that should be removed. In that case, please specify marker IDs and sample IDs to the `id` argument of `setMarFilter()` and `setSamFilter()`, respectively.
```{r}
gds <- setCallFilter(gds, ref_qtile = c(0, 0.9), alt_qtile = c(0, 0.9))
invalid_mar <- getMarID(gds)[1:5]
gds <- setMarFilter(gds, id = invalid_mar)
invalid_sam <- getSamID(gds)[1:3]
gds <- setSamFilter(gds, id = invalid_sam)
```




In addition to those statistics based filtering functions, `r Biocpkg("GBScleanR")` provides a filtering function based on relative marker positions. Markers locating too close each other usually have redundant information, especially if those markers are closer each other than the read length, in which case the markers are supported by completely (or almost) the same set of reads. To select only one marker from those markers, we can sue `thinMarker()`. This function selects one marker having the least missing rate from each stretch of the specified length. If some markers have the least missing rate, select the first marker in the stretch.
```{r}
# Here we select only one marker from each 150 bp stretch.
gds <- thinMarker(gds, range = 150) 
```
\ 

We can obtain the summary statistics using `countGenotype()`, `countRead()`, and `calcReadStats()` for only the SNPs and samples retained after the filtering. Importantly, we need to set `node = "filt` if we have apllied `setCallFiler()`. Otherwise, `countGenotype()` used the raw genotype calls.
```{r}
gds <- countGenotype(gds, node = "filt")
gds <- countRead(gds, node = "filt")
```
\ 

We can check which markers and samples are retained after the filtering using `validSnp()` and `validSam()`.
```{r}
head(validMar(gds))
head(validSam(gds))
```
\ 

The class methods of `GbsrGenotypeData` basically work with only the markers and samples retained after filtering. To use all markers and samples, please specify `valid = FALSE` to the `GbsrGenotypeData` class methods.
```{r}
nmar(gds)
nmar(gds, valid = FALSE)
```
\ 

## Reset Filtering
We can reset filtering as following.
```{r}
# Reset the filter on markers
gds <- resetMarFilter(gds) 

# Reset the filter on samples
gds <- resetSamFilter(gds) 

# Reset the filter on calls
gds <- resetCallFilter(gds) 

# Reset all filters
gds <- resetFilter(gds) 
```



# Error Correction
The error correction algorithm of `r Biocpkg("GBScleanR")` bases on the HMM assuming observed allele read counts for each SNP marker along a chromosome as the outputs from a sequence of latent true genotypes. Our model supposes that a population of $N^o \geq 1$ sampled offspring was originally derived form the crosses between $N^f \geq 2$ parent individuals. The parents can be inbred lines having homozygotes at all markers and outbred lines in which markers show heterozygous genotype.


## Set Replicates
The update on Mar 7, 2024 added a function to set sample replicate information 
to jointly evaluate read counts for replicates in the genotype estimation by 
the `estGeno()` function. The `estGeno()` function sums up the read counts of 
replicates specified by `setReplicates()` and estimates genotypes based on the 
summed-up read counts. The samples specified as replicates in `setReplicates()` 
will have the same genotypes at all markers in the estimated genotypes obtained 
via `estGeno()`. The `setReplicates()` function assumes that replicate 
information would be supplied for all samples in the data including parents via 
the `replicates` argument. In addition, the `setReplicates()` function assumes 
that the samples that are assigned same numbers or characters via the 
`replicates` argument are replicates. Therefore, the ordering of samples in the 
data and the identifiers in the vector specified to `replicates` should match. 
Replicates can be specified as follows. 
First, it is better to confirm the ordering of samples in the data with the 
setting "valid = FALSE" to obtain all sample IDs.
```{r}
sample_id <- getSamID(gds, valid = FALSE)
sample_id
```
Here, as an example, we assume that the samples at odd indices in the 
`sample_id` vector are the replicates of the next samples at even indices. For 
example, F2_1054 and F2_1055 are replicates for which DNA samples were extracted
 from the same F2 individual although they have different samples IDs. In this 
 case, you can set replicate information as shown below.
```{r}
gds <- setReplicates(gds, replicates = rep(1:51, each = 2))
```
As another example, if parents in the data are Founder1 and Founder2 and 
replicates are F2_1054 and F2_1022 for Founder1 and F2_1178 and F2_1637 for 
Founder2, you should give a vector to the `replicates` argument like the 
following.
```{r}
rep_of_parent1 <- sample_id %in% c("Founder1", "F2_1054", "F2_1022")
rep_of_parent2 <- sample_id %in% c("Founder2", "F2_1178", "F2_1637")
sample_id[rep_of_parent1] <- "Founder1"
sample_id[rep_of_parent2] <- "Founder2"
gds <- setReplicates(gds, replicates = sample_id)
```
If you set replicates for parents, you should give a sample id of the replicates 
 as an identifier for a parent in `setParents()` as described in the next 
 section. If you set replicates for parents after setting parents by 
 `setParents()`, the replicates for parents will be also set as parents with 
 assigning the same member ID for the replicates of each parent.



To reset the assigned replicate information, please use `setReplicates()` with 
specifying different values to the `replicates` argument.
```{r}
gds <- setReplicates(gds, replicates = seq_len(nsam(gds, valid = FALSE)))
```



## Set Parents
As the first step for genotype error correction, we have to specify which samples are the parents of the population via `setParents()`. In the case of genotype data in the biparental population, people usually filter out SNPs which are not monomorphic in each parental sample and not biallelic between parents. `setParents()` automatically do this filtering, if you set `mono = TRUE` and `bi = TRUE`.
```{r}
p1 <- grep("Founder1", getSamID(gds, valid = FALSE), value = TRUE)
p2 <- grep("Founder2", getSamID(gds, valid = FALSE), value = TRUE)
gds <- setParents(gds, parents = c(p1, p2), mono = TRUE, bi = TRUE)
```
If you set replicates for parents, you should give a sample id of the replicates 
 as an identifier for a parent in `setParents()`. In the last example in the 
 previous section, we set three replicates for each parent. To properly set 
 parents, we should specify either of "Founder1", "F2_1054", and "F2_1022" for 
 `p1` and either of "Founder2", "F2_1178", "F2_1637" for `p2`.

## Data QC and Filtering
The next step is to visualize statistical summaries of the data. Get genotype data summaries as mentioned in the previous section.
```{r}
gds <- countGenotype(gds)
```
\ 

Then, get histograms.
```{r}
histGBSR(gds, stats = "missing")
```
\ 
```{r}
histGBSR(gds, stats = "het")
```
\ 
```{r}
histGBSR(gds, stats = "raf")
```
\ 

As the histograms showed, the data contains a lot of missing genotype calls with unreasonable heterozygosity in a F2 population. Reference allele frequency shows a bias to reference allele. If you can say your population has no strong segregation distortion in any positions of the genome, you can filter out the markers having too high or too low reference allele frequency.
```{r}
# filter out markers with reference allele frequency
# less than 5% or more than 95%.
gds <- setMarFilter(gds, maf = 0.05) 
```
\ 

However, sometimes filtering based on allele frequency per marker removes all markers from regions truly showing segregation distortion. Although heterozygosity can be a criterion to filter out markers, this will removes too many markers which even contains useful information for genotyping. In addition, as we described in the previous section, the error correction by GBScleanR does not require any filtering for markers based on missing rate, heterozygosity, and allele frequency.
\ 

If we found poor quality samples in you dataset based on missing rate, heterozygosity, and reference allele frequency, we can omit those samples with `setSamFilter()`.
```{r}
# Filter out samples with more than 90% missing genotype calls,
# less than 5% heterozygosity, and less than 5% minor allele frequency.
gds <- setSamFilter(gds, missing = 0.9, het = c(0.05, 1), maf = 0.05)
```
\ 

Before filtering using `setMarFilter()` and `setSamFilter()`, we recomend that you conduct filtering on each genotype call based on read depth. The error correction via `r Biocpkg("GBScleanR")` is robust against low coverage calls, while genotype calls messed up by mismapping might lead less reliable error correction. Therefore, filtering for extremely high coverage calls are necessary rather than that for low coverage ones.
```{r}
# Filter out genotype calls supported by reads less than 2 reads.
gds <- setCallFilter(gds, dp_count = c(2, Inf))

# Filter out genotype calls supported by reads more than 100.
gds <- setCallFilter(gds, dp_count = c(0, 100))

# Filter out genotype calls based on quantile values 
# of read counts at markers in each sample.
gds <- setCallFilter(gds, ref_qtile = c(0, 0.9), alt_qtile = c(0, 0.9))
```
\ 

Since missing genotype calls left in the data basically give no negative effect on genotype error correction. Therefore, you can leave any missing genotype calls. We can, however, remove markers based on missing genotype calls.
```{r}
# Remove markers having more than 75% of missing genotype calls
gds <- setMarFilter(gds, missing = 0.2) 
nmar(gds)
```
\ 

To check statistical summaries of the filtered genotype data, we need to set `node = "filt`. Otherwise, `countGenotype()` used the raw genotype data.
```{r}
gds <- countGenotype(gds, node = "filt")
```
\ 
```{r}
histGBSR(gds, stats = "missing")
```
\ 
```{r}
histGBSR(gds, stats = "het")
```
\ 
```{r}
histGBSR(gds, stats = "raf")
```
\ 

We can still see the markers showing distortion in allele frequency, while the expected allele frequency is 0.5 in a F2 population. To investigate that those markers having distorted allele frequency were derived from truly distorted regions or just error prone markers, we must check if there are regions where the markers with distorted allele frequency are clustered.
```{r}
plotGBSR(gds, stats = "raf")
```
\ 

No region seem to have severe distortion. Based on the histogram of reference allele frequency, we can roughly cut off the markers with frequency more than 0.75 or less than 0.25, in other words, less than 0.25 of minor allele frequency. As we mentioned already in the previous section, the error correction by GBScleanR basically works finely without any filtering for markers based on missing rate, heterozygosity, and allele frequency.
```{r}
gds <- setMarFilter(gds, maf = 0.25)
nmar(gds)
```
\ 

Let's see the statistics again.
```{r}
gds <- countGenotype(gds)
histGBSR(gds, stats = "missing")
```
\ 
```{r}
histGBSR(gds, stats = "het")
```
\ 
```{r}
histGBSR(gds, stats = "raf")
```
\ 

At the end of filtering, check marker density and genotype ratio per marker along chromosomes.
```{r}
# Marker density
plotGBSR(gds, stats = "marker")
```
\ 
```{r}
plotGBSR(gds, stats = "geno")
```
\ 
The `coord` argument controls the number of rows and columns of the facets in the plot.


## Genotype Estimation
### Prepare Scheme Information
Before executing the function for true genotype estimation, we need to build a scheme object. The update on May 17, 2024 added a wrapper function for scheme information preparation. If your population has been developed in a relatively simple scheme, you can use the `makeScheme()` function.
```{r}
# For selfed F2 population
gds <- makeScheme(gds, generation = 2, crosstype = "self")

# For sibling-crossed F2 population
gds <- makeScheme(gds, generation = 2, crosstype = "sib")

# For selfed F5 population
gds <- makeScheme(gds, generation = 5, crosstype = "self")

# For F1 population
gds <- makeScheme(gds, generation = 1) # the crosstype argument will be ignored.
```
When your population has $2^n$ parents specified by `setParents()`, `makeScheme()` assumes those parents were crossed in the "funnel" design in which $2^n$ parents are crossed to obtain $2^n/2$ F1 hybrids followed by successive intercrossings (pairings) of the hybrids to combine the genomes of all parents in one family of siblings. The `makeScheme()` function assumes that the parents that were assigned an odd number member ID (N) in `setParents()` had been crossed with the parent that were assigned an even number (N+1). For example, if you set parents as shown below. The `makeScheme()` function prepare a scheme information that indicates the intercrossings of "p1 x p2", "p3 x p4", "p5 x p6", and "p7 x p8" followed by crossing of "p1xp2_F1 x p3xp4_F1" and "p5xp6_F1 x p7xp8_F1" and then crossing of the two 4-way crossed liens to produce 8-way crossed hybrid lines. If, for example, `generation = 5` indicating an F5 generation was specified to `makeScheme()`, the function adds 4 successive selfing or sibling crossings in the scheme.
```{r, eval=FALSE}
# Do not run.
gds <- setParents(gds, 
                  parents = c("p1", "p2", "p3", "p4", "p5", "p6", "p7", "p8"))
# Member IDs will be 1, 2, 3, 4, 5, 6, 7, and 8 
# for p1, p2, p3, p4, p5, p6, p7, and p8, respectively.
```



In many cases, `makeScheme()` is enough to prepare scheme information. However, if your population underwent more complicated crossings, please register scheme information step-by-step as shown below.

Our sample data is of a biparental F2 population derived from inbred parents. Therefore, we should run `initScheme()` and `addScheme()` as following.
```{r}
# As always the first step of breeding scheme would be "pairing" cross(es) of 
# parents, never be "selfing" and a "sibling" cross,
# the argument `crosstype` in initScheme() was deprecated on the update on April 6, 2023.
# gds <- initScheme(gds, crosstype = "pairing", mating = matrix(1:2, 2))
gds <- initScheme(gds, mating = rbind(1, 2))
gds <- addScheme(gds, crosstype = "selfing")
```
\ 

The function `initScheme()` initializes the scheme object with information about parents. You need to specify a matrix indicating combinations of `mating`, in which each column shows a pair of parental samples. For example, if you have only two parents, the `mating` matrix should be `mating = matrix(1:2, nrow = 2, ncol = 1)` or equivalents. The indices used in the matrix should match with the IDs labeled to parental samples by `setParents()`. To confirm the IDs for parental samples, run the following code.
```{r}
getParents(gds)
```
The created `GbsrScheme` object is set in the `scheme` slot of the `GbsrGenotypeData` object.
The function `addScheme()` adds the information about the next breeding step of your population. In the case of our example data, the second step was selfing to produce F2 individuals from the F1 obtained via the first parent crossing.
\  

The codes shown below in the rest of the section "Prepare scheme information" are sample codes assuming some specific situations that are not applicable for the sample data used in this vignette. Therefore, you will get error messages if you run the codes.



If your population was derived from a 4-way or 8-way cross, you need to add more `paring` steps. In the case of 8-way RILs developed by three pairing crosses followed by five selfing cycles, the scheme object should be built as following. First we need to initialize the scheme object with specifying the first mating scheme. The crosstype argument should be "pairing" and the mating argument should be given as a matrix in which each pairing combination of parents are shown in each column. The following case indicates the pairing of parent 1 and 2 as well as 3 and 4, 5 and 6, and 7 and 8.
```{r eval=FALSE}
# As always the first step of breeding scheme would be "pairing" cross(es) of 
# parents, never be "selfing" and a "sibling" cross,
# the argument `crosstype` in initScheme() was deprecated on the update on April 6, 2023.
# gds <- initScheme(gds, crosstype = "pair", mating = cbind(c(1:2), c(3:4), c(5:6), c(7:8)))

# Do not run.
gds <- initScheme(gds, mating = cbind(c(1:2), c(3:4), c(5:6), c(7:8)))
```
\  

Now the progenies of the crosses above have member ID 9, 10, 11,
and 12 for each combination of mating. You can check IDs with showScheme().

Then, add the step to make 4-way crosses.
```{r eval=FALSE}
# Do not run.
gds <- addScheme(gds, crosstype = "pair", mating = cbind(c(9:10), c(11:12)))

# Check IDs.
showScheme(gds)
```
\  
Add the last generation of the paring step .
```{r eval=FALSE}
# Do not run.
gds <- addScheme(gds, crosstype = "pair", mating = cbind(c(13:14)))

#' # Check IDs.
showScheme(gds)
```
\  
Now we have the scheme information of a 8-way cross.
The follwoing steps add the selfing cycles.
```{r eval=FALSE}
# Inbreeding by five times selfing.
# Do not run.
gds <- addScheme(gds, crosstype = "self")
gds <- addScheme(gds, crosstype = "self")
gds <- addScheme(gds, crosstype = "self")
gds <- addScheme(gds, crosstype = "self")
gds <- addScheme(gds, crosstype = "self")
```
You can set `crosstype = "sibling"` or `crosstype = "random"`, if your population was developed through sibling crosses or random crosses, respectively.

#### Update on April 4, 2023
The update on April 4, 2023 introduced new function to GBScleanR.
The genotype estimation algorithm in estGeno() supports populations that consist
of samples belonging to different pedigree. For example, if you have a population
 of F1 samples that derived from three different crosses of four parents: 
Founder1 x Founder2, Founder1 x Founder3, Founder1 x Founder4. You can build a 
scheme info as following.
```{r eval=FALSE}
# Do not run.
gds <- setParents(object = gds,
                  parents = c("Founder1", "Founder2", "Founder3", "Founder4"))
gds <- initScheme(object = gds, 
                  mating = cbind(c(1, 2), c(1, 3), c(1,4)))
# The initScheme() function here automatically set 5, 6, and 7 as member ID to
# the progenies of the above maiting (pairing) combinations, respectively.

# Then you have to assign member IDs to your samples to indicate which sample 
# belongs to which pedigree.
gds <- assignScheme(object = gds, 
                    id = c(rep(5, 10), rep(6, 15), rep(7, 20)))
```

The assignScheme() assign member IDs `id` to the samples in order.
Please confirm the order of the member IDs in `id` and the order of the
sample IDs shown by getSamID(gds).
```{r eval=FALSE}
# Do not run.
# Get sample ID
sample_id <- getSamID(object = gds)

# Initialize the id vector
id <- integer(nsam(gds))

# Assume your samples were named with prefixes that indicate which 
# sample was derived from which combination of parents.
id[grepl("P1xP2", sample_id)] <- 5
id[grepl("P1xP3", sample_id)] <- 6
id[grepl("P1xP4", sample_id)] <- 7
gds <- assignScheme(object = gds, id = id)
```


#### Update on March 4, 2026
The update on March 4, 2026 enabled GBScleanR to support a scheme with a single 
parental line. You set a single parental line using `setParents()` and initialize 
a scheme object for this design as following.
```{r eval=FALSE}
# Do not run.
gds <- setParents(object = gds, parents = "Founder1")

gds <- initScheme(object = gds, mating = rbind(1, 1))
# The initScheme() function here automatically set 2 as member ID to
# the progenies of the above maiting (selfing).

```
As an important note, `setParents()` automatically runs with the settings 
`mono = FALSE` and `bi = TRUE` when a single parental line is assigned. Thus, 
only markers where the parent is heterozygous are retained.

### Execute Genotype Estimation
The following codes suppose that you built the scheme object for the example data that is a biparental F2 population derived from a cross between inbred parents, not for the 8-way RILs explained above.
Now we can execute genotype estimation for error correction. `r Biocpkg("GBScleanR")` estimates error pattern via iterative optimization of parameters for genotype estimation. We could not guess the best number of iterations, but our simulation tests showed `iter = 4` usually saturates the improvement of estimation accuracy.
```{r message=FALSE, results=FALSE}
gds <- estGeno(gds, node = "filt", iter = 4)
```
\  
*As an important change in estGeno() since version 2, the function now requires the node argument to explicitly specify whether raw or filtered read counts should be used for genotype estimation. If setCallFilter() has not been executed, the user-specified node argument will be ignored, and the "raw" node will be used by default.*

\  

If your population derived from outbred parents, please set `het_parents = TRUE`.
```{r eval=FALSE}
# Do nut run
# This is an example to show the case to use "het_parents = TRUE".
gds <- estGeno(gds, het_parent = TRUE, iter = 4)
```
The larger number of iterations makes running time longer. If you would like to execute no optimization, set `optim = FALSE` or `iter = 1`.
\ 

```{r eval=FALSE}
# Following codes do the same.

# Do nut run
# These are examples to show the case to set "iter = 1" or "optim = FALSE".
gds <- estGeno(gds, iter = 1)
gds <- estGeno(gds, optim = FALSE)
```
\ 

### Get the Results
All of the results of estimation are stored in the gds file linked to the `GbsrGenotypeData` object. You can obtain the estimated genotype data via the `getGenotype()` function with `node = "cor"`.
```{r}
est_geno <- getGenotype(gds, node = "cor")
```
\ 

`r Biocpkg("GBScleanR")` also estimates phased parent genotypes and you can access it.
```{r}
parent_geno <- getGenotype(gds, node = "parents")
```




`r Biocpkg("GBScleanR")` first internally estimate phased haplotype and then convert them to genotype calls. If you need the estimated haplotype data, run `getHaplotype()`.
```{r}
est_hap <- getHaplotype(gds)
```
\ 

The function `gbsrGDS2VCF()` generate a VCF file containing the estimated genotype data and phased haplotype information. The estimated haplotypes are indicated in the FORMAT field with the HAP tag. The parent genotypes correspond to each haplotype are indicated in the INFO field with the PGT tag. HAP shows the pair of haplotype for each marker of each sample, while PGT shows the allele of each haplotype. HAP is indicated by two numbers separated by a pipe symbol "|". Each of the numbers takes one of the numbers from 1 to 2*N, where N is the number of parents.
PGT is indicated by 2*N numbers separated by a pipe symbol "|". The first number in PGT represents the allele of haplotype 1 at the marker, and the rest numbers also show the alleles of rest haplotypes 2, 3 and 4, if your population is of biparental diploid samples. As a default, `gbsrGDS2VCF()` outputs the estimated genotype data as entries of the CGT tag in the FORMAT field. With `node = "cor"`, you can output a VCF file in which GT field was replaced with the estimated genotype data obtained via `estGeno()`.

```{r}
out_fn <- tempfile("sample_est", fileext = ".vcf.gz")
gbsrGDS2VCF(gds, out_fn)
gbsrGDS2VCF(gds, out_fn, node = "cor")
```
The output vcf file contains data like the one shown below.
```{}
##fileformat=VCFv4.2
##fileDate=20240909
##source=SeqArray_Format_v1.0
##INFO=<ID=PGT,Number=1,Type=String,Description="Estimated allele of parental haplotype by GBScleanR">
##FILTER=<ID=PASS,Description="All filters passed">
##FORMAT=<ID=GT,Number=1,Type=String,Description="Genotype">
##FORMAT=<ID=AD,Number=.,Type=Integer,Description="Allelic depths for the reference and alternate alleles in the order listed">
##FORMAT=<ID=FAD,Number=2,Type=Integer,Description="Call-filtered read counts generated by GBScleanR">
##FORMAT=<ID=FGT,Number=2,Type=Float,Description="Estimated mismapping rate by GBScleanR">
##FORMAT=<ID=HAP,Number=1,Type=String,Description="Estimated haplotype data by GBScleanR">
#CHROM  POS  ID  REF  ALT  QUAL  FILTER  INFO  FORMAT  F2_1054  F2_1055  F2_1059  F2_1170  F2_1075  F2_1070  F2_1074  F2_1007  F2_1009  F2_1489  F2_1010  F2_1014  F2_1490  F2_1022  F2_1267  F2_1382  F2_1038  Founder1  F2_1216  F2_1571  F2_1695  F2_1575  F2_1584  F2_1355  F2_1236  F2_1357  F2_1470  F2_1762  F2_1884  F2_1763  F2_1400  F2_1885  F2_1643  F2_1547  F2_1784  F2_1785  F2_1314  F2_1317  F2_1600  F2_1848  F2_1849  F2_1719  F2_1850  F2_1502  F2_1868  F2_1740  F2_1741  F2_1755  F2_1756  F2_1874  Founder2  F2_1811  F2_1812  F2_1700  F2_1824  F2_1827  F2_1710  F2_1714  F2_1166  F2_1282  F2_1178  F2_1192  F2_1195  F2_1361  F2_1122  F2_1486  F2_1132  F2_1378  F2_1257  F2_1258  F2_1262  F2_1384  F2_1152  F2_1274  F2_1150  F2_1688  F2_1681  F2_1682  F2_1684  F2_1686  F2_1565  F2_1339  F2_1333  F2_1222  F2_1592  F2_1472  F2_1476  F2_1404  F2_1527  F2_1641  F2_1666  F2_1541  F2_1677  F2_1671  F2_1602  F2_1618  F2_1635  F2_1637
1  522289  S01_522289  A  G  100  PASS  PGT=0|0|1|1;ADB=0.520833;MR=0,0  GT:AD:FAD:FGT:HAP:EDS  0/0:10,0:10,0:0/0:1|1:0  1/0:6,6:6,6:0/1:2|1:1  0/0:6,0:6,0:0/0:1|1:0  1/1:0,12:0,0:./.:2|2:2  1/0:12,9:0,0:./.:2|1:1  1/0:3,1:3,1:0/1:2|1:1  0/1:5,5:5,5:0/1:1|2:1  1/0:5,2:5,2:0/1:2|1:1  0/1:4,1:4,1:0/1:1|2:1  1/0:1,4:1,4:0/1:2|1:1  1/1:0,14:0,0:./.:2|2:2  1/0:3,6:3,6:0/1:2|1:1  1/0:6,5:6,5:0/1:2|1:1  1/1:9,6:0,0:./.:2|2:2  1/1:0,14:0,14:1/1:2|2:2  0/0:12,0:12,0:0/0:1|1:0  0/0:1,0:1,0:0/0:1|1:0  0/0:146,0:146,0:0/0:1|1:0  0/0:8,0:8,0:0/0:1|1:0  1/0:4,6:4,6:0/1:2|1:1  0/1:11,3:11,3:0/1:1|2:1  0/1:2,2:2,2:0/1:1|2:1  0/1:11,8:11,8:0/1:1|2:1  0/1:6,6:6,6:0/1:1|2:1  0/1:3,2:3,2:0/1:1|2:1  0/0:16,0:16,0:0/0:1|1:0  0/0:24,0:0,0:./.:1|1:0  1/0:6,10:6,10:0/1:2|1:1  0/0:19,0:19,0:0/0:1|1:0  0/0:7,0:7,0:0/0:1|1:0  0/0:8,0:8,0:0/0:1|1:0  1/1:0,9:0,9:1/1:2|2:2  ./.:3,6:0,0:./.:.|.:0  0/0:19,0:19,0:0/0:1|1:0  0/0:8,0:8,0:0/0:1|1:0  0/0:6,0:6,0:0/0:1|1:0  1/0:7,4:7,4:0/1:2|1:1  0/1:10,7:10,7:0/1:1|2:1  0/1:4,8:4,8:0/1:1|2:1  0/1:6,4:6,4:0/1:1|2:1  1/0:7,1:7,1:0/0:2|1:1  0/1:4,8:4,8:0/1:1|2:1  0/1:7,3:7,3:0/1:1|2:1  0/0:5,0:0,0:./.:1|1:0  0/1:4,18:4,18:0/1:1|2:1  0/0:8,0:8,0:0/0:1|1:0  0/1:4,6:0,0:./.:1|2:1  0/1:5,4:5,4:0/1:1|2:1  0/0:8,0:8,0:0/0:1|1:0  1/1:0,8:0,0:./.:2|2:2  1/1:0,285:0,285:1/1:2|2:2  0/1:3,2:3,2:0/1:1|2:1  1/0:6,3:6,3:0/1:2|1:1  1/0:4,5:4,5:0/1:2|1:1  1/0:10,4:0,0:./.:2|1:1  0/0:12,0:12,0:0/0:1|1:0  0/0:10,0:10,0:0/0:1|1:0  0/0:12,0:0,0:./.:1|1:0  0/0:13,0:0,0:./.:1|1:0  0/1:5,3:5,3:0/1:1|2:1  0/0:8,0:8,0:0/0:1|1:0  0/1:5,1:5,1:0/1:1|2:1  ./.:0,6:0,6:1/1:.|.:0  1/0:2,7:2,7:0/1:2|1:1  1/1:0,7:0,7:1/1:2|2:2  1/0:3,1:3,1:0/1:2|1:1  0/0:8,0:0,0:./.:1|1:0  1/0:4,2:4,2:0/1:2|1:1  0/1:2,1:2,1:0/1:1|2:1  1/1:0,10:0,10:1/1:2|2:2  1/0:5,2:5,2:0/1:2|1:1  0/0:3,0:3,0:0/0:1|1:0  0/0:10,0:10,0:0/0:1|1:0  1/1:0,4:0,4:1/1:2|2:2  0/0:4,0:4,0:0/0:1|1:0  0/0:9,0:9,0:0/0:1|1:0  1/1:0,11:0,11:1/1:2|2:2  0/1:3,2:3,2:0/1:1|2:1  0/1:5,2:5,2:0/1:1|2:1  0/0:4,0:4,0:0/0:1|1:0  1/0:3,3:3,3:0/1:2|1:1  1/1:0,8:0,0:./.:2|2:2  0/0:9,0:9,0:0/0:1|1:0  0/1:4,5:4,5:0/1:1|2:1  0/0:10,0:10,0:0/0:1|1:0  0/0:7,0:7,0:0/0:1|1:0  0/1:1,3:1,3:0/1:1|2:1  0/0:7,0:7,0:0/0:1|1:0  1/1:0,11:0,11:1/1:2|2:2  1/0:0,3:0,3:1/1:2|1:1  1/1:0,11:0,0:./.:2|2:2  0/1:6,5:6,5:0/1:1|2:1  1/0:1,4:1,4:0/1:2|1:1  1/0:4,2:4,2:0/1:2|1:1  1/1:0,4:0,4:1/1:2|2:2  0/0:9,0:9,0:0/0:1|1:0  1/0:4,4:4,4:0/1:2|1:1  1/0:6,6:0,0:./.:2|1:1 
```
In the output vcf, "PGT=0|0|1|1" in the INFO field indicates the parental 
samples alleles for haplotype 1, 2, 3, and 4 separated by |. The numbers 0 and 1 represent reference and alternative alleles that are A and G at the marker shown above, resectively.
FAD and FGT in the FORMAT field show the allele read counts and genotype call after filtering by `setCallFiler()`.
HAP and EDS indicate descendent haplotypes and haplotype dosage at the given marker. EDS will be provided only if you specified two parents in `setParents()` and specified `het_parent = FALSE` for `estGeno()`.



Alternatively, you can also output the genotype data into a CSV file using `gbsrGDS2CSV()`
```{r}
out_fn <- tempfile("sample_est", fileext = ".csv")
gbsrGDS2CSV(gds, out_fn)
gbsrGDS2CSV(gds, out_fn, node = "cor")
```
You can format the output for the `r CRANpkg("qtl")` package. 
```{r}
out_fn <- tempfile("sample_est", fileext = ".csv")
gbsrGDS2CSV(gds, out_fn, format = "qtl")
gbsrGDS2CSV(gds, out_fn, node = "cor", format = "qtl")
```
When you set `format = "qtl"`, the marker positions will be automatically converted from physical positions (bp) to genetic distances (cM). The conversion is performed by multiplying the physical positions by the value set to `bp2cm`. The default is `bp2cm = 4e-06` if `format = "qtl"`.

\ 

Please use `reopenGDS()` to open the connection again if you need.
```{r}
gds <- reopenGDS(gds)
```

# Plot Read Ratio and Dosage {#plot_dosage}
The ratio of reference and alternative allele reads can be visualized in dot plots using the `plotReadRatio()` function.
Every single call of `plotReadRatio()` generates dot plots for all chromosomes but only for a single sample. 
```{r}
plotReadRatio(x = gds, coord = c(3, 4), ind = 3, node = "raw", size = 2)
```
Since the sample data contains only one chromosome, `coord = c(3, 4)` does not change any coordinate of the plot. If, for example, you sample has 12 chromosomes, the dot plots for the chromosomes will be shown in 3 rows and 4 columns.
\  

If you need to draw plots for all samples in your dataset, please loop the function over your samples.
```{r eval = FALSE}
for(i in seq_len(nsam(gds))){
plotReadRatio(x = gds, coord = c(3, 4), ind = i, node = "raw")
}
```

If you set `node = "filt"`, you can visualize the read ratio obtained by applying the `setCallFilter()` function.
```{r}
plotReadRatio(x = gds, coord = c(3, 4), ind = 3, node = "filt", size = 2)
```
\  


The `plotDosage()` function enables you to visualize the estimated dosage overlaying on the read ratio plot.
Since this function visualize dosages estimated by the `estGeno()` function, you will get an error message if you call this function before running `estGeno()`.
```{r}
plotDosage(x = gds, coord = c(3, 4), ind = 3, node = "raw", size = 2)
```
The magenta line indicates the estimated alternative allele dosage par marker while colored dots shows alternative allele read ratio par marker. The `plotDosage()` function also draw plots for a single sample in a single call. Please loop the function over samples if needed.

You can also use the filtered read count data for the read ratio visualization in the dosage plot.
```{r}
plotDosage(x = gds, coord = c(3, 4), ind = 3, node = "filt", size = 2)
```

# Closing the Connection
To safely close the connection to the GDS file, use `closeGDS()`.
```{r}
closeGDS(gds)
```



# Session Info{-}
```{r}
sessionInfo()
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/PlotFunctions.R
\name{plotReadRatio}
\alias{plotReadRatio}
\title{Draw line plots of proportion of reference allele read counts
per marker per sample.}
\usage{
plotReadRatio(
  x,
  coord = NULL,
  chr = NULL,
  ind = 1,
  node = "raw",
  dot_fill = c("green", "darkblue"),
  size = 0.8,
  alpha = 0.8
)
}
\arguments{
\item{x}{A \link{GbsrGenotypeData} object.}

\item{coord}{A vector with two integer specifying the number of rows and
columns to draw faceted line plots for chromosomes.}

\item{chr}{A vector of indexes to specify chromosomes to be drawn.}

\item{ind}{A string of sample id or an index to specify the sample to be drawn.}

\item{node}{Either one of "raw" or "filt" to output raw read data, or filtered read data,
respectively.}

\item{dot_fill}{A vector of two strings to indicate the dot colors in the plot. The first and second elements of the vector are set as the colors for the lowest and highest values in the gradient coloring of the dots indicating total read counts par marker.}

\item{size}{A positive number to indicate the dot size in the plot.}

\item{alpha}{A positive number in 0-1 to indicate the dot opacity in the plot.}
}
\value{
A ggplot object.
}
\description{
This function calculate a proportion of reference allele read
counts per marker per sample and
draw line plots of them in facets for each chromosome for each sample.
}
\examples{
# Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
gds <- loadGDS(gds_fn)

plotReadRatio(gds, ind = 1)

# Close the connection to the GDS file
closeGDS(gds)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/Methods-GbsrGenotypeData.R
\name{getPosition}
\alias{getPosition}
\alias{getPosition,GbsrGenotypeData-method}
\title{Obtain marker positions}
\usage{
getPosition(object, valid = TRUE, chr = NULL, ...)

\S4method{getPosition}{GbsrGenotypeData}(object, valid, chr)
}
\arguments{
\item{object}{A \link{GbsrGenotypeData} object.}

\item{valid}{A logical value. See details.}

\item{chr}{A integer or string to specify chromosome to get information.}

\item{...}{Unused.}
}
\value{
An integer vector indicating the physical positions of markers.
}
\description{
This function returns physical positions of markers.
}
\details{
If \code{valid = TRUE}, the positions of the markers which are labeled \code{TRUE} in
the "valid" column of the "marker" slot will be returned. If you need the
positions of over all markers, set \code{valid = FALSE}. \code{\link[=validMar]{validMar()}} tells you
which markers are valid.
}
\examples{
# Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
gds <- loadGDS(gds_fn)

getPosition(gds)

# Close the connection to the GDS file.
closeGDS(gds)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/Methods-GbsrGenotypeData.R
\name{validSam}
\alias{validSam}
\alias{validSam<-}
\alias{validSam,GbsrGenotypeData-method}
\alias{validSam<-,GbsrGenotypeData-method}
\title{Return a logical vector indicating which are valid samples.}
\usage{
validSam(object, parents = FALSE, ...)

validSam(object) <- value

\S4method{validSam}{GbsrGenotypeData}(object, parents)

\S4method{validSam}{GbsrGenotypeData}(object) <- value
}
\arguments{
\item{object}{A \link{GbsrGenotypeData} object.}

\item{parents}{A logical value to indicate to set FALSE or TRUE
to parental samples. If you specify \code{parents = "only"}, this
function returns a logical vector indicating TRUE for only parental samples.}

\item{...}{Unused.}

\item{value}{A logical vector indicating valid samples with the length
matching with the number of samples}
}
\value{
A logical vector of the same length
with the number of total samples.
}
\description{
Return a logical vector indicating which are valid samples.
}
\examples{
# Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
gds <- loadGDS(gds_fn)

validSam(gds)

# Close the connection the GDS file.
closeGDS(gds)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/Methods-GbsrGenotypeData.R
\name{setFixedParameter}
\alias{setFixedParameter}
\alias{setFixedParameter,GbsrGenotypeData-method}
\title{Set fixed allele read biases and mismapping rate}
\usage{
setFixedParameter(object, bias = NULL, mismap = NULL, parent_geno = FALSE, ...)

\S4method{setFixedParameter}{GbsrGenotypeData}(object, bias, mismap, parent_geno)
}
\arguments{
\item{object}{A \link{GbsrGenotypeData} object.}

\item{bias}{A numeric vector of fixed allele read biases to be assigned to
valid markers. The length of \code{bias} vector should match the number of valid
markers.}

\item{mismap}{A numeric matrix of fixed reference and alternative read
mismapping rates to be assigned to valid markers. The number of rows of the
given matrix should match the number of valid markers and should have two
columns that are for reference and alternative read mismapping rates,
respectively.}

\item{parent_geno}{A logical value indicating whether to use fixed parental
genotypes in the genoype estimation by \code{\link[=estGeno]{estGeno()}}. This mode requires the
estimated genotypes for parental samples that were estimated by \code{\link[=estGeno]{estGeno()}}
and stored in the GDS file linked to the input \link{GbsrGenotypeData} object.}

\item{...}{Unused.}
}
\value{
A \link{GbsrGenotypeData} object after adding dominant marker information
}
\description{
Set fixed allele read biases and mismapping rates of markers
}
\details{
If you have already executed genotype estimation and want to reuse the
marker-wise allele read biases and mismapping rates estimated in the
completed run of estGeno(), you can use them in the next genotype estimation
run.
For example, if you want to estimate genotypes with different argument
settings of setGeno(), it is worth to set fixed parameters and run
estGeno() with setting \code{optim = FALSE} to skip time-consuming iterative
parameter optimization steps but use the estimated parameters from the first
run to incorporate the marker-wise error parameters.
Since the bias set by \code{\link[=setFixedParameter]{setFixedParameter()}} function is the reference allele read
bias, the values 0 and 1 mean that the marker only gives alternative
and reference allele reads, respectively.
The values in the \code{bias} vector are assigned to the valid markers.
Similarly, the values in the \code{mismap} matrix are
assigned to the valid markers in the order they appear in the rows.
}
\examples{
# Create a GDS file from a sample VCF file.
vcf_fn <- system.file("extdata", "sample.vcf", package = "GBScleanR")
gds_fn <- tempfile("sample", fileext = ".gds")
gbsrVCF2GDS(vcf_fn = vcf_fn, out_fn = gds_fn, force = TRUE)

# Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
gds <- loadGDS(gds_fn)

# Not run.
# Run estGeno() and reuse the estimated parameters in the second run.
# gds <- makeScheme(gds, generation = 2, crosstype = "self")
# gds <- estGeno(gds)
# fixed_param <- getFixedParameter(gds)
# gds <- setFixedParameter(gds,
#                          bias = fixed_param$bias,
#                          mismap = fixed_param$mismap)
# gds <- estGeno(gds, optim = FALSE, call_threshold = 0.5)

# You can also set arbitrary values.
bias <- sample(seq(0, 1, 0.01), nmar(gds), replace = TRUE)
mismap <- cbind(sample(seq(0, 0.2, 0.01), nmar(gds), replace = TRUE),
                sample(seq(0, 0.2, 0.01), nmar(gds), replace = TRUE))
gds <- setFixedParameter(gds, bias = bias, mismap = mismap)

# Close the connection to the GDS file
closeGDS(gds)


}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/Methods-GbsrGenotypeData.R
\name{setCallFilter}
\alias{setCallFilter}
\alias{setCallFilter,GbsrGenotypeData-method}
\title{Filter out each genotype call meeting criteria}
\usage{
setCallFilter(
  object,
  dp_count = c(0, Inf),
  ref_count = c(0, Inf),
  alt_count = c(0, Inf),
  dp_qtile = c(0, 1),
  ref_qtile = c(0, 1),
  alt_qtile = c(0, 1),
  ...
)

\S4method{setCallFilter}{GbsrGenotypeData}(
  object,
  dp_count,
  ref_count,
  alt_count,
  dp_qtile,
  ref_qtile,
  alt_qtile
)
}
\arguments{
\item{object}{A \link{GbsrGenotypeData} object.}

\item{dp_count}{A numeric vector with length two specifying lower and
upper limit of total read counts (reference reads + alternative reads).}

\item{ref_count}{A numeric vector with length two specifying lower and
upper limit of reference read counts.}

\item{alt_count}{A numeric vector with length two specifying lower and
upper limit of alternative read counts.}

\item{dp_qtile}{A numeric vector with length two specifying lower
and upper limit of quantile of total read counts in each sample.}

\item{ref_qtile}{A numeric vector with length two specifying lower
and upper limit of quantile of reference read counts in each sample.}

\item{alt_qtile}{A numeric vector with length two specifying lower
and upper limit of quantile of alternative read counts in each
sample.}

\item{...}{Unused.}
}
\value{
A \link{GbsrGenotypeData} object with filters on genotype calls.
}
\description{
Perform filtering of each genotype call, neither markers
nor samples. Each genotype call is supported by its read counts
for the reference allele and the alternative allele of
a marker of a sample. \code{setCallFilter()} set missing to
the genotype calls which are not reliable enough and set zero
to reference and alternative read counts of the genotype calls.
}
\details{
\code{dp_qtile}, \code{ref_qtile},
and \code{alt_qtile} use quantile values of read counts
of each sample to decide the lower and upper limit of read counts.
This function generate two new nodes in the GDS file linked with
the given \link{GbsrGenotypeData} object. The filtered read counts and genotype
calls will be stored in the data node in the "FAD" folder and the data node
in the "FGT" folder, while the data node in the "CFT" stores call fitering
informatin.
To reset the filter applied by setCallFilter(), run \code{\link[=resetCallFilter]{resetCallFilter()}}.
}
\examples{
# Create a GDS file from a sample VCF file.
vcf_fn <- system.file("extdata", "sample.vcf", package = "GBScleanR")
gds_fn <- tempfile("sample", fileext = ".gds")
gbsrVCF2GDS(vcf_fn = vcf_fn, out_fn = gds_fn, force = TRUE)

# Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
gds <- loadGDS(gds_fn)

# Filter out genotype calls supported by less than 5 reads.
gds <- setCallFilter(gds, dp_count = c(5, Inf))

# Filter out genotype calls supported by reads less than
# the 20 percentile of read counts per marker in each sample.
gds <- setCallFilter(gds, dp_qtile = c(0.2, 1))

# Reset the filter
gds <- resetCallFilter(gds)

# Close the connection to the GDS file.
closeGDS(gds)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/Methods-GbsrGenotypeData.R,
%   R/Methods-GbsrScheme.R
\name{assignScheme}
\alias{assignScheme}
\alias{assignScheme,GbsrGenotypeData-method}
\alias{assignScheme,GbsrScheme-method}
\title{Assign member IDs to samples}
\usage{
assignScheme(object, id, ...)

\S4method{assignScheme}{GbsrGenotypeData}(object, id)

\S4method{assignScheme}{GbsrScheme}(object, id)
}
\arguments{
\item{object}{A \link{GbsrGenotypeData} object.}

\item{id}{A numeric vector indicating member IDs to assign to samples.}

\item{...}{Unused.}
}
\value{
A \link{GbsrGenotypeData} object storing
a \link{GbsrScheme} object in the "scheme" slot.
}
\description{
\link{GBScleanR} uses breeding scheme information to set the expected
number of cross overs in a chromosome which is a required parameter
for the genotype error correction with the Hidden Markov model
implemented in the \code{estGeno()} function.
This function assign member IDs to indicate which samples were derived from
which pedigree that recorded in the \link{GbsrScheme} object.
}
\details{
Member IDs can be shown by \code{\link[=showScheme]{showScheme()}}. Only the member IDs assigned to
progenies (not parents) are available to assign to samples. If the last
generation recorded in the \link{GbsrScheme} object has only one member ID that
should be assigned to all samples in your population, you can omit assigning
IDs by \code{\link[=assignScheme]{assignScheme()}}. In that case, \code{\link[=estGeno]{estGeno()}} automatically assign the
only one member ID to all samples.
}
\examples{
# Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
gds <- loadGDS(gds_fn)

# Biparental F2 population.
gds <- setParents(gds, parents = c("Founder1", "Founder2"))

# setParents gave member ID 1 and 2 to Founder1 and Founder2, respectively.
gds <- initScheme(gds, mating = cbind(c(1:2)))

# Now the progeny of the cross above have member ID 3.
# If `crosstype = "selfing"` or `"sibling"`, you can omit a `mating` matrix.
gds <- addScheme(gds, crosstype = "self")

# The progeny of the selfing above has member ID 4.
# To execute genotype estimation for your samples, you need to assign a member
# ID to each of the samples.

# Check IDs of samples to be assigned member IDs if necessary.
getSamID(gds)

# The assignScheme() assign member IDs `id` to the samples in order.
# Please confirm the order of the member IDs in `id` and the order of the
# sample IDs shown by getSamID(gds).
gds <- assignScheme(gds, rep(4, nsam(gds)))

# If your population has samples all of which belong to only one pedigree,
# you can omit assignScheme() and let estGeno() automatically assign the
# last member ID to all samples.

############################################################################
# Now you can execute `estGeno()` which requires a [GbsrScheme] object.

# Close the connection to the GDS file
closeGDS(gds)
}
\seealso{
\code{\link[=addScheme]{addScheme()}} and \code{\link[=showScheme]{showScheme()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/Methods-GbsrGenotypeData.R
\name{setInfoFilter}
\alias{setInfoFilter}
\alias{setInfoFilter,GbsrGenotypeData-method}
\title{Filter out markers based on marker quality metrics}
\usage{
setInfoFilter(
  object,
  mq = 0,
  fs = Inf,
  qd = 0,
  sor = Inf,
  mqranksum = c(-Inf, Inf),
  readposranksum = c(-Inf, Inf),
  baseqranksum = c(-Inf, Inf),
  ...
)

\S4method{setInfoFilter}{GbsrGenotypeData}(object, mq, fs, qd, sor, mqranksum, readposranksum, baseqranksum)
}
\arguments{
\item{object}{A \link{GbsrGenotypeData} object.}

\item{mq}{A numeric value to specify minimum mapping
quality (shown as MQ in the VCF format).}

\item{fs}{A numeric value to specify maximum Phred-scaled
p-value (strand bias) (shown as FS in the VCF format).}

\item{qd}{A numeric value to specify minimum Variant
Quality by Depth (shown as QD in the VCF format).}

\item{sor}{A numeric value to specify maximum
Symmetric Odds Ratio (strand bias) (shown as SOR in the VCF format).}

\item{mqranksum}{A numeric values to specify the lower
and upper limit of Alt vs. Ref read mapping
qualities (shown as MQRankSum in the VCF format).}

\item{readposranksum}{A numeric values to specify the lower
and upper limit of Alt vs. Ref read position
bias (shown as ReadPosRankSum in the VCF format).}

\item{baseqranksum}{A numeric values to specify the lower
and upper limit of Alt Vs. Ref base
qualities (shown as BaseQRankSum in the VCF format).}

\item{...}{Unused.}
}
\value{
A \link{GbsrGenotypeData} object with filters on markers.
}
\description{
A VCF file usually has marker quality metrics in
the INFO filed and those are stored in
a GDS file created via \link{GBScleanR}. This function filter
out markers based on those marker
quality metrics.
}
\details{
Detailed explanation of each metric can be found
in \href{https://gatk.broadinstitute.org/hc/en-us}{GATK's web site}.
}
\examples{
# Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
gds <- loadGDS(gds_fn)

gds <- setInfoFilter(gds, mq = 40, qd = 20)

# Close the connection to the GDS file.
closeGDS(gds)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/Methods-GbsrGenotypeData.R
\name{nsam}
\alias{nsam}
\alias{nsam,GbsrGenotypeData-method}
\title{Return the number of samples.}
\usage{
nsam(object, valid = TRUE, parents = FALSE, ...)

\S4method{nsam}{GbsrGenotypeData}(object, valid, parents)
}
\arguments{
\item{object}{A \link{GbsrGenotypeData} object.}

\item{valid}{A logical value. See details.}

\item{parents}{A logical value whether to include to parental samples or not.}

\item{...}{Unused.}
}
\value{
An integer value to indicate the number of samples.
}
\description{
This function returns the number of samples recorded in the GDS file
connected to the given \link{GbsrGenotypeData} object.
}
\details{
If \code{valid = TRUE}, the number of the samples which are labeled \code{TRUE}
in the "valid" column of the "sample" slot will be returned. If you need
the number of over all samples, set \code{valid = FALSE}.
\code{\link[=validSam]{validSam()}} tells you which samples are valid.
}
\examples{
# Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
gds <- loadGDS(gds_fn)

nsam(gds)

# Close the connection to the GDS file.
closeGDS(gds)

}
\seealso{
\code{\link[=validSam]{validSam()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/Methods-GbsrGenotypeData.R
\name{resetSamFilter}
\alias{resetSamFilter}
\alias{resetSamFilter,GbsrGenotypeData-method}
\title{Reset the filter made by \code{\link[=setSamFilter]{setSamFilter()}}}
\usage{
resetSamFilter(object, ...)

\S4method{resetSamFilter}{GbsrGenotypeData}(object)
}
\arguments{
\item{object}{A \link{GbsrGenotypeData} object.}

\item{...}{Unused.}
}
\value{
A \link{GbsrGenotypeData} object after removing
all filters on samples.
}
\description{
Remove "invalid" labels put on samples and make all samples valid.
}
\examples{
# Create a GDS file from a sample VCF file.
vcf_fn <- system.file("extdata", "sample.vcf", package = "GBScleanR")
gds_fn <- tempfile("sample", fileext = ".gds")
gbsrVCF2GDS(vcf_fn = vcf_fn, out_fn = gds_fn, force = TRUE)

# Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
gds <- loadGDS(gds_fn)

# Summarize the information needed for filtering.
gds <- countGenotype(gds)
gds <- countRead(gds)

gds <- setSamFilter(gds,
                       id = getSamID(gds)[1:10],
                       missing = 0.2,
                       dp = c(5, Inf))

# Reset all filters applied above.
gds <- resetSamFilter(gds)

# Close the connection to the GDS file
closeGDS(gds)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/GBScleanR.R
\docType{package}
\name{GBScleanR}
\alias{GBScleanR-package}
\alias{GBScleanR}
\title{GBScleanR: A package to conduct error correction for noisy genotyping by
sequencing (reduced representation sequencing based genotyoing) data.}
\description{
GBScleanR is a package for quality check, filtering, and error correction of
genotype data derived from next generation sequcener (NGS) based genotyping
platforms. GBScleanR takes Variant Call Format (VCF) file as input. The main
function of this package is "clean.geno" which estimates the true genotypes
of samples from given read counts for genotype markers using a hidden Markov
model with incorporating uneven observation ratio of allelic reads. This
implementation gives robust genotype estimation even in noisy genotype data
usually observed in Genotyping-By-Sequnencing (GBS) and similar methods, e.g.
RADseq. GBScleanR currenly only supports genotype data of
biparental populations.
}
\seealso{
Useful links:
\itemize{
  \item \url{https://github.com/tomoyukif/GBScleanR}
  \item Report bugs at \url{https://github.com/tomoyukif/GBScleanR/issues}
}

}
\author{
\strong{Maintainer}: Tomoyuki Furuta \email{f.tomoyuki@okayama-u.ac.jp} (\href{https://orcid.org/0000-0002-0869-6626}{ORCID})

}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/Methods-GbsrGenotypeData.R
\name{validMar}
\alias{validMar}
\alias{validMar<-}
\alias{validMar,GbsrGenotypeData-method}
\alias{validMar<-,GbsrGenotypeData-method}
\title{Return a logical vector indicating which are valid SNP markers.}
\usage{
validMar(object, chr = NULL, ...)

validMar(object) <- value

\S4method{validMar}{GbsrGenotypeData}(object, chr)

\S4method{validMar}{GbsrGenotypeData}(object) <- value
}
\arguments{
\item{object}{A \link{GbsrGenotypeData} object.}

\item{chr}{A index to spefcify chromosome to get information.}

\item{...}{Unused.}

\item{value}{A logical vector indicating valid markers with the length
matching with the number of markers.}
}
\value{
A logical vector of the same length with
the number of total SNP markers
}
\description{
Return a logical vector indicating which are valid SNP markers.
}
\examples{
# Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
gds <- loadGDS(gds_fn)

validMar(gds)

# Close the connection to the GDS file.
closeGDS(gds)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllClasses.R
\docType{class}
\name{GbsrScheme-class}
\alias{GbsrScheme-class}
\alias{GbsrScheme}
\title{Class \code{GbsrScheme}}
\description{
\link{GBScleanR} uses breeding scheme information to set the expected
number of cross overs in a chromosome which is a required parameter
for the genotype error correction with the hidden Markov model
implemented in the \code{\link[=estGeno]{estGeno()}} function. This class stores those
information including ID of parental samples, type crosses
performed at each generation of breeding and population
sizes of each generation. This class is not exported.
}
\section{Slots}{

\describe{
\item{\code{crosstype}}{A vector of strings indicating the type of
crossing done at each generation.}

\item{\code{mating}}{A list of matrices showing combinations member
IDs of samples mated.}

\item{\code{parents}}{A vector of member IDs of parents.}

\item{\code{progenies}}{A vector of memeber IDs of progenies produced
at each generation.}

\item{\code{samples}}{A vector of member IDs of samples indicating which samples are
derived from which pedigrees.}
}}

\examples{
# [loadGDS()] initialize a `GbsrScheme` object internally and
# attache it to the shceme slot of a [GbsrGenotypeData] object.

# Load data in the GDS file and instantiate
# a [GbsrGenotypeData] object.
gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
gds <- loadGDS(gds_fn)

# Print the information stored in the `GbsrScheme` object.
showScheme(gds)

# Close the connection to the GDS file.
closeGDS(gds)

}
\seealso{
\link{GbsrGenotypeData} dnd \code{\link[=loadGDS]{loadGDS()}}.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/Methods-GbsrGenotypeData.R
\name{gbsrGDS2CSV}
\alias{gbsrGDS2CSV}
\alias{gbsrGDS2CSV,GbsrGenotypeData-method}
\title{Write a CSV file based on data in a GDS file}
\usage{
gbsrGDS2CSV(
  object,
  out_fn,
  node = "raw",
  incl_parents = TRUE,
  bp2cm = NULL,
  format = "",
  read = FALSE,
  ...
)

\S4method{gbsrGDS2CSV}{GbsrGenotypeData}(object, out_fn, node, incl_parents, bp2cm, format, read)
}
\arguments{
\item{object}{A \link{GbsrGenotypeData} object.}

\item{out_fn}{A string to specify the path to an output VCF file.}

\item{node}{Either one of "raw", "filt", "cor", "hap", "dosage to output raw
genotype data, filtered genotype data, corrected genotype data, estimated
haplotype data, and estimated allele dosage data, respectively.}

\item{incl_parents}{A logical value to specify whether parental
samples should be included in an output VCF file or not.}

\item{bp2cm}{A numeric value to convert positions in basepairs (bp) to
centiMorgan (cm). The specified here is used to multiply position values. The
default is NULL and then internally sets \code{bp2cm = 4e-06} when
\verb{format = "qtl}. If not \verb{format = "qtl}, 1 is set to \code{bp2cm} as default.}

\item{format}{A string to indicate the output format. See details.}

\item{read}{A logical value to indicate whether read counts should be output
with genotype data or not. See details.}

\item{...}{Unused.}
}
\value{
The path to the CSV file.
}
\description{
Write out a CSV file with raw, filtered, corrected genotype data or
estimated haplotype data
stored in a GDS file.
}
\details{
Create a CSV file at location specified by out_fn. The setting
\code{format = "qtl"} makes the function export the data in the r/qtl format
that can be loaded using read.cross as \code{format = "csvs"} with a phenotype
data. If you have executed \code{\link[=estGeno]{estGeno()}} and your population is a biparental
population, set 'node = "dosage"' to export a r/qtl format CSV in which
homozygoutes of the alleles of Parent 1 and 2, which have been specified by
\code{\link[=setParents]{setParents()}}, are represented by A and B, respectively. If 'node = "raw"',
'node = "fill"', and 'node = "cor"', A and B in the r/qtl format CSV indicate
homozygoutes of reference and alternative alleles shown in a given VCF file.
This means that if Parent 1 has the alternative allele homozygoute at
Marker 1 and Offspring 1 has the same genotype with Parent 1, the genotype of
Offspring 1 at Marker 1 will be B in the r/qtl format CSV. On the other hand,
if you set 'node = "dosage"', the genotype of Offspring 1 at Marker 1 will be
A in the r/qtl format CSV.
The output CSV file has the rows indicating chromosome ID and positions
of markers followed by the rows indicating genotype or haplotype data of
samples.
If \code{read = TRUE}, the output of each genotype call would be in
the form of \verb{GT:ADR,ADA} where GT, ADR, and ADA represent genotype,
referenece read count, and alternative read count, respectively.
If \code{format = "qtl"}, \code{read = TRUE} will be ignored.
}
\examples{
# Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
gds <- loadGDS(gds_fn)

# Create a CSV file with data from the GDS file
#  connected to the [GbsrGenotypeData] oobject.
out_fn <- tempfile("sample_out", fileext = ".csv")
gbsrGDS2CSV(gds, out_fn)

# Close the connection to the GDS file.
closeGDS(gds)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/Methods-GbsrGenotypeData.R,
%   R/Methods-GbsrScheme.R
\name{addScheme}
\alias{addScheme}
\alias{addScheme,GbsrGenotypeData-method}
\alias{addScheme,GbsrScheme-method}
\title{#' Build a \link{GbsrScheme} object}
\usage{
addScheme(object, crosstype, mating, ...)

\S4method{addScheme}{GbsrGenotypeData}(object, crosstype, mating)

\S4method{addScheme}{GbsrScheme}(object, crosstype, mating)
}
\arguments{
\item{object}{A \link{GbsrGenotypeData} object.}

\item{crosstype}{A string to indicate the type of
cross conducted with a given generation.}

\item{mating}{An integer matrix to indicate mating combinations.
The each element should match with member IDs of the last generation.}

\item{...}{Unused.}
}
\value{
A \link{GbsrGenotypeData} object storing
a \link{GbsrScheme} object in the "scheme" slot.
}
\description{
\link{GBScleanR} uses breeding scheme information to set the expected
number of cross overs in a chromosome which is a required parameter
for the genotype error correction with the Hidden Markov model
implemented in the \code{estGeno()} function.
This function build the object storing
type crosses performed at each generation of breeding and population sizes.
}
\details{
A scheme object is just a data.frame indicating a population size and
a type of cross applied to each generation of the breeding process
to generate the population which you are going to subject
to the \code{\link[=estGeno]{estGeno()}} function.
The \code{crosstype} can take either of "selfing", "sibling",
"pairing", and "random".
When you set \code{crosstype = "random"}, you need to
specify \code{pop_size} to indicate how many
individuals were crossed in the random mating.
You also need to specify a matrix indicating
combinations of \code{mating}, in which
each column shows a pair of member IDs indicating
parental samples of the cross.
Member IDs are serial numbers starts from 1 and
automatically assigned by
\code{\link[=initScheme]{initScheme()}} and \code{\link[=addScheme]{addScheme()}}. To check the member IDs,
run \code{\link[=showScheme]{showScheme()}}.
Please see the examples section for more details of
specifying a \code{mating} matrix.
The created \link{GbsrScheme} object is set in the \code{scheme}
slot of the \link{GbsrGenotypeData} object.
}
\examples{
# Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
gds <- loadGDS(gds_fn)

# Biparental F2 population.
gds <- setParents(gds, parents = c("Founder1", "Founder2"))

# setParents gave member ID 1 and 2 to Founder1 and Founder2, respectively.
gds <- initScheme(gds, mating = cbind(c(1:2)))

# Now the progenies of the cross above have member ID 3.
# If `crosstype = "selfing"` or `"sibling"`, you can omit a `mating` matrix.
gds <- addScheme(gds, crosstype = "self")

############################################################################
# Now you can execute `estGeno()` which requires a [GbsrScheme] object.

# Close the connection to the GDS file
closeGDS(gds)
}
\seealso{
\code{\link[=addScheme]{addScheme()}} and \code{\link[=showScheme]{showScheme()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/Methods-GbsrGenotypeData.R
\name{resetCallFilter}
\alias{resetCallFilter}
\alias{resetCallFilter,GbsrGenotypeData-method}
\title{Set the origina; data to be used in GBScleanR's functions}
\usage{
resetCallFilter(object, ...)

\S4method{resetCallFilter}{GbsrGenotypeData}(object)
}
\arguments{
\item{object}{A \link{GbsrGenotypeData} object.}

\item{...}{Unused.}
}
\value{
A \link{GbsrGenotypeData} object.
}
\description{
Set the "genotype" node and the "data" node
as primary nodes for genotype
data and read count data. The data stored
in the primary nodes are used in the
functions of GBScleanR.
}
\details{
A \link{GbsrGenotypeData} object storing information of
the primary node of genotype data and
read count data. All of the functions implemented
in \link{GBScleanR} check the primary nodes
and use data stored in those nodes.
\code{\link[=setCallFilter]{setCallFilter()}} create new nodes storing
filtered genotype calls and read counts in
a GDS file and change the primary nodes to
"filt.genotype" and "filt.data" for genotype and
read count data, respectively.
\code{\link[=resetCallFilter]{resetCallFilter()}} set back the nodes to
the original, those are "genotype" and "data" for
genotype and read count data, respectively.
}
\examples{
# Create a GDS file from a sample VCF file.
vcf_fn <- system.file("extdata", "sample.vcf", package = "GBScleanR")
gds_fn <- tempfile("sample", fileext = ".gds")
gbsrVCF2GDS(vcf_fn = vcf_fn, out_fn = gds_fn, force = TRUE)

# Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
gds <- loadGDS(gds_fn)

# Filter out set zero to read counts and
# missing to genotype calls of which meet the criteria.
gds <- setCallFilter(gds, dp_count = c(5, Inf))

# Now any functions of [GBScleanR] reference the genotype data
# stored in the "filt.genotype" node of the GDS file.

# If you need to set the "genotype" node, where store the raw genotype data
# as genotype to be referenced by the functions of GBScleanR,
# run the following.
gds <- resetCallFilter(gds)

# Reopening the connection to the GDS file also set the raw genotype again.
gds <- loadGDS(gds)

# Close the connection to the GDS file
closeGDS(gds)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/Methods-GbsrGenotypeData.R
\name{getHaplotype}
\alias{getHaplotype}
\alias{getHaplotype,GbsrGenotypeData-method}
\title{Get haplotype call data.}
\usage{
getHaplotype(object, parents = FALSE, valid = TRUE, chr = NULL, ...)

\S4method{getHaplotype}{GbsrGenotypeData}(object, parents, valid, chr)
}
\arguments{
\item{object}{A \link{GbsrGenotypeData} object.}

\item{parents}{A logical value or "only" to include data for
parents or to get data only for parents.}

\item{valid}{A logical value. See details.}

\item{chr}{A integer vector of indexes indicating chromosomes
to get read count data.}

\item{...}{Unused.}
}
\value{
An integer array of haplotype data. The array have 2 x M x N
dimensions, where M is the number of markers and N is the number of
samples. Each integer values represent the origin of the haplotype.
For example, in the population with two inbred founders, values take
either 1 or 2 indicating the hapotype descent from founder 1 and 2.
If two outbred founders, values take 1, 2, 3, or 4 indicating
the first and second haplotype in founder 1 and the first and
second haplotype in founder 2.
}
\description{
Haplotype calls are retrieved from the GDS file linked to the given
\link{GbsrGenotypeData} object.
}
\details{
Haplotype call data can be obtained from the "estimated.haplotype" node of
the GDS file which can be generated via the \code{\link[=estGeno]{estGeno()}} function.
Thus, this function is valid only after having executed \code{\link[=estGeno]{estGeno()}}.
If \code{valid = TRUE}, read counts for only valid marker and valid samples will
be obtained.
}
\examples{
# Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
gds <- loadGDS(gds_fn)

# Find the IDs of parental samples.
parents <- grep("Founder", getSamID(gds), value = TRUE)

# Set the parents and flip allele information
# if the reference sample (Founder1 in our case) has homozygous
# alternative genotype at some markers of which alleles will
# be swapped to make the reference sample have homozygous
# reference genotype.
gds <- setParents(gds, parents = parents)

# Initialize a scheme object stored in the slot of the GbsrGenotypeData.
# We chose `crosstype = "pair"` because two inbred founders were mated
# in our breeding scheme.
# We also need to specify the mating matrix which has two rows and
# one column with integers 1 and 2 indicating a sample (founder)
# with the memberID 1 and a sample (founder) with the memberID 2
# were mated.
gds <- initScheme(gds, mating = cbind(c(1:2)))

# Add information of the next cross conducted in our scheme.
# We chose 'crosstype = "selfing"', which do not require a
# mating matrix.
gds <- addScheme(gds, crosstype = "selfing")

# Execute error correction by estimating genotype and haplotype of
# founders and offspring.
gds <- estGeno(gds)

hap <- getHaplotype(gds)

# Close the connection to the GDS file.
closeGDS(gds)

}
\seealso{
\code{\link[=estGeno]{estGeno()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/Methods-GbsrGenotypeData.R
\name{gbsrGDS2VCF}
\alias{gbsrGDS2VCF}
\alias{gbsrGDS2VCF,GbsrGenotypeData-method}
\title{Write a VCF file based on data in a GDS file}
\usage{
gbsrGDS2VCF(
  object,
  out_fn,
  node = "raw",
  info.export = NULL,
  fmt.export = NULL,
  parents = TRUE,
  ...
)

\S4method{gbsrGDS2VCF}{GbsrGenotypeData}(object, out_fn, node, info.export, fmt.export, parents)
}
\arguments{
\item{object}{A \link{GbsrGenotypeData} object.}

\item{out_fn}{A string to specify the path to an output VCF file.}

\item{node}{Either one of "raw" or "cor" to output raw genotype data or
corrected genotype data, respectively.}

\item{info.export}{characters, the variable name(s) in the INFO node for
export; or NULL for all variables. If you specify \code{character(0)}, nothing
will be exported from the INFO node.}

\item{fmt.export}{characters, the variable name(s) in the FORMAT node for
import; or NULL for all variables. If you specify \code{character(0)}, nothing
will be exported from the FORMAT node, except for GT.}

\item{parents}{A logical value to specify whether parental
samples should be included in an output VCF file or not.}

\item{...}{Unused.}
}
\value{
The path to the VCF file.
}
\description{
Write out a VCF file with raw, filtered, or corrected genotype data
stored in a GDS file. The output VCF file contains the GT, AD, and DP fields.
}
\details{
Create a VCF file at location specified by out_fn.
The connection to the GDS file of the input \link{GbsrGenotypeData} object will be
automatically closed for internal file handling in this function. Please use
\code{\link[=reopenGDS]{reopenGDS()}} to open the connection again. If you use \code{\link[=loadGDS]{loadGDS()}}, summary
statistics and filtering information will be discarded.
}
\examples{
# Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
gds <- loadGDS(gds_fn)

# Create a VCF file with data from the GDS file
#  connected to the [GbsrGenotypeData] oobject.
out_fn <- tempfile("sample_out", fileext = ".vcf.gz")
# gbsrGDS2VCF(gds, out_fn)

# Close the connection to the GDS file.
closeGDS(gds)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/Methods-GbsrGenotypeData.R
\name{getMarID}
\alias{getMarID}
\alias{getMarID,GbsrGenotypeData-method}
\title{Obtain the marker IDs}
\usage{
getMarID(object, valid = TRUE, chr = NULL, ...)

\S4method{getMarID}{GbsrGenotypeData}(object, valid, chr)
}
\arguments{
\item{object}{A \link{GbsrGenotypeData} object.}

\item{valid}{A logical value. See details.}

\item{chr}{A index to specify chromosome to get information.}

\item{...}{Unused.}
}
\value{
A integer vector of marker IDs.
}
\description{
Obtain the marker IDs
}
\details{
If \code{valid = TRUE}, the IDs of markers which are labeled \code{TRUE} in the "valid"
column of the "marker" slot will be returned. If you need the number
of over all markers, set \code{valid = FALSE}. \code{\link[=validMar]{validMar()}} tells you
which markers are valid.
}
\examples{
# Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
gds <- loadGDS(gds_fn)

getMarID(gds)

# Close the connection to the GDS file.
closeGDS(gds)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/Methods-GbsrGenotypeData.R
\name{getPloidy}
\alias{getPloidy}
\alias{getPloidy,GbsrGenotypeData-method}
\title{Get ploidy}
\usage{
getPloidy(object, ...)

\S4method{getPloidy}{GbsrGenotypeData}(object)
}
\arguments{
\item{object}{A \link{GbsrGenotypeData} object.}

\item{...}{Unused.}
}
\value{
An integer value.
}
\description{
Get the ploidy of a given population in the input \link{GbsrGenotypeData} object.
}
\examples{
# Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
gds <- loadGDS(gds_fn)

ploidy <- getPloidy(gds)
print(ploidy)

# Close the connection to the GDS file.
closeGDS(gds)

}
\seealso{
\code{\link[=setPloidy]{setPloidy()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/Methods-GbsrGenotypeData.R
\name{setSamFilter}
\alias{setSamFilter}
\alias{setSamFilter,GbsrGenotypeData-method}
\title{Filter out samples}
\usage{
setSamFilter(
  object,
  id = NA_character_,
  missing = 1,
  het = c(0, 1),
  mac = 0,
  maf = 0,
  ad_ref = c(0, Inf),
  ad_alt = c(0, Inf),
  dp = c(0, Inf),
  mean_ref = c(0, Inf),
  mean_alt = c(0, Inf),
  sd_ref = Inf,
  sd_alt = Inf,
  ...
)

\S4method{setSamFilter}{GbsrGenotypeData}(
  object,
  id,
  missing,
  het,
  mac,
  maf,
  ad_ref,
  ad_alt,
  dp,
  mean_ref,
  mean_alt,
  sd_ref,
  sd_alt
)
}
\arguments{
\item{object}{A \link{GbsrGenotypeData} object.}

\item{id}{A vector of strings matching with sample ID which can
be retrieve by \code{getSamID()}. The samples with the specified IDs
will be filtered out.}

\item{missing}{A numeric value [0-1] to specify the maximum
missing genotype call rate per sample.}

\item{het}{A vector of two numeric values [0-1] to specify
the minimum and maximum heterozygous genotype call rate per sample.}

\item{mac}{A integer value to specify the minimum minor
allele count per sample.}

\item{maf}{A numeric value to specify the minimum minor
allele frequency per sample.}

\item{ad_ref}{A numeric vector with length two specifying lower
and upper limit of reference read counts per sample.}

\item{ad_alt}{A numeric vector with length two specifying lower
and upper limit of alternative read counts per sample.}

\item{dp}{A numeric vector with length two specifying lower
and upper limit of total read counts per sample.}

\item{mean_ref}{A numeric vector with length two specifying lower
and upper limit of mean of reference read counts per sample.}

\item{mean_alt}{A numeric vector with length two specifying lower
and upper limit of mean of alternative read counts per sample.}

\item{sd_ref}{A numeric value specifying the upper limit of
standard deviation of reference read counts per sample.}

\item{sd_alt}{A numeric value specifying the upper limit of
standard deviation of alternative read counts per sample.}

\item{...}{Unused.}
}
\value{
A \link{GbsrGenotypeData} object with filters on samples.
}
\description{
Search samples which do not meet the criteria and label them as "invalid".
}
\details{
For \code{mean_ref}, \code{mean_alt}, \code{sd_ref}, and \code{sd_alt},
this function calculate mean and standard deviation of reads
obtained at SNP markers of each sample. If a mean read counts
of a sample was smaller than the specified lower limit or larger
than the upper limit, this function labels the sample as "invalid".
In the case of \code{sd_ref} and \code{sd_alt}, standard deviations of read counts
of each sample are checked and the samples having
a larger standard deviation will be labeled as "invalid".
To check valid and invalid samples, run \code{\link[=validSam]{validSam()}}.
}
\examples{
# Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
gds <- loadGDS(gds_fn)

# Summarize the information needed for filtering.
gds <- countGenotype(gds)
gds <- countRead(gds)

gds <- setSamFilter(gds,
                       id = getSamID(gds)[1:10],
                       missing = 0.2,
                       dp = c(5, Inf))

# Close the connection to the GDS file.
closeGDS(gds)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllUtilities.R
\name{gbsrVCF2GDS}
\alias{gbsrVCF2GDS}
\title{Convert a VCF file to a GDS file}
\usage{
gbsrVCF2GDS(
  vcf_fn,
  out_fn,
  gt = "GT",
  info.import = NULL,
  fmt.import = NULL,
  force = FALSE,
  verbose = TRUE
)
}
\arguments{
\item{vcf_fn}{A string to indicate path to an input VCF file.}

\item{out_fn}{A string to indicate path to an output GDS file.}

\item{gt}{the ID for genotypic data in the FORMAT column; "GT" by default,
VCFv4.0.}

\item{info.import}{characters, the variable name(s) in the INFO field for
import; or NULL for all variables. If you specify \code{character(0)}, nothing
will be retrieved from the INFO filed.}

\item{fmt.import}{characters, the variable name(s) in the FORMAT field for
import; or NULL for all variables. If you specify \code{character(0)}, nothing
will be retrieved from the FORMAT filed, except for GT.}

\item{force}{A logical value to overwrite a GDS file even if
the file specified in "out_fn" exists.}

\item{verbose}{if TRUE, show information.}
}
\value{
The output GDS file path.
}
\description{
This function converts a variant call data in the VCF format.
The current implementation only accepts biallelic
single nucleotide polymorphisms.
Please filter out variants which are insertions and
deletions or multiallelic.
You may use "bcftools" or "vcftools" for filtering.
}
\details{
gbsrVCF2GDS converts a VCF file to a GDS file.
The data structure of the GDS file created via this functions is same with
those created by \code{\link[SeqArray]{seqVCF2GDS}} of \code{SeqArray}.
}
\examples{
# Create a GDS file from a sample VCF file.
vcf_fn <- system.file("extdata", "sample.vcf", package = "GBScleanR")
gds_fn <- tempfile("sample", fileext = ".gds")
gbsrVCF2GDS(vcf_fn = vcf_fn, out_fn = gds_fn, force = TRUE)

# Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
gds <- loadGDS(gds_fn)

# Close the connection to the GDS file.
closeGDS(gds)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllClasses.R
\docType{class}
\name{GbsrGenotypeData-class}
\alias{GbsrGenotypeData-class}
\alias{GbsrGenotypeData}
\title{Class \link{GbsrGenotypeData}}
\description{
The \link{GbsrGenotypeData} class is the main class of \link{GBScleanR} and
user work with this class object.
}
\details{
The \link{GbsrGenotypeData} class is an extention of \code{\link[SeqArray]{SeqVarGDSClass-class}} in the
\code{SeqArray} package to store summary data of genotypes and reads and a
\link{GbsrScheme} object that contains mating scheme information of the given
population..
The slots \code{marker} and \code{sample} store a \link{data.frame} object for variant-wise
and sample-wise summary information, respectively. The \code{scheme} slot holds a
\link{GbsrScheme} object. The function \code{\link[=loadGDS]{loadGDS()}} initialize the
\link{GbsrGenotypeData} class.
}
\section{Slots}{

\describe{
\item{\code{marker}}{A \link{data.frame} object.}

\item{\code{sample}}{A \link{data.frame} object.}

\item{\code{scheme}}{A \link{GbsrScheme} object.}
}}

\examples{
# [loadGDS()] initialize the [GbsrGenotypeData] object.

# Load a GDS file and instantiate a [GbsrGenotypeData] object.
gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
gds <- loadGDS(gds_fn)

# Close connection to the GDS file.
closeGDS(gds)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/Methods-GbsrGenotypeData.R,
%   R/Methods-GbsrScheme.R
\name{initScheme}
\alias{initScheme}
\alias{initScheme,GbsrGenotypeData-method}
\alias{initScheme,GbsrScheme-method}
\title{Build a \link{GbsrScheme} object}
\usage{
initScheme(object, mating, ...)

\S4method{initScheme}{GbsrGenotypeData}(object, mating)

\S4method{initScheme}{GbsrScheme}(object, mating, parents)
}
\arguments{
\item{object}{A \link{GbsrGenotypeData} object.}

\item{mating}{An integer matrix to indicate mating combinations.
The each element should match with IDs of
parental samples which are 1 to N. see Details.}

\item{...}{Unused.}

\item{parents}{Indices of parental lines.}
}
\value{
A \link{GbsrGenotypeData} object storing
a \link{GbsrScheme} object in the "scheme" slot.
}
\description{
\link{GBScleanR} uses breeding scheme information to set the expected
number of cross overs in a chromosome which is a required parameter
for the genotype error correction with the hidden Markov model
implemented in the \code{\link[=estGeno]{estGeno()}} function.
This function build the object storing
type crosses performed at each generation of breeding and population sizes.
}
\details{
A \link{GbsrScheme} object stores information of a population size,
mating combinations and
a type of cross applied to each generation of the breeding process
to generate the population which you are going to subject
to the \code{\link[=estGeno]{estGeno()}} function.
The first generation should be parents of the population.
It is supposed that
\code{\link[=setParents]{setParents()}} has been already executed and parents
are labeled in the
\link{GbsrGenotypeData} object. The number of parents
are automatically recognized.
The "crosstype" of the first generation can be
"pairing" or "random" with
\code{pop_size = N}, where N is the number of parents.
You need to specify a matrix indicating combinations
of \code{mating}, in which each column shows
a pair of parental samples. For example, if you have
only two parents, the \code{mating} matrix
is \code{mating = cbind(c(1:2))}. The indices used in the matrix
should match with the IDs labeled to parental samples by \code{\link[=setParents]{setParents()}}.
The created \link{GbsrScheme} object is set
in the \code{scheme} slot of the \link{GbsrGenotypeData} object.
}
\examples{
# Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
gds <- loadGDS(gds_fn)

# Biparental F2 population.
gds <- setParents(gds, parents = c("Founder1", "Founder2"))

# setParents gave member ID 1 and 2 to Founder1 and Founder2, respectively.
gds <- initScheme(gds, mating = cbind(c(1:2)))

# Now the progenies of the cross above have member ID 3.
# If `crosstype = "selfing"` or `"sibling"`, you can omit a `mating` matrix.
gds <- addScheme(gds, crosstype = "self")

# Now you can execute `estGeno()` which requires a [GbsrScheme] object.

# Close the connection to the GDS file
closeGDS(gds)

}
\seealso{
\code{\link[=addScheme]{addScheme()}} and \code{\link[=showScheme]{showScheme()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/PlotFunctions.R
\name{boxplotGBSR}
\alias{boxplotGBSR}
\title{Draw boxplots of specified statistics}
\usage{
boxplotGBSR(
  x,
  stats = "missing",
  target = c("marker", "sample"),
  color = c(Marker = "darkblue", Sample = "darkblue"),
  fill = c(Marker = "skyblue", Sample = "skyblue")
)
}
\arguments{
\item{x}{A \link{GbsrGenotypeData} object.}

\item{stats}{A string to specify statistics to be drawn.}

\item{target}{Either or both of "marker" and "sample", e.g. \code{target = "marker"}
to draw a histogram only for SNPs.}

\item{color}{A named vector "Marker" and "Sample" to specify
border color of bins in the histograms.}

\item{fill}{A named vector "Marker" and "Sample" to specify
fill color of bins in the histograms.}
}
\value{
A ggplot object.
}
\description{
Draw boxplots of specified statistics
}
\details{
You can draw boxplots of several summary statistics of genotype counts
and read counts per sample and per marker. The "stats" argument can take
the following values:

\describe{
\item{missing}{Proportion of missing genotype calls.}
\item{het}{Proportion of heterozygote calls.}
\item{raf}{Reference allele frequency.}
\item{dp}{Total read counts.}
\item{ad_ref}{Reference allele read counts.}
\item{ad_alt}{Alternative allele read counts.}
\item{rrf}{Reference allele read frequency.}
\item{mean_ref}{Mean of reference allele read counts.}
\item{sd_ref}{Standard deviation of reference allele read counts.}
\item{median_ref}{Quantile of reference allele read counts.}
\item{mean_alt}{Mean of alternative allele read counts.}
\item{sd_alt}{Standard deviation of alternative allele read counts.}
\item{median_alt}{Quantile of alternative allele read counts.}
\item{mq}{Mapping quality.}
\item{fs}{Phred-scaled p-value (strand bias)}
\item{qd}{Variant Quality by Depth}
\item{sor}{Symmetric Odds Ratio (strand bias)}
\item{mqranksum}{Alt vs. Ref read mapping qualities}
\item{readposranksum}{Alt vs. Ref read position bias}
\item{baseqranksum}{Alt Vs. Ref base qualities}
}

To draw boxplots for "missing", "het", "raf", you need to run
\code{\link[=countGenotype]{countGenotype()}} first to obtain statistics. Similary, "dp",
"ad_ref", "ad_alt", "rrf" requires values obtained via \code{\link[=countRead]{countRead()}}.
"mq", "fs", "qd", "sor", "mqranksum", "readposranksum",
and "baseqranksum" only work with \code{target = "marker"}, if your data
contains those values supplied via SNP calling tools like
\href{https://gatk.broadinstitute.org/hc/en-us}{GATK}.
}
\examples{
# Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
gds <- loadGDS(gds_fn)

# Summarize genotype count information to be used in `boxplotGBSR()`
gds <- countGenotype(gds)

boxplotGBSR(gds, stats = "missing")

# Close the connection to the GDS file
closeGDS(gds)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/Methods-GbsrGenotypeData.R
\name{thinMarker}
\alias{thinMarker}
\alias{thinMarker,GbsrGenotypeData-method}
\title{Remove markers potentially having redundant information.}
\usage{
thinMarker(object, range = 150, ...)

\S4method{thinMarker}{GbsrGenotypeData}(object, range)
}
\arguments{
\item{object}{A \link{GbsrGenotypeData} object.}

\item{range}{A integer value to indicate the stretch to search markers.}

\item{...}{Unused.}
}
\value{
A \link{GbsrGenotypeData} object with filters on markers.
}
\description{
Markers within the length of the sequenced reads
(usually ~ 150 bp, up to your sequencer)
potentially have redundant information and
those will cause unexpected errors
in error correction which assumes
independency of markers each other.
This function only retains the first marker or
the least missing rate marker
from the markers locating within the specified stretch.
}
\details{
This function search valid markers from the first marker
of each chromosome and
compare its physical position with a neighbor marker.
If the distance between those
markers are equal or less then \code{range}, one of them
which has a larger missing rate
will be removed (labeled as invalid marker).
When the first marker was retained and
the second marker was removed as invalid marker,
next the distance between the first marker
and the third marker will be checked and
this cycle is repeated until reaching the
end of each chromosome. Run \code{\link[=validMar]{validMar()}}
to check the valid SNP markers.
}
\examples{
# Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
gds <- loadGDS(gds_fn)

# Summarize genotype count information to be used in thinMarker().
gds <- countGenotype(gds)
gds <- thinMarker(gds, range = 150)

closeGDS(gds) # Close the connection to the GDS file
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/Methods-GbsrGenotypeData.R
\name{reopenGDS}
\alias{reopenGDS}
\alias{reopenGDS,GbsrGenotypeData-method}
\title{Reopen the connection to the GDS file.}
\usage{
reopenGDS(object, ...)

\S4method{reopenGDS}{GbsrGenotypeData}(object)
}
\arguments{
\item{object}{A \link{GbsrGenotypeData} object.}

\item{...}{Unused.}
}
\value{
A \link{GbsrGenotypeData} object.
}
\description{
Reopen the connection to the GDS file.
}
\details{
The GbsrGenotypeData object stores the file path of the GDS file
even after closing the connection the file. This function open again the
connection to the GDS file at the file path stored in the GbsrGenotypeData
object. If the GbsrGenotypeData object witch has an open connection to
the GDS file, this function will reopen the connection. The data stored in
the marker and sample slots will not be changed.
Thus, you can open a connection with the GDS file with keeping information
of filtering and summary statistics.
}
\examples{
# Use a GDS file of example data.
gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")

# Instantiation of [GbsrGenotypeData]
gds <- loadGDS(gds_fn)

# Close the connection to the GDS file
closeGDS(gds)

gds <- reopenGDS(gds)

# Close the connection to the GDS file
closeGDS(gds)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/Methods-GbsrGenotypeData.R
\name{setParents}
\alias{setParents}
\alias{setParents,GbsrGenotypeData-method}
\title{Set labels to samples which should be recognized as
parents of the population to be subjected to error correction.}
\usage{
setParents(object, parents, nonmiss = FALSE, mono = FALSE, bi = FALSE, ...)

\S4method{setParents}{GbsrGenotypeData}(object, parents, nonmiss, mono, bi)
}
\arguments{
\item{object}{A \link{GbsrGenotypeData} object.}

\item{parents}{A vector of strings with at least length two.
The specified strings should match with the samples
ID available via \code{\link[=getSamID]{getSamID()}}.}

\item{nonmiss}{A logical value whether to filter out markers which
are missing in parents.}

\item{mono}{A logical value whether to filter out markers which
are not monomorphic in parents.}

\item{bi}{A logical value whether to filter out marekrs which
are not biallelic between parents.}

\item{...}{Unused.}
}
\value{
A \link{GbsrGenotypeData} object with parents information.
}
\description{
Specify two or more samples in the dataset as parents
of the population. Markers will be filtered out up on your specification.
}
\details{
The \code{clean} function of \link{GBScleanR} uses read count information of
samples and their parents separately to estimate most probable
genotype calls of them. Therefore, you must specify proper samples
as parents via this function. If you would like to remove SNP markers
which are not biallelic and/or not monomorphic in each parent,
set \code{mono = TRUE} and \code{bi = TRUE}. The replicates of parental samples
specified to the \code{repliate} argument of \code{\link[=setParents]{setParents()}} will have the same
genotypes at all markers in the estimated genotypes obtained via \code{\link[=estGeno]{estGeno()}}.
In the genotype estimation by \code{\link[=estGeno]{estGeno()}}, the Viterbi scores for each
possible genotype at each marker for the replicates will be replaced with
the average score for the replicates.
}
\examples{
# Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
gds <- loadGDS(gds_fn)

# Find the IDs of parental samples.
parents <- grep("Founder", getSamID(gds), value = TRUE)

# Set the parents and flip allele information
# if the reference sample (Founder1 in our case) has homozygous
# alternative genotype at some markers of which alleles will
# be swapped to make the reference sample have homozygous
# reference genotype.
gds <- setParents(gds, parents = parents)

# Initialize a scheme object stored in the slot of the GbsrGenotypeData.
# We chose `crosstype = "pair"` because two inbred founders were mated
# in our breeding scheme.
# We also need to specify the mating matrix which has two rows and
# one column with integers 1 and 2 indicating a sample (founder)
# with the memberID 1 and a sample (founder) with the memberID 2
# were mated.
gds <- initScheme(gds, mating = cbind(c(1:2)))

# Add information of the next cross conducted in our scheme.
# We chose 'crosstype = "selfing"', which do not require a
# mating matrix.
gds <- addScheme(gds, crosstype = "selfing")

# Execute error correction by estimating genotype and haplotype of
# founders and offspring.
gds <- estGeno(gds)

# Close the connection to the GDS file.
closeGDS(gds)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/Methods-GbsrGenotypeData.R
\name{getReplicates}
\alias{getReplicates}
\alias{getReplicates,GbsrGenotypeData-method}
\title{Get identifiers to indicates which samples are replicates.}
\usage{
getReplicates(object, parents = FALSE, ...)

\S4method{getReplicates}{GbsrGenotypeData}(object, parents)
}
\arguments{
\item{object}{A \link{GbsrGenotypeData} object.}

\item{parents}{A logical value to indicate whether to include replicate IDs
for parental samples in the output. If you specify \code{parents = "only"}, this
function returns replicate IDs only for parental samples.}

\item{...}{Unused.}
}
\value{
A \link{GbsrGenotypeData} object with genotype count information.
}
\description{
Not implemented yet.
This function assign identifiers that indicates which samples are replicates
those which should have the same genotypes at all markers.
}
\details{
The replicates of samples specified in \code{\link[=setReplicates]{setReplicates()}} will have the same
genotypes at all markers in the estimated genotypes obtained via \code{\link[=estGeno]{estGeno()}}.
In the genotype estimation by \code{\link[=estGeno]{estGeno()}}, the Viterbi scores for each
possible genotype (haplotype) at each marker for the replicates will be
replaced with the average score for the replicates.
}
\examples{
# Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
gds <- loadGDS(gds_fn)

gds <- setParents(gds, parents = c("Founder1", "Founder2"))

# When your data has 100 samples, two replicates for each offspring,
# and the samples are ordered as the 1st replicate followed by the 2nd
# replicate, you can specify replicates as below.
# gds <- setReplicates(gds, replicates = rep(1:50, each = 2))

# If you need to confirm the order of samples, run the following code.
# id <- getSamID(gds)

# Replicate IDs should be set also to parents. Therefore, please include


# getReplicates(gds)

# Close the connection to the GDS file.
closeGDS(gds)

}
\seealso{
\code{\link[=setReplicates]{setReplicates()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/Methods-GbsrGenotypeData.R
\name{getCountRead}
\alias{getCountRead}
\alias{getCountRead,GbsrGenotypeData-method}
\title{Obtain total read counts per SNP or per sample}
\usage{
getCountRead(object, target = "marker", valid = TRUE, ...)

\S4method{getCountRead}{GbsrGenotypeData}(object, target, valid)
}
\arguments{
\item{object}{A \link{GbsrGenotypeData} object.}

\item{target}{Either of "marker" and "sample".}

\item{valid}{A logical value. See details.}

\item{...}{Unused.}
}
\value{
A integer vector of total read counts
(reference allele reads + alternative allele reads) per marker.
}
\description{
Obtain total read counts per SNP or per sample
}
\details{
You need to execute \code{\link[=countRead]{countRead()}} to calculate sumaary statisticsto be
obtained via this function.
If \code{valid = TRUE}, the chromosome information of markers which are
labeled \code{TRUE} in the \link{sample} slot will be returned.
\code{\link[=validMar]{validMar()}} tells you which samples are valid.
}
\examples{
# Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
gds <- loadGDS(gds_fn)
gds <- countRead(gds)

getCountRead(gds)

# Close the connection to the GDS file.
closeGDS(gds)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/Methods-GbsrGenotypeData.R
\name{getGenotype}
\alias{getGenotype}
\alias{getGenotype,GbsrGenotypeData-method}
\title{Get genotype call data.}
\usage{
getGenotype(
  object,
  node = "raw",
  parents = FALSE,
  valid = TRUE,
  chr = NULL,
  phased = FALSE,
  ...
)

\S4method{getGenotype}{GbsrGenotypeData}(object, node, parents, valid, chr, phased)
}
\arguments{
\item{object}{A \link{GbsrGenotypeData} object.}

\item{node}{Either of "raw", "filt", "cor", and "parents". See details.}

\item{parents}{A logical value or "only" whether to include data for
parents or not or to get data only for parents. Ignored if \verb{node = "parents}.}

\item{valid}{A logical value. See details.}

\item{chr}{A integer vector of indexes indicating chromosomes
to get read count data.}

\item{phased}{If set \code{TRUE} to \code{phased}, the function will return phased
genotype data in a P x N x M array where P, N, and M are the ploidy, number
of samples, and number of markers.}

\item{...}{Unused.}
}
\value{
An integer matrix of genotype data which is represented
by the number of alternative alleles at each marker of each sample.
}
\description{
Genotype calls are retrieved from the GDS file linked to the given
\link{GbsrGenotypeData} object.
}
\details{
When \verb{node = "raw}, the raw genotype data stored in the "genotype/data" node
will be returned, while \verb{node = "filt} make the function to return the
filtered genotype data stored in the "annotation/format/FGT/data" that can
be generated via the \code{\link[=setCallFilter]{setCallFilter()}} function. \verb{node = "cor} indicates to
get the corrected genotype data stored in the "annotation/format/CGT/data"
that can be generated via the \code{\link[=estGeno]{estGeno()}} function. The estimated parental
genotypes, which also can be generated via the \code{\link[=estGeno]{estGeno()}} function and
stored in the "annotation/info/PGT" node, can be obtained with
\code{node = "parents"}.
If \code{valid = TRUE}, genotype calls for only valid marker and valid samples
will be obtained.
}
\examples{
# Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
gds <- loadGDS(gds_fn)

geno <- getGenotype(gds)

# Close the connection to the GDS file.
closeGDS(gds)


}
\seealso{
\code{\link[=setCallFilter]{setCallFilter()}} and \code{\link[=estGeno]{estGeno()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/Methods-GbsrGenotypeData.R
\name{countRead}
\alias{countRead}
\alias{countRead,GbsrGenotypeData-method}
\title{Count reads per sample and per marker.}
\usage{
countRead(object, target = "both", node = "raw", ...)

\S4method{countRead}{GbsrGenotypeData}(object, target, node)
}
\arguments{
\item{object}{A \link{GbsrGenotypeData} object.}

\item{target}{Either of "marker" and "sample".}

\item{node}{Either of "raw" and "filt". See details.}

\item{...}{Unused.}
}
\value{
A \link{GbsrGenotypeData} object with read count information.
}
\description{
This function calculates several summary statistics of read counts
per marker and per sample. Those values will be stored
in the SnpAnnotaionDataFrame slot and the \link{sample} slot
and obtained via getter functions, e.g.
\code{\link[=getCountReadRef]{getCountReadRef()}} and \code{\link[=getCountReadAlt]{getCountReadAlt()}}.
This function first calculates normalized allele read counts by dividing
allele read counts at each marker in each sample by the total allele read
of the sample followed by multiplication by 10^6. In other words, it
calculates reads per million (rpm). Then, the function calculates
mean, standard deviation, quantile values of rpm per marker and per sample.
The results will be stored in the SnpAnnotaionDataFrame slot and the
\link{sample} slot and obtained via getter functions, e.g.
\code{\link[=getMeanReadRef]{getMeanReadRef()}} and \code{\link[=getMedianReadAlt]{getMedianReadAlt()}}.
}
\details{
Read count data can be obtained from the "annotation/format/AD/data" node
or the "annotation/format/AD/filt.data" node of the GDS file
with \code{node = "raw"} or \code{node = "filt"}, respectively.
The \code{\link[=setCallFilter]{setCallFilter()}} function generate filtered read count data
in the "annotation/format/AD/filt.data" node which can be accessed as
mentioned above.
}
\examples{
# Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
gds <- loadGDS(gds_fn)

# Summarize the read count information and store them in the
# [marker] and [sample] slots of the [GbsrGenotypeData] object.
gds <- countRead(gds)

# Get the total read counts per marker
read_depth_per_marker <- getCountRead(gds, target = "marker")

# Get the proportion of reference allele rads per marker.
reference_read_freq <- getCountReadRef(gds, target = "marker", prop = TRUE)

# Draw histgrams of reference allele read counts per sample and marker.
histGBSR(gds, stats = "ad_ref")

# Close the connection to the GDS file.
closeGDS(gds)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/PlotFunctions.R
\name{plotDosage}
\alias{plotDosage}
\title{Draw line plots of allele dosage per marker per sample.}
\usage{
plotDosage(
  x,
  coord = NULL,
  chr = NULL,
  ind = 1,
  node = "raw",
  showratio = TRUE,
  dot_fill = c("green", "darkblue"),
  size = 0.8,
  alpha = 0.8,
  line_color = "magenta"
)
}
\arguments{
\item{x}{A \link{GbsrGenotypeData} object.}

\item{coord}{A vector with two integer specifying the number of rows
and columns to draw faceted line plots for chromosomes.}

\item{chr}{A vector of indexes to specify chromosomes to be drawn.}

\item{ind}{An index to specify samples to be drawn.}

\item{node}{Either one of "raw" or "filt" to output raw read data, or filtered read data,
respectively.}

\item{showratio}{If \code{TRUE}, draw dots indicating read ratio.}

\item{dot_fill}{A vector of two strings to indicate the dot colors in the plot. The first and second elements of the vector are set as the colors for the lowest and highest values in the gradient coloring of the dots indicating total read counts par marker.}

\item{size}{A positive number to indicate the dot size in a plot.}

\item{alpha}{A positive number in 0-1 to indicate the dot opacity in a plot.}

\item{line_color}{A string to indicate the line color in the plot.}
}
\value{
A ggplot object.
}
\description{
This function counts a reference allele dosage per marker per sample and
draw line plots of them in facets for each chromosome for each sample.
}
\examples{
# Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
gds <- loadGDS(gds_fn)

plotDosage(gds, ind = 1)

# Close the connection to the GDS file
closeGDS(gds)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/Methods-GbsrGenotypeData.R
\name{getInfo}
\alias{getInfo}
\alias{getInfo,GbsrGenotypeData-method}
\title{Obtain information stored in the "annotation/info" node}
\usage{
getInfo(object, var, valid = TRUE, chr = NULL, ...)

\S4method{getInfo}{GbsrGenotypeData}(object, var, valid, chr)
}
\arguments{
\item{object}{A \link{GbsrGenotypeData} object.}

\item{var}{A string to indicate which annotation info should be retrieved.}

\item{valid}{A logical value. See details.}

\item{chr}{A index to specify chromosome to get information.}

\item{...}{Unused.}
}
\value{
A numeric vector of data stored in INFO node of the GDS file.
}
\description{
The "annotation/info" node stores annotation infromation of markers obtained
via SNP calling tools like bcftools and GATK.
}
\details{
If \code{valid = TRUE}, the information of the markers which are labeled \code{TRUE}
in the "valid" column of the "marker" slot will be returned. If you need the
number of over all markers, set \code{valid = FALSE}. \code{\link[=validMar]{validMar()}} tells you
which markers are valid.
}
\examples{
# Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
gds <- loadGDS(gds_fn)

# Get mapping qualities (MQ) of markers.
mq <- getInfo(gds, "MQ")

# Close the connection to the GDS file.
closeGDS(gds)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/PlotFunctions.R
\name{pairsGBSR}
\alias{pairsGBSR}
\title{Draw a scatter plot of a pair of specified statistics}
\usage{
pairsGBSR(
  x,
  stats1 = "dp",
  stats2 = "missing",
  target = "marker",
  size = 0.5,
  alpha = 0.8,
  color = c(Marker = "darkblue", Sample = "darkblue"),
  fill = c(Marker = "skyblue", Sample = "skyblue"),
  smooth = FALSE
)
}
\arguments{
\item{x}{A \link{GbsrGenotypeData} object.}

\item{stats1}{A string to specify statistics to be drawn.}

\item{stats2}{A string to specify statistics to be drawn.}

\item{target}{Either or both of "marker" and "sample", e.g.
\code{target = "marker"} to draw a histogram only for SNPs.}

\item{size}{A numeric value to specify the dot size of a scatter plot.}

\item{alpha}{A numeric value [0-1] to specify the transparency of
dots in a scatter plot.}

\item{color}{A named vector "Marker" and "Sample" to specify border
color of bins in the histograms.}

\item{fill}{A named vector "Marker" and "Sample" to specify fill color
of bins in the histograms.\verb{stats = "geno} only requires "Ref", "Het"
and "Alt", while others uses the value named "Marker".}

\item{smooth}{A logical value to indicate whether draw a smooth line for
data points. See also \code{\link[ggplot2:geom_smooth]{ggplot2::stat_smooth()}}.}
}
\value{
A ggplot object.
}
\description{
Draw a scatter plot of a pair of specified statistics
}
\details{
You can draw a scatter plot of per-marker and/or per-sample summary
statistics specified at \code{stats1} and \code{stats2}. The "stats1" and "stats2"
arguments can take the following values:
\describe{
\item{missing}{Proportion of missing genotype calls.}
\item{het}{Proportion of heterozygote calls.}
\item{raf}{Reference allele frequency.}
\item{dp}{Total read counts.}
\item{ad_ref}{Reference allele read counts.}
\item{ad_alt}{Alternative allele read counts.}
\item{rrf}{Reference allele read frequency.}
\item{mean_ref}{Mean of reference allele read counts.}
\item{sd_ref}{Standard deviation of reference allele read counts.}
\item{median_ref}{Quantile of reference allele read counts.}
\item{mean_alt}{Mean of alternative allele read counts.}
\item{sd_alt}{Standard deviation of alternative allele read counts.}
\item{median_alt}{Quantile of alternative allele read counts.}
\item{mq}{Mapping quality.}
\item{fs}{Phred-scaled p-value (strand bias)}
\item{qd}{Variant Quality by Depth}
\item{sor}{Symmetric Odds Ratio (strand bias)}
\item{mqranksum}{Alt vs. Ref read mapping qualities}
\item{readposranksum}{Alt vs. Ref read position bias}
\item{baseqranksum}{Alt Vs. Ref base qualities}
}

To draw scatter plots for "missing", "het", "raf", you need to run
\code{\link[=countGenotype]{countGenotype()}} first to obtain statistics. Similary, "dp",
"ad_ref", "ad_alt", "rrf" requires values obtained via \code{\link[=countRead]{countRead()}}.
"mq", "fs", "qd", "sor", "mqranksum", "readposranksum",
and "baseqranksum" only work with \code{target = "marker"}, if your data
contains those values supplied via SNP calling tools like
\href{https://gatk.broadinstitute.org/hc/en-us}{GATK}.
}
\examples{
# Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
gds <- loadGDS(gds_fn)

# Summarize genotype count information to be used in `pairsGBSR()`
gds <- countGenotype(gds)

# Draw scatter plots of missing rate vs heterozygosity.
pairsGBSR(gds, stats1 = "missing", stats2 = "het")

# Close the connection to the GDS file
closeGDS(gds)


}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/Methods-GbsrGenotypeData.R
\name{getRead}
\alias{getRead}
\alias{getRead,GbsrGenotypeData-method}
\title{Get read count data.}
\usage{
getRead(object, node = "raw", parents = FALSE, valid = TRUE, chr = NULL, ...)

\S4method{getRead}{GbsrGenotypeData}(object, node, parents, valid, chr)
}
\arguments{
\item{object}{A \link{GbsrGenotypeData} object.}

\item{node}{Either of "raw" and "filt". See details.}

\item{parents}{A logical value or "only" whether to include data for
parents or not or to get data only for parents.}

\item{valid}{A logical value. See details.}

\item{chr}{An integer vector of indexes indicating
chromosomes to get read count data.}

\item{...}{Unused.}
}
\value{
A named list with two elements "ref" and "alt" storing
a matrix of reference allele read counts and a matrix of
alternative read counts for all markers in all samples.
}
\description{
Read counts for reference allele and alternative allele are retrieved
from the GDS file linked to the given \link{GbsrGenotypeData} object.
}
\details{
When \verb{node = "raw}, the raw read counts stored in the
"annotation/format/AD/data" node will be returned, while \verb{node = "filt} make
the function to return the filtered read counts stored in the
"annotation/format/FAD/data" that can be generated via the \code{\link[=setCallFilter]{setCallFilter()}}
function.
If \code{valid = TRUE}, read counts for only valid marker and valid samples will
be obtained.
}
\examples{
# Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
gds <- loadGDS(gds_fn)

read <- getRead(gds)

# Close the connection to the GDS file.
closeGDS(gds)

}
\seealso{
\code{\link[=setCallFilter]{setCallFilter()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/Methods-GbsrGenotypeData.R
\name{getSDReadAlt}
\alias{getSDReadAlt}
\alias{getSDReadAlt,GbsrGenotypeData-method}
\title{Obtain standard deviations of total alternative read counts per
SNP or per sample}
\usage{
getSDReadAlt(object, target = "marker", valid = TRUE, ...)

\S4method{getSDReadAlt}{GbsrGenotypeData}(object, target, valid)
}
\arguments{
\item{object}{A \link{GbsrGenotypeData} object.}

\item{target}{Either of "marker" and "sample".}

\item{valid}{A logical value. See details.}

\item{...}{Unused.}
}
\value{
A numeric vector of the standard deviations of
alternative allele reads per marker.
}
\description{
Obtain standard deviations of total alternative read counts per
SNP or per sample
}
\details{
You need to execute \code{\link[=countRead]{countRead()}} to calculate sumaary statisticsto be
obtained via this function.
If \code{valid = TRUE}, the chromosome information of markers which are
labeled \code{TRUE} in the \link{sample} slot will be returned.
\code{\link[=validMar]{validMar()}} tells you which samples are valid.
}
\examples{
# Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
gds <- loadGDS(gds_fn)

# Calculate means, standard deviations, quantiles of read counts
# per marker and per sample with or without standardization of
# the counts and store them in the [marker] and [sample] slots
# of the [GbsrGenotypeData] object.
gds <- countRead(gds)

getSDReadAlt(gds)

# Close the connection to the GDS file.
closeGDS(gds)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/Methods-GbsrGenotypeData.R
\name{isOpenGDS}
\alias{isOpenGDS}
\alias{isOpenGDS,GbsrGenotypeData-method}
\title{Check if a GDS file has been opened or not.}
\usage{
isOpenGDS(object, ...)

\S4method{isOpenGDS}{GbsrGenotypeData}(object)
}
\arguments{
\item{object}{A \link{GbsrGenotypeData} object.}

\item{...}{Unused.}
}
\value{
\code{TRUE} if the GDS file linked to the input \link{GbsrGenotypeData} object
has been opened, while \code{FALSE} if closed.
}
\description{
Check if a GDS file has been opened or not.
}
\examples{
# Use a GDS file of example data.
gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")

# Instantiation of [GbsrGenotypeData]
gds <- loadGDS(gds_fn)

# Check connection to the GDS file
isOpenGDS(gds)

# Close the connection to the GDS file
closeGDS(gds)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/Methods-GbsrGenotypeData.R
\name{makeScheme}
\alias{makeScheme}
\alias{makeScheme,GbsrGenotypeData-method}
\title{Automate a \link{GbsrScheme} object building.}
\usage{
makeScheme(object, generation, crosstype, ...)

\S4method{makeScheme}{GbsrGenotypeData}(object, generation, crosstype)
}
\arguments{
\item{object}{A \link{GbsrGenotypeData} object.}

\item{generation}{An integer to indicate which generation of selfing or
sibling-crossing your population is.}

\item{crosstype}{A string to indicate the type of
cross conducted with a given generation.}

\item{...}{Unused.}
}
\value{
A \link{GbsrGenotypeData} object storing
a \link{GbsrScheme} object in the "scheme" slot.
}
\description{
\link{GBScleanR} uses breeding scheme information to set the expected
number of cross overs in a chromosome which is a required parameter
for the genotype error correction with the Hidden Markov model
implemented in the \code{estGeno()} function.
This function automates the building of a \link{GbsrScheme} object.
}
\details{
A scheme object is just a data.frame indicating a population size and
a type of cross applied to each generation of the breeding process
to generate the population which you are going to subject
to the \code{\link[=estGeno]{estGeno()}} function.
The \code{crosstype} specified to \code{\link[=makeScheme]{makeScheme()}} can take "selfing" and "sibling".
When your population has $2^n$ parents specified by \code{\link[=setParents]{setParents()}},
\code{\link[=makeScheme]{makeScheme()}} assumes those parents were crossed in the "funnel" design in
which $2^n$ parents are crossed to obtain $2^n/2$ F1 hybrids followed by
successive intercrossings (pairings) of the hybrids to combine the genomes
of all parents in one family of siblings. The \code{\link[=makeScheme]{makeScheme()}} function assumes
that the parents that were assigned an odd number member ID (N) in
\code{\link[=setParents]{setParents()}} had been crossed with the parent that were assigned an even
number (N+1). For example, if you set parents as shown below. The
\code{\link[=makeScheme]{makeScheme()}} function prepare a scheme information that indicates the
intercrossings of "p1 x p2", "p3 x p4", "p5 x p6", and "p7 x p8" followed by
crossing of "p1xp2_F1 x p3xp4_F1" and "p5xp6_F1 x p7xp8_F1" and then crossing
of the two 4-way crossed liens to produce 8-way crossed hybrid lines. If,
for example, \code{generation = 5} indicating an F5 generation was specified to
\code{\link[=makeScheme]{makeScheme()}}, the function adds 4 successive selfing or sibling crossings
in the scheme. The created \link{GbsrScheme} object will be set in the \code{scheme}
slot of the \link{GbsrGenotypeData} object.
}
\examples{
# Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
gds <- loadGDS(gds_fn)

# Biparental F2 population.
gds <- setParents(gds, parents = c("Founder1", "Founder2"))

gds <- makeScheme(gds, generation = 2, crosstype = "self")

############################################################################
# Now you can execute `estGeno()` which requires a [GbsrScheme] object.

# Close the connection to the GDS file
closeGDS(gds)
}
\seealso{
\code{\link[=initScheme]{initScheme()}}, \code{\link[=addScheme]{addScheme()}}, and \code{\link[=showScheme]{showScheme()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/Methods-GbsrGenotypeData.R
\name{resetMarFilter}
\alias{resetMarFilter}
\alias{resetMarFilter,GbsrGenotypeData-method}
\title{Reset the filter made by \code{\link[=setMarFilter]{setMarFilter()}}}
\usage{
resetMarFilter(object, ...)

\S4method{resetMarFilter}{GbsrGenotypeData}(object)
}
\arguments{
\item{object}{A \link{GbsrGenotypeData} object.}

\item{...}{Unused.}
}
\value{
A \link{GbsrGenotypeData} object after removing all filters on markers.
}
\description{
Remove "invalid" labels put on markers and make all markers valid.
}
\examples{
# Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
gds <- loadGDS(gds_fn)

# Check the number of markers.
nmar(gds)

# Summarize the information needed for filtering.
gds <- countGenotype(gds)
gds <- countRead(gds)

# filter out some markers meeting the criteria.
gds <- setMarFilter(gds,
                      id = getMarID(gds)[1:100],
                      missing = 0.2,
                      dp = c(5, Inf))

# Check the number of the retained markers.
nmar(gds)

# Reset all filters applied above.
gds <- resetMarFilter(gds)

# Check the number of the markers again.
nmar(gds)

# Close the connection to the GDS file.
closeGDS(gds)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/Methods-GbsrGenotypeData.R
\name{getParents}
\alias{getParents}
\alias{getParents,GbsrGenotypeData-method}
\title{Get parental sample information}
\usage{
getParents(object, bool = FALSE, verbose = TRUE, ...)

\S4method{getParents}{GbsrGenotypeData}(object, bool, verbose = TRUE)
}
\arguments{
\item{object}{A \link{GbsrGenotypeData} object.}

\item{bool}{If TRUE, the function returns a logical vector indicating
which samples have been set as parents.}

\item{verbose}{If FALSE, the function does not print a warning message even
when parents were not specified in the given \link{GbsrGenotypeData} object. The
setting \code{verbose = FALSE} is used in the other functions to call
\code{getParents()} without evoking unnecessary warnings to users.}

\item{...}{Unused.}
}
\value{
A data frame of parents information indicating sampleIDs, memberIDs
and indexes of parental lines assigned via \code{\link[=setParents]{setParents()}}.
}
\description{
This function returns sample IDs, member IDs and indexes of parental samples
set via \code{\link[=setParents]{setParents()}}. Sample IDs are IDs given by user or obtained from the
original VCF file. Member IDs are serial numbers assigned by \code{\link[=setParents]{setParents()}}.
}
\examples{
# Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
gds <- loadGDS(gds_fn)

# Find the IDs of parental samples.
parents <- grep("Founder", getSamID(gds), value = TRUE)

# Set the parents.
gds <- setParents(gds, parents = parents)

# Get the information of parents.
getParents(gds)

# Close the connection to the GDS file.
closeGDS(gds)


}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/Methods-GbsrGenotypeData.R
\name{closeGDS}
\alias{closeGDS}
\alias{closeGDS,GbsrGenotypeData-method}
\title{Close the connection to the GDS file}
\usage{
closeGDS(object, save_filter = FALSE, verbose = TRUE, ...)

\S4method{closeGDS}{GbsrGenotypeData}(object, save_filter, verbose)
}
\arguments{
\item{object}{A \link{GbsrGenotypeData} object.}

\item{save_filter}{A logical whether to save the filtering information made
via \code{\link[=setSamFilter]{setSamFilter()}} and \code{\link[=setMarFilter]{setMarFilter()}} in the GDS file. The saved
filter information can be reused if set \code{load_filter = TRUE} for
\code{\link[=loadGDS]{loadGDS()}}.}

\item{verbose}{if TRUE, show information.}

\item{...}{Unused.}
}
\value{
NULL.
}
\description{
Close the connection to the GDS file linked to the given
\link{GbsrGenotypeData} object.
}
\examples{
# Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
gds <- loadGDS(gds_fn)

# Close the connection to the GDS file
closeGDS(gds)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/Methods-GbsrGenotypeData.R
\name{resetFilter}
\alias{resetFilter}
\alias{resetFilter,GbsrGenotypeData-method}
\title{Reset all filters made by \code{\link[=setSamFilter]{setSamFilter()}}, \code{\link[=setMarFilter]{setMarFilter()}},
and \code{\link[=setCallFilter]{setCallFilter()}}.}
\usage{
resetFilter(object, ...)

\S4method{resetFilter}{GbsrGenotypeData}(object)
}
\arguments{
\item{object}{A \link{GbsrGenotypeData} object.}

\item{...}{Unused.}
}
\value{
A \link{GbsrGenotypeData} object after removing all filters.

A \link{GbsrGenotypeData} object after removing all filters on markers.
}
\description{
Return all data intact.
}
\examples{
# Create a GDS file from a sample VCF file.
vcf_fn <- system.file("extdata", "sample.vcf", package = "GBScleanR")
gds_fn <- tempfile("sample", fileext = ".gds")
gbsrVCF2GDS(vcf_fn = vcf_fn, out_fn = gds_fn, force = TRUE)

# Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
gds <- loadGDS(gds_fn)

# `setCallFilter()` do not require summarized information of
# genotype counts and read counts.
gds <- setCallFilter(gds, dp_count = c(5, Inf))

# `setSamFilter()` and `setMarFilter()` needs information of
# the genotype count summary and the read count summary.
gds <- countGenotype(gds)
gds <- countRead(gds)

gds <- setSamFilter(gds,
                       id = getSamID(gds)[1:10],
                       missing = 0.2,
                       dp = c(5, Inf))

gds <- setMarFilter(gds,
                      id = getMarID(gds)[1:100],
                      missing = 0.2,
                      dp = c(5, Inf))

gds <- setInfoFilter(gds, mq = 40, qd = 20)

# Reset all filters applied above.
gds <- resetFilter(gds)

# Close the connection to the GDS file.
closeGDS(gds)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/Methods-GbsrGenotypeData.R
\name{setPloidy}
\alias{setPloidy}
\alias{setPloidy,GbsrGenotypeData-method}
\title{Set ploidy}
\usage{
setPloidy(object, ploidy = 2, ...)

\S4method{setPloidy}{GbsrGenotypeData}(object, ploidy = 2)
}
\arguments{
\item{object}{A \link{GbsrGenotypeData} object.}

\item{ploidy}{A integer value to specify the ploidy of the given population.}

\item{...}{Unused.}
}
\value{
A \link{GbsrGenotypeData} object with filters on markers.
}
\description{
Set the ploidy of a given population in the input \link{GbsrGenotypeData} object.
}
\details{
The genotype estimation by \code{\link[=estGeno]{estGeno()}} would be performed with the assumption
of the ploidy specified through this function or the \code{ploidy} argument of
\code{\link[=loadGDS]{loadGDS()}}.
When an odd number was specified as \code{ploidy}, the ploidy of intermediate
generations would be treated as \code{ploidy} + 1 to properly list up possible
descendent haplotype patterns in the process by \code{\link[=estGeno]{estGeno()}}.
}
\examples{
# Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
gds <- loadGDS(gds_fn)

gds <- setPloidy(gds, ploidy = 4)

# Close the connection to the GDS file.
closeGDS(gds)

}
\seealso{
\code{\link[=getPloidy]{getPloidy()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/Methods-GbsrGenotypeData.R,
%   R/Methods-GbsrScheme.R
\name{showScheme}
\alias{showScheme}
\alias{showScheme,GbsrGenotypeData-method}
\alias{showScheme,GbsrScheme-method}
\title{Show the information stored in a \link{GbsrScheme} object}
\usage{
showScheme(object, ...)

\S4method{showScheme}{GbsrGenotypeData}(object)

\S4method{showScheme}{GbsrScheme}(object, parents_name, pedigree)
}
\arguments{
\item{object}{A \link{GbsrGenotypeData} object.}

\item{...}{Unused.}

\item{parents_name}{A vector of strings to indicate names
of parental samples. This argument is used internally by showScheme()
for the gbsrGenotypeData object.}

\item{pedigree}{A integer vector indicating the member
ID assignment to samples. This argument is used internally by
showScheme() for the gbsrGenotypeData object.}
}
\value{
NULL. Print the scheme information on the R console.
}
\description{
Print the information of each generation in
a \link{GbsrScheme} object in the scheme
slot of a \link{GbsrGenotypeData} object.
A \link{GbsrScheme} object stores information of a population size,
mating combinations and
a type of cross applied to each generation of the breeding process
to generate the population which you are going to
subject to the \code{estGeno()} function.
}
\examples{
# Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
gds <- loadGDS(gds_fn)

# Biparental F2 population.
gds <- setParents(gds, parents = c("Founder1", "Founder2"))

# setParents gave member ID 1 and 2 to Founder1 and Founder2, respectively.
gds <- initScheme(gds, mating = cbind(c(1:2)))

# Now the progenies of the cross above have member ID 3.
# If `crosstype = "selfing"` or `"sibling"`, you can omit a `mating` matrix.
gds <- addScheme(gds, crosstype = "self")

# Now you can execute `estGeno()` which requires a [GbsrScheme] object.

# Close the connection to the GDS file
closeGDS(gds)

}
\seealso{
\code{\link[=initScheme]{initScheme()}} and \code{\link[=addScheme]{addScheme()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/Methods-GbsrGenotypeData_HMM.R
\name{estGeno}
\alias{estGeno}
\alias{estGeno,GbsrGenotypeData-method}
\title{Genotype estimation using a hiden Morkov model}
\usage{
estGeno(
  object,
  node = "raw",
  recomb_rate = 0.04,
  error_rate = 0.0025,
  call_threshold = 0.9,
  het_parent = FALSE,
  optim = TRUE,
  iter = 4,
  n_threads = 1,
  dummy_reads = 5,
  ...
)

\S4method{estGeno}{GbsrGenotypeData}(
  object,
  node,
  recomb_rate,
  error_rate,
  call_threshold,
  het_parent,
  optim,
  iter,
  n_threads,
  dummy_reads
)
}
\arguments{
\item{object}{A \link{GbsrGenotypeData} object.}

\item{node}{Either "raw" or "filt" to indicate whether raw or filtered read
counts are used for genotype estimation. See \code{\link[=setCallFilter]{setCallFilter()}} for the
details of filtered read counts.}

\item{recomb_rate}{A numeric value to indicate the expected
recombination frequency per chromosome per megabase pairs.}

\item{error_rate}{A numeric value of the expected sequence error rate.}

\item{call_threshold}{A numeric value of the probability threshold
to accept estimated genotype calls.}

\item{het_parent}{A logical value to indicate whether parental
samples are outbred or inbred. If FALSE, this function assume all
true genotype of markers in parents are homozygotes.}

\item{optim}{A logical value to specify whether to
conduct parameter optimization for
error correction.}

\item{iter}{An integer value to specify the number of
iterative parameter updates.}

\item{n_threads}{An integer value to specify the number of
threads used for the calculation. The default is 1 and if \code{n_threads = NULL},
automatically set half the number of available threads on the computer.}

\item{dummy_reads}{An integer to specify the number of dummy reads to assign
to dummy parental samples for genotype estimation. See details.}

\item{...}{Unused.}
}
\value{
A \link{GbsrGenotypeData} object in which the "estimated.haplotype",
"corrected.genotype" and
"parents.genotype" nodes were added.
}
\description{
Clean up genotype data by error correction based on
genotype estimation using a hidden Markov model.
}
\details{
If you have not set parental samples by \code{\link[=setParents]{setParents()}} and
initialized the scheme object using \code{\link[=initScheme]{initScheme()}}, you have the scheme
object without explicit parental information that is assumed to be a
bi-parental population. In this case, \code{\link[=estGeno]{estGeno()}} will run in the parentless
mode. In the parentless mode, the algorithm assumes that the given population
is a bi-parental population. The number of reference allele reads and
the number of alternative allele reads of the dummy parents are set based on
\code{dummy_reads}, respectively. Dummy parent 1 has \code{dummy_reads} of the
reference allele reads and 0 alternative allele reads at all markers, while
dummy parent 2 has 0 and \code{dummy_reads} of reference and alternative allele
reads at all markers. If the parents of your population were outbred lines or
you cannot assume one of the parents has completely reference homozygotes and
another has laternative homozygotes at all markers, Set \code{dummy_reads = 0} to
leave uncertainty to estimate parental genotypes based on the offspring
genotypes. Nevertheless, the parentless mode is less accurate and has more
chance to get a genotype estimate randomly selected from the equally likely
genotype estimates.
}
\examples{
# Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
gds <- loadGDS(gds_fn)

# Find the IDs of parental samples.
parents <- grep("Founder", getSamID(gds), value = TRUE)

# Set the parents and flip allele information
# if the reference sample (Founder1 in our case) has homozygous
# alternative genotype at some markers of which alleles will
# be swapped to make the reference sample have homozygous
# reference genotype.
gds <- setParents(gds, parents = parents)

# Initialize a scheme object stored in the slot of the GbsrGenotypeData.
# We chose `crosstype = "pair"` because two inbred founders were mated
# in our breeding scheme.
# We also need to specify the mating matrix which has two rows and
# one column with integers 1 and 2 indicating a sample (founder)
# with the memberID 1 and a sample (founder) with the memberID 2
# were mated.
gds <- initScheme(gds, mating = cbind(c(1:2)))

# Add information of the next cross conducted in our scheme.
# We chose 'crosstype = "selfing"', which do not require a
# mating matrix.
gds <- addScheme(gds, crosstype = "selfing")

# Execute error correction by estimating genotype and haplotype of
# founders and offspring.
gds <- estGeno(gds)

# Close the connection to the GDS file.
closeGDS(gds)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/Methods-GbsrGenotypeData.R
\name{countGenotype}
\alias{countGenotype}
\alias{countGenotype,GbsrGenotypeData-method}
\title{Count genotype calls and alleles per sample and per marker.}
\usage{
countGenotype(object, target = "both", node = "raw", ...)

\S4method{countGenotype}{GbsrGenotypeData}(object, target, node)
}
\arguments{
\item{object}{A \link{GbsrGenotypeData} object.}

\item{target}{Either of "marker" and "sample".}

\item{node}{Either of "raw", "filt", and "cor". See details.}

\item{...}{Unused.}
}
\value{
A \link{GbsrGenotypeData} object with genotype count information.
}
\description{
This function calculates several summary statistics of
genotype calls and alleles per marker and per sample.
Those values will be stored in the SnpAnnotaionDataFrame slot
and the \link{sample} slot and obtained via getter
functions, e.g.s
\code{\link[=getCountGenoRef]{getCountGenoRef()}}, \code{\link[=getCountAlleleRef]{getCountAlleleRef()}}, and \code{\link[=getMAF]{getMAF()}}.
}
\details{
#' Genotype call data can be obtained from the "genotype" node,
the "filt.genotype" node, or the "corrected.genotype" node of
the GDS file with \code{node = "raw"}, \code{node = "filt"}, or \code{node = "raw"},
respectively.
The \code{\link[=setCallFilter]{setCallFilter()}} function generate filtered genotype call data in the
"filt.genotype" node which can be accessed as mentioned above.
On the other hand, the "corrected.genotype" node can be generated
via the \code{\link[=estGeno]{estGeno()}} function.
}
\examples{
# Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
gds_fn <- system.file("extdata", "sample.gds", package = "GBScleanR")
gds <- loadGDS(gds_fn)

# Summarize the genotype count information and store them in the
# [marker] and [sample] slots of the [GbsrGenotypeData] object.
gds <- countGenotype(gds)

# Get the proportion of missing genotype per sample.
sample_missing_rate <- getCountGenoMissing(gds,
                                           target = "sample",
                                           prop = TRUE)

# Get the minor allele frequency per marker.
marker_minor_allele_freq <- getMAF(gds, target = "marker")

# Draw histograms of the missing rate per sample and marker.
histGBSR(gds, stats = "missing")

# Close the connection to the GDS file.
closeGDS(gds)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/Methods-GbsrGenotypeData.R
\name{getFixedParameter}
\alias{getFixedParameter}
\alias{getFixedParameter,GbsrGenotypeData-method}
\title{Get fixed allele read biases and mismapping rate}
\usage{
getFixedParameter(object, valid = TRUE, chr = NULL, ...)

\S4method{getFixedParameter}{GbsrGenotypeData}(object, valid, chr)
}
\arguments{
\item{object}{A \link{GbsrGenotypeData} object.}

\item{valid}{A logical value. See details.}

\item{chr}{A integer or string to specify chromosome to get information.}

\item{...}{Unused.}
}
\value{
A numeric vector of fixed allele read biases.

A \link{GbsrGenotypeData} object after adding dominant marker information
}
\description{
Get fixed allele read biases and mismapping rates of markers
}
\details{
If \code{valid = TRUE}, A logical vector for the markers which are labeled \code{TRUE} in
the "valid" column of the "marker" slot will be returned. If you need check
the dominant markers in all markers, set \code{valid = FALSE}. \code{\link[=validMar]{validMar()}} tells you
which markers are valid.
}
\examples{
vcf_fn <- system.file("extdata", "sample.vcf", package = "GBScleanR")
gds_fn <- tempfile("sample", fileext = ".gds")
gbsrVCF2GDS(vcf_fn = vcf_fn, out_fn = gds_fn, force = TRUE)

# Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
gds <- loadGDS(gds_fn)

# Not run.
# Run estGeno() and reuse the estimated parameters in the second run.
# gds <- makeScheme(gds, generation = 2, crosstype = "self")
# gds <- estGeno(gds)
# fixed_param <- getFixedParameter(gds)
# gds <- setFixedParameter(gds,
#                          bias = fixed_param$bias,
#                          mismap = fixed_param$mismap)
# gds <- estGeno(gds, optim = FALSE, call_threshold = 0.5)

# Close the connection to the GDS file
closeGDS(gds)

}
\seealso{
\code{\link[=setFixedParameter]{setFixedParameter()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllUtilities.R
\name{loadGDS}
\alias{loadGDS}
\title{Load a GDS file and construct a \link{GbsrGenotypeData} object.}
\usage{
loadGDS(x, load_filter = FALSE, ploidy = 2, verbose = TRUE)
}
\arguments{
\item{x}{A string of the path to an input GDS file or
a \link{GbsrGenotypeData} object to reload.}

\item{load_filter}{A logical whether to load the filtering information made
via \code{\link[=setSamFilter]{setSamFilter()}} and \code{\link[=setMarFilter]{setMarFilter()}} and saved in the GDS file via
\code{\link[=closeGDS]{closeGDS()}} with \code{save_filter = TRUE}.}

\item{ploidy}{Set the ploidy of the population.}

\item{verbose}{if TRUE, show information.}
}
\value{
A \link{GbsrGenotypeData} object.
}
\description{
Load data stored in an input GDS file to R environment and
create a \link{GbsrGenotypeData} instance.
GBScleanR handles only one class \link{GbsrGenotypeData} and
conducts all data manipulation via class methods for it.
}
\details{
The first time to load a newly produced GDS file will take long time due to
data reformatting for quick access. The \link{GbsrGenotypeData} object returned
from \code{\link[=loadGDS]{loadGDS()}} can be also handled as \code{\link[SeqArray]{SeqVarGDSClass-class}} of the \code{SeqArray} package.
}
\examples{
# Create a GDS file from a sample VCF file.
vcf_fn <- system.file("extdata", "sample.vcf", package = "GBScleanR")
gds_fn <- tempfile("sample", fileext = ".gds")
gbsrVCF2GDS(vcf_fn = vcf_fn, out_fn = gds_fn, force = TRUE)

# Load data in the GDS file and instantiate a [GbsrGenotypeData] object.
gds <- loadGDS(gds_fn)

# Reload data from the GDS file.
gds <- loadGDS(gds)

# Close the connection to the GDS file.
closeGDS(gds)

}
